"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getIndicationsAndOtherDocumentedUsages = void 0;
var apollo_server_micro_1 = require("apollo-server-micro");
var queryMedicalDb_1 = require("../queryMedicalDb");
var getIndicationsAndOtherDocumentedUsages = function (_a) {
    var shortname = _a.shortname;
    return __awaiter(void 0, void 0, void 0, function () {
        var drugs;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, (0, queryMedicalDb_1.callMedicalDb)(queryMedicalDb_1.indicationsAndOtherDocumentedUsagesBody, {
                        shortname: shortname,
                    })];
                case 1:
                    drugs = (_b.sent()).drugs;
                    if (drugs.length === 0) {
                        throw new apollo_server_micro_1.ApolloError("Error: There is no drug with this shortname.");
                    }
                    return [2 /*return*/, drugs.map(function (_a) {
                            var form = _a.form, dose = _a.dose, indications = _a.indications, unofficial_indications = _a.unofficial_indications;
                            return {
                                form: form,
                                dose: dose,
                                indications: indications.map(getFormedIndication),
                                unofficialIndications: unofficial_indications,
                            };
                        })];
            }
        });
    });
};
exports.getIndicationsAndOtherDocumentedUsages = getIndicationsAndOtherDocumentedUsages;
var getFormedIndication = function (indications) {
    var disease = indications.disease, text = indications.text, comments = indications.comments, nature_comments = indications.nature_comments, types = indications.types, level = indications.level, smr = indications.smr, cim10 = indications.cim10;
    var excludes = [" OU", "  OU", " ET/OU", "  ET/OU"];
    var typesCommentsAndNatureComments = __spreadArray(__spreadArray(__spreadArray([], types, true), (comments !== null && comments !== void 0 ? comments : []), true), nature_comments.map(function (_a) {
        var name = _a.name;
        return name;
    }), true).filter(function (b) { return !excludes.includes(b) && b.indexOf("Cf.") !== 0; });
    var cim10Codes = cim10 === null || cim10 === void 0 ? void 0 : cim10.reduce(function (acc, curr) {
        var _a, _b;
        if (((_a = curr.code) === null || _a === void 0 ? void 0 : _a.length) &&
            curr.code !== "." &&
            curr.code !== ".." &&
            curr.code !== "...") {
            if ((_b = curr.label) === null || _b === void 0 ? void 0 : _b.length) {
                acc.push("".concat(curr.code, " (").concat(curr.label, ")"));
            }
            else {
                acc.push("".concat(curr.code));
            }
        }
        return acc;
    }, []);
    return {
        disease: disease,
        typesCommentsAndNatureComments: typesCommentsAndNatureComments,
        text: text,
        level: level,
        smr: smr,
        cim10Codes: cim10Codes,
    };
};
