"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getInteractions = void 0;
var apollo_server_micro_1 = require("apollo-server-micro");
var lodash_1 = require("lodash");
var queryMedicalDb_1 = require("../queryMedicalDb");
var interactionsMap_1 = require("../toolbox/interactionsMap");
var possibleSources = ["Thesaurus - ANSM"];
var getInteractions = function (_a) {
    var dci = _a.dci;
    return __awaiter(void 0, void 0, void 0, function () {
        var response;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, (0, queryMedicalDb_1.callMedicalDb)(queryMedicalDb_1.interactionsBody, {
                        dci: dci,
                    })];
                case 1:
                    response = (_b.sent());
                    if (response.dci === null) {
                        throw new apollo_server_micro_1.ApolloError("Error: There is no drug with this dci.");
                    }
                    return [2 /*return*/, (0, lodash_1.sortBy)(response.dci.interactions
                            .filter(function (_a) {
                            var nature = _a.nature, source = _a.details.source;
                            return (!source || possibleSources.includes(source)) &&
                                nature.some(function (n) { return interactionsMap_1.possibleNatureInteractions.includes(n); });
                        })
                            .map(function (_a) {
                            var nature = _a.nature, _with = _a.with, details = _a.details;
                            return {
                                severity: nature.map(interactionsMap_1.getInteractionSeverityValue),
                                with: _with.map(function (w) { return w.dci; }).sort(),
                                title: formatTitle(details.title),
                                nature: details.nature,
                                instructions: details.instructions,
                                informations: details.informations,
                                history: details.history,
                                bibliography: details.bibliography,
                            };
                        }), function (i) { return i.title; })];
            }
        });
    });
};
exports.getInteractions = getInteractions;
var formatTitle = function (title) {
    var t = title.replace(/^(\+|-|\s)+|(\+|-|\s)+$/g, "");
    if (t.includes(" + ")) {
        return t
            .split(" + ")
            .map(function (c) { return (0, lodash_1.capitalize)(c); })
            .join(" + ");
    }
    if (t.includes(" - ")) {
        return t
            .split(" - ")
            .map(function (c) { return (0, lodash_1.capitalize)(c); })
            .join(" - ");
    }
    return (0, lodash_1.capitalize)(t);
};
