"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.formatSpecialties = exports.getSpecialties = void 0;
var apollo_server_micro_1 = require("apollo-server-micro");
var lodash_1 = require("lodash");
var queryMedicalDb_1 = require("../queryMedicalDb");
var crushabilityTools_1 = require("../toolbox/crushabilityTools");
var getSpecialties = function (_a) {
    var shortname = _a.shortname, context = _a.context;
    return __awaiter(void 0, void 0, void 0, function () {
        var drugs;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, (0, queryMedicalDb_1.callMedicalDb)(queryMedicalDb_1.specialtiesBody, {
                        shortname: shortname,
                    }, (context === null || context === void 0 ? void 0 : context.mdbHeaders) || null)];
                case 1:
                    drugs = (_b.sent()).drugs;
                    if (drugs.length === 0) {
                        throw new apollo_server_micro_1.ApolloError("Error: There is no drug with this shortname.");
                    }
                    return [2 /*return*/, drugs.map(function (_a) {
                            var form = _a.form, dose = _a.dose, specialties = _a.specialties, formulary_specialties = _a.formulary_specialties;
                            var cisInFormulary = (formulary_specialties === null || formulary_specialties === void 0 ? void 0 : formulary_specialties.map(function (_a) {
                                var cis = _a.cis;
                                return cis;
                            })) || [];
                            return {
                                form: form,
                                dose: dose,
                                specialties: (0, exports.formatSpecialties)(specialties, cisInFormulary),
                            };
                        })];
            }
        });
    });
};
exports.getSpecialties = getSpecialties;
var formatSpecialties = function (specialties, cisInFormulary) {
    return specialties.map(function (_a) {
        var name = _a.name, cis = _a.cis, crushable = _a.crushable, excipients = _a.excipients, presentations = _a.presentations;
        return {
            name: name,
            excipients: (0, lodash_1.uniq)(excipients.map(function (_a) {
                var name = _a.name;
                return name;
            }).sort()),
            crushable: (0, crushabilityTools_1.getCrushableWithoutBackslashes)(crushable),
            availableInFormulary: cisInFormulary.includes(cis),
            presentations: presentations.map(function (_a) {
                var presentation = _a.presentation, p = __rest(_a, ["presentation"]);
                return __assign(__assign({}, p), { name: presentation });
            }),
        };
    });
};
exports.formatSpecialties = formatSpecialties;
