"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
require("graphql-import-node");
var micro_cors_1 = __importDefault(require("micro-cors"));
var apollo_server_micro_1 = require("apollo-server-micro");
var micro_1 = require("micro");
var api_1 = require("./api");
var dotenv_1 = __importDefault(require("dotenv"));
var schema_gql_1 = __importDefault(require("./schema.gql"));
var types_1 = require("./types");
var FORWARDABLE_HEADERS = [types_1.FACILITY_SLUG_HEADER, types_1.FORMULARY_IDENTIFIER_HEADER];
dotenv_1.default.config();
var cors = (0, micro_cors_1.default)({
    allowHeaders: __spreadArray([
        "X-Requested-With",
        "Access-Control-Allow-Origin",
        "X-HTTP-Method-Override",
        "Content-Type",
        "Authorization",
        "Accept"
    ], FORWARDABLE_HEADERS, true),
});
var resolvers = {
    Query: {
        getGeneralInformations: function (parent, arg, context) {
            return (0, api_1.getGeneralInformations)(arg);
        },
        getIndicationsAndOtherDocumentedUsages: function (parent, arg, context) {
            return (0, api_1.getIndicationsAndOtherDocumentedUsages)(arg);
        },
        getContraindications: function (parent, arg, context) {
            return (0, api_1.getContraindications)(arg);
        },
        getSideEffects: function (parent, arg, context) {
            return (0, api_1.getSideEffects)(arg);
        },
        getInteractions: function (parent, arg, context) {
            return (0, api_1.getInteractions)(arg);
        },
        getSpecialties: function (parent, arg, context) {
            return (0, api_1.getSpecialties)(__assign(__assign({}, arg), { context: context }));
        },
        getCrushableSpecialties: function (parent, arg, context) {
            return (0, api_1.getCrushableSpecialties)(arg);
        },
        getPharmacology: function (parent, arg, context) {
            return (0, api_1.getPharmacology)(arg);
        },
        getProtocols: function (parent, arg, context) {
            return (0, api_1.getProtocols)(arg);
        }
    },
};
var context = function (_a) {
    var req = _a.req;
    var mdbHeaders = {};
    FORWARDABLE_HEADERS.forEach(function (headerName) {
        if (req.headers[headerName]) {
            mdbHeaders[headerName] = req.headers[headerName];
        }
    });
    return {
        mdbHeaders: mdbHeaders,
    };
};
var apolloServer = new apollo_server_micro_1.ApolloServer({ typeDefs: schema_gql_1.default, resolvers: resolvers, context: context });
module.exports = apolloServer.start().then(function () {
    var handler = apolloServer.createHandler();
    return cors(function (req, res) {
        req.method === "OPTIONS" ? (0, micro_1.send)(res, 200, "ok") : handler(req, res);
    });
});
