"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.callMedicalDb = exports.protocolsBody = exports.crushableSpecialtiesBody = exports.pharmacologyBody = exports.specialtiesBody = exports.sideEffectsBody = exports.interactionsBody = exports.contraindicationsBody = exports.indicationsAndOtherDocumentedUsagesBody = exports.generalInformationBody = void 0;
var apollo_server_micro_1 = require("apollo-server-micro");
var posos_client_nodejs_1 = require("@posos-tech/posos-client-nodejs");
exports.generalInformationBody = "\n  query ($shortname: String) {\n    drugs(shortname: $shortname) {\n      form\n      dose\n      ingredients\n      atc_parent {\n        code\n        label\n      }\n      atc {\n        code\n        label\n      }\n      conditions {\n        icons {\n          alt\n          title\n        }\n      }\n    }\n  }\n";
exports.indicationsAndOtherDocumentedUsagesBody = "\n  query ($shortname: String!) {\n    drugs(shortname: $shortname) {\n      form\n      dose\n      indications {\n        disease\n        nature_comments {\n          name\n        }\n        level\n        types\n        smr\n        text\n        cim10 {\n          code\n          label\n        }\n      }\n      unofficial_indications {\n        label\n        references\n      }\n    }\n  }\n";
exports.contraindicationsBody = "\n  query ($shortname: String!) {\n    drugs(shortname: $shortname) {\n      dose\n      form\n      contraindications {\n        label\n        level\n        comment\n        other_comment\n        text\n      }\n    }\n  }\n";
exports.interactionsBody = "\n  query ($dci: String) {\n    dci(dci: $dci) {\n      interactions {\n        nature\n        with {\n          dci\n        }\n        details {\n          title\n          nature\n          instructions\n          informations\n          history\n          bibliography\n          source\n        }\n      }\n    }\n  }\n";
exports.sideEffectsBody = "\n  query ($shortname: String!) {\n    drugs(shortname: $shortname) {\n      form\n      dose\n      side_effects_categories {\n        category\n        effects\n        severity\n        severity_category\n        frequency\n        frequency_string\n        behaviour\n        behaviour_comment\n        occurence_time\n        favoring_factors\n        other_favoring_factors\n      }\n    }\n  }\n";
exports.specialtiesBody = "\n  query ($shortname: String!) {\n    drugs(shortname: $shortname) {\n      form\n      dose\n      formulary_specialties {\n        cis\n      }\n      specialties {\n        name\n        cis\n        crushable {\n          uri\n          recommandations\n          intake\n          stability\n          pk_pd\n          smpc_comment\n          other_comments\n        }\n        excipients(known_effects: true) {\n          name\n        }\n        presentations {\n          presentation\n          reimbursement\n          price\n        }\n      }\n    }\n  }\n";
exports.pharmacologyBody = "\n  query ($shortname: String!) {\n    drugs(shortname: $shortname) {\n      form\n      dose\n      pharmacodynamics {\n        description\n      }\n      pharmacokinetics {\n        description\n      }\n      etiology {\n        intro\n        inconsistently_sensitive {\n          agent {\n            name\n            percentage\n            category\n          }\n          comment\n          text\n        }\n        usually_sensitive {\n          agent {\n            name\n            percentage\n            category\n          }\n          comment\n          text\n        }\n        moderate_sensitive {\n          agent {\n            name\n            percentage\n            category\n          }\n          comment\n          text\n        }\n        resistant {\n          agent {\n            name\n            percentage\n            category\n          }\n          comment\n          text\n        }\n      }\n    }\n  }\n";
exports.crushableSpecialtiesBody = "\n  query ($shortname: String!) {\n    drugs(shortname: $shortname) {\n      form\n      dose\n      specialties {\n        name\n        crushable {\n          uri\n          recommandations\n          intake\n          stability\n          pk_pd\n          smpc_comment\n          other_comments\n        }\n      }\n    }\n  }\n";
exports.protocolsBody = "\n  query ($shortname: String!) {\n    drugs(shortname: $shortname) {\n      form\n      dose\n      conditions {\n        uri\n        summary\n        prescription {\n          base_content\n          validity_initial_hospital_prescription\n          maximum_prescription_period\n          prescription_reserved\n          monitoring_during_treatment\n          hospital_prescription\n          exception_drugs\n          archives\n        }\n        first_issuance {\n          base_content\n          prescription_support\n          time_limit\n          duration_treatment\n        }\n        renewal {\n          base_content\n          prescription_support\n        }\n      }\n    }\n  }\n";
var callMedicalDb = function (body, variables, headers) {
    if (headers === void 0) { headers = null; }
    return __awaiter(void 0, void 0, void 0, function () {
        var POSOS_API_KEY, POSOS_API_URL, client;
        return __generator(this, function (_a) {
            POSOS_API_KEY = process.env.POSOS_API_KEY;
            POSOS_API_URL = process.env.POSOS_API_URL;
            client = new posos_client_nodejs_1.PososClient(POSOS_API_URL, POSOS_API_KEY);
            if (headers) {
                client = client.withHeaders(headers);
            }
            return [2 /*return*/, client.v2.medicaldb.graphql(body, variables).catch(function (err) {
                    throw new apollo_server_micro_1.ApolloError("Error in medical-db request: ".concat(JSON.stringify(err)));
                })];
        });
    });
};
exports.callMedicalDb = callMedicalDb;
