"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCrushableWithoutBackslashes = void 0;
var lodash_1 = require("lodash");
var getCrushableWithoutBackslashes = function (crushable) {
    if (!crushable) {
        return null;
    }
    var intake = crushable.intake, other_comments = crushable.other_comments, pk_pd = crushable.pk_pd, recommandations = crushable.recommandations, smpc_comment = crushable.smpc_comment, stability = crushable.stability, uri = crushable.uri;
    return {
        intake: removesBackslashes(intake),
        other_comments: removesBackslashes(other_comments),
        pk_pd: removesBackslashes(pk_pd),
        recommandations: removesBackslashes(recommandations),
        smpc_comment: removesBackslashes(smpc_comment),
        stability: removesBackslashes(stability),
        uri: uri,
    };
};
exports.getCrushableWithoutBackslashes = getCrushableWithoutBackslashes;
var removesBackslashes = function (str) {
    return (0, lodash_1.replace)(str, new RegExp(/\\/, "g"), "");
};
