"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getInteractionSeverityValue = exports.getInteractionsMap = exports.possibleNatureInteractions = exports.interactionsMap = void 0;
exports.interactionsMap = [
    {
        value: "CONTRE-INDICATION",
        matches: ["CONTRE INDICATION", "CONTRE-INDICATION"],
        level: 0,
    },
    {
        value: "ASSOCIATION DECONSEILLEE",
        matches: ["ASSOCIATION DECONSEILLEE"],
        level: 1,
    },
    {
        value: "PRECAUTION D'EMPLOI",
        matches: ["PRECAUTION D'EMPLOI"],
        level: 2,
    },
    {
        value: "A PRENDRE EN COMPTE",
        matches: ["A PRENDRE EN COMPTE"],
        level: 3,
    },
    {
        value: "―",
        matches: [null],
        level: Number.MAX_SAFE_INTEGER - 1,
    },
];
exports.possibleNatureInteractions = exports.interactionsMap
    .flatMap(function (_a) {
    var matches = _a.matches;
    return matches;
})
    .filter(function (matche) { return matche !== null; });
var getInteractionsMap = function (val) {
    var _a;
    return (_a = exports.interactionsMap.find(function (e) { return e.matches.includes(val); })) !== null && _a !== void 0 ? _a : exports.interactionsMap.slice(-1)[0];
};
exports.getInteractionsMap = getInteractionsMap;
var getInteractionSeverityValue = function (val) {
    return (0, exports.getInteractionsMap)(val).value;
};
exports.getInteractionSeverityValue = getInteractionSeverityValue;
