import { replace } from "lodash";
import { Crushable } from "../types";

export const getCrushableWithoutBackslashes = (crushable: Crushable | null) => {
    if (!crushable) {
      return null;
    }
    const {
      intake,
      other_comments,
      pk_pd,
      recommandations,
      smpc_comment,
      stability,
      uri
    } = crushable
  
    return {
      intake: removesBackslashes(intake),
      other_comments: removesBackslashes(other_comments),
      pk_pd: removesBackslashes(pk_pd),
      recommandations: removesBackslashes(recommandations),
      smpc_comment: removesBackslashes(smpc_comment),
      stability: removesBackslashes(stability),
      uri,
    };
  };
  
  
  const removesBackslashes = (str?: string): string => {
      return replace(str, new RegExp(/\\/, "g"), "");
    };