type InteractionMap = {
  value: string;
  matches: string[];
  level: number;
};

export const interactionsMap: InteractionMap[] = [
  {
    value: "CONTRE-INDICATION",
    matches: ["CONTRE INDICATION", "CONTRE-INDICATION"],
    level: 0,
  },
  {
    value: "ASSOCIATION DECONSEILLEE",
    matches: ["ASSOCIATION DECONSEILLEE"],
    level: 1,
  },
  {
    value: "PRECAUTION D'EMPLOI",
    matches: ["PRECAUTION D'EMPLOI"],
    level: 2,
  },
  {
    value: "A PRENDRE EN COMPTE",
    matches: ["A PRENDRE EN COMPTE"],
    level: 3,
  },
  {
    value: "―",
    matches: [null],
    level: Number.MAX_SAFE_INTEGER - 1,
  },
];

export const possibleNatureInteractions: string[] = interactionsMap
  .flatMap(({ matches }) => matches)
  .filter((matche) => matche !== null);

export const getInteractionsMap = (val: string): InteractionMap =>
  interactionsMap.find((e) => e.matches.includes(val)) ??
  interactionsMap.slice(-1)[0];

export const getInteractionSeverityValue = (val: string): string =>
  getInteractionsMap(val).value;
