export type Maybe<T> = T | null;
export type InputMaybe<T> = Maybe<T>;
export type Exact<T extends { [key: string]: unknown }> = { [K in keyof T]: T[K] };
export type MakeOptional<T, K extends keyof T> = Omit<T, K> & { [SubKey in K]?: Maybe<T[SubKey]> };
export type MakeMaybe<T, K extends keyof T> = Omit<T, K> & { [SubKey in K]: Maybe<T[SubKey]> };
/** All built-in and custom scalars, mapped to their actual values */
export type Scalars = {
  ID: string;
  String: string;
  Boolean: boolean;
  Int: number;
  Float: number;
};

export type Agent = {
  __typename?: 'Agent';
  category?: Maybe<Scalars['String']>;
  name: Scalars['String'];
  percentage?: Maybe<Scalars['String']>;
};

export type AtcLabelAndCode = {
  __typename?: 'AtcLabelAndCode';
  code?: Maybe<Scalars['String']>;
  label?: Maybe<Scalars['String']>;
};

export type ContraindicationFromDrugs = {
  __typename?: 'ContraindicationFromDrugs';
  comment: Array<Scalars['String']>;
  label: Scalars['String'];
  level: Array<Scalars['String']>;
  other_comment: Array<Scalars['String']>;
  text: Array<Scalars['String']>;
};

export type Crushable = {
  __typename?: 'Crushable';
  intake?: Maybe<Scalars['String']>;
  other_comments?: Maybe<Scalars['String']>;
  pk_pd?: Maybe<Scalars['String']>;
  recommandations?: Maybe<Scalars['String']>;
  smpc_comment?: Maybe<Scalars['String']>;
  stability?: Maybe<Scalars['String']>;
  uri: Scalars['String'];
};

export type CrushableSpecialties = {
  __typename?: 'CrushableSpecialties';
  crushable?: Maybe<Crushable>;
  name: Scalars['String'];
};

export type Etiology = {
  __typename?: 'Etiology';
  inconsistentlySensitive?: Maybe<Resistivity>;
  intro?: Maybe<Scalars['String']>;
  moderateSensitive?: Maybe<Resistivity>;
  resistantSensitive?: Maybe<Resistivity>;
  usuallySensitive?: Maybe<Resistivity>;
};

export type FirstIssuance = {
  __typename?: 'FirstIssuance';
  baseContent?: Maybe<Scalars['String']>;
  durationTreatment?: Maybe<Scalars['String']>;
  prescriptionSupport?: Maybe<Scalars['String']>;
  timeLimit?: Maybe<Scalars['String']>;
};

export type FormDoseAndContraindications = {
  __typename?: 'FormDoseAndContraindications';
  contraindications: Array<ContraindicationFromDrugs>;
  dose?: Maybe<Scalars['String']>;
  form?: Maybe<Scalars['String']>;
};

export type FormDoseAndCrushableSpecialties = {
  __typename?: 'FormDoseAndCrushableSpecialties';
  crushableSpecialties: Array<CrushableSpecialties>;
  dose?: Maybe<Scalars['String']>;
  form?: Maybe<Scalars['String']>;
};

export type FormDoseAndPharmacology = {
  __typename?: 'FormDoseAndPharmacology';
  dose?: Maybe<Scalars['String']>;
  etiology?: Maybe<Etiology>;
  form?: Maybe<Scalars['String']>;
  pharmacodynamics?: Maybe<Scalars['String']>;
  pharmacokinetics?: Maybe<Scalars['String']>;
};

export type FormDoseAndPrescriptionConditions = {
  __typename?: 'FormDoseAndPrescriptionConditions';
  dose?: Maybe<Scalars['String']>;
  form?: Maybe<Scalars['String']>;
  prescriptionConditions: Array<Scalars['String']>;
};

export type FormDoseAndProtocols = {
  __typename?: 'FormDoseAndProtocols';
  dose?: Maybe<Scalars['String']>;
  form?: Maybe<Scalars['String']>;
  protocols: Protocols;
};

export type FormDoseAndSideEffectsCategory = {
  __typename?: 'FormDoseAndSideEffectsCategory';
  dose?: Maybe<Scalars['String']>;
  form?: Maybe<Scalars['String']>;
  sideEffectsCategories: Array<SideEffectsCategoryFromDrugGuide>;
};

export type FormDoseAndSpecialties = {
  __typename?: 'FormDoseAndSpecialties';
  dose?: Maybe<Scalars['String']>;
  form?: Maybe<Scalars['String']>;
  specialties: Array<SpecialtyFromDrugGuide>;
};

export type FormDoseIndicationsAndUnofficialIndications = {
  __typename?: 'FormDoseIndicationsAndUnofficialIndications';
  dose?: Maybe<Scalars['String']>;
  form?: Maybe<Scalars['String']>;
  indications: Array<Indication>;
  unofficialIndications: Array<UnofficialIndication>;
};

export type GeneralInformations = {
  __typename?: 'GeneralInformations';
  atc?: Maybe<AtcLabelAndCode>;
  atcParent?: Maybe<AtcLabelAndCode>;
  formDoseAndPrescriptionConditions: Array<FormDoseAndPrescriptionConditions>;
  ingredients: Array<Scalars['String']>;
};

export type Indication = {
  __typename?: 'Indication';
  cim10Codes: Array<Scalars['String']>;
  disease: Scalars['String'];
  level: Scalars['String'];
  smr?: Maybe<Scalars['String']>;
  text: Scalars['String'];
  typesCommentsAndNatureComments: Array<Scalars['String']>;
};

export type InteractionFromDrugGuide = {
  __typename?: 'InteractionFromDrugGuide';
  bibliography: Array<Scalars['String']>;
  history: Array<Scalars['String']>;
  informations: Array<Scalars['String']>;
  instructions?: Maybe<Scalars['String']>;
  nature?: Maybe<Scalars['String']>;
  severity: Array<Scalars['String']>;
  title: Scalars['String'];
  with: Array<Scalars['String']>;
};

export type Prescription = {
  __typename?: 'Prescription';
  archives?: Maybe<Scalars['String']>;
  baseContent?: Maybe<Scalars['String']>;
  exceptionDrugs?: Maybe<Scalars['String']>;
  hospitalPrescription?: Maybe<Scalars['String']>;
  maximumPrescriptionPeriod?: Maybe<Scalars['String']>;
  monitoringDuringTreatment?: Maybe<Scalars['String']>;
  prescriptionReserved?: Maybe<Scalars['String']>;
  validityInitialHospitalPrescription?: Maybe<Scalars['String']>;
};

export type Presentation = {
  __typename?: 'Presentation';
  name: Scalars['String'];
  price?: Maybe<Scalars['String']>;
  reimbursement?: Maybe<Scalars['String']>;
};

export type Protocols = {
  __typename?: 'Protocols';
  firstIssuance?: Maybe<FirstIssuance>;
  prescription?: Maybe<Prescription>;
  renewal?: Maybe<Renewal>;
  summary?: Maybe<Scalars['String']>;
  uri: Scalars['String'];
};

export type Query = {
  __typename?: 'Query';
  getContraindications: Array<FormDoseAndContraindications>;
  getCrushableSpecialties: Array<FormDoseAndCrushableSpecialties>;
  getGeneralInformations: GeneralInformations;
  getIndicationsAndOtherDocumentedUsages: Array<FormDoseIndicationsAndUnofficialIndications>;
  getInteractions: Array<InteractionFromDrugGuide>;
  getPharmacology: Array<FormDoseAndPharmacology>;
  getProtocols: Array<FormDoseAndProtocols>;
  getSideEffects: Array<FormDoseAndSideEffectsCategory>;
  getSpecialties: Array<FormDoseAndSpecialties>;
};


export type QueryGetContraindicationsArgs = {
  shortname: Scalars['String'];
};


export type QueryGetCrushableSpecialtiesArgs = {
  shortname: Scalars['String'];
};


export type QueryGetGeneralInformationsArgs = {
  shortname: Scalars['String'];
};


export type QueryGetIndicationsAndOtherDocumentedUsagesArgs = {
  shortname: Scalars['String'];
};


export type QueryGetInteractionsArgs = {
  dci: Scalars['String'];
};


export type QueryGetPharmacologyArgs = {
  shortname: Scalars['String'];
};


export type QueryGetProtocolsArgs = {
  shortname: Scalars['String'];
};


export type QueryGetSideEffectsArgs = {
  shortname: Scalars['String'];
};


export type QueryGetSpecialtiesArgs = {
  shortname: Scalars['String'];
};

export type Renewal = {
  __typename?: 'Renewal';
  baseContent?: Maybe<Scalars['String']>;
  prescriptionSupport?: Maybe<Scalars['String']>;
};

export type Resistivity = {
  __typename?: 'Resistivity';
  agent: Array<Agent>;
  comment?: Maybe<Array<Scalars['String']>>;
  text?: Maybe<Array<Scalars['String']>>;
};

export type SideEffectsCategoryFromDrugGuide = {
  __typename?: 'SideEffectsCategoryFromDrugGuide';
  behaviour: Array<Scalars['String']>;
  behaviourComment?: Maybe<Scalars['String']>;
  category?: Maybe<Scalars['String']>;
  effects: Array<Scalars['String']>;
  favoringFactors: Array<Scalars['String']>;
  frequency?: Maybe<Scalars['Int']>;
  frequencyComment?: Maybe<Scalars['String']>;
  frequencyString?: Maybe<Scalars['String']>;
  occurenceComment?: Maybe<Scalars['String']>;
  occurenceTime: Array<Scalars['String']>;
  otherFavoringFactors: Array<Scalars['String']>;
  severity: Array<Scalars['String']>;
  severityCategory: Scalars['String'];
};

export type SpecialtyFromDrugGuide = {
  __typename?: 'SpecialtyFromDrugGuide';
  availableInFormulary: Scalars['Boolean'];
  crushable?: Maybe<Crushable>;
  excipients: Array<Scalars['String']>;
  name: Scalars['String'];
  presentations: Array<Presentation>;
};

export type UnofficialIndication = {
  __typename?: 'UnofficialIndication';
  label: Scalars['String'];
  references: Array<Scalars['String']>;
};
