import {
  DTOGeneralInformationResponse,
  DTOIndicationsAndOtherDocumentedUsages,
  GeneralInformations,
  FormDoseIndicationsAndUnofficialIndications,
  DTOContraindicationsResponse,
  FormDoseAndContraindications,
  FormDoseAndSideEffectsCategory,
  DTOSideEffectsResponse,
  DTOInteractionsResponse,
  InteractionFromDrugGuide,
  FormDoseAndSpecialties,
  DTOSpecialtiesResponse,
  DTOCrushableSpecialtiesResponse,
  FormDoseAndCrushableSpecialties,
  DTOPharmacologyResponse,
  FormDoseAndPharmacology,
  DTOProtocolsResponse,
  FormDoseAndProtocols,
} from "../types";

export const mockExprexGeneralInformationDTOResponse: DTOGeneralInformationResponse =
  {
    drugs: [
      {
        form: "solution injectable",
        dose: "40 000 ui/ml",
        ingredients: ["époétine alfa"],
        atc_parent: {
          code: "B03XA",
          label: "AUTRES PREPARATIONS ANTIANEMIQUES",
        },
        atc: {
          code: "B03XA01",
          label: "ERYTHROPOIETINE",
        },
        conditions: {
          icons: [
            {
              title: "Médicaments à prescription initiale hospitalière",
              alt: "PIH",
            },
            {
              title: "Médicaments d'exception",
              alt: "EXC",
            },
            {
              title: "Médicament Biologique",
              alt: "Médicament Biologique",
            },
            {
              title: "Froid",
              alt: "Froid",
            },
          ],
        },
      },
      {
        form: "solution injectable",
        dose: "4000 ui/ml",
        ingredients: ["époétine alfa"],
        atc_parent: {
          code: "B03XA",
          label: "AUTRES PREPARATIONS ANTIANEMIQUES",
        },
        atc: {
          code: "B03XA01",
          label: "ERYTHROPOIETINE",
        },
        conditions: {
          icons: [
            {
              title: "Médicaments à prescription initiale hospitalière",
              alt: "PIH",
            },
            {
              title: "Médicaments d'exception",
              alt: "EXC",
            },
            {
              title: "Médicament Biologique",
              alt: "Médicament Biologique",
            },
            {
              title: "Froid",
              alt: "Froid",
            },
          ],
        },
      },
      {
        form: "solution injectable",
        dose: "10 000 ui/ml",
        ingredients: ["époétine alfa"],
        atc_parent: {
          code: "B03XA",
          label: "AUTRES PREPARATIONS ANTIANEMIQUES",
        },
        atc: {
          code: "B03XA01",
          label: "ERYTHROPOIETINE",
        },
        conditions: {
          icons: [
            {
              title: "Médicaments à prescription initiale hospitalière",
              alt: "PIH",
            },
            {
              title: "Médicaments d'exception",
              alt: "EXC",
            },
            {
              title: "Médicament Biologique",
              alt: "Médicament Biologique",
            },
            {
              title: "Froid",
              alt: "Froid",
            },
          ],
        },
      },
      {
        form: "solution injectable",
        dose: "2000 ui/ml",
        ingredients: ["époétine alfa"],
        atc_parent: {
          code: "B03XA",
          label: "AUTRES PREPARATIONS ANTIANEMIQUES",
        },
        atc: {
          code: "B03XA01",
          label: "ERYTHROPOIETINE",
        },
        conditions: {
          icons: [
            {
              title: "Médicaments à prescription initiale hospitalière",
              alt: "PIH",
            },
            {
              title: "Médicaments d'exception",
              alt: "EXC",
            },
            {
              title: "Médicament Biologique",
              alt: "Médicament Biologique",
            },
            {
              title: "Froid",
              alt: "Froid",
            },
          ],
        },
      },
    ],
  };

export const mockEprexGeneralInformations: GeneralInformations = {
  ingredients: ["époétine alfa"],
  atcParent: {
    code: "B03XA",
    label: "AUTRES PREPARATIONS ANTIANEMIQUES",
  },
  atc: {
    code: "B03XA01",
    label: "ERYTHROPOIETINE",
  },
  formDoseAndPrescriptionConditions: [
    {
      form: "solution injectable",
      dose: "40 000 ui/ml",
      prescriptionConditions: [
        "Médicaments à prescription initiale hospitalière",
        "Médicaments d'exception",
        "Médicament Biologique",
      ],
    },
    {
      form: "solution injectable",
      dose: "4000 ui/ml",
      prescriptionConditions: [
        "Médicaments à prescription initiale hospitalière",
        "Médicaments d'exception",
        "Médicament Biologique",
      ],
    },
    {
      form: "solution injectable",
      dose: "10 000 ui/ml",
      prescriptionConditions: [
        "Médicaments à prescription initiale hospitalière",
        "Médicaments d'exception",
        "Médicament Biologique",
      ],
    },
    {
      form: "solution injectable",
      dose: "2000 ui/ml",
      prescriptionConditions: [
        "Médicaments à prescription initiale hospitalière",
        "Médicaments d'exception",
        "Médicament Biologique",
      ],
    },
  ],
};

export const mockAbilifyIndicationsAndOtherDocumentedUsagesDTOResponse: DTOIndicationsAndOtherDocumentedUsages =
  {
    drugs: [
      {
        form: "comprimé",
        dose: "5 mg",
        indications: [
          {
            disease: "SCHIZOPHRENIE",
            nature_comments: [
              {
                name: "CHEZ L'ADULTE",
              },
            ],
            level: "AMM/INDIQUE",
            types: [],
            smr: null,
            text: "Ce médicament est indiqué dans le traitement de la schizophrénie chez les adultes et les adolescents âgés de 15 ans ou plus.",
            cim10: [
              {
                code: "F20",
                label: "Schizophrénie",
              },
            ],
          },
          {
            disease: "TROUBLE BIPOLAIRE",
            nature_comments: [
              {
                name: "DANS LES FORMES DE TYPE 1",
              },
              {
                name: "DANS LES FORMES MODEREES",
              },
              {
                name: "DANS LES FORMES SEVERES",
              },
              {
                name: "EN CAS D'EPISODE MANIAQUE",
              },
              {
                name: "CHEZ L'ADULTE",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT CURATIF", "TRAITEMENT PREVENTIF DES RECIDIVES"],
            smr: null,
            text: "Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I et dans la prévention de récidives d'épisodes maniaques chez l'adulte ayant présenté des épisodes à prédominance maniaques et pour qui les épisodes maniaques ont répondu à un traitement par aripiprazole (Cf. rubrique \"Propriétés pharmacodynamiques\").",
            cim10: [
              {
                code: "F31",
                label: "Trouble affectif bipolaire",
              },
            ],
          },
          {
            disease: "ACCES MANIAQUE",
            nature_comments: [
              {
                name: "DANS LES FORMES MODEREES",
              },
              {
                name: "DANS LES FORMES SEVERES",
              },
              {
                name: "EN CAS DE TROUBLE BIPOLAIRE",
              },
              {
                name: "CHEZ L'ADULTE",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT CURATIF", "TRAITEMENT PREVENTIF DES RECIDIVES"],
            smr: null,
            text: "Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I et dans la prévention de récidives d'épisodes maniaques chez l'adulte ayant présenté des épisodes à prédominance maniaques et pour qui les épisodes maniaques ont répondu à un traitement par aripiprazole (cf. rubrique \"Propriétés pharmacodynamiques\").",
            cim10: [
              {
                code: "F30",
                label: "Épisode maniaque",
              },
            ],
          },
          {
            disease: "ACCES MANIAQUE",
            nature_comments: [
              {
                name: "DANS LES FORMES MODEREES",
              },
              {
                name: "DANS LES FORMES SEVERES",
              },
              {
                name: "EN CAS DE TROUBLE BIPOLAIRE",
              },
              {
                name: "CHEZ L'ENFANT A PARTIR DE 13 ANS",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT CURATIF"],
            smr: null,
            text: 'Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I chez l\'adolescent âgé de 13 ans ou plus pour une durée allant jusque 12 semaines (cf. rubrique "Propriétés pharmacodynamiques").',
            cim10: [
              {
                code: "F30",
                label: "Épisode maniaque",
              },
            ],
          },
          {
            disease: "TROUBLE BIPOLAIRE",
            nature_comments: [
              {
                name: "DANS LES FORMES DE TYPE 1",
              },
              {
                name: "DANS LES FORMES MODEREES",
              },
              {
                name: "DANS LES FORMES SEVERES",
              },
              {
                name: "EN CAS D'EPISODE MANIAQUE",
              },
              {
                name: "CHEZ L'ENFANT A PARTIR DE 13 ANS",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT CURATIF"],
            smr: null,
            text: 'Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I chez l\'adolescent âgé de 13 ans ou plus pour une durée allant jusque 12 semaines (cf. rubrique "Propriétés pharmacodynamiques").',
            cim10: [
              {
                code: "F31",
                label: "Trouble affectif bipolaire",
              },
            ],
          },
        ],
        unofficial_indications: [
          {
            label: "Syndrome de Tourette",
            references: [
              "27672358",
              "28686474",
              "29154107",
              "27028456",
              "26914764",
              "25928702",
              "16684686",
              "25477724",
              "29388585",
              "26310194",
            ],
          },
          {
            label: "trouble obsessionnel compulsif",
            references: [
              "28922290",
              "26375768",
              "25653829",
              "29110139",
              "27518476",
              "29040153",
              "25093799",
              "27812841",
              "27629160",
              "28786825",
            ],
          },
          {
            label: "trouble dépressif résistant aux traitements",
            references: [
              "27274249",
              "26012350",
              "24991148",
              "16862232",
              "21220079",
              "26784490",
              "22143953",
              "26423182",
              "27438687",
            ],
          },
          {
            label: "maladie d'Alzheimer",
            references: ["23350964"],
          },
          {
            label: "démence",
            references: ["15264966", "19560726", "17508328", "16505124"],
          },
          {
            label: "trouble de la personnalité limite",
            references: [
              "18052583",
              "17318503",
              "20044651",
              "28145998",
              "17327963",
              "28825781",
              "16721700",
              "16648324",
              "30689305",
              "18848360",
            ],
          },
          {
            label: "troubles anxieux",
            references: [
              "18567977",
              "18399707",
              "29110139",
              "25439852",
              "21220076",
              "15602109",
            ],
          },
        ],
      },
      {
        form: "comprimé",
        dose: "10 mg",
        indications: [
          {
            disease: "SCHIZOPHRENIE",
            nature_comments: [
              {
                name: "CHEZ L'ADULTE",
              },
            ],
            level: "AMM/INDIQUE",
            types: [],
            smr: null,
            text: "Ce médicament est indiqué dans le traitement de la schizophrénie chez les adultes et les adolescents âgés de 15 ans ou plus.",
            cim10: [
              {
                code: "F20",
                label: "Schizophrénie",
              },
            ],
          },
          {
            disease: "TROUBLE BIPOLAIRE",
            nature_comments: [
              {
                name: "DANS LES FORMES DE TYPE 1",
              },
              {
                name: "DANS LES FORMES MODEREES",
              },
              {
                name: "DANS LES FORMES SEVERES",
              },
              {
                name: "EN CAS D'EPISODE MANIAQUE",
              },
              {
                name: "CHEZ L'ADULTE",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT CURATIF", "TRAITEMENT PREVENTIF DES RECIDIVES"],
            smr: null,
            text: "Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I et dans la prévention de récidives d'épisodes maniaques chez l'adulte ayant présenté des épisodes à prédominance maniaques et pour qui les épisodes maniaques ont répondu à un traitement par aripiprazole (Cf. rubrique \"Propriétés pharmacodynamiques\").",
            cim10: [
              {
                code: "F31",
                label: "Trouble affectif bipolaire",
              },
            ],
          },
          {
            disease: "ACCES MANIAQUE",
            nature_comments: [
              {
                name: "DANS LES FORMES MODEREES",
              },
              {
                name: "DANS LES FORMES SEVERES",
              },
              {
                name: "EN CAS DE TROUBLE BIPOLAIRE",
              },
              {
                name: "CHEZ L'ADULTE",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT CURATIF", "TRAITEMENT PREVENTIF DES RECIDIVES"],
            smr: null,
            text: "Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I et dans la prévention de récidives d'épisodes maniaques chez l'adulte ayant présenté des épisodes à prédominance maniaques et pour qui les épisodes maniaques ont répondu à un traitement par aripiprazole (cf. rubrique \"Propriétés pharmacodynamiques\").",
            cim10: [
              {
                code: "F30",
                label: "Épisode maniaque",
              },
            ],
          },
          {
            disease: "ACCES MANIAQUE",
            nature_comments: [
              {
                name: "DANS LES FORMES MODEREES",
              },
              {
                name: "DANS LES FORMES SEVERES",
              },
              {
                name: "EN CAS DE TROUBLE BIPOLAIRE",
              },
              {
                name: "CHEZ L'ENFANT A PARTIR DE 13 ANS",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT CURATIF"],
            smr: null,
            text: 'Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I chez l\'adolescent âgé de 13 ans ou plus pour une durée allant jusque 12 semaines (cf. rubrique "Propriétés pharmacodynamiques").',
            cim10: [
              {
                code: "F30",
                label: "Épisode maniaque",
              },
            ],
          },
          {
            disease: "TROUBLE BIPOLAIRE",
            nature_comments: [
              {
                name: "DANS LES FORMES DE TYPE 1",
              },
              {
                name: "DANS LES FORMES MODEREES",
              },
              {
                name: "DANS LES FORMES SEVERES",
              },
              {
                name: "EN CAS D'EPISODE MANIAQUE",
              },
              {
                name: "CHEZ L'ENFANT A PARTIR DE 13 ANS",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT CURATIF"],
            smr: null,
            text: 'Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I chez l\'adolescent âgé de 13 ans ou plus pour une durée allant jusque 12 semaines (cf. rubrique "Propriétés pharmacodynamiques").',
            cim10: [
              {
                code: "F31",
                label: "Trouble affectif bipolaire",
              },
            ],
          },
        ],
        unofficial_indications: [
          {
            label: "maladie d'Alzheimer",
            references: ["23350964"],
          },
          {
            label: "démence",
            references: ["15264966", "19560726", "17508328", "16505124"],
          },
          {
            label: "troubles anxieux",
            references: [
              "18567977",
              "18399707",
              "29110139",
              "25439852",
              "21220076",
              "15602109",
            ],
          },
          {
            label: "trouble obsessionnel compulsif",
            references: [
              "28922290",
              "26375768",
              "25653829",
              "29110139",
              "27518476",
              "29040153",
              "25093799",
              "27812841",
              "27629160",
              "28786825",
            ],
          },
          {
            label: "Syndrome de Tourette",
            references: [
              "27672358",
              "28686474",
              "29154107",
              "27028456",
              "26914764",
              "25928702",
              "16684686",
              "25477724",
              "29388585",
              "26310194",
            ],
          },
          {
            label: "trouble dépressif résistant aux traitements",
            references: [
              "27274249",
              "26012350",
              "24991148",
              "16862232",
              "21220079",
              "26784490",
              "22143953",
              "26423182",
              "27438687",
            ],
          },
          {
            label: "trouble de la personnalité limite",
            references: [
              "18052583",
              "17318503",
              "20044651",
              "28145998",
              "17327963",
              "28825781",
              "16721700",
              "16648324",
              "30689305",
              "18848360",
            ],
          },
        ],
      },
      {
        form: "solution  buvable",
        dose: "1 mg/ml",
        indications: [
          {
            disease: "SCHIZOPHRENIE",
            nature_comments: [
              {
                name: "CHEZ L'ADULTE",
              },
            ],
            level: "AMM/INDIQUE",
            types: [],
            smr: "NIVEAU IMPORTANT",
            text: "Ce médicament est indiqué dans le traitement de la schizophrénie chez les adultes et les adolescents âgés de 15 ans ou plus.",
            cim10: [
              {
                code: "F20",
                label: "Schizophrénie",
              },
            ],
          },
          {
            disease: "TROUBLE BIPOLAIRE",
            nature_comments: [
              {
                name: "DANS LES FORMES DE TYPE 1",
              },
              {
                name: "DANS LES FORMES MODEREES",
              },
              {
                name: "DANS LES FORMES SEVERES",
              },
              {
                name: "EN CAS D'EPISODE MANIAQUE",
              },
              {
                name: "CHEZ L'ADULTE",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT CURATIF", "TRAITEMENT PREVENTIF DES RECIDIVES"],
            smr: "NIVEAU IMPORTANT",
            text: "Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I et dans la prévention de récidives d'épisodes maniaques chez l'adulte ayant présenté des épisodes à prédominance maniaques et pour qui les épisodes maniaques ont répondu à un traitement par aripiprazole (Cf. rubrique \"Propriétés pharmacodynamiques\").",
            cim10: [
              {
                code: "F31",
                label: "Trouble affectif bipolaire",
              },
            ],
          },
          {
            disease: "ACCES MANIAQUE",
            nature_comments: [
              {
                name: "DANS LES FORMES MODEREES",
              },
              {
                name: "DANS LES FORMES SEVERES",
              },
              {
                name: "EN CAS DE TROUBLE BIPOLAIRE",
              },
              {
                name: "CHEZ L'ADULTE",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT CURATIF", "TRAITEMENT PREVENTIF DES RECIDIVES"],
            smr: "NIVEAU IMPORTANT",
            text: "Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I et dans la prévention de récidives d'épisodes maniaques chez l'adulte ayant présenté des épisodes à prédominance maniaques et pour qui les épisodes maniaques ont répondu à un traitement par aripiprazole (cf. rubrique \"Propriétés pharmacodynamiques\").",
            cim10: [
              {
                code: "F30",
                label: "Épisode maniaque",
              },
            ],
          },
          {
            disease: "ACCES MANIAQUE",
            nature_comments: [
              {
                name: "DANS LES FORMES MODEREES",
              },
              {
                name: "DANS LES FORMES SEVERES",
              },
              {
                name: "EN CAS DE TROUBLE BIPOLAIRE",
              },
              {
                name: "CHEZ L'ENFANT A PARTIR DE 13 ANS",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT CURATIF"],
            smr: "NIVEAU IMPORTANT",
            text: 'Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I chez l\'adolescent âgé de 13 ans ou plus pour une durée allant jusque 12 semaines (cf. rubrique "Propriétés pharmacodynamiques").',
            cim10: [
              {
                code: "F30",
                label: "Épisode maniaque",
              },
            ],
          },
          {
            disease: "TROUBLE BIPOLAIRE",
            nature_comments: [
              {
                name: "DANS LES FORMES DE TYPE 1",
              },
              {
                name: "DANS LES FORMES MODEREES",
              },
              {
                name: "DANS LES FORMES SEVERES",
              },
              {
                name: "EN CAS D'EPISODE MANIAQUE",
              },
              {
                name: "CHEZ L'ENFANT A PARTIR DE 13 ANS",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT CURATIF"],
            smr: "NIVEAU IMPORTANT",
            text: 'Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I chez l\'adolescent âgé de 13 ans ou plus pour une durée allant jusque 12 semaines (cf. rubrique "Propriétés pharmacodynamiques").',
            cim10: [
              {
                code: "F31",
                label: "Trouble affectif bipolaire",
              },
            ],
          },
        ],
        unofficial_indications: [
          {
            label: "trouble obsessionnel compulsif",
            references: [
              "28922290",
              "26375768",
              "25653829",
              "29110139",
              "27518476",
              "29040153",
              "25093799",
              "27812841",
              "27629160",
              "28786825",
            ],
          },
          {
            label: "maladie d'Alzheimer",
            references: ["23350964"],
          },
          {
            label: "trouble de la personnalité limite",
            references: [
              "18052583",
              "17318503",
              "20044651",
              "28145998",
              "17327963",
              "28825781",
              "16721700",
              "16648324",
              "30689305",
              "18848360",
            ],
          },
          {
            label: "trouble dépressif résistant aux traitements",
            references: [
              "27274249",
              "26012350",
              "24991148",
              "16862232",
              "21220079",
              "26784490",
              "22143953",
              "26423182",
              "27438687",
            ],
          },
          {
            label: "démence",
            references: ["15264966", "19560726", "17508328", "16505124"],
          },
          {
            label: "troubles anxieux",
            references: [
              "18567977",
              "18399707",
              "29110139",
              "25439852",
              "21220076",
              "15602109",
            ],
          },
          {
            label: "Syndrome de Tourette",
            references: [
              "27672358",
              "28686474",
              "29154107",
              "27028456",
              "26914764",
              "25928702",
              "16684686",
              "25477724",
              "29388585",
              "26310194",
            ],
          },
        ],
      },
      {
        form: "comprimé orodispersible",
        dose: "15 mg",
        indications: [
          {
            disease: "SCHIZOPHRENIE",
            nature_comments: [
              {
                name: "CHEZ L'ADULTE",
              },
            ],
            level: "AMM/INDIQUE",
            types: [],
            smr: "NIVEAU IMPORTANT",
            text: "Ce médicament est indiqué dans le traitement de la schizophrénie chez les adultes et les adolescents âgés de 15 ans ou plus.",
            cim10: [
              {
                code: "F20",
                label: "Schizophrénie",
              },
            ],
          },
          {
            disease: "TROUBLE BIPOLAIRE",
            nature_comments: [
              {
                name: "DANS LES FORMES DE TYPE 1",
              },
              {
                name: "DANS LES FORMES MODEREES",
              },
              {
                name: "DANS LES FORMES SEVERES",
              },
              {
                name: "EN CAS D'EPISODE MANIAQUE",
              },
              {
                name: "CHEZ L'ADULTE",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT CURATIF", "TRAITEMENT PREVENTIF DES RECIDIVES"],
            smr: "NIVEAU IMPORTANT",
            text: "Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I et dans la prévention de récidives d'épisodes maniaques chez l'adulte ayant présenté des épisodes à prédominance maniaques et pour qui les épisodes maniaques ont répondu à un traitement par aripiprazole (Cf. rubrique \"Propriétés pharmacodynamiques\").",
            cim10: [
              {
                code: "F31",
                label: "Trouble affectif bipolaire",
              },
            ],
          },
          {
            disease: "ACCES MANIAQUE",
            nature_comments: [
              {
                name: "DANS LES FORMES MODEREES",
              },
              {
                name: "DANS LES FORMES SEVERES",
              },
              {
                name: "EN CAS DE TROUBLE BIPOLAIRE",
              },
              {
                name: "CHEZ L'ADULTE",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT CURATIF", "TRAITEMENT PREVENTIF DES RECIDIVES"],
            smr: "NIVEAU IMPORTANT",
            text: "Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I et dans la prévention de récidives d'épisodes maniaques chez l'adulte ayant présenté des épisodes à prédominance maniaques et pour qui les épisodes maniaques ont répondu à un traitement par aripiprazole (cf. rubrique \"Propriétés pharmacodynamiques\").",
            cim10: [
              {
                code: "F30",
                label: "Épisode maniaque",
              },
            ],
          },
          {
            disease: "ACCES MANIAQUE",
            nature_comments: [
              {
                name: "DANS LES FORMES MODEREES",
              },
              {
                name: "DANS LES FORMES SEVERES",
              },
              {
                name: "EN CAS DE TROUBLE BIPOLAIRE",
              },
              {
                name: "CHEZ L'ENFANT A PARTIR DE 13 ANS",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT CURATIF"],
            smr: "NIVEAU IMPORTANT",
            text: 'Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I chez l\'adolescent âgé de 13 ans ou plus pour une durée allant jusque 12 semaines (cf. rubrique "Propriétés pharmacodynamiques").',
            cim10: [
              {
                code: "F30",
                label: "Épisode maniaque",
              },
            ],
          },
          {
            disease: "TROUBLE BIPOLAIRE",
            nature_comments: [
              {
                name: "DANS LES FORMES DE TYPE 1",
              },
              {
                name: "DANS LES FORMES MODEREES",
              },
              {
                name: "DANS LES FORMES SEVERES",
              },
              {
                name: "EN CAS D'EPISODE MANIAQUE",
              },
              {
                name: "CHEZ L'ENFANT A PARTIR DE 13 ANS",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT CURATIF"],
            smr: "NIVEAU IMPORTANT",
            text: 'Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I chez l\'adolescent âgé de 13 ans ou plus pour une durée allant jusque 12 semaines (cf. rubrique "Propriétés pharmacodynamiques").',
            cim10: [
              {
                code: "F31",
                label: "Trouble affectif bipolaire",
              },
            ],
          },
        ],
        unofficial_indications: [
          {
            label: "trouble dépressif résistant aux traitements",
            references: [
              "27274249",
              "26012350",
              "24991148",
              "16862232",
              "21220079",
              "26784490",
              "22143953",
              "26423182",
              "27438687",
            ],
          },
          {
            label: "trouble obsessionnel compulsif",
            references: [
              "28922290",
              "26375768",
              "25653829",
              "29110139",
              "27518476",
              "29040153",
              "25093799",
              "27812841",
              "27629160",
              "28786825",
            ],
          },
          {
            label: "maladie d'Alzheimer",
            references: ["23350964"],
          },
          {
            label: "démence",
            references: ["15264966", "19560726", "17508328", "16505124"],
          },
          {
            label: "troubles anxieux",
            references: [
              "18567977",
              "18399707",
              "29110139",
              "25439852",
              "21220076",
              "15602109",
            ],
          },
          {
            label: "Syndrome de Tourette",
            references: [
              "27672358",
              "28686474",
              "29154107",
              "27028456",
              "26914764",
              "25928702",
              "16684686",
              "25477724",
              "29388585",
              "26310194",
            ],
          },
          {
            label: "trouble de la personnalité limite",
            references: [
              "18052583",
              "17318503",
              "20044651",
              "28145998",
              "17327963",
              "28825781",
              "16721700",
              "16648324",
              "30689305",
              "18848360",
            ],
          },
        ],
      },
      {
        form: "comprimé",
        dose: "15 mg",
        indications: [
          {
            disease: "SCHIZOPHRENIE",
            nature_comments: [
              {
                name: "CHEZ L'ADULTE",
              },
            ],
            level: "AMM/INDIQUE",
            types: [],
            smr: null,
            text: "Ce médicament est indiqué dans le traitement de la schizophrénie chez les adultes et les adolescents âgés de 15 ans ou plus.",
            cim10: [
              {
                code: "F20",
                label: "Schizophrénie",
              },
            ],
          },
          {
            disease: "TROUBLE BIPOLAIRE",
            nature_comments: [
              {
                name: "DANS LES FORMES DE TYPE 1",
              },
              {
                name: "DANS LES FORMES MODEREES",
              },
              {
                name: "DANS LES FORMES SEVERES",
              },
              {
                name: "EN CAS D'EPISODE MANIAQUE",
              },
              {
                name: "CHEZ L'ADULTE",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT CURATIF", "TRAITEMENT PREVENTIF DES RECIDIVES"],
            smr: null,
            text: "Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I et dans la prévention de récidives d'épisodes maniaques chez l'adulte ayant présenté des épisodes à prédominance maniaques et pour qui les épisodes maniaques ont répondu à un traitement par aripiprazole (Cf. rubrique \"Propriétés pharmacodynamiques\").",
            cim10: [
              {
                code: "F31",
                label: "Trouble affectif bipolaire",
              },
            ],
          },
          {
            disease: "ACCES MANIAQUE",
            nature_comments: [
              {
                name: "DANS LES FORMES MODEREES",
              },
              {
                name: "DANS LES FORMES SEVERES",
              },
              {
                name: "EN CAS DE TROUBLE BIPOLAIRE",
              },
              {
                name: "CHEZ L'ADULTE",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT CURATIF", "TRAITEMENT PREVENTIF DES RECIDIVES"],
            smr: null,
            text: "Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I et dans la prévention de récidives d'épisodes maniaques chez l'adulte ayant présenté des épisodes à prédominance maniaques et pour qui les épisodes maniaques ont répondu à un traitement par aripiprazole (cf. rubrique \"Propriétés pharmacodynamiques\").",
            cim10: [
              {
                code: "F30",
                label: "Épisode maniaque",
              },
            ],
          },
          {
            disease: "ACCES MANIAQUE",
            nature_comments: [
              {
                name: "DANS LES FORMES MODEREES",
              },
              {
                name: "DANS LES FORMES SEVERES",
              },
              {
                name: "EN CAS DE TROUBLE BIPOLAIRE",
              },
              {
                name: "CHEZ L'ENFANT A PARTIR DE 13 ANS",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT CURATIF"],
            smr: null,
            text: 'Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I chez l\'adolescent âgé de 13 ans ou plus pour une durée allant jusque 12 semaines (cf. rubrique "Propriétés pharmacodynamiques").',
            cim10: [
              {
                code: "F30",
                label: "Épisode maniaque",
              },
            ],
          },
          {
            disease: "TROUBLE BIPOLAIRE",
            nature_comments: [
              {
                name: "DANS LES FORMES DE TYPE 1",
              },
              {
                name: "DANS LES FORMES MODEREES",
              },
              {
                name: "DANS LES FORMES SEVERES",
              },
              {
                name: "EN CAS D'EPISODE MANIAQUE",
              },
              {
                name: "CHEZ L'ENFANT A PARTIR DE 13 ANS",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT CURATIF"],
            smr: null,
            text: 'Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I chez l\'adolescent âgé de 13 ans ou plus pour une durée allant jusque 12 semaines (cf. rubrique "Propriétés pharmacodynamiques").',
            cim10: [
              {
                code: "F31",
                label: "Trouble affectif bipolaire",
              },
            ],
          },
        ],
        unofficial_indications: [
          {
            label: "troubles anxieux",
            references: [
              "18567977",
              "18399707",
              "29110139",
              "25439852",
              "21220076",
              "15602109",
            ],
          },
          {
            label: "trouble de la personnalité limite",
            references: [
              "18052583",
              "17318503",
              "20044651",
              "28145998",
              "17327963",
              "28825781",
              "16721700",
              "16648324",
              "30689305",
              "18848360",
            ],
          },
          {
            label: "maladie d'Alzheimer",
            references: ["23350964"],
          },
          {
            label: "trouble dépressif résistant aux traitements",
            references: [
              "27274249",
              "26012350",
              "24991148",
              "16862232",
              "21220079",
              "26784490",
              "22143953",
              "26423182",
              "27438687",
            ],
          },
          {
            label: "démence",
            references: ["15264966", "19560726", "17508328", "16505124"],
          },
          {
            label: "Syndrome de Tourette",
            references: [
              "27672358",
              "28686474",
              "29154107",
              "27028456",
              "26914764",
              "25928702",
              "16684686",
              "25477724",
              "29388585",
              "26310194",
            ],
          },
          {
            label: "trouble obsessionnel compulsif",
            references: [
              "28922290",
              "26375768",
              "25653829",
              "29110139",
              "27518476",
              "29040153",
              "25093799",
              "27812841",
              "27629160",
              "28786825",
            ],
          },
        ],
      },
      {
        form: "comprimé orodispersible",
        dose: "10 mg",
        indications: [
          {
            disease: "SCHIZOPHRENIE",
            nature_comments: [
              {
                name: "CHEZ L'ADULTE",
              },
            ],
            level: "AMM/INDIQUE",
            types: [],
            smr: "NIVEAU IMPORTANT",
            text: "Ce médicament est indiqué dans le traitement de la schizophrénie chez les adultes et les adolescents âgés de 15 ans ou plus.",
            cim10: [
              {
                code: "F20",
                label: "Schizophrénie",
              },
            ],
          },
          {
            disease: "TROUBLE BIPOLAIRE",
            nature_comments: [
              {
                name: "DANS LES FORMES DE TYPE 1",
              },
              {
                name: "DANS LES FORMES MODEREES",
              },
              {
                name: "DANS LES FORMES SEVERES",
              },
              {
                name: "EN CAS D'EPISODE MANIAQUE",
              },
              {
                name: "CHEZ L'ADULTE",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT CURATIF", "TRAITEMENT PREVENTIF DES RECIDIVES"],
            smr: "NIVEAU IMPORTANT",
            text: "Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I et dans la prévention de récidives d'épisodes maniaques chez l'adulte ayant présenté des épisodes à prédominance maniaques et pour qui les épisodes maniaques ont répondu à un traitement par aripiprazole (Cf. rubrique \"Propriétés pharmacodynamiques\").",
            cim10: [
              {
                code: "F31",
                label: "Trouble affectif bipolaire",
              },
            ],
          },
          {
            disease: "ACCES MANIAQUE",
            nature_comments: [
              {
                name: "DANS LES FORMES MODEREES",
              },
              {
                name: "DANS LES FORMES SEVERES",
              },
              {
                name: "EN CAS DE TROUBLE BIPOLAIRE",
              },
              {
                name: "CHEZ L'ADULTE",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT CURATIF", "TRAITEMENT PREVENTIF DES RECIDIVES"],
            smr: "NIVEAU IMPORTANT",
            text: "Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I et dans la prévention de récidives d'épisodes maniaques chez l'adulte ayant présenté des épisodes à prédominance maniaques et pour qui les épisodes maniaques ont répondu à un traitement par aripiprazole (cf. rubrique \"Propriétés pharmacodynamiques\").",
            cim10: [
              {
                code: "F30",
                label: "Épisode maniaque",
              },
            ],
          },
          {
            disease: "ACCES MANIAQUE",
            nature_comments: [
              {
                name: "DANS LES FORMES MODEREES",
              },
              {
                name: "DANS LES FORMES SEVERES",
              },
              {
                name: "EN CAS DE TROUBLE BIPOLAIRE",
              },
              {
                name: "CHEZ L'ENFANT A PARTIR DE 13 ANS",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT CURATIF"],
            smr: "NIVEAU IMPORTANT",
            text: 'Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I chez l\'adolescent âgé de 13 ans ou plus pour une durée allant jusque 12 semaines (cf. rubrique "Propriétés pharmacodynamiques").',
            cim10: [
              {
                code: "F30",
                label: "Épisode maniaque",
              },
            ],
          },
          {
            disease: "TROUBLE BIPOLAIRE",
            nature_comments: [
              {
                name: "DANS LES FORMES DE TYPE 1",
              },
              {
                name: "DANS LES FORMES MODEREES",
              },
              {
                name: "DANS LES FORMES SEVERES",
              },
              {
                name: "EN CAS D'EPISODE MANIAQUE",
              },
              {
                name: "CHEZ L'ENFANT A PARTIR DE 13 ANS",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT CURATIF"],
            smr: "NIVEAU IMPORTANT",
            text: 'Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I chez l\'adolescent âgé de 13 ans ou plus pour une durée allant jusque 12 semaines (cf. rubrique "Propriétés pharmacodynamiques").',
            cim10: [
              {
                code: "F31",
                label: "Trouble affectif bipolaire",
              },
            ],
          },
        ],
        unofficial_indications: [
          {
            label: "Syndrome de Tourette",
            references: [
              "27672358",
              "28686474",
              "29154107",
              "27028456",
              "26914764",
              "25928702",
              "16684686",
              "25477724",
              "29388585",
              "26310194",
            ],
          },
          {
            label: "trouble de la personnalité limite",
            references: [
              "18052583",
              "17318503",
              "20044651",
              "28145998",
              "17327963",
              "28825781",
              "16721700",
              "16648324",
              "30689305",
              "18848360",
            ],
          },
          {
            label: "démence",
            references: ["15264966", "19560726", "17508328", "16505124"],
          },
          {
            label: "troubles anxieux",
            references: [
              "18567977",
              "18399707",
              "29110139",
              "25439852",
              "21220076",
              "15602109",
            ],
          },
          {
            label: "maladie d'Alzheimer",
            references: ["23350964"],
          },
          {
            label: "trouble dépressif résistant aux traitements",
            references: [
              "27274249",
              "26012350",
              "24991148",
              "16862232",
              "21220079",
              "26784490",
              "22143953",
              "26423182",
              "27438687",
            ],
          },
          {
            label: "trouble obsessionnel compulsif",
            references: [
              "28922290",
              "26375768",
              "25653829",
              "29110139",
              "27518476",
              "29040153",
              "25093799",
              "27812841",
              "27629160",
              "28786825",
            ],
          },
        ],
      },
      {
        form: "solution injectable",
        dose: "7,5 mg/ml",
        indications: [
          {
            disease: "AGITATION",
            nature_comments: [
              {
                name: "CHEZ L'ADULTE",
              },
              {
                name: "EN CAS DE SCHIZOPHRENIE",
              },
              {
                name: "  OU",
              },
              {
                name: "EN CAS DE TROUBLE BIPOLAIRE",
              },
              {
                name: "EN CAS D'EPISODE MANIAQUE",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT DE COURTE DUREE"],
            smr: "NIVEAU IMPORTANT",
            text: "Ce médicament est indiqué pour contrôler rapidement l'agitation et les troubles du comportement chez les patients adultes schizophrènes ou présentant un épisode maniaque dans le cadre d'un trouble bipolaire de type I, lorsque le traitement par voie orale n'est pas adapté. \r\n\r\nLe traitement par aripiprazole solution injectable doit être arrêté et remplacé par l'aripiprazole par voie orale dès que l'état clinique du patient le permet.",
            cim10: [
              {
                code: "R451",
                label: "Agitation",
              },
            ],
          },
          {
            disease: "TROUBLE DU COMPORTEMENT",
            nature_comments: [
              {
                name: "EN CAS DE SCHIZOPHRENIE",
              },
              {
                name: "  OU",
              },
              {
                name: "EN CAS DE TROUBLE BIPOLAIRE",
              },
              {
                name: "EN CAS D'EPISODE MANIAQUE",
              },
              {
                name: "CHEZ L'ADULTE",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT DE COURTE DUREE"],
            smr: "NIVEAU IMPORTANT",
            text: "Ce médicament est indiqué pour contrôler rapidement l'agitation et les troubles du comportement chez les patients adultes schizophrènes ou présentant un épisode maniaque dans le cadre d'un trouble bipolaire de type I, lorsque le traitement par voie orale n'est pas adapté. \r\n\r\nLe traitement par aripiprazole solution injectable doit être arrêté et remplacé par l'aripiprazole par voie orale dès que l'état clinique du patient le permet.",
            cim10: [
              {
                code: "F00-F09",
                label:
                  "troubles mentaux organiques, y compris les troubles symtomatiques",
              },
              {
                code: "F10-F19",
                label:
                  "Troubles mentaux et du comportement liés à l'utilisation de substances psycho-actives",
              },
              {
                code: "F20-F29",
                label:
                  "schizophrénie, trouble schizotypique et troubles délirants",
              },
              {
                code: "F30-F39",
                label: "troubles de l'humeur (affectifs)",
              },
              {
                code: "F40-F48",
                label:
                  "troubles névrotiques, troubles liés à des facteurs de stress et troubles somatoformes",
              },
              {
                code: "F50-F59",
                label:
                  "syndromes comportementaux associés à des perturbations physiologiques et à des facteurs physiques",
              },
              {
                code: "F60-F69",
                label:
                  "troubles de la personnalité et du comportement chez l'adulte",
              },
              {
                code: "F70-F79",
                label: "retard mental",
              },
              {
                code: "F80-F89",
                label: "troubles du développement psychologique",
              },
              {
                code: "F90-F98",
                label:
                  "troubles du comportement et troubles émotionnels apparaissant habituellement durant l'enfance et l'adolescence",
              },
              {
                code: "F99",
                label: "Trouble mental, sans autre indication",
              },
            ],
          },
          {
            disease: "SCHIZOPHRENIE",
            nature_comments: [
              {
                name: "AVEC AGITATION",
              },
              {
                name: "CHEZ L'ADULTE",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT DE COURTE DUREE"],
            smr: "NIVEAU IMPORTANT",
            text: "Ce médicament est indiqué pour contrôler rapidement l'agitation et les troubles du comportement chez les patients adultes schizophrènes, lorsque le traitement par voie orale n'est pas adapté. \r\n\r\nLe traitement par aripiprazole solution injectable doit être arrêté et remplacé par l'aripiprazole par voie orale dès que l'état clinique du patient le permet.",
            cim10: [
              {
                code: "F20",
                label: "Schizophrénie",
              },
            ],
          },
          {
            disease: "ETAT D'EXCITATION MANIAQUE",
            nature_comments: [
              {
                name: "EN CAS DE TROUBLE BIPOLAIRE",
              },
              {
                name: "CHEZ L'ADULTE",
              },
            ],
            level: "AMM/INDIQUE",
            types: ["TRAITEMENT DE COURTE DUREE"],
            smr: "NIVEAU IMPORTANT",
            text: "Ce médicament est indiqué pour contrôler rapidement l'agitation et les troubles du comportement chez les patients adultes présentant un épisode maniaque dans le cadre d'un trouble bipolaire de type I, lorsque le traitement par voie orale n'est pas adapté. \r\n\r\nLe traitement par aripiprazole solution injectable doit être arrêté et remplacé par l'aripiprazole par voie orale dès que l'état clinique du patient le permet.",
            cim10: [
              {
                code: "F302",
                label: "Manie avec symptômes psychotiques",
              },
            ],
          },
        ],
        unofficial_indications: [
          {
            label: "trouble dépressif résistant aux traitements",
            references: [
              "27274249",
              "26012350",
              "24991148",
              "16862232",
              "21220079",
              "26784490",
              "22143953",
              "26423182",
              "27438687",
            ],
          },
          {
            label: "maladie d'Alzheimer",
            references: ["23350964"],
          },
          {
            label: "trouble obsessionnel compulsif",
            references: [
              "28922290",
              "26375768",
              "25653829",
              "29110139",
              "27518476",
              "29040153",
              "25093799",
              "27812841",
              "27629160",
              "28786825",
            ],
          },
          {
            label: "troubles anxieux",
            references: [
              "18567977",
              "18399707",
              "29110139",
              "25439852",
              "21220076",
              "15602109",
            ],
          },
          {
            label: "Syndrome de Tourette",
            references: [
              "27672358",
              "28686474",
              "29154107",
              "27028456",
              "26914764",
              "25928702",
              "16684686",
              "25477724",
              "29388585",
              "26310194",
            ],
          },
          {
            label: "démence",
            references: ["15264966", "19560726", "17508328", "16505124"],
          },
          {
            label: "trouble de la personnalité limite",
            references: [
              "18052583",
              "17318503",
              "20044651",
              "28145998",
              "17327963",
              "28825781",
              "16721700",
              "16648324",
              "30689305",
              "18848360",
            ],
          },
        ],
      },
    ],
  };

export const mockAbilifyIndicationsAndOtherDocumentedUsages: FormDoseIndicationsAndUnofficialIndications[] =
  [
    {
      form: "comprimé",
      dose: "5 mg",
      indications: [
        {
          disease: "SCHIZOPHRENIE",
          typesCommentsAndNatureComments: ["CHEZ L'ADULTE"],
          text: "Ce médicament est indiqué dans le traitement de la schizophrénie chez les adultes et les adolescents âgés de 15 ans ou plus.",
          level: "AMM/INDIQUE",
          smr: null,
          cim10Codes: ["F20 (Schizophrénie)"],
        },
        {
          disease: "TROUBLE BIPOLAIRE",
          typesCommentsAndNatureComments: [
            "TRAITEMENT CURATIF",
            "TRAITEMENT PREVENTIF DES RECIDIVES",
            "DANS LES FORMES DE TYPE 1",
            "DANS LES FORMES MODEREES",
            "DANS LES FORMES SEVERES",
            "EN CAS D'EPISODE MANIAQUE",
            "CHEZ L'ADULTE",
          ],
          text: "Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I et dans la prévention de récidives d'épisodes maniaques chez l'adulte ayant présenté des épisodes à prédominance maniaques et pour qui les épisodes maniaques ont répondu à un traitement par aripiprazole (Cf. rubrique \"Propriétés pharmacodynamiques\").",
          level: "AMM/INDIQUE",
          smr: null,
          cim10Codes: ["F31 (Trouble affectif bipolaire)"],
        },
        {
          disease: "ACCES MANIAQUE",
          typesCommentsAndNatureComments: [
            "TRAITEMENT CURATIF",
            "TRAITEMENT PREVENTIF DES RECIDIVES",
            "DANS LES FORMES MODEREES",
            "DANS LES FORMES SEVERES",
            "EN CAS DE TROUBLE BIPOLAIRE",
            "CHEZ L'ADULTE",
          ],
          text: "Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I et dans la prévention de récidives d'épisodes maniaques chez l'adulte ayant présenté des épisodes à prédominance maniaques et pour qui les épisodes maniaques ont répondu à un traitement par aripiprazole (cf. rubrique \"Propriétés pharmacodynamiques\").",
          level: "AMM/INDIQUE",
          smr: null,
          cim10Codes: ["F30 (Épisode maniaque)"],
        },
        {
          disease: "ACCES MANIAQUE",
          typesCommentsAndNatureComments: [
            "TRAITEMENT CURATIF",
            "DANS LES FORMES MODEREES",
            "DANS LES FORMES SEVERES",
            "EN CAS DE TROUBLE BIPOLAIRE",
            "CHEZ L'ENFANT A PARTIR DE 13 ANS",
          ],
          text: 'Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I chez l\'adolescent âgé de 13 ans ou plus pour une durée allant jusque 12 semaines (cf. rubrique "Propriétés pharmacodynamiques").',
          level: "AMM/INDIQUE",
          smr: null,
          cim10Codes: ["F30 (Épisode maniaque)"],
        },
        {
          disease: "TROUBLE BIPOLAIRE",
          typesCommentsAndNatureComments: [
            "TRAITEMENT CURATIF",
            "DANS LES FORMES DE TYPE 1",
            "DANS LES FORMES MODEREES",
            "DANS LES FORMES SEVERES",
            "EN CAS D'EPISODE MANIAQUE",
            "CHEZ L'ENFANT A PARTIR DE 13 ANS",
          ],
          text: 'Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I chez l\'adolescent âgé de 13 ans ou plus pour une durée allant jusque 12 semaines (cf. rubrique "Propriétés pharmacodynamiques").',
          level: "AMM/INDIQUE",
          smr: null,
          cim10Codes: ["F31 (Trouble affectif bipolaire)"],
        },
      ],
      unofficialIndications: [
        {
          label: "Syndrome de Tourette",
          references: [
            "27672358",
            "28686474",
            "29154107",
            "27028456",
            "26914764",
            "25928702",
            "16684686",
            "25477724",
            "29388585",
            "26310194",
          ],
        },
        {
          label: "trouble obsessionnel compulsif",
          references: [
            "28922290",
            "26375768",
            "25653829",
            "29110139",
            "27518476",
            "29040153",
            "25093799",
            "27812841",
            "27629160",
            "28786825",
          ],
        },
        {
          label: "trouble dépressif résistant aux traitements",
          references: [
            "27274249",
            "26012350",
            "24991148",
            "16862232",
            "21220079",
            "26784490",
            "22143953",
            "26423182",
            "27438687",
          ],
        },
        {
          label: "maladie d'Alzheimer",
          references: ["23350964"],
        },
        {
          label: "démence",
          references: ["15264966", "19560726", "17508328", "16505124"],
        },
        {
          label: "trouble de la personnalité limite",
          references: [
            "18052583",
            "17318503",
            "20044651",
            "28145998",
            "17327963",
            "28825781",
            "16721700",
            "16648324",
            "30689305",
            "18848360",
          ],
        },
        {
          label: "troubles anxieux",
          references: [
            "18567977",
            "18399707",
            "29110139",
            "25439852",
            "21220076",
            "15602109",
          ],
        },
      ],
    },
    {
      form: "comprimé",
      dose: "10 mg",
      indications: [
        {
          disease: "SCHIZOPHRENIE",
          typesCommentsAndNatureComments: ["CHEZ L'ADULTE"],
          text: "Ce médicament est indiqué dans le traitement de la schizophrénie chez les adultes et les adolescents âgés de 15 ans ou plus.",
          level: "AMM/INDIQUE",
          smr: null,
          cim10Codes: ["F20 (Schizophrénie)"],
        },
        {
          disease: "TROUBLE BIPOLAIRE",
          typesCommentsAndNatureComments: [
            "TRAITEMENT CURATIF",
            "TRAITEMENT PREVENTIF DES RECIDIVES",
            "DANS LES FORMES DE TYPE 1",
            "DANS LES FORMES MODEREES",
            "DANS LES FORMES SEVERES",
            "EN CAS D'EPISODE MANIAQUE",
            "CHEZ L'ADULTE",
          ],
          text: "Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I et dans la prévention de récidives d'épisodes maniaques chez l'adulte ayant présenté des épisodes à prédominance maniaques et pour qui les épisodes maniaques ont répondu à un traitement par aripiprazole (Cf. rubrique \"Propriétés pharmacodynamiques\").",
          level: "AMM/INDIQUE",
          smr: null,
          cim10Codes: ["F31 (Trouble affectif bipolaire)"],
        },
        {
          disease: "ACCES MANIAQUE",
          typesCommentsAndNatureComments: [
            "TRAITEMENT CURATIF",
            "TRAITEMENT PREVENTIF DES RECIDIVES",
            "DANS LES FORMES MODEREES",
            "DANS LES FORMES SEVERES",
            "EN CAS DE TROUBLE BIPOLAIRE",
            "CHEZ L'ADULTE",
          ],
          text: "Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I et dans la prévention de récidives d'épisodes maniaques chez l'adulte ayant présenté des épisodes à prédominance maniaques et pour qui les épisodes maniaques ont répondu à un traitement par aripiprazole (cf. rubrique \"Propriétés pharmacodynamiques\").",
          level: "AMM/INDIQUE",
          smr: null,
          cim10Codes: ["F30 (Épisode maniaque)"],
        },
        {
          disease: "ACCES MANIAQUE",
          typesCommentsAndNatureComments: [
            "TRAITEMENT CURATIF",
            "DANS LES FORMES MODEREES",
            "DANS LES FORMES SEVERES",
            "EN CAS DE TROUBLE BIPOLAIRE",
            "CHEZ L'ENFANT A PARTIR DE 13 ANS",
          ],
          text: 'Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I chez l\'adolescent âgé de 13 ans ou plus pour une durée allant jusque 12 semaines (cf. rubrique "Propriétés pharmacodynamiques").',
          level: "AMM/INDIQUE",
          smr: null,
          cim10Codes: ["F30 (Épisode maniaque)"],
        },
        {
          disease: "TROUBLE BIPOLAIRE",
          typesCommentsAndNatureComments: [
            "TRAITEMENT CURATIF",
            "DANS LES FORMES DE TYPE 1",
            "DANS LES FORMES MODEREES",
            "DANS LES FORMES SEVERES",
            "EN CAS D'EPISODE MANIAQUE",
            "CHEZ L'ENFANT A PARTIR DE 13 ANS",
          ],
          text: 'Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I chez l\'adolescent âgé de 13 ans ou plus pour une durée allant jusque 12 semaines (cf. rubrique "Propriétés pharmacodynamiques").',
          level: "AMM/INDIQUE",
          smr: null,
          cim10Codes: ["F31 (Trouble affectif bipolaire)"],
        },
      ],
      unofficialIndications: [
        {
          label: "maladie d'Alzheimer",
          references: ["23350964"],
        },
        {
          label: "démence",
          references: ["15264966", "19560726", "17508328", "16505124"],
        },
        {
          label: "troubles anxieux",
          references: [
            "18567977",
            "18399707",
            "29110139",
            "25439852",
            "21220076",
            "15602109",
          ],
        },
        {
          label: "trouble obsessionnel compulsif",
          references: [
            "28922290",
            "26375768",
            "25653829",
            "29110139",
            "27518476",
            "29040153",
            "25093799",
            "27812841",
            "27629160",
            "28786825",
          ],
        },
        {
          label: "Syndrome de Tourette",
          references: [
            "27672358",
            "28686474",
            "29154107",
            "27028456",
            "26914764",
            "25928702",
            "16684686",
            "25477724",
            "29388585",
            "26310194",
          ],
        },
        {
          label: "trouble dépressif résistant aux traitements",
          references: [
            "27274249",
            "26012350",
            "24991148",
            "16862232",
            "21220079",
            "26784490",
            "22143953",
            "26423182",
            "27438687",
          ],
        },
        {
          label: "trouble de la personnalité limite",
          references: [
            "18052583",
            "17318503",
            "20044651",
            "28145998",
            "17327963",
            "28825781",
            "16721700",
            "16648324",
            "30689305",
            "18848360",
          ],
        },
      ],
    },
    {
      form: "solution  buvable",
      dose: "1 mg/ml",
      indications: [
        {
          disease: "SCHIZOPHRENIE",
          typesCommentsAndNatureComments: ["CHEZ L'ADULTE"],
          text: "Ce médicament est indiqué dans le traitement de la schizophrénie chez les adultes et les adolescents âgés de 15 ans ou plus.",
          level: "AMM/INDIQUE",
          smr: "NIVEAU IMPORTANT",
          cim10Codes: ["F20 (Schizophrénie)"],
        },
        {
          disease: "TROUBLE BIPOLAIRE",
          typesCommentsAndNatureComments: [
            "TRAITEMENT CURATIF",
            "TRAITEMENT PREVENTIF DES RECIDIVES",
            "DANS LES FORMES DE TYPE 1",
            "DANS LES FORMES MODEREES",
            "DANS LES FORMES SEVERES",
            "EN CAS D'EPISODE MANIAQUE",
            "CHEZ L'ADULTE",
          ],
          text: "Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I et dans la prévention de récidives d'épisodes maniaques chez l'adulte ayant présenté des épisodes à prédominance maniaques et pour qui les épisodes maniaques ont répondu à un traitement par aripiprazole (Cf. rubrique \"Propriétés pharmacodynamiques\").",
          level: "AMM/INDIQUE",
          smr: "NIVEAU IMPORTANT",
          cim10Codes: ["F31 (Trouble affectif bipolaire)"],
        },
        {
          disease: "ACCES MANIAQUE",
          typesCommentsAndNatureComments: [
            "TRAITEMENT CURATIF",
            "TRAITEMENT PREVENTIF DES RECIDIVES",
            "DANS LES FORMES MODEREES",
            "DANS LES FORMES SEVERES",
            "EN CAS DE TROUBLE BIPOLAIRE",
            "CHEZ L'ADULTE",
          ],
          text: "Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I et dans la prévention de récidives d'épisodes maniaques chez l'adulte ayant présenté des épisodes à prédominance maniaques et pour qui les épisodes maniaques ont répondu à un traitement par aripiprazole (cf. rubrique \"Propriétés pharmacodynamiques\").",
          level: "AMM/INDIQUE",
          smr: "NIVEAU IMPORTANT",
          cim10Codes: ["F30 (Épisode maniaque)"],
        },
        {
          disease: "ACCES MANIAQUE",
          typesCommentsAndNatureComments: [
            "TRAITEMENT CURATIF",
            "DANS LES FORMES MODEREES",
            "DANS LES FORMES SEVERES",
            "EN CAS DE TROUBLE BIPOLAIRE",
            "CHEZ L'ENFANT A PARTIR DE 13 ANS",
          ],
          text: 'Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I chez l\'adolescent âgé de 13 ans ou plus pour une durée allant jusque 12 semaines (cf. rubrique "Propriétés pharmacodynamiques").',
          level: "AMM/INDIQUE",
          smr: "NIVEAU IMPORTANT",
          cim10Codes: ["F30 (Épisode maniaque)"],
        },
        {
          disease: "TROUBLE BIPOLAIRE",
          typesCommentsAndNatureComments: [
            "TRAITEMENT CURATIF",
            "DANS LES FORMES DE TYPE 1",
            "DANS LES FORMES MODEREES",
            "DANS LES FORMES SEVERES",
            "EN CAS D'EPISODE MANIAQUE",
            "CHEZ L'ENFANT A PARTIR DE 13 ANS",
          ],
          text: 'Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I chez l\'adolescent âgé de 13 ans ou plus pour une durée allant jusque 12 semaines (cf. rubrique "Propriétés pharmacodynamiques").',
          level: "AMM/INDIQUE",
          smr: "NIVEAU IMPORTANT",
          cim10Codes: ["F31 (Trouble affectif bipolaire)"],
        },
      ],
      unofficialIndications: [
        {
          label: "trouble obsessionnel compulsif",
          references: [
            "28922290",
            "26375768",
            "25653829",
            "29110139",
            "27518476",
            "29040153",
            "25093799",
            "27812841",
            "27629160",
            "28786825",
          ],
        },
        {
          label: "maladie d'Alzheimer",
          references: ["23350964"],
        },
        {
          label: "trouble de la personnalité limite",
          references: [
            "18052583",
            "17318503",
            "20044651",
            "28145998",
            "17327963",
            "28825781",
            "16721700",
            "16648324",
            "30689305",
            "18848360",
          ],
        },
        {
          label: "trouble dépressif résistant aux traitements",
          references: [
            "27274249",
            "26012350",
            "24991148",
            "16862232",
            "21220079",
            "26784490",
            "22143953",
            "26423182",
            "27438687",
          ],
        },
        {
          label: "démence",
          references: ["15264966", "19560726", "17508328", "16505124"],
        },
        {
          label: "troubles anxieux",
          references: [
            "18567977",
            "18399707",
            "29110139",
            "25439852",
            "21220076",
            "15602109",
          ],
        },
        {
          label: "Syndrome de Tourette",
          references: [
            "27672358",
            "28686474",
            "29154107",
            "27028456",
            "26914764",
            "25928702",
            "16684686",
            "25477724",
            "29388585",
            "26310194",
          ],
        },
      ],
    },
    {
      form: "comprimé orodispersible",
      dose: "15 mg",
      indications: [
        {
          disease: "SCHIZOPHRENIE",
          typesCommentsAndNatureComments: ["CHEZ L'ADULTE"],
          text: "Ce médicament est indiqué dans le traitement de la schizophrénie chez les adultes et les adolescents âgés de 15 ans ou plus.",
          level: "AMM/INDIQUE",
          smr: "NIVEAU IMPORTANT",
          cim10Codes: ["F20 (Schizophrénie)"],
        },
        {
          disease: "TROUBLE BIPOLAIRE",
          typesCommentsAndNatureComments: [
            "TRAITEMENT CURATIF",
            "TRAITEMENT PREVENTIF DES RECIDIVES",
            "DANS LES FORMES DE TYPE 1",
            "DANS LES FORMES MODEREES",
            "DANS LES FORMES SEVERES",
            "EN CAS D'EPISODE MANIAQUE",
            "CHEZ L'ADULTE",
          ],
          text: "Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I et dans la prévention de récidives d'épisodes maniaques chez l'adulte ayant présenté des épisodes à prédominance maniaques et pour qui les épisodes maniaques ont répondu à un traitement par aripiprazole (Cf. rubrique \"Propriétés pharmacodynamiques\").",
          level: "AMM/INDIQUE",
          smr: "NIVEAU IMPORTANT",
          cim10Codes: ["F31 (Trouble affectif bipolaire)"],
        },
        {
          disease: "ACCES MANIAQUE",
          typesCommentsAndNatureComments: [
            "TRAITEMENT CURATIF",
            "TRAITEMENT PREVENTIF DES RECIDIVES",
            "DANS LES FORMES MODEREES",
            "DANS LES FORMES SEVERES",
            "EN CAS DE TROUBLE BIPOLAIRE",
            "CHEZ L'ADULTE",
          ],
          text: "Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I et dans la prévention de récidives d'épisodes maniaques chez l'adulte ayant présenté des épisodes à prédominance maniaques et pour qui les épisodes maniaques ont répondu à un traitement par aripiprazole (cf. rubrique \"Propriétés pharmacodynamiques\").",
          level: "AMM/INDIQUE",
          smr: "NIVEAU IMPORTANT",
          cim10Codes: ["F30 (Épisode maniaque)"],
        },
        {
          disease: "ACCES MANIAQUE",
          typesCommentsAndNatureComments: [
            "TRAITEMENT CURATIF",
            "DANS LES FORMES MODEREES",
            "DANS LES FORMES SEVERES",
            "EN CAS DE TROUBLE BIPOLAIRE",
            "CHEZ L'ENFANT A PARTIR DE 13 ANS",
          ],
          text: 'Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I chez l\'adolescent âgé de 13 ans ou plus pour une durée allant jusque 12 semaines (cf. rubrique "Propriétés pharmacodynamiques").',
          level: "AMM/INDIQUE",
          smr: "NIVEAU IMPORTANT",
          cim10Codes: ["F30 (Épisode maniaque)"],
        },
        {
          disease: "TROUBLE BIPOLAIRE",
          typesCommentsAndNatureComments: [
            "TRAITEMENT CURATIF",
            "DANS LES FORMES DE TYPE 1",
            "DANS LES FORMES MODEREES",
            "DANS LES FORMES SEVERES",
            "EN CAS D'EPISODE MANIAQUE",
            "CHEZ L'ENFANT A PARTIR DE 13 ANS",
          ],
          text: 'Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I chez l\'adolescent âgé de 13 ans ou plus pour une durée allant jusque 12 semaines (cf. rubrique "Propriétés pharmacodynamiques").',
          level: "AMM/INDIQUE",
          smr: "NIVEAU IMPORTANT",
          cim10Codes: ["F31 (Trouble affectif bipolaire)"],
        },
      ],
      unofficialIndications: [
        {
          label: "trouble dépressif résistant aux traitements",
          references: [
            "27274249",
            "26012350",
            "24991148",
            "16862232",
            "21220079",
            "26784490",
            "22143953",
            "26423182",
            "27438687",
          ],
        },
        {
          label: "trouble obsessionnel compulsif",
          references: [
            "28922290",
            "26375768",
            "25653829",
            "29110139",
            "27518476",
            "29040153",
            "25093799",
            "27812841",
            "27629160",
            "28786825",
          ],
        },
        {
          label: "maladie d'Alzheimer",
          references: ["23350964"],
        },
        {
          label: "démence",
          references: ["15264966", "19560726", "17508328", "16505124"],
        },
        {
          label: "troubles anxieux",
          references: [
            "18567977",
            "18399707",
            "29110139",
            "25439852",
            "21220076",
            "15602109",
          ],
        },
        {
          label: "Syndrome de Tourette",
          references: [
            "27672358",
            "28686474",
            "29154107",
            "27028456",
            "26914764",
            "25928702",
            "16684686",
            "25477724",
            "29388585",
            "26310194",
          ],
        },
        {
          label: "trouble de la personnalité limite",
          references: [
            "18052583",
            "17318503",
            "20044651",
            "28145998",
            "17327963",
            "28825781",
            "16721700",
            "16648324",
            "30689305",
            "18848360",
          ],
        },
      ],
    },
    {
      form: "comprimé",
      dose: "15 mg",
      indications: [
        {
          disease: "SCHIZOPHRENIE",
          typesCommentsAndNatureComments: ["CHEZ L'ADULTE"],
          text: "Ce médicament est indiqué dans le traitement de la schizophrénie chez les adultes et les adolescents âgés de 15 ans ou plus.",
          level: "AMM/INDIQUE",
          smr: null,
          cim10Codes: ["F20 (Schizophrénie)"],
        },
        {
          disease: "TROUBLE BIPOLAIRE",
          typesCommentsAndNatureComments: [
            "TRAITEMENT CURATIF",
            "TRAITEMENT PREVENTIF DES RECIDIVES",
            "DANS LES FORMES DE TYPE 1",
            "DANS LES FORMES MODEREES",
            "DANS LES FORMES SEVERES",
            "EN CAS D'EPISODE MANIAQUE",
            "CHEZ L'ADULTE",
          ],
          text: "Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I et dans la prévention de récidives d'épisodes maniaques chez l'adulte ayant présenté des épisodes à prédominance maniaques et pour qui les épisodes maniaques ont répondu à un traitement par aripiprazole (Cf. rubrique \"Propriétés pharmacodynamiques\").",
          level: "AMM/INDIQUE",
          smr: null,
          cim10Codes: ["F31 (Trouble affectif bipolaire)"],
        },
        {
          disease: "ACCES MANIAQUE",
          typesCommentsAndNatureComments: [
            "TRAITEMENT CURATIF",
            "TRAITEMENT PREVENTIF DES RECIDIVES",
            "DANS LES FORMES MODEREES",
            "DANS LES FORMES SEVERES",
            "EN CAS DE TROUBLE BIPOLAIRE",
            "CHEZ L'ADULTE",
          ],
          text: "Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I et dans la prévention de récidives d'épisodes maniaques chez l'adulte ayant présenté des épisodes à prédominance maniaques et pour qui les épisodes maniaques ont répondu à un traitement par aripiprazole (cf. rubrique \"Propriétés pharmacodynamiques\").",
          level: "AMM/INDIQUE",
          smr: null,
          cim10Codes: ["F30 (Épisode maniaque)"],
        },
        {
          disease: "ACCES MANIAQUE",
          typesCommentsAndNatureComments: [
            "TRAITEMENT CURATIF",
            "DANS LES FORMES MODEREES",
            "DANS LES FORMES SEVERES",
            "EN CAS DE TROUBLE BIPOLAIRE",
            "CHEZ L'ENFANT A PARTIR DE 13 ANS",
          ],
          text: 'Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I chez l\'adolescent âgé de 13 ans ou plus pour une durée allant jusque 12 semaines (cf. rubrique "Propriétés pharmacodynamiques").',
          level: "AMM/INDIQUE",
          smr: null,
          cim10Codes: ["F30 (Épisode maniaque)"],
        },
        {
          disease: "TROUBLE BIPOLAIRE",
          typesCommentsAndNatureComments: [
            "TRAITEMENT CURATIF",
            "DANS LES FORMES DE TYPE 1",
            "DANS LES FORMES MODEREES",
            "DANS LES FORMES SEVERES",
            "EN CAS D'EPISODE MANIAQUE",
            "CHEZ L'ENFANT A PARTIR DE 13 ANS",
          ],
          text: 'Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I chez l\'adolescent âgé de 13 ans ou plus pour une durée allant jusque 12 semaines (cf. rubrique "Propriétés pharmacodynamiques").',
          level: "AMM/INDIQUE",
          smr: null,
          cim10Codes: ["F31 (Trouble affectif bipolaire)"],
        },
      ],
      unofficialIndications: [
        {
          label: "troubles anxieux",
          references: [
            "18567977",
            "18399707",
            "29110139",
            "25439852",
            "21220076",
            "15602109",
          ],
        },
        {
          label: "trouble de la personnalité limite",
          references: [
            "18052583",
            "17318503",
            "20044651",
            "28145998",
            "17327963",
            "28825781",
            "16721700",
            "16648324",
            "30689305",
            "18848360",
          ],
        },
        {
          label: "maladie d'Alzheimer",
          references: ["23350964"],
        },
        {
          label: "trouble dépressif résistant aux traitements",
          references: [
            "27274249",
            "26012350",
            "24991148",
            "16862232",
            "21220079",
            "26784490",
            "22143953",
            "26423182",
            "27438687",
          ],
        },
        {
          label: "démence",
          references: ["15264966", "19560726", "17508328", "16505124"],
        },
        {
          label: "Syndrome de Tourette",
          references: [
            "27672358",
            "28686474",
            "29154107",
            "27028456",
            "26914764",
            "25928702",
            "16684686",
            "25477724",
            "29388585",
            "26310194",
          ],
        },
        {
          label: "trouble obsessionnel compulsif",
          references: [
            "28922290",
            "26375768",
            "25653829",
            "29110139",
            "27518476",
            "29040153",
            "25093799",
            "27812841",
            "27629160",
            "28786825",
          ],
        },
      ],
    },
    {
      form: "comprimé orodispersible",
      dose: "10 mg",
      indications: [
        {
          disease: "SCHIZOPHRENIE",
          typesCommentsAndNatureComments: ["CHEZ L'ADULTE"],
          text: "Ce médicament est indiqué dans le traitement de la schizophrénie chez les adultes et les adolescents âgés de 15 ans ou plus.",
          level: "AMM/INDIQUE",
          smr: "NIVEAU IMPORTANT",
          cim10Codes: ["F20 (Schizophrénie)"],
        },
        {
          disease: "TROUBLE BIPOLAIRE",
          typesCommentsAndNatureComments: [
            "TRAITEMENT CURATIF",
            "TRAITEMENT PREVENTIF DES RECIDIVES",
            "DANS LES FORMES DE TYPE 1",
            "DANS LES FORMES MODEREES",
            "DANS LES FORMES SEVERES",
            "EN CAS D'EPISODE MANIAQUE",
            "CHEZ L'ADULTE",
          ],
          text: "Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I et dans la prévention de récidives d'épisodes maniaques chez l'adulte ayant présenté des épisodes à prédominance maniaques et pour qui les épisodes maniaques ont répondu à un traitement par aripiprazole (Cf. rubrique \"Propriétés pharmacodynamiques\").",
          level: "AMM/INDIQUE",
          smr: "NIVEAU IMPORTANT",
          cim10Codes: ["F31 (Trouble affectif bipolaire)"],
        },
        {
          disease: "ACCES MANIAQUE",
          typesCommentsAndNatureComments: [
            "TRAITEMENT CURATIF",
            "TRAITEMENT PREVENTIF DES RECIDIVES",
            "DANS LES FORMES MODEREES",
            "DANS LES FORMES SEVERES",
            "EN CAS DE TROUBLE BIPOLAIRE",
            "CHEZ L'ADULTE",
          ],
          text: "Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I et dans la prévention de récidives d'épisodes maniaques chez l'adulte ayant présenté des épisodes à prédominance maniaques et pour qui les épisodes maniaques ont répondu à un traitement par aripiprazole (cf. rubrique \"Propriétés pharmacodynamiques\").",
          level: "AMM/INDIQUE",
          smr: "NIVEAU IMPORTANT",
          cim10Codes: ["F30 (Épisode maniaque)"],
        },
        {
          disease: "ACCES MANIAQUE",
          typesCommentsAndNatureComments: [
            "TRAITEMENT CURATIF",
            "DANS LES FORMES MODEREES",
            "DANS LES FORMES SEVERES",
            "EN CAS DE TROUBLE BIPOLAIRE",
            "CHEZ L'ENFANT A PARTIR DE 13 ANS",
          ],
          text: 'Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I chez l\'adolescent âgé de 13 ans ou plus pour une durée allant jusque 12 semaines (cf. rubrique "Propriétés pharmacodynamiques").',
          level: "AMM/INDIQUE",
          smr: "NIVEAU IMPORTANT",
          cim10Codes: ["F30 (Épisode maniaque)"],
        },
        {
          disease: "TROUBLE BIPOLAIRE",
          typesCommentsAndNatureComments: [
            "TRAITEMENT CURATIF",
            "DANS LES FORMES DE TYPE 1",
            "DANS LES FORMES MODEREES",
            "DANS LES FORMES SEVERES",
            "EN CAS D'EPISODE MANIAQUE",
            "CHEZ L'ENFANT A PARTIR DE 13 ANS",
          ],
          text: 'Ce médicament est indiqué dans le traitement des épisodes maniaques modérés à sévères des troubles bipolaires de type I chez l\'adolescent âgé de 13 ans ou plus pour une durée allant jusque 12 semaines (cf. rubrique "Propriétés pharmacodynamiques").',
          level: "AMM/INDIQUE",
          smr: "NIVEAU IMPORTANT",
          cim10Codes: ["F31 (Trouble affectif bipolaire)"],
        },
      ],
      unofficialIndications: [
        {
          label: "Syndrome de Tourette",
          references: [
            "27672358",
            "28686474",
            "29154107",
            "27028456",
            "26914764",
            "25928702",
            "16684686",
            "25477724",
            "29388585",
            "26310194",
          ],
        },
        {
          label: "trouble de la personnalité limite",
          references: [
            "18052583",
            "17318503",
            "20044651",
            "28145998",
            "17327963",
            "28825781",
            "16721700",
            "16648324",
            "30689305",
            "18848360",
          ],
        },
        {
          label: "démence",
          references: ["15264966", "19560726", "17508328", "16505124"],
        },
        {
          label: "troubles anxieux",
          references: [
            "18567977",
            "18399707",
            "29110139",
            "25439852",
            "21220076",
            "15602109",
          ],
        },
        {
          label: "maladie d'Alzheimer",
          references: ["23350964"],
        },
        {
          label: "trouble dépressif résistant aux traitements",
          references: [
            "27274249",
            "26012350",
            "24991148",
            "16862232",
            "21220079",
            "26784490",
            "22143953",
            "26423182",
            "27438687",
          ],
        },
        {
          label: "trouble obsessionnel compulsif",
          references: [
            "28922290",
            "26375768",
            "25653829",
            "29110139",
            "27518476",
            "29040153",
            "25093799",
            "27812841",
            "27629160",
            "28786825",
          ],
        },
      ],
    },
    {
      form: "solution injectable",
      dose: "7,5 mg/ml",
      indications: [
        {
          disease: "AGITATION",
          typesCommentsAndNatureComments: [
            "TRAITEMENT DE COURTE DUREE",
            "CHEZ L'ADULTE",
            "EN CAS DE SCHIZOPHRENIE",
            "EN CAS DE TROUBLE BIPOLAIRE",
            "EN CAS D'EPISODE MANIAQUE",
          ],
          text: "Ce médicament est indiqué pour contrôler rapidement l'agitation et les troubles du comportement chez les patients adultes schizophrènes ou présentant un épisode maniaque dans le cadre d'un trouble bipolaire de type I, lorsque le traitement par voie orale n'est pas adapté. \r\n\r\nLe traitement par aripiprazole solution injectable doit être arrêté et remplacé par l'aripiprazole par voie orale dès que l'état clinique du patient le permet.",
          level: "AMM/INDIQUE",
          smr: "NIVEAU IMPORTANT",
          cim10Codes: ["R451 (Agitation)"],
        },
        {
          disease: "TROUBLE DU COMPORTEMENT",
          typesCommentsAndNatureComments: [
            "TRAITEMENT DE COURTE DUREE",
            "EN CAS DE SCHIZOPHRENIE",
            "EN CAS DE TROUBLE BIPOLAIRE",
            "EN CAS D'EPISODE MANIAQUE",
            "CHEZ L'ADULTE",
          ],
          text: "Ce médicament est indiqué pour contrôler rapidement l'agitation et les troubles du comportement chez les patients adultes schizophrènes ou présentant un épisode maniaque dans le cadre d'un trouble bipolaire de type I, lorsque le traitement par voie orale n'est pas adapté. \r\n\r\nLe traitement par aripiprazole solution injectable doit être arrêté et remplacé par l'aripiprazole par voie orale dès que l'état clinique du patient le permet.",
          level: "AMM/INDIQUE",
          smr: "NIVEAU IMPORTANT",
          cim10Codes: [
            "F00-F09 (troubles mentaux organiques, y compris les troubles symtomatiques)",
            "F10-F19 (Troubles mentaux et du comportement liés à l'utilisation de substances psycho-actives)",
            "F20-F29 (schizophrénie, trouble schizotypique et troubles délirants)",
            "F30-F39 (troubles de l'humeur (affectifs))",
            "F40-F48 (troubles névrotiques, troubles liés à des facteurs de stress et troubles somatoformes)",
            "F50-F59 (syndromes comportementaux associés à des perturbations physiologiques et à des facteurs physiques)",
            "F60-F69 (troubles de la personnalité et du comportement chez l'adulte)",
            "F70-F79 (retard mental)",
            "F80-F89 (troubles du développement psychologique)",
            "F90-F98 (troubles du comportement et troubles émotionnels apparaissant habituellement durant l'enfance et l'adolescence)",
            "F99 (Trouble mental, sans autre indication)",
          ],
        },
        {
          disease: "SCHIZOPHRENIE",
          typesCommentsAndNatureComments: [
            "TRAITEMENT DE COURTE DUREE",
            "AVEC AGITATION",
            "CHEZ L'ADULTE",
          ],
          text: "Ce médicament est indiqué pour contrôler rapidement l'agitation et les troubles du comportement chez les patients adultes schizophrènes, lorsque le traitement par voie orale n'est pas adapté. \r\n\r\nLe traitement par aripiprazole solution injectable doit être arrêté et remplacé par l'aripiprazole par voie orale dès que l'état clinique du patient le permet.",
          level: "AMM/INDIQUE",
          smr: "NIVEAU IMPORTANT",
          cim10Codes: ["F20 (Schizophrénie)"],
        },
        {
          disease: "ETAT D'EXCITATION MANIAQUE",
          typesCommentsAndNatureComments: [
            "TRAITEMENT DE COURTE DUREE",
            "EN CAS DE TROUBLE BIPOLAIRE",
            "CHEZ L'ADULTE",
          ],
          text: "Ce médicament est indiqué pour contrôler rapidement l'agitation et les troubles du comportement chez les patients adultes présentant un épisode maniaque dans le cadre d'un trouble bipolaire de type I, lorsque le traitement par voie orale n'est pas adapté. \r\n\r\nLe traitement par aripiprazole solution injectable doit être arrêté et remplacé par l'aripiprazole par voie orale dès que l'état clinique du patient le permet.",
          level: "AMM/INDIQUE",
          smr: "NIVEAU IMPORTANT",
          cim10Codes: ["F302 (Manie avec symptômes psychotiques)"],
        },
      ],
      unofficialIndications: [
        {
          label: "trouble dépressif résistant aux traitements",
          references: [
            "27274249",
            "26012350",
            "24991148",
            "16862232",
            "21220079",
            "26784490",
            "22143953",
            "26423182",
            "27438687",
          ],
        },
        {
          label: "maladie d'Alzheimer",
          references: ["23350964"],
        },
        {
          label: "trouble obsessionnel compulsif",
          references: [
            "28922290",
            "26375768",
            "25653829",
            "29110139",
            "27518476",
            "29040153",
            "25093799",
            "27812841",
            "27629160",
            "28786825",
          ],
        },
        {
          label: "troubles anxieux",
          references: [
            "18567977",
            "18399707",
            "29110139",
            "25439852",
            "21220076",
            "15602109",
          ],
        },
        {
          label: "Syndrome de Tourette",
          references: [
            "27672358",
            "28686474",
            "29154107",
            "27028456",
            "26914764",
            "25928702",
            "16684686",
            "25477724",
            "29388585",
            "26310194",
          ],
        },
        {
          label: "démence",
          references: ["15264966", "19560726", "17508328", "16505124"],
        },
        {
          label: "trouble de la personnalité limite",
          references: [
            "18052583",
            "17318503",
            "20044651",
            "28145998",
            "17327963",
            "28825781",
            "16721700",
            "16648324",
            "30689305",
            "18848360",
          ],
        },
      ],
    },
  ];

export const mockDolipraneContraindicationsDTOResponse: DTOContraindicationsResponse =
  {
    drugs: [
      {
        dose: "1000 mg",
        form: "poudre pour solution buvable",
        contraindications: [
          {
            label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: [
              "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
              "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
              "HYPERSENSIBILITE FRUCTOSE (INTOLERANCE)",
              "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
              "HYPERSENSIBILITE SACCHAROSE (INTOLERANCE)",
            ],
            other_comment: [
              "TENIR COMPTE PRESENCE SACCHAROSE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "INTOLERANCE GENETIQUE AU FRUCTOSE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "TENIR COMPTE PRESENCE SACCHAROSE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "DEFICIT EN SUCRASE-ISOMALTASE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "TENIR COMPTE PRESENCE SACCHAROSE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: [
              "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
              "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
              "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
            ],
            other_comment: [
              "TENIR COMPTE PRESENCE GLUCOSE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du glucose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) d'une intolérance à certains sucres, contactez-le avant de prendre ce médicament.\r\n\r\n- Commentaire :\r\nProposition de RCP : Les patients présentant un syndrome de malabsorption du glucose et du galactose\r\n(maladie héréditaire rare) ne doivent pas prendre ce médicament.\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "QUEL QUE SOIT LE TERRAIN",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "TENIR COMPTE PRESENCE SACCHAROSE",
              "Cf. COMPOSITION",
              "RISQUE DE SURDOSAGE",
              "HEPATOTOXICITE",
              "PRESENCE D'EXCIPIENT(S) A EFFET NOTOIRE",
            ],
            text: null,
          },
          {
            label: "MUCOVISCIDOSE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HEPATITE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["HEPATITE AIGUE"],
            other_comment: [
              "ARRETER LE TRAITEMENT",
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
            ],
            text: [
              "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
            ],
          },
          {
            label: "HEPATITE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["HEPATITE CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
            other_comment: null,
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: [
              "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
              "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
            ],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INFECTION VIH",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DESHYDRATATION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HYPOVOLEMIE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "RISQUE D'ANEMIE",
              "RISQUE D'HEMOLYSE",
            ],
            text: null,
          },
          {
            label: "SYNDROME DE GILBERT",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DENUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "AMAIGRISSEMENT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "MALNUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["MALNUTRITION CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ALCOOLISME CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "SEVRAGE ALCOOLIQUE SYNDROME",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SEVRAGE ALCOOLIQUE"],
            other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
            text: null,
          },
          {
            label: "ANOREXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE RENALE CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["INSUFFISANCE RENALE SEVERE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. PROPRIETES PHARMACOCINETIQUES",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INTERACTION D'ORIGINE ALIMENTAIRE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: ["INGESTION D'ALCOOL"],
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "RISQUE D'ATTEINTE HEPATIQUE",
            ],
            text: [
              "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
            ],
          },
          {
            label: "JEUNE STRICT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "CACHEXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "EXAMEN LABORATOIRE INTERFERENCE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
            other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
            text: [
              "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
            ],
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "UTILISER AVEC PRUDENCE",
              "EN CAS DE POSOLOGIE ELEVEE",
              "RISQUE D'HEMOLYSE",
              "REFERENTIEL ANSM G6PD 13/06/2014",
            ],
            text: [
              "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
            ],
          },
          {
            label: "PATIENT DE FAIBLE POIDS",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["PATIENT DE MOINS DE 50 KG"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ENFANT",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["ENFANT DE MOINS DE 50 KG"],
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'adulte et à l'enfant à partir de 50 kg (soit à partir d'environ 15 ans).",
            ],
          },
          {
            label: "NOURRISSON",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
              "RISQUE DE FAUSSE ROUTE",
              "FORME GALENIQUE INADAPTEE A CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'adulte et à l'enfant à partir de 50 kg (soit à partir d'environ 15 ans).",
            ],
          },
          {
            label: "NOUVEAU-NE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
              "RISQUE DE FAUSSE ROUTE",
              "FORME GALENIQUE INADAPTEE A CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'adulte et à l'enfant à partir de 50 kg (soit à partir d'environ 15 ans).",
            ],
          },
          {
            label: "SUJET AGE",
            level: ["PAS DE PRECAUTION D'EMPLOI"],
            comment: ["SUJET AGE DE PLUS DE 75 ANS"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "SUJET AGE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SUJET POLYPATHOLOGIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
        ],
      },
      {
        dose: "500 mg",
        form: "poudre pour solution buvable",
        contraindications: [
          {
            label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: [
              "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
              "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
              "HYPERSENSIBILITE FRUCTOSE (INTOLERANCE)",
              "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
              "HYPERSENSIBILITE SACCHAROSE (INTOLERANCE)",
            ],
            other_comment: [
              "TENIR COMPTE PRESENCE SACCHAROSE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "INTOLERANCE GENETIQUE AU FRUCTOSE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "TENIR COMPTE PRESENCE SACCHAROSE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "DEFICIT EN SUCRASE-ISOMALTASE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "TENIR COMPTE PRESENCE SACCHAROSE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: [
              "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
              "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
              "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
            ],
            other_comment: [
              "TENIR COMPTE PRESENCE GLUCOSE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du glucose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) d'une intolérance à certains sucres, contactez-le avant de prendre ce médicament.\r\n\r\n- Commentaire :\r\nProposition de RCP : Les patients présentant un syndrome de malabsorption du glucose et du galactose\r\n(maladie héréditaire rare) ne doivent pas prendre ce médicament.\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "QUEL QUE SOIT LE TERRAIN",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "TENIR COMPTE PRESENCE SACCHAROSE",
              "Cf. COMPOSITION",
              "RISQUE DE SURDOSAGE",
              "HEPATOTOXICITE",
              "PRESENCE D'EXCIPIENT(S) A EFFET NOTOIRE",
            ],
            text: null,
          },
          {
            label: "MUCOVISCIDOSE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HEPATITE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["HEPATITE AIGUE"],
            other_comment: [
              "ARRETER LE TRAITEMENT",
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
            ],
            text: [
              "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
            ],
          },
          {
            label: "HEPATITE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["HEPATITE CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
            other_comment: null,
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: [
              "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
              "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
            ],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INFECTION VIH",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DESHYDRATATION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HYPOVOLEMIE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "RISQUE D'ANEMIE",
              "RISQUE D'HEMOLYSE",
            ],
            text: null,
          },
          {
            label: "SYNDROME DE GILBERT",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DENUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "AMAIGRISSEMENT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "MALNUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["MALNUTRITION CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ALCOOLISME CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "SEVRAGE ALCOOLIQUE SYNDROME",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SEVRAGE ALCOOLIQUE"],
            other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
            text: null,
          },
          {
            label: "ANOREXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE RENALE CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["INSUFFISANCE RENALE SEVERE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. PROPRIETES PHARMACOCINETIQUES",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INTERACTION D'ORIGINE ALIMENTAIRE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: ["INGESTION D'ALCOOL"],
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "RISQUE D'ATTEINTE HEPATIQUE",
            ],
            text: [
              "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
            ],
          },
          {
            label: "JEUNE STRICT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "CACHEXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "EXAMEN LABORATOIRE INTERFERENCE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
            other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
            text: [
              "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
            ],
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "UTILISER AVEC PRUDENCE",
              "EN CAS DE POSOLOGIE ELEVEE",
              "RISQUE D'HEMOLYSE",
              "REFERENTIEL ANSM G6PD 13/06/2014",
            ],
            text: [
              "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
            ],
          },
          {
            label: "PATIENT DE FAIBLE POIDS",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["PATIENT DE MOINS DE 50 KG"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ENFANT",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["ENFANT DE MOINS DE 27 KG"],
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'adulte et l'enfant à partir de 27 kg (à partir d'environ 8 ans).",
            ],
          },
          {
            label: "ENFANT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["ENFANT DE MOINS DE 50 KG", "ENFANT DE PLUS DE 26 KG"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "ADAPTER LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "NOURRISSON",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'adulte et l'enfant à partir de 27 kg (à partir d'environ 8 ans).",
            ],
          },
          {
            label: "NOUVEAU-NE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'adulte et l'enfant à partir de 27 kg (à partir d'environ 8 ans).",
            ],
          },
          {
            label: "SUJET AGE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SUJET AGE DE PLUS DE 75 ANS"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: [
              "La dose journalière efficace la plus faible possible doit être envisagée, sans excéder 60 mg/kg/jour (sans dépasser 3 g/jour) dans les situations suivantes : [...]\r\n- sujet âgé de plus de 75 ans.",
            ],
          },
          {
            label: "SUJET AGE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SUJET POLYPATHOLOGIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: [
              "La dose journalière efficace la plus faible possible doit être envisagée, sans excéder 60 mg/kg/jour (sans dépasser 3 g/jour) dans les situations suivantes : [...]\r\n- sujet âgé de plus de 65 ans et polypathologique.",
            ],
          },
        ],
      },
      {
        dose: "100 mg",
        form: "poudre pour solution buvable",
        contraindications: [
          {
            label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: [
              "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
              "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
              "HYPERSENSIBILITE FRUCTOSE (INTOLERANCE)",
              "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
              "HYPERSENSIBILITE SACCHAROSE (INTOLERANCE)",
            ],
            other_comment: [
              "TENIR COMPTE PRESENCE SACCHAROSE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "INTOLERANCE GENETIQUE AU FRUCTOSE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "TENIR COMPTE PRESENCE SACCHAROSE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "DEFICIT EN SUCRASE-ISOMALTASE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "TENIR COMPTE PRESENCE SACCHAROSE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: [
              "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
              "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
              "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
            ],
            other_comment: [
              "TENIR COMPTE PRESENCE GLUCOSE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du glucose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) d'une intolérance à certains sucres, contactez-le avant de prendre ce médicament.\r\n\r\n- Commentaire :\r\nProposition de RCP : Les patients présentant un syndrome de malabsorption du glucose et du galactose\r\n(maladie héréditaire rare) ne doivent pas prendre ce médicament.\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "QUEL QUE SOIT LE TERRAIN",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "TENIR COMPTE PRESENCE SACCHAROSE",
              "Cf. COMPOSITION",
              "RISQUE DE SURDOSAGE",
              "HEPATOTOXICITE",
              "PRESENCE D'EXCIPIENT(S) A EFFET NOTOIRE",
            ],
            text: null,
          },
          {
            label: "MUCOVISCIDOSE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HEPATITE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["HEPATITE AIGUE"],
            other_comment: [
              "ARRETER LE TRAITEMENT",
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
            ],
            text: [
              "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
            ],
          },
          {
            label: "HEPATITE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["HEPATITE CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
            other_comment: null,
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: [
              "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
              "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
            ],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INFECTION VIH",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DESHYDRATATION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HYPOVOLEMIE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "RISQUE D'ANEMIE",
              "RISQUE D'HEMOLYSE",
            ],
            text: null,
          },
          {
            label: "SYNDROME DE GILBERT",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DENUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "AMAIGRISSEMENT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "MALNUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["MALNUTRITION CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ALCOOLISME CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "SEVRAGE ALCOOLIQUE SYNDROME",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SEVRAGE ALCOOLIQUE"],
            other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
            text: null,
          },
          {
            label: "ANOREXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE RENALE CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["INSUFFISANCE RENALE SEVERE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. PROPRIETES PHARMACOCINETIQUES",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INTERACTION D'ORIGINE ALIMENTAIRE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: ["INGESTION D'ALCOOL"],
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "RISQUE D'ATTEINTE HEPATIQUE",
            ],
            text: [
              "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
            ],
          },
          {
            label: "JEUNE STRICT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "CACHEXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "EXAMEN LABORATOIRE INTERFERENCE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
            other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
            text: [
              "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
            ],
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "UTILISER AVEC PRUDENCE",
              "EN CAS DE POSOLOGIE ELEVEE",
              "RISQUE D'HEMOLYSE",
              "REFERENTIEL ANSM G6PD 13/06/2014",
            ],
            text: [
              "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
            ],
          },
          {
            label: "ENFANT",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["ENFANT DE PLUS DE 20 KG"],
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant de 6 à 20 kg (soit environ de 3 mois à 7 ans).",
            ],
          },
          {
            label: "NOURRISSON",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["NOURRISSON DE MOINS DE 6 KG"],
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant de 6 à 20 kg (soit environ de 3 mois à 7 ans).",
            ],
          },
          {
            label: "NOUVEAU-NE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant de 6 à 20 kg (soit environ de 3 mois à 7 ans).",
            ],
          },
          {
            label: "SUJET AGE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: null,
          },
          {
            label: "ADULTE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant de 6 à 20 kg (soit environ de 3 mois à 7 ans).",
            ],
          },
        ],
      },
      {
        dose: "1000 mg",
        form: "comprimé effervescent",
        contraindications: [
          {
            label: "REGIME HYPOSODE STRICT",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "TENIR COMPTE PRESENCE SODIUM",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du sodium comme excipient.\r\n\r\n* Voie d'administration : Orale et parentérale\r\n\r\n- Seuil : > ou = 1 mmol (23 mg) par \"dose administrée\"\r\n\r\n- Information pour la notice \r\nCe médicament contient x mg de sodium (composant principal du sel de cuisine/table) par <dose><volume unitaire>. Cela équivaut à y% de l'apport alimentaire quotidien maximal recommandé de sodium pour un adulte.\r\n\r\n- Commentaires\r\nEn cas d'administration parentérale à dosage variable (par exemple, en fonction du poids), la teneur en sodium\r\npeut être exprimée en mg par flacon.\r\nLibellé proposé pour le RCP : \"Ce médicament contient x mg de sodium par <dose>, ce qui équivaut à y% de l'apport alimentaire quotidien maximal recommandé par l'OMS de 2 g de sodium par adulte.\"\r\n\r\n\r\n* Voie d'administration : Orale et parentérale\r\n\r\n- Seuil : 17 mmol (391 mg) à la dose quotidienne maximale\r\n\r\n- Information pour la notice \r\nParlez-en à votre médecin ou votre pharmacien si vous avez besoin de <Z> ou de plus de <dose> quotidiennement pendant une période prolongée, surtout si vous devez suivre un régime à faible teneur en sel (sodium).\r\n\r\n- Commentaires\r\nCeci s'applique uniquement aux produits pour lesquels la posologie indiquée permet une prise quotidienne pendant\r\nplus d'un mois ou une utilisation répétée de plus de deux jours par semaine.\r\n17 mmol (391 mg) représente environ 20% de l'apport alimentaire quotidien maximal adulte recommandé par\r\nl'OMS de 2 g de sodium et est considéré comme un dosage \"élevé\". Ceci vaut également pour les enfants, pour lesquels l'apport quotidien maximal est censé être proportionnel à celui des adultes et calculé selon les besoins\r\nénergétiques.\r\n<Doses Z> reflète le nombre minimum de doses pour lesquelles le seuil de 17 mmol (391 mg) de sodium est\r\natteint/dépassé. Arrondir au nombre entier le plus proche.\r\nPour le libellé du RCP, veuillez vous reporter à la recommandation du PRAC: \"1.3. Sodium-containing effervescent, dispersible and soluble medicines – Cardiovascular events\" (EMA/PRAC/234960/2015).\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "EPILEPSIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: ["EPILEPSIE ANTECEDENT PERSONNEL"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "TENIR COMPTE PRESENCE TERPENE",
              "ABAISSEMENT SEUIL EPILEPTOGENE",
              "LIE A EXCIPIENT",
            ],
            text: [
              "Ce médicament contient des dérivés terpéniques, comme excipient, qui peuvent abaisser le seuil épileptogène.  ",
            ],
          },
          {
            label: "ENFANT",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "TENIR COMPTE PRESENCE TERPENE",
              "RISQUE DE NEUROTOXICITE",
              "ABAISSEMENT SEUIL EPILEPTOGENE",
              "LIE A EXCIPIENT",
            ],
            text: [
              "Ce médicament contient des dérivés terpéniques, comme excipient, qui peuvent abaisser le seuil épileptogène.\r\n\r\nEn raison de la présence de dérivés terpéniques dans la composition et en cas de non respect des doses préconisées, un risque de convulsion existe chez l'enfant et le nourrisson.\r\n\r\nPour ces raisons entre autres, certains de ces médicaments contenant des dérivés terpéniques peuvent être réservés à l'adulte.",
            ],
          },
          {
            label: "NOURRISSON",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "TENIR COMPTE PRESENCE TERPENE",
              "RISQUE DE NEUROTOXICITE",
              "ABAISSEMENT SEUIL EPILEPTOGENE",
              "LIE A EXCIPIENT",
            ],
            text: [
              "Ce médicament contient des dérivés terpéniques, comme excipient, qui peuvent abaisser le seuil épileptogène.\r\n\r\nEn raison de la présence de dérivés terpéniques dans la composition et en cas de non respect des doses préconisées, un risque de convulsion existe chez l'enfant et le nourrisson.\r\n\r\nPour ces raisons entre autres, certains de ces médicaments contenant des dérivés terpéniques peuvent être réservés à l'adulte.",
            ],
          },
          {
            label: "NOUVEAU-NE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "TENIR COMPTE PRESENCE TERPENE",
              "RISQUE DE NEUROTOXICITE",
              "ABAISSEMENT SEUIL EPILEPTOGENE",
              "LIE A EXCIPIENT",
            ],
            text: [
              "Ce médicament contient des dérivés terpéniques, comme excipient, qui peuvent abaisser le seuil épileptogène.\r\n\r\nEn raison de la présence de dérivés terpéniques dans la composition et en cas de non respect des doses préconisées, un risque de convulsion existe chez l'enfant et le nourrisson.\r\n\r\nPour ces raisons entre autres, certains de ces médicaments contenant des dérivés terpéniques peuvent être réservés à l'adulte.",
            ],
          },
          {
            label: "ALLAITEMENT",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISATION A EVITER",
              "TENIR COMPTE PRESENCE TERPENE",
              "PAS D'ETUDE DANS L'ESPECE HUMAINE",
              "RISQUE DE NEUROTOXICITE",
              "Cf. GROSSESSE ET ALLAITEMENT",
              "LIE A EXCIPIENT",
            ],
            text: [
              "Ce médicament contient des dérivés terpéniques comme excipient.\r\n\r\nEn cas d'allaitement, il est préférable de ne pas utiliser ce médicament du fait de l'absence de donnée cinétique sur le passage des dérivés terpéniques dans le lait et de leur toxicité neurologique potentielle chez le nourrisson.",
            ],
          },
          {
            label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: [
              "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
              "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
              "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
            ],
            other_comment: [
              "TENIR COMPTE PRESENCE GLUCOSE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du glucose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) d'une intolérance à certains sucres, contactez-le avant de prendre ce médicament.\r\n\r\n- Commentaire :\r\nProposition de RCP : Les patients présentant un syndrome de malabsorption du glucose et du galactose\r\n(maladie héréditaire rare) ne doivent pas prendre ce médicament.\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "EPILEPSIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "TENIR COMPTE PRESENCE TERPENE",
              "ABAISSEMENT SEUIL EPILEPTOGENE",
              "LIE A EXCIPIENT",
            ],
            text: [
              "Ce médicament contient des dérivés terpéniques, comme excipient, qui peuvent abaisser le seuil épileptogène.  ",
            ],
          },
          {
            label: "QUEL QUE SOIT LE TERRAIN",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "TENIR COMPTE PRESENCE MALTOSE DEXTRINE",
              "TENIR COMPTE PRESENCE SODIUM",
              "RISQUE DE SURDOSAGE",
              "HEPATOTOXICITE",
              "PRESENCE D'EXCIPIENT(S) A EFFET NOTOIRE",
            ],
            text: null,
          },
          {
            label: "MUCOVISCIDOSE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HEPATITE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["HEPATITE AIGUE"],
            other_comment: [
              "ARRETER LE TRAITEMENT",
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
            ],
            text: [
              "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
            ],
          },
          {
            label: "HEPATITE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["HEPATITE CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
            other_comment: null,
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: [
              "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
              "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
            ],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INFECTION VIH",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DESHYDRATATION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HYPOVOLEMIE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "RISQUE D'ANEMIE",
              "RISQUE D'HEMOLYSE",
            ],
            text: null,
          },
          {
            label: "SYNDROME DE GILBERT",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DENUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "AMAIGRISSEMENT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "MALNUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["MALNUTRITION CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ALCOOLISME CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "SEVRAGE ALCOOLIQUE SYNDROME",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SEVRAGE ALCOOLIQUE"],
            other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
            text: null,
          },
          {
            label: "ANOREXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE RENALE CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["INSUFFISANCE RENALE SEVERE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. PROPRIETES PHARMACOCINETIQUES",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INTERACTION D'ORIGINE ALIMENTAIRE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: ["INGESTION D'ALCOOL"],
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "RISQUE D'ATTEINTE HEPATIQUE",
            ],
            text: [
              "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
            ],
          },
          {
            label: "JEUNE STRICT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "CACHEXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "EXAMEN LABORATOIRE INTERFERENCE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
            other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
            text: [
              "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
            ],
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "UTILISER AVEC PRUDENCE",
              "EN CAS DE POSOLOGIE ELEVEE",
              "RISQUE D'HEMOLYSE",
              "REFERENTIEL ANSM G6PD 13/06/2014",
            ],
            text: [
              "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
            ],
          },
          {
            label: "PATIENT DE FAIBLE POIDS",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["PATIENT DE MOINS DE 50 KG"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ENFANT",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["ENFANT DE MOINS DE 50 KG"],
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'adulte et à l'enfant à partir de 50 kg (soit à partir d'environ 15 ans).",
            ],
          },
          {
            label: "NOURRISSON",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
              "RISQUE DE FAUSSE ROUTE",
              "FORME GALENIQUE INADAPTEE A CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'adulte et à l'enfant à partir de 50 kg (soit à partir d'environ 15 ans).",
            ],
          },
          {
            label: "NOUVEAU-NE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
              "RISQUE DE FAUSSE ROUTE",
              "FORME GALENIQUE INADAPTEE A CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'adulte et à l'enfant à partir de 50 kg (soit à partir d'environ 15 ans).",
            ],
          },
          {
            label: "SUJET AGE",
            level: ["PAS DE PRECAUTION D'EMPLOI"],
            comment: ["SUJET AGE DE PLUS DE 75 ANS"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "SUJET AGE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SUJET POLYPATHOLOGIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
        ],
      },
      {
        dose: "200 mg",
        form: "poudre pour solution buvable",
        contraindications: [
          {
            label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: [
              "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
              "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
              "HYPERSENSIBILITE FRUCTOSE (INTOLERANCE)",
              "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
              "HYPERSENSIBILITE SACCHAROSE (INTOLERANCE)",
            ],
            other_comment: [
              "TENIR COMPTE PRESENCE SACCHAROSE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "INTOLERANCE GENETIQUE AU FRUCTOSE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "TENIR COMPTE PRESENCE SACCHAROSE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "DEFICIT EN SUCRASE-ISOMALTASE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "TENIR COMPTE PRESENCE SACCHAROSE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: [
              "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
              "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
              "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
            ],
            other_comment: [
              "TENIR COMPTE PRESENCE GLUCOSE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du glucose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) d'une intolérance à certains sucres, contactez-le avant de prendre ce médicament.\r\n\r\n- Commentaire :\r\nProposition de RCP : Les patients présentant un syndrome de malabsorption du glucose et du galactose\r\n(maladie héréditaire rare) ne doivent pas prendre ce médicament.\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "QUEL QUE SOIT LE TERRAIN",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "TENIR COMPTE PRESENCE SACCHAROSE",
              "Cf. COMPOSITION",
              "RISQUE DE SURDOSAGE",
              "HEPATOTOXICITE",
              "PRESENCE D'EXCIPIENT(S) A EFFET NOTOIRE",
            ],
            text: null,
          },
          {
            label: "MUCOVISCIDOSE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HEPATITE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["HEPATITE AIGUE"],
            other_comment: [
              "ARRETER LE TRAITEMENT",
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
            ],
            text: [
              "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
            ],
          },
          {
            label: "HEPATITE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["HEPATITE CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
            other_comment: null,
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: [
              "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
              "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
            ],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INFECTION VIH",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DESHYDRATATION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HYPOVOLEMIE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "RISQUE D'ANEMIE",
              "RISQUE D'HEMOLYSE",
            ],
            text: null,
          },
          {
            label: "SYNDROME DE GILBERT",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DENUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "AMAIGRISSEMENT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "MALNUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["MALNUTRITION CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ALCOOLISME CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "SEVRAGE ALCOOLIQUE SYNDROME",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SEVRAGE ALCOOLIQUE"],
            other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
            text: null,
          },
          {
            label: "ANOREXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE RENALE CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["INSUFFISANCE RENALE SEVERE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. PROPRIETES PHARMACOCINETIQUES",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INTERACTION D'ORIGINE ALIMENTAIRE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: ["INGESTION D'ALCOOL"],
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "RISQUE D'ATTEINTE HEPATIQUE",
            ],
            text: [
              "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
            ],
          },
          {
            label: "JEUNE STRICT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "CACHEXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "EXAMEN LABORATOIRE INTERFERENCE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
            other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
            text: [
              "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
            ],
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "UTILISER AVEC PRUDENCE",
              "EN CAS DE POSOLOGIE ELEVEE",
              "RISQUE D'HEMOLYSE",
              "REFERENTIEL ANSM G6PD 13/06/2014",
            ],
            text: [
              "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
            ],
          },
          {
            label: "ENFANT",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["ENFANT DE MOINS DE 11 KG", "ENFANT DE PLUS DE 25 KG"],
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant de 11 à 25 kg (soit environ de 18 mois à 10 ans).",
            ],
          },
          {
            label: "NOURRISSON",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["NOURRISSON DE MOINS DE 11 KG"],
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant de 11 à 25 kg (soit environ de 18 mois à 10 ans).",
            ],
          },
          {
            label: "NOUVEAU-NE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant de 11 à 25 kg (soit environ de 18 mois à 10 ans).",
            ],
          },
          {
            label: "SUJET AGE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant de 11 à 25 kg (soit environ de 18 mois à 10 ans).",
            ],
          },
          {
            label: "ADULTE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant de 11 à 25 kg (soit environ de 18 mois à 10 ans).",
            ],
          },
        ],
      },
      {
        dose: "100 mg",
        form: "suppositoire",
        contraindications: [
          {
            label: "MUCOVISCIDOSE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HEPATITE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["HEPATITE AIGUE"],
            other_comment: [
              "ARRETER LE TRAITEMENT",
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
            ],
            text: [
              "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
            ],
          },
          {
            label: "HEPATITE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["HEPATITE CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
            other_comment: null,
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: [
              "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
              "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
            ],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INFECTION VIH",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DESHYDRATATION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HYPOVOLEMIE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "RISQUE D'ANEMIE",
              "RISQUE D'HEMOLYSE",
            ],
            text: null,
          },
          {
            label: "SYNDROME DE GILBERT",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DENUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "AMAIGRISSEMENT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "MALNUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["MALNUTRITION CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ALCOOLISME CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "SEVRAGE ALCOOLIQUE SYNDROME",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SEVRAGE ALCOOLIQUE"],
            other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
            text: null,
          },
          {
            label: "ANOREXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE RENALE CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["INSUFFISANCE RENALE SEVERE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. PROPRIETES PHARMACOCINETIQUES",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INTERACTION D'ORIGINE ALIMENTAIRE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: ["INGESTION D'ALCOOL"],
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "RISQUE D'ATTEINTE HEPATIQUE",
            ],
            text: [
              "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
            ],
          },
          {
            label: "JEUNE STRICT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "CACHEXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "EXAMEN LABORATOIRE INTERFERENCE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
            other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
            text: [
              "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
            ],
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "UTILISER AVEC PRUDENCE",
              "EN CAS DE POSOLOGIE ELEVEE",
              "RISQUE D'HEMOLYSE",
              "REFERENTIEL ANSM G6PD 13/06/2014",
            ],
            text: [
              "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
            ],
          },
          {
            label: "ENFANT",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée au nourrisson pesant de 3 à 8 kg (environ de la naissance à 9 mois).",
            ],
          },
          {
            label: "NOURRISSON",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: [
              "NOURRISSON DE MOINS DE 3 KG",
              "NOURRISSON DE PLUS DE 8 KG",
            ],
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée au nourrisson pesant de 3 à 8 kg (environ de la naissance à 9 mois).",
            ],
          },
          {
            label: "NOUVEAU-NE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["NOUVEAU-NE DE MOINS DE 3 KG"],
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée au nourrisson pesant de 3 à 8 kg (environ de la naissance à 9 mois).",
            ],
          },
          {
            label: "SUJET AGE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée au nourrisson pesant de 3 à 8 kg (environ de la naissance à 9 mois).",
            ],
          },
          {
            label: "ADULTE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée au nourrisson pesant de 3 à 8 kg (environ de la naissance à 9 mois).",
            ],
          },
          {
            label: "DIARRHEE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: null,
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "FORME GALENIQUE INADAPTEE A CE TERRAIN",
            ],
            text: [
              "En cas de diarrhée, la forme suppositoire n'est pas adaptée.",
            ],
          },
          {
            label: "RECTITE / RECTORRAGIE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: [
              "LESION ANORECTALE ANTECEDENT PERSONNEL",
              "RECTITE/RECTORRAGIE ANTECEDENT PERSONNEL",
            ],
            other_comment: null,
            text: null,
          },
          {
            label: "QUEL QUE SOIT LE TERRAIN",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "PREVENIR LE MALADE",
              "RISQUE DE TOXICITE LOCALE",
              "RISQUE DE SURDOSAGE",
              "RISQUE DE REACTION CUTANEE",
              "HEPATOTOXICITE",
              "RISQUE DE SYNDROME DE STEVENS JOHNSON (SSJ)",
              "RISQUE DE PUSTULOSE EXANTHEMATIQUE (PEAG)",
              "SURVEILLANCE CLINIQUE",
            ],
            text: null,
          },
        ],
      },
      {
        dose: "200 mg",
        form: "suppositoire",
        contraindications: [
          {
            label: "MUCOVISCIDOSE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HEPATITE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["HEPATITE AIGUE"],
            other_comment: [
              "ARRETER LE TRAITEMENT",
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
            ],
            text: [
              "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
            ],
          },
          {
            label: "HEPATITE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["HEPATITE CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
            other_comment: null,
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: [
              "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
              "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
            ],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INFECTION VIH",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DESHYDRATATION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HYPOVOLEMIE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "RISQUE D'ANEMIE",
              "RISQUE D'HEMOLYSE",
            ],
            text: null,
          },
          {
            label: "SYNDROME DE GILBERT",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DENUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "AMAIGRISSEMENT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "MALNUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["MALNUTRITION CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ALCOOLISME CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "SEVRAGE ALCOOLIQUE SYNDROME",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SEVRAGE ALCOOLIQUE"],
            other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
            text: null,
          },
          {
            label: "ANOREXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE RENALE CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["INSUFFISANCE RENALE SEVERE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. PROPRIETES PHARMACOCINETIQUES",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INTERACTION D'ORIGINE ALIMENTAIRE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: ["INGESTION D'ALCOOL"],
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "RISQUE D'ATTEINTE HEPATIQUE",
            ],
            text: [
              "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
            ],
          },
          {
            label: "JEUNE STRICT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "CACHEXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "EXAMEN LABORATOIRE INTERFERENCE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
            other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
            text: [
              "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
            ],
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "UTILISER AVEC PRUDENCE",
              "EN CAS DE POSOLOGIE ELEVEE",
              "RISQUE D'HEMOLYSE",
              "REFERENTIEL ANSM G6PD 13/06/2014",
            ],
            text: [
              "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
            ],
          },
          {
            label: "ENFANT",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["ENFANT DE MOINS DE 12 KG", "ENFANT DE PLUS DE 16 KG"],
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant pesant de 12 à 16 kg (environ 2 ans à 5 ans).",
            ],
          },
          {
            label: "NOURRISSON",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["NOURRISSON DE MOINS DE 12 KG"],
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant pesant de 12 à 16 kg (environ 2 ans à 5 ans).",
            ],
          },
          {
            label: "NOUVEAU-NE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant pesant de 12 à 16 kg (environ 2 ans à 5 ans).",
            ],
          },
          {
            label: "SUJET AGE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant pesant de 12 à 16 kg (environ 2 ans à 5 ans).",
            ],
          },
          {
            label: "ADULTE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant pesant de 12 à 16 kg (environ 2 ans à 5 ans).",
            ],
          },
          {
            label: "DIARRHEE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: null,
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "FORME GALENIQUE INADAPTEE A CE TERRAIN",
            ],
            text: [
              "En cas de diarrhée, la forme suppositoire n'est pas adaptée.",
            ],
          },
          {
            label: "RECTITE / RECTORRAGIE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: [
              "LESION ANORECTALE ANTECEDENT PERSONNEL",
              "RECTITE/RECTORRAGIE ANTECEDENT PERSONNEL",
            ],
            other_comment: null,
            text: null,
          },
          {
            label: "QUEL QUE SOIT LE TERRAIN",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "PREVENIR LE MALADE",
              "RISQUE DE TOXICITE LOCALE",
              "RISQUE DE SURDOSAGE",
              "RISQUE DE REACTION CUTANEE",
              "HEPATOTOXICITE",
              "RISQUE DE SYNDROME DE STEVENS JOHNSON (SSJ)",
              "RISQUE DE PUSTULOSE EXANTHEMATIQUE (PEAG)",
              "SURVEILLANCE CLINIQUE",
            ],
            text: null,
          },
        ],
      },
      {
        dose: "2,4 %",
        form: "suspension buvable",
        contraindications: [
          {
            label: "QUEL QUE SOIT LE TERRAIN",
            level: [
              "MISE EN GARDE (SPECIALE)",
              "PRECAUTION (PARTICULIERE) D'EMPLOI",
            ],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "TENIR COMPTE PRESENCE ALCOOL BENZYLIQUE",
              "TENIR COMPTE PRESENCE SODIUM BENZOATE",
              "TENIR COMPTE PRESENCE SORBITOL",
              "TENIR COMPTE PRESENCE MALTITOL",
              "TENIR COMPTE PRESENCE PROPYLENEGLYCOL",
              "RISQUE DE SURDOSAGE",
              "Cf. SURDOSAGE",
              "HEPATOTOXICITE",
              "PRESENCE D'EXCIPIENT(S) A EFFET NOTOIRE",
            ],
            text: null,
          },
          {
            label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: [
              "HYPERSENSIBILITE FRUCTOSE (INTOLERANCE)",
              "HYPERSENSIBILITE MALTITOL (INTOLERANCE)",
            ],
            other_comment: [
              "TENIR COMPTE PRESENCE MALTITOL",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du maltitol (E 965), de l'iIsomalt (E 953) (isomaltitol) ou du maltitol liquide (sirop de\r\nglucose hydrogéné) comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n-> Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) d'une intolérance à certains sucres, contactez-le avant de prendre ce médicament.\r\n\r\n- Commentaires\r\nProposition de RCP : Les patients présentant des problèmes héréditaires rares d'intolérance au fructose ne\r\ndoivent pas prendre ce médicament.\r\n\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "INTOLERANCE GENETIQUE AU FRUCTOSE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: null,
            other_comment: [
              "TENIR COMPTE PRESENCE MALTITOL",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du maltitol (E 965), de l'iIsomalt (E 953) (isomaltitol) ou du maltitol liquide (sirop de\r\nglucose hydrogéné) comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n-> Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) d'une intolérance à certains sucres, contactez-le avant de prendre ce médicament.\r\n\r\n- Commentaires\r\nProposition de RCP : Les patients présentant des problèmes héréditaires rares d'intolérance au fructose ne\r\ndoivent pas prendre ce médicament.\r\n\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "QUEL QUE SOIT LE TERRAIN",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "TENIR COMPTE PRESENCE MALTITOL",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du maltitol (E 965), de l'iIsomalt (E 953) (isomaltitol) ou du maltitol liquide (sirop de\r\nglucose hydrogéné) comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n-> Seuil : 10 g\r\n\r\n- Informations\r\nPeut avoir un effet laxatif léger.\r\nValeur calorique 2,3 kcal/g de <maltitol><isomaltitol>.\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "REGIME HYPOCALORIQUE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "TENIR COMPTE PRESENCE MALTITOL",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du maltitol (E 965), de l'iIsomalt (E 953) (isomaltitol) ou du maltitol liquide (sirop de\r\nglucose hydrogéné) comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n-> Seuil : 10 g\r\n\r\n- Informations\r\nPeut avoir un effet laxatif léger.\r\nValeur calorique 2,3 kcal/g de <maltitol><isomaltitol>.\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "TENIR COMPTE PRESENCE ALCOOL BENZYLIQUE",
              "RISQUE D'ACIDOSE METABOLIQUE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient de l'alcool benzylique comme excipient\r\n\r\n- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nDemandez conseil à votre médecin ou à votre pharmacien si vous souffrez d'une maladie du foie ou du rein. De grandes quantités d'alcool benzylique peuvent s'accumuler dans votre corps et entraîner des effets secondaires (appelés \"acidose métabolique\").\r\n- Commentaires\r\nLes volumes élevés doivent être utilisés avec prudence et en cas de nécessité uniquement, en particulier chez les personnes atteintes d'insuffisance hépatique ou rénale en raison du risque d'accumulation et de toxicité (acidose métabolique).\r\r\n\r\n\r\nansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "ATTEINTE HEPATIQUE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RISQUE D'ACIDOSE METABOLIQUE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient de l'alcool benzylique comme excipient\r\n\r\n- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nDemandez conseil à votre médecin ou à votre pharmacien si vous souffrez d'une maladie du foie ou du rein. De grandes quantités d'alcool benzylique peuvent s'accumuler dans votre corps et entraîner des effets secondaires (appelés \"acidose métabolique\").\r\n- Commentaires\r\nLes volumes élevés doivent être utilisés avec prudence et en cas de nécessité uniquement, en particulier chez les personnes atteintes d'insuffisance hépatique ou rénale en raison du risque d'accumulation et de toxicité (acidose métabolique).\r\r\n\r\n\r\nansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "INSUFFISANCE RENALE CHRONIQUE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "TENIR COMPTE PRESENCE ALCOOL BENZYLIQUE",
              "RISQUE D'ACIDOSE METABOLIQUE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient de l'alcool benzylique comme excipient\r\n\r\n- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nDemandez conseil à votre médecin ou à votre pharmacien si vous souffrez d'une maladie du foie ou du rein. De grandes quantités d'alcool benzylique peuvent s'accumuler dans votre corps et entraîner des effets secondaires (appelés \"acidose métabolique\").\r\n- Commentaires\r\nLes volumes élevés doivent être utilisés avec prudence et en cas de nécessité uniquement, en particulier chez les personnes atteintes d'insuffisance hépatique ou rénale en raison du risque d'accumulation et de toxicité (acidose métabolique).\r\r\n\r\n\r\nansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "ATTEINTE RENALE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "TENIR COMPTE PRESENCE ALCOOL BENZYLIQUE",
              "RISQUE D'ACIDOSE METABOLIQUE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient de l'alcool benzylique comme excipient\r\n\r\n- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nDemandez conseil à votre médecin ou à votre pharmacien si vous souffrez d'une maladie du foie ou du rein. De grandes quantités d'alcool benzylique peuvent s'accumuler dans votre corps et entraîner des effets secondaires (appelés \"acidose métabolique\").\r\n- Commentaires\r\nLes volumes élevés doivent être utilisés avec prudence et en cas de nécessité uniquement, en particulier chez les personnes atteintes d'insuffisance hépatique ou rénale en raison du risque d'accumulation et de toxicité (acidose métabolique).\r\r\n\r\n\r\nansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "ENFANT",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: ["ENFANT DE MOINS DE 3 ANS"],
            other_comment: [
              "TENIR COMPTE PRESENCE ALCOOL BENZYLIQUE",
              "RISQUE DE MAJORATION DE TOXICITE",
              "RISQUE D'ACCUMULATION",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nL'alcool benzylique est associé à un risque d'effets secondaires graves y compris des problèmes respiratoires (appelés \"syndrome de suffocation\") chez les jeunes enfants.\r\nNe pas utiliser chez le nouveau-né (jusqu'à 4 semaines) sauf recommandation contraire de votre médecin.\r\n- Commentaires\r\nL'administration intraveineuse d'alcool benzylique a été associée à des effets indésirables graves et à la mort chez les nouveau-nés (\"syndrome de suffocation\"). La quantité minimale d'alcool benzylique susceptible d'entraîner une toxicité n'est pas connue.\r\nL'avertissement à la rubrique \"Mises en garde et précautions d'emploi\" du RCP doit être donné en cas d'utilisation chez le nouveau-né.\r\n\r\n\r\n- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nNe pas utiliser pendant plus d'une semaine chez les jeunes enfants (moins de 3 ans), sauf avis contraire de votre médecin ou de votre pharmacien.\r\n- Commentaires\r\nRisque accru en raison de l'accumulation chez les jeunes enfants.\r\n\r\n\r\n- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nDemandez conseil à votre médecin ou à votre pharmacien si vous êtes enceinte ou si vous allaitez. De grandes quantités d'alcool benzylique peuvent s'accumuler dans votre corps et entraîner des effets secondaires (appelés \"acidose métabolique\").\r\n\r\n\r\n- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nDemandez conseil à votre médecin ou à votre pharmacien si vous souffrez d'une maladie du foie ou du rein. De grandes quantités d'alcool benzylique peuvent s'accumuler dans votre corps et entraîner des effets secondaires (appelés \"acidose métabolique\").\r\n- Commentaires\r\nLes volumes élevés doivent être utilisés avec prudence et en cas de nécessité uniquement, en particulier chez les personnes atteintes d'insuffisance hépatique ou rénale en raison du risque d'accumulation et de toxicité (acidose métabolique).\r\r\n\r\nansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "NOUVEAU-NE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "TENIR COMPTE PRESENCE ALCOOL BENZYLIQUE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nL'alcool benzylique est associé à un risque d'effets secondaires graves y compris des problèmes respiratoires (appelés \"syndrome de suffocation\") chez les jeunes enfants.\r\nNe pas utiliser chez le nouveau-né (jusqu'à 4 semaines) sauf recommandation contraire de votre médecin.\r\n- Commentaires\r\nL'administration intraveineuse d'alcool benzylique a été associée à des effets indésirables graves et à la mort chez les nouveau-nés (\"syndrome de suffocation\"). La quantité minimale d'alcool benzylique susceptible d'entraîner une toxicité n'est pas connue.\r\nL'avertissement à la rubrique \"Mises en garde et précautions d'emploi\" du RCP doit être donné en cas d'utilisation chez le nouveau-né.\r\n\r\n\r\n- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nNe pas utiliser pendant plus d'une semaine chez les jeunes enfants (moins de 3 ans), sauf avis contraire de votre médecin ou de votre pharmacien.\r\n- Commentaires\r\nRisque accru en raison de l'accumulation chez les jeunes enfants.\r\n\r\n\r\n- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nDemandez conseil à votre médecin ou à votre pharmacien si vous êtes enceinte ou si vous allaitez. De grandes quantités d'alcool benzylique peuvent s'accumuler dans votre corps et entraîner des effets secondaires (appelés \"acidose métabolique\").\r\n\r\n\r\n- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nDemandez conseil à votre médecin ou à votre pharmacien si vous souffrez d'une maladie du foie ou du rein. De grandes quantités d'alcool benzylique peuvent s'accumuler dans votre corps et entraîner des effets secondaires (appelés \"acidose métabolique\").\r\n- Commentaires\r\nLes volumes élevés doivent être utilisés avec prudence et en cas de nécessité uniquement, en particulier chez les personnes atteintes d'insuffisance hépatique ou rénale en raison du risque d'accumulation et de toxicité (acidose métabolique).\r\r\n\r\nansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "PREMATURE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: null,
            other_comment: [
              "TENIR COMPTE PRESENCE ALCOOL BENZYLIQUE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nL'alcool benzylique est associé à un risque d'effets secondaires graves y compris des problèmes respiratoires (appelés \"syndrome de suffocation\") chez les jeunes enfants.\r\nNe pas utiliser chez le nouveau-né (jusqu'à 4 semaines) sauf recommandation contraire de votre médecin.\r\n- Commentaires\r\nL'administration intraveineuse d'alcool benzylique a été associée à des effets indésirables graves et à la mort chez les nouveau-nés (\"syndrome de suffocation\"). La quantité minimale d'alcool benzylique susceptible d'entraîner une toxicité n'est pas connue.\r\nL'avertissement à la rubrique \"Mises en garde et précautions d'emploi\" du RCP doit être donné en cas d'utilisation chez le nouveau-né.\r\n\r\n\r\n- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nNe pas utiliser pendant plus d'une semaine chez les jeunes enfants (moins de 3 ans), sauf avis contraire de votre médecin ou de votre pharmacien.\r\n- Commentaires\r\nRisque accru en raison de l'accumulation chez les jeunes enfants.\r\n\r\n\r\nansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "GROSSESSE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "TENIR COMPTE PRESENCE ALCOOL BENZYLIQUE",
              "RISQUE D'ACIDOSE METABOLIQUE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient de l'alcool benzylique comme excipient\r\n\r\n- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nDemandez conseil à votre médecin ou à votre pharmacien si vous êtes enceinte ou si vous allaitez. De grandes quantités d'alcool benzylique peuvent s'accumuler dans votre corps et entraîner des effets secondaires (appelés \"acidose métabolique\").\r\n\r\n\r\nansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "ALLAITEMENT",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "TENIR COMPTE PRESENCE ALCOOL BENZYLIQUE",
              "RISQUE D'ACIDOSE METABOLIQUE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient de l'alcool benzylique comme excipient\r\n\r\n- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nDemandez conseil à votre médecin ou à votre pharmacien si vous êtes enceinte ou si vous allaitez. De grandes quantités d'alcool benzylique peuvent s'accumuler dans votre corps et entraîner des effets secondaires (appelés \"acidose métabolique\").\r\n\r\n\r\nansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: [
              "HYPERSENSIBILITE FRUCTOSE (INTOLERANCE)",
              "HYPERSENSIBILITE SORBITOL (INTOLERANCE)",
            ],
            other_comment: [
              "TENIR COMPTE PRESENCE SORBITOL",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du sorbitol E 420 comme excipient.\r\n\r\n\r\n* Voie d'administration : Orale, parentérale\r\n\r\n- Seuil : Zéro\r\n\r\n- Information pour la notice\r\nCe médicament contient x mg de sorbitol par <dose><volume unitaire> <équivalent à x mg/<poids><volume >>.\r\n\r\n- Commentaires\r\nL'effet additif des produits administrés concomitamment contenant du sorbitol (ou du fructose) et l'apport\r\nalimentaire de sorbitol (ou de fructose) doit être pris en compte.\r\nLa teneur en sorbitol dans les médicaments à usage oral peut affecter la biodisponibilité d'autres médicaments à\r\nusage oral administrés de façon concomitante.\r\n\r\n\r\n* Voie d'administration : Intraveineuse (IV)\r\n\r\n- Seuil : Zéro\r\n\r\n- Information pour la notice\r\nLe sorbitol est une source de fructose. Si vous (ou votre enfant) présentez une intolérance héréditaire au fructose (IHF), une maladie génétique rare, vous (ou votre enfant) ne devez pas recevoir ce médicament. Les patients atteints d'IHF ne peuvent pas décomposer le fructose, et ne doivent pas recevoir ce médicament en raison de risque d'effets indésirables graves.\r\nVous devez en informer votre médecin avant de recevoir ce médicament si vous (ou votre enfant) présentez une IHF ou si votre enfant ne peut plus prendre d'aliments ou de boissons sucrées du fait de nausées, de vomissements ou d'effets désagréables tels que des ballonnements, des crampes d'estomac ou la diarrhée.\r\n\r\n- Commentaires\r\nLes patients présentant une intolérance héréditaire au fructose (IHF) ne doivent pas recevoir ce médicament, sauf en cas de nécessité uniquement.\r\nLes bébés et les jeunes enfants (moins de 2 ans) peuvent ne pas avoir été diagnostiqués avec une intolérance\r\nhéréditaire au fructose (IHF). Les médicaments (contenant du sorbitol/fructose) administrés par voie\r\nintraveineuse peuvent être mortels et doivent être contreindiqués dans cette population, sauf nécessité clinique\r\nimpérieuse et en l'absence de solution alternative.\r\nL'historique détaillé des symptômes d'IHF doit être obtenu pour chaque patient avant de prescrire ce médicament.\r\n\r\n\r\n* Voie d'administration : Orale, parentérale (autre que IV)\r\n\r\n- Seuil : 5 mg/kg/jour\r\n\r\n- Information pour la notice\r\nLe sorbitol est une source de fructose. Si votre médecin vous a informé(e) que vous (ou votre enfant) présentiez une intolérance à certains sucres ou si vous avez été diagnostiqué(e) avec une intolérance héréditaire au fructose (IHF), un trouble génétique rare caractérisé par l'incapacité à décomposer le fructose, parlez-en à votre médecin\r\navant que vous (ou votre enfant) ne preniez ou ne receviez ce médicament.\r\n\r\n- Commentaires\r\nLes patients présentant une intolérance héréditaire au fructose (IHF) ne doivent pas prendre/recevoir ce médicament.\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "INTOLERANCE GENETIQUE AU FRUCTOSE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: null,
            other_comment: [
              "TENIR COMPTE PRESENCE SORBITOL",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du sorbitol E 420 comme excipient.\r\n\r\n\r\n* Voie d'administration : Orale, parentérale\r\n\r\n- Seuil : Zéro\r\n\r\n- Information pour la notice\r\nCe médicament contient x mg de sorbitol par <dose><volume unitaire> <équivalent à x mg/<poids><volume >>.\r\n\r\n- Commentaires\r\nL'effet additif des produits administrés concomitamment contenant du sorbitol (ou du fructose) et l'apport\r\nalimentaire de sorbitol (ou de fructose) doit être pris en compte.\r\nLa teneur en sorbitol dans les médicaments à usage oral peut affecter la biodisponibilité d'autres médicaments à\r\nusage oral administrés de façon concomitante.\r\n\r\n\r\n* Voie d'administration : Intraveineuse (IV)\r\n\r\n- Seuil : Zéro\r\n\r\n- Information pour la notice\r\nLe sorbitol est une source de fructose. Si vous (ou votre enfant) présentez une intolérance héréditaire au fructose (IHF), une maladie génétique rare, vous (ou votre enfant) ne devez pas recevoir ce médicament. Les patients atteints d'IHF ne peuvent pas décomposer le fructose, et ne doivent pas recevoir ce médicament en raison de risque d'effets indésirables graves.\r\nVous devez en informer votre médecin avant de recevoir ce médicament si vous (ou votre enfant) présentez une IHF ou si votre enfant ne peut plus prendre d'aliments ou de boissons sucrées du fait de nausées, de vomissements ou d'effets désagréables tels que des ballonnements, des crampes d'estomac ou la diarrhée.\r\n\r\n- Commentaires\r\nLes patients présentant une intolérance héréditaire au fructose (IHF) ne doivent pas recevoir ce médicament, sauf en cas de nécessité uniquement.\r\nLes bébés et les jeunes enfants (moins de 2 ans) peuvent ne pas avoir été diagnostiqués avec une intolérance\r\nhéréditaire au fructose (IHF). Les médicaments (contenant du sorbitol/fructose) administrés par voie\r\nintraveineuse peuvent être mortels et doivent être contreindiqués dans cette population, sauf nécessité clinique\r\nimpérieuse et en l'absence de solution alternative.\r\nL'historique détaillé des symptômes d'IHF doit être obtenu pour chaque patient avant de prescrire ce médicament.\r\n\r\n\r\n* Voie d'administration : Orale, parentérale (autre que IV)\r\n\r\n- Seuil : 5 mg/kg/jour\r\n\r\n- Information pour la notice\r\nLe sorbitol est une source de fructose. Si votre médecin vous a informé(e) que vous (ou votre enfant) présentiez une intolérance à certains sucres ou si vous avez été diagnostiqué(e) avec une intolérance héréditaire au fructose (IHF), un trouble génétique rare caractérisé par l'incapacité à décomposer le fructose, parlez-en à votre médecin\r\navant que vous (ou votre enfant) ne preniez ou ne receviez ce médicament.\r\n\r\n- Commentaires\r\nLes patients présentant une intolérance héréditaire au fructose (IHF) ne doivent pas prendre/recevoir ce médicament.\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "MUCOVISCIDOSE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HEPATITE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["HEPATITE AIGUE"],
            other_comment: [
              "ARRETER LE TRAITEMENT",
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
            ],
            text: [
              "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
            ],
          },
          {
            label: "HEPATITE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["HEPATITE CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
            other_comment: null,
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: [
              "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
              "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
            ],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INFECTION VIH",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DESHYDRATATION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HYPOVOLEMIE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "RISQUE D'ANEMIE",
              "RISQUE D'HEMOLYSE",
            ],
            text: null,
          },
          {
            label: "SYNDROME DE GILBERT",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DENUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "AMAIGRISSEMENT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "MALNUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["MALNUTRITION CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ALCOOLISME CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "SEVRAGE ALCOOLIQUE SYNDROME",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SEVRAGE ALCOOLIQUE"],
            other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
            text: null,
          },
          {
            label: "ANOREXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE RENALE CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["INSUFFISANCE RENALE SEVERE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. PROPRIETES PHARMACOCINETIQUES",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INTERACTION D'ORIGINE ALIMENTAIRE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: ["INGESTION D'ALCOOL"],
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "RISQUE D'ATTEINTE HEPATIQUE",
            ],
            text: [
              "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
            ],
          },
          {
            label: "JEUNE STRICT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "CACHEXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "EXAMEN LABORATOIRE INTERFERENCE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
            other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
            text: [
              "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
            ],
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "UTILISER AVEC PRUDENCE",
              "EN CAS DE POSOLOGIE ELEVEE",
              "RISQUE D'HEMOLYSE",
              "REFERENTIEL ANSM G6PD 13/06/2014",
            ],
            text: [
              "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
            ],
          },
          {
            label: "ENFANT",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["ENFANT DE PLUS DE 26 KG"],
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant de 3 à 26 kg (soit environ de la naissance à 9 ans).",
            ],
          },
          {
            label: "NOURRISSON",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["NOURRISSON DE MOINS DE 3 KG"],
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant de 3 à 26 kg (soit environ de la naissance à 9 ans).",
            ],
          },
          {
            label: "NOUVEAU-NE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["NOUVEAU-NE DE MOINS DE 3 KG"],
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant de 3 à 26 kg (soit environ de la naissance à 9 ans).",
            ],
          },
          {
            label: "SUJET AGE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant de 3 à 26 kg (soit environ de la naissance à 9 ans).",
            ],
          },
          {
            label: "ADULTE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant de 3 à 26 kg (soit environ de la naissance à 9 ans).",
            ],
          },
        ],
      },
      {
        dose: "500 mg",
        form: "comprimé effervescent",
        contraindications: [
          {
            label: "REGIME HYPOSODE STRICT",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "TENIR COMPTE PRESENCE SODIUM",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du sodium comme excipient.\r\n\r\n* Voie d'administration : Orale et parentérale\r\n\r\n- Seuil : > ou = 1 mmol (23 mg) par \"dose administrée\"\r\n\r\n- Information pour la notice \r\nCe médicament contient x mg de sodium (composant principal du sel de cuisine/table) par <dose><volume unitaire>. Cela équivaut à y% de l'apport alimentaire quotidien maximal recommandé de sodium pour un adulte.\r\n\r\n- Commentaires\r\nEn cas d'administration parentérale à dosage variable (par exemple, en fonction du poids), la teneur en sodium\r\npeut être exprimée en mg par flacon.\r\nLibellé proposé pour le RCP : \"Ce médicament contient x mg de sodium par <dose>, ce qui équivaut à y% de l'apport alimentaire quotidien maximal recommandé par l'OMS de 2 g de sodium par adulte.\"\r\n\r\n\r\n* Voie d'administration : Orale et parentérale\r\n\r\n- Seuil : 17 mmol (391 mg) à la dose quotidienne maximale\r\n\r\n- Information pour la notice \r\nParlez-en à votre médecin ou votre pharmacien si vous avez besoin de <Z> ou de plus de <dose> quotidiennement pendant une période prolongée, surtout si vous devez suivre un régime à faible teneur en sel (sodium).\r\n\r\n- Commentaires\r\nCeci s'applique uniquement aux produits pour lesquels la posologie indiquée permet une prise quotidienne pendant\r\nplus d'un mois ou une utilisation répétée de plus de deux jours par semaine.\r\n17 mmol (391 mg) représente environ 20% de l'apport alimentaire quotidien maximal adulte recommandé par\r\nl'OMS de 2 g de sodium et est considéré comme un dosage \"élevé\". Ceci vaut également pour les enfants, pour lesquels l'apport quotidien maximal est censé être proportionnel à celui des adultes et calculé selon les besoins\r\nénergétiques.\r\n<Doses Z> reflète le nombre minimum de doses pour lesquelles le seuil de 17 mmol (391 mg) de sodium est\r\natteint/dépassé. Arrondir au nombre entier le plus proche.\r\nPour le libellé du RCP, veuillez vous reporter à la recommandation du PRAC: \"1.3. Sodium-containing effervescent, dispersible and soluble medicines – Cardiovascular events\" (EMA/PRAC/234960/2015).\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: [
              "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
              "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
              "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
            ],
            other_comment: [
              "TENIR COMPTE PRESENCE GLUCOSE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du glucose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) d'une intolérance à certains sucres, contactez-le avant de prendre ce médicament.\r\n\r\n- Commentaire :\r\nProposition de RCP : Les patients présentant un syndrome de malabsorption du glucose et du galactose\r\n(maladie héréditaire rare) ne doivent pas prendre ce médicament.\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "MUCOVISCIDOSE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HEPATITE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["HEPATITE AIGUE"],
            other_comment: [
              "ARRETER LE TRAITEMENT",
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
            ],
            text: [
              "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
            ],
          },
          {
            label: "HEPATITE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["HEPATITE CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
            other_comment: null,
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: [
              "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
              "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
            ],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INFECTION VIH",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DESHYDRATATION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HYPOVOLEMIE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "RISQUE D'ANEMIE",
              "RISQUE D'HEMOLYSE",
            ],
            text: null,
          },
          {
            label: "SYNDROME DE GILBERT",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DENUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "AMAIGRISSEMENT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "MALNUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["MALNUTRITION CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ALCOOLISME CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "SEVRAGE ALCOOLIQUE SYNDROME",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SEVRAGE ALCOOLIQUE"],
            other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
            text: null,
          },
          {
            label: "ANOREXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE RENALE CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["INSUFFISANCE RENALE SEVERE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. PROPRIETES PHARMACOCINETIQUES",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INTERACTION D'ORIGINE ALIMENTAIRE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: ["INGESTION D'ALCOOL"],
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "RISQUE D'ATTEINTE HEPATIQUE",
            ],
            text: [
              "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
            ],
          },
          {
            label: "JEUNE STRICT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "CACHEXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "EXAMEN LABORATOIRE INTERFERENCE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
            other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
            text: [
              "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
            ],
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "UTILISER AVEC PRUDENCE",
              "EN CAS DE POSOLOGIE ELEVEE",
              "RISQUE D'HEMOLYSE",
              "REFERENTIEL ANSM G6PD 13/06/2014",
            ],
            text: [
              "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
            ],
          },
          {
            label: "PATIENT DE FAIBLE POIDS",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["PATIENT DE MOINS DE 50 KG"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ENFANT",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["ENFANT DE MOINS DE 27 KG"],
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'adulte et l'enfant à partir de 27 kg (à partir d'environ 8 ans).",
            ],
          },
          {
            label: "ENFANT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["ENFANT DE MOINS DE 50 KG", "ENFANT DE PLUS DE 26 KG"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "ADAPTER LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "NOURRISSON",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'adulte et l'enfant à partir de 27 kg (à partir d'environ 8 ans).",
            ],
          },
          {
            label: "NOUVEAU-NE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'adulte et l'enfant à partir de 27 kg (à partir d'environ 8 ans).",
            ],
          },
          {
            label: "SUJET AGE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SUJET AGE DE PLUS DE 75 ANS"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: [
              "La dose journalière efficace la plus faible possible doit être envisagée, sans excéder 60 mg/kg/jour (sans dépasser 3 g/jour) dans les situations suivantes : [...]\r\n- sujet âgé de plus de 75 ans.",
            ],
          },
          {
            label: "SUJET AGE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SUJET POLYPATHOLOGIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: [
              "La dose journalière efficace la plus faible possible doit être envisagée, sans excéder 60 mg/kg/jour (sans dépasser 3 g/jour) dans les situations suivantes : [...]\r\n- sujet âgé de plus de 65 ans et polypathologique.",
            ],
          },
          {
            label: "QUEL QUE SOIT LE TERRAIN",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "TENIR COMPTE PRESENCE SULFITES",
              "TENIR COMPTE PRESENCE SODIUM",
              "RISQUE DE SURDOSAGE",
              "HEPATOTOXICITE",
              "PRESENCE D'EXCIPIENT(S) A EFFET NOTOIRE",
            ],
            text: null,
          },
        ],
      },
      {
        dose: "300 mg",
        form: "poudre pour solution buvable",
        contraindications: [
          {
            label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: [
              "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
              "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
              "HYPERSENSIBILITE FRUCTOSE (INTOLERANCE)",
              "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
              "HYPERSENSIBILITE SACCHAROSE (INTOLERANCE)",
            ],
            other_comment: [
              "TENIR COMPTE PRESENCE SACCHAROSE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "INTOLERANCE GENETIQUE AU FRUCTOSE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "TENIR COMPTE PRESENCE SACCHAROSE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "DEFICIT EN SUCRASE-ISOMALTASE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "TENIR COMPTE PRESENCE SACCHAROSE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: [
              "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
              "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
              "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
            ],
            other_comment: [
              "TENIR COMPTE PRESENCE GLUCOSE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du glucose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) d'une intolérance à certains sucres, contactez-le avant de prendre ce médicament.\r\n\r\n- Commentaire :\r\nProposition de RCP : Les patients présentant un syndrome de malabsorption du glucose et du galactose\r\n(maladie héréditaire rare) ne doivent pas prendre ce médicament.\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "QUEL QUE SOIT LE TERRAIN",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "TENIR COMPTE PRESENCE SACCHAROSE",
              "Cf. COMPOSITION",
              "RISQUE DE SURDOSAGE",
              "HEPATOTOXICITE",
              "PRESENCE D'EXCIPIENT(S) A EFFET NOTOIRE",
            ],
            text: null,
          },
          {
            label: "MUCOVISCIDOSE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HEPATITE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["HEPATITE AIGUE"],
            other_comment: [
              "ARRETER LE TRAITEMENT",
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
            ],
            text: [
              "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
            ],
          },
          {
            label: "HEPATITE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["HEPATITE CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
            other_comment: null,
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: [
              "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
              "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
            ],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INFECTION VIH",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DESHYDRATATION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HYPOVOLEMIE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "RISQUE D'ANEMIE",
              "RISQUE D'HEMOLYSE",
            ],
            text: null,
          },
          {
            label: "SYNDROME DE GILBERT",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DENUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "AMAIGRISSEMENT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "MALNUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["MALNUTRITION CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ALCOOLISME CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "SEVRAGE ALCOOLIQUE SYNDROME",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SEVRAGE ALCOOLIQUE"],
            other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
            text: null,
          },
          {
            label: "ANOREXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE RENALE CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["INSUFFISANCE RENALE SEVERE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. PROPRIETES PHARMACOCINETIQUES",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INTERACTION D'ORIGINE ALIMENTAIRE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: ["INGESTION D'ALCOOL"],
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "RISQUE D'ATTEINTE HEPATIQUE",
            ],
            text: [
              "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
            ],
          },
          {
            label: "JEUNE STRICT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "CACHEXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "EXAMEN LABORATOIRE INTERFERENCE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
            other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
            text: [
              "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
            ],
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "UTILISER AVEC PRUDENCE",
              "EN CAS DE POSOLOGIE ELEVEE",
              "RISQUE D'HEMOLYSE",
              "REFERENTIEL ANSM G6PD 13/06/2014",
            ],
            text: [
              "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
            ],
          },
          {
            label: "ENFANT",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["ENFANT DE MOINS DE 16 KG", "ENFANT DE PLUS DE 48 KG"],
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant de 16 à 48 kg (soit environ de 4 à 15 ans).",
            ],
          },
          {
            label: "NOURRISSON",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant de 16 à 48 kg (soit environ de 4 à 15 ans).",
            ],
          },
          {
            label: "NOUVEAU-NE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant de 16 à 48 kg (soit environ de 4 à 15 ans).",
            ],
          },
          {
            label: "SUJET AGE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant de 16 à 48 kg (soit environ de 4 à 15 ans).",
            ],
          },
          {
            label: "ADULTE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant de 16 à 48 kg (soit environ de 4 à 15 ans).",
            ],
          },
        ],
      },
      {
        dose: "300 mg",
        form: "suppositoire",
        contraindications: [
          {
            label: "MUCOVISCIDOSE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HEPATITE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["HEPATITE AIGUE"],
            other_comment: [
              "ARRETER LE TRAITEMENT",
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
            ],
            text: [
              "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
            ],
          },
          {
            label: "HEPATITE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["HEPATITE CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
            other_comment: null,
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: [
              "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
              "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
            ],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INFECTION VIH",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DESHYDRATATION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HYPOVOLEMIE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "RISQUE D'ANEMIE",
              "RISQUE D'HEMOLYSE",
            ],
            text: null,
          },
          {
            label: "SYNDROME DE GILBERT",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DENUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "AMAIGRISSEMENT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "MALNUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["MALNUTRITION CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ALCOOLISME CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "SEVRAGE ALCOOLIQUE SYNDROME",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SEVRAGE ALCOOLIQUE"],
            other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
            text: null,
          },
          {
            label: "ANOREXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE RENALE CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["INSUFFISANCE RENALE SEVERE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. PROPRIETES PHARMACOCINETIQUES",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INTERACTION D'ORIGINE ALIMENTAIRE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: ["INGESTION D'ALCOOL"],
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "RISQUE D'ATTEINTE HEPATIQUE",
            ],
            text: [
              "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
            ],
          },
          {
            label: "JEUNE STRICT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "CACHEXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "EXAMEN LABORATOIRE INTERFERENCE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
            other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
            text: [
              "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
            ],
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "UTILISER AVEC PRUDENCE",
              "EN CAS DE POSOLOGIE ELEVEE",
              "RISQUE D'HEMOLYSE",
              "REFERENTIEL ANSM G6PD 13/06/2014",
            ],
            text: [
              "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
            ],
          },
          {
            label: "ENFANT",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["ENFANT DE MOINS DE 15 KG", "ENFANT DE PLUS DE 24 KG"],
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant pesant de 15 à 24 kg (environ 4 à 9 ans).",
            ],
          },
          {
            label: "NOURRISSON",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["NOURRISSON DE MOINS DE 15 KG"],
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant pesant de 15 à 24 kg (environ 4 à 9 ans).",
            ],
          },
          {
            label: "NOUVEAU-NE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant pesant de 15 à 24 kg (environ 4 à 9 ans).",
            ],
          },
          {
            label: "SUJET AGE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant pesant de 15 à 24 kg (environ 4 à 9 ans).",
            ],
          },
          {
            label: "ADULTE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant pesant de 15 à 24 kg (environ 4 à 9 ans).",
            ],
          },
          {
            label: "DIARRHEE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: null,
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "FORME GALENIQUE INADAPTEE A CE TERRAIN",
            ],
            text: [
              "En cas de diarrhée, la forme suppositoire n'est pas adaptée.",
            ],
          },
          {
            label: "RECTITE / RECTORRAGIE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: [
              "LESION ANORECTALE ANTECEDENT PERSONNEL",
              "RECTITE/RECTORRAGIE ANTECEDENT PERSONNEL",
            ],
            other_comment: null,
            text: null,
          },
          {
            label: "QUEL QUE SOIT LE TERRAIN",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "PREVENIR LE MALADE",
              "RISQUE DE TOXICITE LOCALE",
              "RISQUE DE SURDOSAGE",
              "RISQUE DE REACTION CUTANEE",
              "HEPATOTOXICITE",
              "RISQUE DE SYNDROME DE STEVENS JOHNSON (SSJ)",
              "RISQUE DE PUSTULOSE EXANTHEMATIQUE (PEAG)",
              "SURVEILLANCE CLINIQUE",
            ],
            text: null,
          },
        ],
      },
      {
        dose: "1000 mg",
        form: "gélule",
        contraindications: [
          {
            label: "MUCOVISCIDOSE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HEPATITE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["HEPATITE AIGUE"],
            other_comment: [
              "ARRETER LE TRAITEMENT",
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
            ],
            text: [
              "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
            ],
          },
          {
            label: "HEPATITE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["HEPATITE CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
            other_comment: null,
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: [
              "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
              "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
            ],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INFECTION VIH",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DESHYDRATATION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HYPOVOLEMIE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "RISQUE D'ANEMIE",
              "RISQUE D'HEMOLYSE",
            ],
            text: null,
          },
          {
            label: "SYNDROME DE GILBERT",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DENUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "AMAIGRISSEMENT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "MALNUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["MALNUTRITION CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ALCOOLISME CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "SEVRAGE ALCOOLIQUE SYNDROME",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SEVRAGE ALCOOLIQUE"],
            other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
            text: null,
          },
          {
            label: "ANOREXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE RENALE CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["INSUFFISANCE RENALE SEVERE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. PROPRIETES PHARMACOCINETIQUES",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INTERACTION D'ORIGINE ALIMENTAIRE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: ["INGESTION D'ALCOOL"],
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "RISQUE D'ATTEINTE HEPATIQUE",
            ],
            text: [
              "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
            ],
          },
          {
            label: "JEUNE STRICT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "CACHEXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "EXAMEN LABORATOIRE INTERFERENCE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
            other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
            text: [
              "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
            ],
          },
          {
            label: "PATIENT DE FAIBLE POIDS",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["PATIENT DE MOINS DE 50 KG"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ENFANT",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["ENFANT DE MOINS DE 50 KG"],
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'adulte et à l'enfant à partir de 50 kg (soit à partir d'environ 15 ans).",
            ],
          },
          {
            label: "ENFANT",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["ENFANT DE MOINS DE 6 ANS"],
            other_comment: [
              "RISQUE DE FAUSSE ROUTE",
              "FORME GALENIQUE INADAPTEE A CE TERRAIN",
            ],
            text: null,
          },
          {
            label: "NOURRISSON",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "RISQUE DE FAUSSE ROUTE",
              "FORME GALENIQUE INADAPTEE A CE TERRAIN",
            ],
            text: [""],
          },
          {
            label: "NOUVEAU-NE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "RISQUE DE FAUSSE ROUTE",
              "FORME GALENIQUE INADAPTEE A CE TERRAIN",
            ],
            text: [""],
          },
          {
            label: "SUJET AGE",
            level: ["PAS DE PRECAUTION D'EMPLOI"],
            comment: ["SUJET AGE DE PLUS DE 75 ANS"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "SUJET AGE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SUJET POLYPATHOLOGIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "UTILISER AVEC PRUDENCE",
              "EN CAS DE POSOLOGIE ELEVEE",
              "RISQUE D'HEMOLYSE",
              "REFERENTIEL ANSM G6PD 13/06/2014",
            ],
            text: [
              "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
            ],
          },
          {
            label: "QUEL QUE SOIT LE TERRAIN",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "ARRETER TRT EN CAS DE RISQUE AVERE",
              "RESPECTER LA POSOLOGIE",
              "TENIR COMPTE PRESENCE AZORUBINE",
              "RISQUE FATAL",
              "RISQUE DE SURDOSAGE",
              "RISQUE DE REACTION CUTANEE",
              "HEPATOTOXICITE",
              "RISQUE DE SYNDROME DE STEVENS JOHNSON (SSJ)",
              "RISQUE DE PUSTULOSE EXANTHEMATIQUE (PEAG)",
              "PRESENCE D'EXCIPIENT(S) A EFFET NOTOIRE",
            ],
            text: null,
          },
        ],
      },
      {
        dose: "500 mg",
        form: "gélule",
        contraindications: [
          {
            label: "PATIENT DE FAIBLE POIDS",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["PATIENT DE MOINS DE 50 KG"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ENFANT",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["ENFANT DE MOINS DE 6 ANS", "ENFANT DE MOINS DE 27 KG"],
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
              "RISQUE DE FAUSSE ROUTE",
              "FORME GALENIQUE INADAPTEE A CE TERRAIN",
            ],
            text: [
              "La prise de comprimé ou de gélule est contre-indiquée chez l'enfant de moins de 6 ans car elle peut entraîner une fausse route.\r\n\r\nCette présentation est réservée à l'adulte et l'enfant à partir de 27 kg (soit environ à partir de 8 ans).",
            ],
          },
          {
            label: "ENFANT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: [
              "ENFANT DE PLUS DE 6 ANS",
              "ENFANT DE MOINS DE 50 KG",
              "ENFANT DE PLUS DE 26 KG",
            ],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "ADAPTER LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "NOURRISSON",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "RISQUE DE FAUSSE ROUTE",
              "FORME GALENIQUE INADAPTEE A CE TERRAIN",
            ],
            text: [
              "La prise de comprimé ou de gélule est contre-indiquée chez l'enfant de moins de 6 ans car elle peut entraîner une fausse route.",
            ],
          },
          {
            label: "NOUVEAU-NE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "RISQUE DE FAUSSE ROUTE",
              "FORME GALENIQUE INADAPTEE A CE TERRAIN",
            ],
            text: [
              "La prise de comprimé ou de gélule est contre-indiquée chez l'enfant de moins de 6 ans car elle peut entraîner une fausse route.",
            ],
          },
          {
            label: "SUJET AGE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SUJET AGE DE PLUS DE 75 ANS"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: [
              "La dose journalière efficace la plus faible possible doit être envisagée, sans excéder 60 mg/kg/jour (sans dépasser 3 g/jour) dans les situations suivantes : [...]\r\n- sujet âgé de plus de 75 ans.",
            ],
          },
          {
            label: "SUJET AGE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SUJET POLYPATHOLOGIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: [
              "La dose journalière efficace la plus faible possible doit être envisagée, sans excéder 60 mg/kg/jour (sans dépasser 3 g/jour) dans les situations suivantes : [...]\r\n- sujet âgé de plus de 65 ans et polypathologique.",
            ],
          },
          {
            label: "MUCOVISCIDOSE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HEPATITE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["HEPATITE AIGUE"],
            other_comment: [
              "ARRETER LE TRAITEMENT",
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
            ],
            text: [
              "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
            ],
          },
          {
            label: "HEPATITE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["HEPATITE CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
            other_comment: null,
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: [
              "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
              "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
            ],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INFECTION VIH",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DESHYDRATATION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HYPOVOLEMIE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "RISQUE D'ANEMIE",
              "RISQUE D'HEMOLYSE",
            ],
            text: null,
          },
          {
            label: "SYNDROME DE GILBERT",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DENUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "AMAIGRISSEMENT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "MALNUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["MALNUTRITION CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ALCOOLISME CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "SEVRAGE ALCOOLIQUE SYNDROME",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SEVRAGE ALCOOLIQUE"],
            other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
            text: null,
          },
          {
            label: "ANOREXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE RENALE CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["INSUFFISANCE RENALE SEVERE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. PROPRIETES PHARMACOCINETIQUES",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INTERACTION D'ORIGINE ALIMENTAIRE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: ["INGESTION D'ALCOOL"],
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "RISQUE D'ATTEINTE HEPATIQUE",
            ],
            text: [
              "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
            ],
          },
          {
            label: "JEUNE STRICT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "CACHEXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "EXAMEN LABORATOIRE INTERFERENCE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
            other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
            text: [
              "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
            ],
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "UTILISER AVEC PRUDENCE",
              "EN CAS DE POSOLOGIE ELEVEE",
              "RISQUE D'HEMOLYSE",
              "REFERENTIEL ANSM G6PD 13/06/2014",
            ],
            text: [
              "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
            ],
          },
          {
            label: "QUEL QUE SOIT LE TERRAIN",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "RISQUE DE SURDOSAGE",
              "RISQUE DE REACTION CUTANEE",
              "HEPATOTOXICITE",
              "RISQUE DE SYNDROME DE STEVENS JOHNSON (SSJ)",
              "RISQUE DE PUSTULOSE EXANTHEMATIQUE (PEAG)",
            ],
            text: null,
          },
        ],
      },
      {
        dose: "1000 mg",
        form: "suppositoire",
        contraindications: [
          {
            label: "MUCOVISCIDOSE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HEPATITE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["HEPATITE AIGUE"],
            other_comment: [
              "ARRETER LE TRAITEMENT",
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
            ],
            text: [
              "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
            ],
          },
          {
            label: "HEPATITE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["HEPATITE CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
            other_comment: null,
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: [
              "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
              "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
            ],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INFECTION VIH",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DESHYDRATATION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HYPOVOLEMIE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "RISQUE D'ANEMIE",
              "RISQUE D'HEMOLYSE",
            ],
            text: null,
          },
          {
            label: "SYNDROME DE GILBERT",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DENUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "AMAIGRISSEMENT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "MALNUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["MALNUTRITION CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ALCOOLISME CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "SEVRAGE ALCOOLIQUE SYNDROME",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SEVRAGE ALCOOLIQUE"],
            other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
            text: null,
          },
          {
            label: "ANOREXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE RENALE CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["INSUFFISANCE RENALE SEVERE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. PROPRIETES PHARMACOCINETIQUES",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INTERACTION D'ORIGINE ALIMENTAIRE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: ["INGESTION D'ALCOOL"],
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "RISQUE D'ATTEINTE HEPATIQUE",
            ],
            text: [
              "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
            ],
          },
          {
            label: "JEUNE STRICT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "CACHEXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "EXAMEN LABORATOIRE INTERFERENCE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
            other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
            text: [
              "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
            ],
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "UTILISER AVEC PRUDENCE",
              "EN CAS DE POSOLOGIE ELEVEE",
              "RISQUE D'HEMOLYSE",
              "REFERENTIEL ANSM G6PD 13/06/2014",
            ],
            text: [
              "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
            ],
          },
          {
            label: "PATIENT DE FAIBLE POIDS",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["PATIENT DE MOINS DE 50 KG"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ENFANT",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["ENFANT DE MOINS DE 50 KG"],
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'adulte et à l'enfant à partir de 50 kg (soit à partir d'environ 15 ans).",
            ],
          },
          {
            label: "NOURRISSON",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
              "RISQUE DE FAUSSE ROUTE",
              "FORME GALENIQUE INADAPTEE A CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'adulte et à l'enfant à partir de 50 kg (soit à partir d'environ 15 ans).",
            ],
          },
          {
            label: "NOUVEAU-NE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
              "RISQUE DE FAUSSE ROUTE",
              "FORME GALENIQUE INADAPTEE A CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'adulte et à l'enfant à partir de 50 kg (soit à partir d'environ 15 ans).",
            ],
          },
          {
            label: "SUJET AGE",
            level: ["PAS DE PRECAUTION D'EMPLOI"],
            comment: ["SUJET AGE DE PLUS DE 75 ANS"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "SUJET AGE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SUJET POLYPATHOLOGIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DIARRHEE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: null,
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "FORME GALENIQUE INADAPTEE A CE TERRAIN",
            ],
            text: [
              "En cas de diarrhée, la forme suppositoire n'est pas adaptée.",
            ],
          },
          {
            label: "RECTITE / RECTORRAGIE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: [
              "LESION ANORECTALE ANTECEDENT PERSONNEL",
              "RECTITE/RECTORRAGIE ANTECEDENT PERSONNEL",
            ],
            other_comment: null,
            text: null,
          },
          {
            label: "QUEL QUE SOIT LE TERRAIN",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "PREVENIR LE MALADE",
              "RISQUE DE TOXICITE LOCALE",
              "RISQUE DE SURDOSAGE",
              "RISQUE DE REACTION CUTANEE",
              "HEPATOTOXICITE",
              "RISQUE DE SYNDROME DE STEVENS JOHNSON (SSJ)",
              "RISQUE DE PUSTULOSE EXANTHEMATIQUE (PEAG)",
              "SURVEILLANCE CLINIQUE",
            ],
            text: null,
          },
        ],
      },
      {
        dose: "150 mg",
        form: "poudre pour solution buvable",
        contraindications: [
          {
            label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: [
              "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
              "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
              "HYPERSENSIBILITE FRUCTOSE (INTOLERANCE)",
              "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
              "HYPERSENSIBILITE SACCHAROSE (INTOLERANCE)",
            ],
            other_comment: [
              "TENIR COMPTE PRESENCE SACCHAROSE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "INTOLERANCE GENETIQUE AU FRUCTOSE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "TENIR COMPTE PRESENCE SACCHAROSE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "DEFICIT EN SUCRASE-ISOMALTASE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "TENIR COMPTE PRESENCE SACCHAROSE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: [
              "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
              "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
              "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
            ],
            other_comment: [
              "TENIR COMPTE PRESENCE GLUCOSE",
              "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
            ],
            text: [
              "Ce médicament contient du glucose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) d'une intolérance à certains sucres, contactez-le avant de prendre ce médicament.\r\n\r\n- Commentaire :\r\nProposition de RCP : Les patients présentant un syndrome de malabsorption du glucose et du galactose\r\n(maladie héréditaire rare) ne doivent pas prendre ce médicament.\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
            ],
          },
          {
            label: "QUEL QUE SOIT LE TERRAIN",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "TENIR COMPTE PRESENCE SACCHAROSE",
              "Cf. COMPOSITION",
              "RISQUE DE SURDOSAGE",
              "HEPATOTOXICITE",
              "PRESENCE D'EXCIPIENT(S) A EFFET NOTOIRE",
            ],
            text: null,
          },
          {
            label: "MUCOVISCIDOSE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HEPATITE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["HEPATITE AIGUE"],
            other_comment: [
              "ARRETER LE TRAITEMENT",
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
            ],
            text: [
              "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
            ],
          },
          {
            label: "HEPATITE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["HEPATITE CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
            other_comment: null,
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: [
              "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
              "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
            ],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INFECTION VIH",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DESHYDRATATION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HYPOVOLEMIE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "RISQUE D'ANEMIE",
              "RISQUE D'HEMOLYSE",
            ],
            text: null,
          },
          {
            label: "SYNDROME DE GILBERT",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DENUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "AMAIGRISSEMENT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "MALNUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["MALNUTRITION CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ALCOOLISME CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "SEVRAGE ALCOOLIQUE SYNDROME",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SEVRAGE ALCOOLIQUE"],
            other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
            text: null,
          },
          {
            label: "ANOREXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE RENALE CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["INSUFFISANCE RENALE SEVERE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. PROPRIETES PHARMACOCINETIQUES",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INTERACTION D'ORIGINE ALIMENTAIRE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: ["INGESTION D'ALCOOL"],
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "RISQUE D'ATTEINTE HEPATIQUE",
            ],
            text: [
              "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
            ],
          },
          {
            label: "JEUNE STRICT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "CACHEXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "EXAMEN LABORATOIRE INTERFERENCE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
            other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
            text: [
              "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
            ],
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "UTILISER AVEC PRUDENCE",
              "EN CAS DE POSOLOGIE ELEVEE",
              "RISQUE D'HEMOLYSE",
              "REFERENTIEL ANSM G6PD 13/06/2014",
            ],
            text: [
              "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
            ],
          },
          {
            label: "ENFANT",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["ENFANT DE PLUS DE 30 KG"],
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant de 8 à 30 kg (soit environ de 6 mois à 11 ans).",
            ],
          },
          {
            label: "NOURRISSON",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["NOURRISSON DE MOINS DE 8 KG"],
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant de 8 à 30 kg (soit environ de 6 mois à 11 ans).",
            ],
          },
          {
            label: "NOUVEAU-NE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant pesant de 8 à 30 kg (environ 6 mois à 11 ans).",
            ],
          },
          {
            label: "SUJET AGE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant de 8 à 30 kg (soit environ de 6 mois à 11 ans).",
            ],
          },
          {
            label: "ADULTE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'enfant de 8 à 30 kg (soit environ de 6 mois à 11 ans).",
            ],
          },
        ],
      },
      {
        dose: "500 mg",
        form: "comprimé",
        contraindications: [
          {
            label: "PATIENT DE FAIBLE POIDS",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["PATIENT DE MOINS DE 50 KG"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ENFANT",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["ENFANT DE MOINS DE 6 ANS", "ENFANT DE MOINS DE 27 KG"],
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
              "RISQUE DE FAUSSE ROUTE",
              "FORME GALENIQUE INADAPTEE A CE TERRAIN",
            ],
            text: [
              "La prise de comprimé ou de gélule est contre-indiquée chez l'enfant de moins de 6 ans car elle peut entraîner une fausse route.\r\n\r\nCette présentation est réservée à l'adulte et l'enfant à partir de 27 kg (soit environ à partir de 8 ans).",
            ],
          },
          {
            label: "ENFANT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: [
              "ENFANT DE PLUS DE 6 ANS",
              "ENFANT DE MOINS DE 50 KG",
              "ENFANT DE PLUS DE 26 KG",
            ],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "ADAPTER LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "NOURRISSON",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "RISQUE DE FAUSSE ROUTE",
              "FORME GALENIQUE INADAPTEE A CE TERRAIN",
            ],
            text: [
              "La prise de comprimé ou de gélule est contre-indiquée chez l'enfant de moins de 6 ans car elle peut entraîner une fausse route.",
            ],
          },
          {
            label: "NOUVEAU-NE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "RISQUE DE FAUSSE ROUTE",
              "FORME GALENIQUE INADAPTEE A CE TERRAIN",
            ],
            text: [
              "La prise de comprimé ou de gélule est contre-indiquée chez l'enfant de moins de 6 ans car elle peut entraîner une fausse route.",
            ],
          },
          {
            label: "SUJET AGE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SUJET AGE DE PLUS DE 75 ANS"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: [
              "La dose journalière efficace la plus faible possible doit être envisagée, sans excéder 60 mg/kg/jour (sans dépasser 3 g/jour) dans les situations suivantes : [...]\r\n- sujet âgé de plus de 75 ans.",
            ],
          },
          {
            label: "SUJET AGE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SUJET POLYPATHOLOGIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: [
              "La dose journalière efficace la plus faible possible doit être envisagée, sans excéder 60 mg/kg/jour (sans dépasser 3 g/jour) dans les situations suivantes : [...]\r\n- sujet âgé de plus de 65 ans et polypathologique.",
            ],
          },
          {
            label: "MUCOVISCIDOSE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HEPATITE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["HEPATITE AIGUE"],
            other_comment: [
              "ARRETER LE TRAITEMENT",
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
            ],
            text: [
              "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
            ],
          },
          {
            label: "HEPATITE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["HEPATITE CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
            other_comment: null,
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: [
              "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
              "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
            ],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INFECTION VIH",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DESHYDRATATION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HYPOVOLEMIE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "RISQUE D'ANEMIE",
              "RISQUE D'HEMOLYSE",
            ],
            text: null,
          },
          {
            label: "SYNDROME DE GILBERT",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DENUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "AMAIGRISSEMENT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "MALNUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["MALNUTRITION CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ALCOOLISME CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "SEVRAGE ALCOOLIQUE SYNDROME",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SEVRAGE ALCOOLIQUE"],
            other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
            text: null,
          },
          {
            label: "ANOREXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE RENALE CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["INSUFFISANCE RENALE SEVERE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. PROPRIETES PHARMACOCINETIQUES",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INTERACTION D'ORIGINE ALIMENTAIRE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: ["INGESTION D'ALCOOL"],
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "RISQUE D'ATTEINTE HEPATIQUE",
            ],
            text: [
              "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
            ],
          },
          {
            label: "JEUNE STRICT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "CACHEXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "EXAMEN LABORATOIRE INTERFERENCE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
            other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
            text: [
              "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
            ],
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "UTILISER AVEC PRUDENCE",
              "EN CAS DE POSOLOGIE ELEVEE",
              "RISQUE D'HEMOLYSE",
              "REFERENTIEL ANSM G6PD 13/06/2014",
            ],
            text: [
              "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
            ],
          },
          {
            label: "QUEL QUE SOIT LE TERRAIN",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "RISQUE DE SURDOSAGE",
              "RISQUE DE REACTION CUTANEE",
              "HEPATOTOXICITE",
              "RISQUE DE SYNDROME DE STEVENS JOHNSON (SSJ)",
              "RISQUE DE PUSTULOSE EXANTHEMATIQUE (PEAG)",
            ],
            text: null,
          },
        ],
      },
      {
        dose: "1000 mg",
        form: "comprimé",
        contraindications: [
          {
            label: "MUCOVISCIDOSE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HEPATITE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["HEPATITE AIGUE"],
            other_comment: [
              "ARRETER LE TRAITEMENT",
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
            ],
            text: [
              "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
            ],
          },
          {
            label: "HEPATITE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["HEPATITE CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
            other_comment: null,
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: [
              "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
              "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
            ],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INFECTION VIH",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DESHYDRATATION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HYPOVOLEMIE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "RISQUE D'ANEMIE",
              "RISQUE D'HEMOLYSE",
            ],
            text: null,
          },
          {
            label: "SYNDROME DE GILBERT",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DENUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "AMAIGRISSEMENT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "MALNUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["MALNUTRITION CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ALCOOLISME CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "SEVRAGE ALCOOLIQUE SYNDROME",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SEVRAGE ALCOOLIQUE"],
            other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
            text: null,
          },
          {
            label: "ANOREXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE RENALE CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["INSUFFISANCE RENALE SEVERE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. PROPRIETES PHARMACOCINETIQUES",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INTERACTION D'ORIGINE ALIMENTAIRE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: ["INGESTION D'ALCOOL"],
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "RISQUE D'ATTEINTE HEPATIQUE",
            ],
            text: [
              "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
            ],
          },
          {
            label: "JEUNE STRICT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "CACHEXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "EXAMEN LABORATOIRE INTERFERENCE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
            other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
            text: [
              "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
            ],
          },
          {
            label: "PATIENT DE FAIBLE POIDS",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["PATIENT DE MOINS DE 50 KG"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ENFANT",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["ENFANT DE MOINS DE 50 KG"],
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée à l'adulte et à l'enfant à partir de 50 kg (soit à partir d'environ 15 ans).",
            ],
          },
          {
            label: "ENFANT",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["ENFANT DE MOINS DE 6 ANS"],
            other_comment: [
              "RISQUE DE FAUSSE ROUTE",
              "FORME GALENIQUE INADAPTEE A CE TERRAIN",
            ],
            text: null,
          },
          {
            label: "NOURRISSON",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "RISQUE DE FAUSSE ROUTE",
              "FORME GALENIQUE INADAPTEE A CE TERRAIN",
            ],
            text: [""],
          },
          {
            label: "NOUVEAU-NE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "RISQUE DE FAUSSE ROUTE",
              "FORME GALENIQUE INADAPTEE A CE TERRAIN",
            ],
            text: [""],
          },
          {
            label: "SUJET AGE",
            level: ["PAS DE PRECAUTION D'EMPLOI"],
            comment: ["SUJET AGE DE PLUS DE 75 ANS"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "SUJET AGE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SUJET POLYPATHOLOGIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "UTILISER AVEC PRUDENCE",
              "EN CAS DE POSOLOGIE ELEVEE",
              "RISQUE D'HEMOLYSE",
              "REFERENTIEL ANSM G6PD 13/06/2014",
            ],
            text: [
              "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
            ],
          },
          {
            label: "QUEL QUE SOIT LE TERRAIN",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "RISQUE DE SURDOSAGE",
              "RISQUE DE REACTION CUTANEE",
              "HEPATOTOXICITE",
              "RISQUE DE SYNDROME DE STEVENS JOHNSON (SSJ)",
              "RISQUE DE PUSTULOSE EXANTHEMATIQUE (PEAG)",
            ],
            text: null,
          },
        ],
      },
      {
        dose: "150 mg",
        form: "suppositoire",
        contraindications: [
          {
            label: "MUCOVISCIDOSE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HEPATITE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["HEPATITE AIGUE"],
            other_comment: [
              "ARRETER LE TRAITEMENT",
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
            ],
            text: [
              "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
            ],
          },
          {
            label: "HEPATITE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["HEPATITE CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
            other_comment: null,
            text: null,
          },
          {
            label: "INSUFFISANCE HEPATIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: [
              "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
              "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
            ],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INFECTION VIH",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DESHYDRATATION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "HYPOVOLEMIE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "RISQUE D'ANEMIE",
              "RISQUE D'HEMOLYSE",
            ],
            text: null,
          },
          {
            label: "SYNDROME DE GILBERT",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "DENUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "AMAIGRISSEMENT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "MALNUTRITION",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["MALNUTRITION CHRONIQUE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "ALCOOLISME CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "SEVRAGE ALCOOLIQUE SYNDROME",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["SEVRAGE ALCOOLIQUE"],
            other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
            text: null,
          },
          {
            label: "ANOREXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INSUFFISANCE RENALE CHRONIQUE",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: ["INSUFFISANCE RENALE SEVERE"],
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. PROPRIETES PHARMACOCINETIQUES",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "INTERACTION D'ORIGINE ALIMENTAIRE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: ["INGESTION D'ALCOOL"],
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "RISQUE D'ATTEINTE HEPATIQUE",
            ],
            text: [
              "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
            ],
          },
          {
            label: "JEUNE STRICT",
            level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "CACHEXIE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "UTILISER AVEC PRUDENCE",
              "REDUIRE LA POSOLOGIE",
              "Cf. POSOLOGIE",
            ],
            text: null,
          },
          {
            label: "EXAMEN LABORATOIRE INTERFERENCE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
            other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
            text: [
              "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
            ],
          },
          {
            label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "UTILISER AVEC PRUDENCE",
              "EN CAS DE POSOLOGIE ELEVEE",
              "RISQUE D'HEMOLYSE",
              "REFERENTIEL ANSM G6PD 13/06/2014",
            ],
            text: [
              "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
            ],
          },
          {
            label: "ENFANT",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: ["ENFANT DE PLUS DE 12 KG"],
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée AU NOURRISSON pesant de 8 à 12 kg (environ 6 à 24 mois).",
            ],
          },
          {
            label: "NOURRISSON",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: [
              "NOURRISSON DE PLUS DE 12 KG",
              "NOURRISSON DE MOINS DE 8 KG",
            ],
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée AU NOURRISSON pesant de 8 à 12 kg (environ 6 à 24 mois).",
            ],
          },
          {
            label: "NOUVEAU-NE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée AU NOURRISSON pesant de 8 à 12 kg (environ 6 à 24 mois).",
            ],
          },
          {
            label: "SUJET AGE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée AU NOURRISSON pesant de 8 à 12 kg (environ 6 à 24 mois).",
            ],
          },
          {
            label: "ADULTE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: null,
            other_comment: [
              "Cf. INDICATIONS",
              "DOSAGE INADAPTE POUR CE TERRAIN",
            ],
            text: [
              "Cette présentation est réservée AU NOURRISSON pesant de 8 à 12 kg (environ 6 à 24 mois).",
            ],
          },
          {
            label: "DIARRHEE",
            level: ["UTILISATION DECONSEILLEE"],
            comment: null,
            other_comment: [
              "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
              "FORME GALENIQUE INADAPTEE A CE TERRAIN",
            ],
            text: [
              "En cas de diarrhée, la forme suppositoire n'est pas adaptée.",
            ],
          },
          {
            label: "RECTITE / RECTORRAGIE",
            level: ["CONTRE-INDICATION ABSOLUE"],
            comment: [
              "LESION ANORECTALE ANTECEDENT PERSONNEL",
              "RECTITE/RECTORRAGIE ANTECEDENT PERSONNEL",
            ],
            other_comment: null,
            text: null,
          },
          {
            label: "QUEL QUE SOIT LE TERRAIN",
            level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
            comment: null,
            other_comment: [
              "RESPECTER LA POSOLOGIE",
              "PREVENIR LE MALADE",
              "RISQUE DE TOXICITE LOCALE",
              "RISQUE DE SURDOSAGE",
              "RISQUE DE REACTION CUTANEE",
              "HEPATOTOXICITE",
              "RISQUE DE SYNDROME DE STEVENS JOHNSON (SSJ)",
              "RISQUE DE PUSTULOSE EXANTHEMATIQUE (PEAG)",
              "SURVEILLANCE CLINIQUE",
            ],
            text: null,
          },
        ],
      },
    ],
  };

export const mockDolipraneContraindications: FormDoseAndContraindications[] = [
  {
    dose: "1000 mg",
    form: "poudre pour solution buvable",
    contraindications: [
      {
        label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [
          "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
          "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
          "HYPERSENSIBILITE FRUCTOSE (INTOLERANCE)",
          "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
          "HYPERSENSIBILITE SACCHAROSE (INTOLERANCE)",
        ],
        other_comment: [
          "TENIR COMPTE PRESENCE SACCHAROSE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "INTOLERANCE GENETIQUE AU FRUCTOSE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: [
          "TENIR COMPTE PRESENCE SACCHAROSE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "DEFICIT EN SUCRASE-ISOMALTASE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: [
          "TENIR COMPTE PRESENCE SACCHAROSE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [
          "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
          "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
          "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
        ],
        other_comment: [
          "TENIR COMPTE PRESENCE GLUCOSE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du glucose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) d'une intolérance à certains sucres, contactez-le avant de prendre ce médicament.\r\n\r\n- Commentaire :\r\nProposition de RCP : Les patients présentant un syndrome de malabsorption du glucose et du galactose\r\n(maladie héréditaire rare) ne doivent pas prendre ce médicament.\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "QUEL QUE SOIT LE TERRAIN",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "TENIR COMPTE PRESENCE SACCHAROSE",
          "Cf. COMPOSITION",
          "RISQUE DE SURDOSAGE",
          "HEPATOTOXICITE",
          "PRESENCE D'EXCIPIENT(S) A EFFET NOTOIRE",
        ],
        text: [],
      },
      {
        label: "MUCOVISCIDOSE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HEPATITE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["HEPATITE AIGUE"],
        other_comment: [
          "ARRETER LE TRAITEMENT",
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
        ],
        text: [
          "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
        ],
      },
      {
        label: "HEPATITE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["HEPATITE CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
        other_comment: [],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [
          "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
          "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
        ],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INFECTION VIH",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DESHYDRATATION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HYPOVOLEMIE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "RISQUE D'ANEMIE",
          "RISQUE D'HEMOLYSE",
        ],
        text: [],
      },
      {
        label: "SYNDROME DE GILBERT",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DENUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "AMAIGRISSEMENT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "MALNUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["MALNUTRITION CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ALCOOLISME CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "SEVRAGE ALCOOLIQUE SYNDROME",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SEVRAGE ALCOOLIQUE"],
        other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
        text: [],
      },
      {
        label: "ANOREXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE RENALE CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["INSUFFISANCE RENALE SEVERE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. PROPRIETES PHARMACOCINETIQUES",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INTERACTION D'ORIGINE ALIMENTAIRE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: ["INGESTION D'ALCOOL"],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "RISQUE D'ATTEINTE HEPATIQUE",
        ],
        text: [
          "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
        ],
      },
      {
        label: "JEUNE STRICT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "CACHEXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "EXAMEN LABORATOIRE INTERFERENCE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
        other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
        text: [
          "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
        ],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "UTILISER AVEC PRUDENCE",
          "EN CAS DE POSOLOGIE ELEVEE",
          "RISQUE D'HEMOLYSE",
          "REFERENTIEL ANSM G6PD 13/06/2014",
        ],
        text: [
          "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
        ],
      },
      {
        label: "PATIENT DE FAIBLE POIDS",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["PATIENT DE MOINS DE 50 KG"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ENFANT",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["ENFANT DE MOINS DE 50 KG"],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'adulte et à l'enfant à partir de 50 kg (soit à partir d'environ 15 ans).",
        ],
      },
      {
        label: "NOURRISSON",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: [
          "Cf. INDICATIONS",
          "DOSAGE INADAPTE POUR CE TERRAIN",
          "RISQUE DE FAUSSE ROUTE",
          "FORME GALENIQUE INADAPTEE A CE TERRAIN",
        ],
        text: [
          "Cette présentation est réservée à l'adulte et à l'enfant à partir de 50 kg (soit à partir d'environ 15 ans).",
        ],
      },
      {
        label: "NOUVEAU-NE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: [
          "Cf. INDICATIONS",
          "DOSAGE INADAPTE POUR CE TERRAIN",
          "RISQUE DE FAUSSE ROUTE",
          "FORME GALENIQUE INADAPTEE A CE TERRAIN",
        ],
        text: [
          "Cette présentation est réservée à l'adulte et à l'enfant à partir de 50 kg (soit à partir d'environ 15 ans).",
        ],
      },
      {
        label: "SUJET AGE",
        level: ["PAS DE PRECAUTION D'EMPLOI"],
        comment: ["SUJET AGE DE PLUS DE 75 ANS"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "SUJET AGE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SUJET POLYPATHOLOGIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
    ],
  },
  {
    dose: "500 mg",
    form: "poudre pour solution buvable",
    contraindications: [
      {
        label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [
          "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
          "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
          "HYPERSENSIBILITE FRUCTOSE (INTOLERANCE)",
          "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
          "HYPERSENSIBILITE SACCHAROSE (INTOLERANCE)",
        ],
        other_comment: [
          "TENIR COMPTE PRESENCE SACCHAROSE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "INTOLERANCE GENETIQUE AU FRUCTOSE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: [
          "TENIR COMPTE PRESENCE SACCHAROSE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "DEFICIT EN SUCRASE-ISOMALTASE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: [
          "TENIR COMPTE PRESENCE SACCHAROSE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [
          "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
          "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
          "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
        ],
        other_comment: [
          "TENIR COMPTE PRESENCE GLUCOSE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du glucose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) d'une intolérance à certains sucres, contactez-le avant de prendre ce médicament.\r\n\r\n- Commentaire :\r\nProposition de RCP : Les patients présentant un syndrome de malabsorption du glucose et du galactose\r\n(maladie héréditaire rare) ne doivent pas prendre ce médicament.\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "QUEL QUE SOIT LE TERRAIN",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "TENIR COMPTE PRESENCE SACCHAROSE",
          "Cf. COMPOSITION",
          "RISQUE DE SURDOSAGE",
          "HEPATOTOXICITE",
          "PRESENCE D'EXCIPIENT(S) A EFFET NOTOIRE",
        ],
        text: [],
      },
      {
        label: "MUCOVISCIDOSE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HEPATITE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["HEPATITE AIGUE"],
        other_comment: [
          "ARRETER LE TRAITEMENT",
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
        ],
        text: [
          "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
        ],
      },
      {
        label: "HEPATITE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["HEPATITE CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
        other_comment: [],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [
          "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
          "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
        ],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INFECTION VIH",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DESHYDRATATION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HYPOVOLEMIE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "RISQUE D'ANEMIE",
          "RISQUE D'HEMOLYSE",
        ],
        text: [],
      },
      {
        label: "SYNDROME DE GILBERT",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DENUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "AMAIGRISSEMENT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "MALNUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["MALNUTRITION CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ALCOOLISME CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "SEVRAGE ALCOOLIQUE SYNDROME",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SEVRAGE ALCOOLIQUE"],
        other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
        text: [],
      },
      {
        label: "ANOREXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE RENALE CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["INSUFFISANCE RENALE SEVERE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. PROPRIETES PHARMACOCINETIQUES",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INTERACTION D'ORIGINE ALIMENTAIRE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: ["INGESTION D'ALCOOL"],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "RISQUE D'ATTEINTE HEPATIQUE",
        ],
        text: [
          "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
        ],
      },
      {
        label: "JEUNE STRICT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "CACHEXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "EXAMEN LABORATOIRE INTERFERENCE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
        other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
        text: [
          "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
        ],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "UTILISER AVEC PRUDENCE",
          "EN CAS DE POSOLOGIE ELEVEE",
          "RISQUE D'HEMOLYSE",
          "REFERENTIEL ANSM G6PD 13/06/2014",
        ],
        text: [
          "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
        ],
      },
      {
        label: "PATIENT DE FAIBLE POIDS",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["PATIENT DE MOINS DE 50 KG"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ENFANT",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["ENFANT DE MOINS DE 27 KG"],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'adulte et l'enfant à partir de 27 kg (à partir d'environ 8 ans).",
        ],
      },
      {
        label: "ENFANT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["ENFANT DE MOINS DE 50 KG", "ENFANT DE PLUS DE 26 KG"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "ADAPTER LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "NOURRISSON",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'adulte et l'enfant à partir de 27 kg (à partir d'environ 8 ans).",
        ],
      },
      {
        label: "NOUVEAU-NE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'adulte et l'enfant à partir de 27 kg (à partir d'environ 8 ans).",
        ],
      },
      {
        label: "SUJET AGE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SUJET AGE DE PLUS DE 75 ANS"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [
          "La dose journalière efficace la plus faible possible doit être envisagée, sans excéder 60 mg/kg/jour (sans dépasser 3 g/jour) dans les situations suivantes : [...]\r\n- sujet âgé de plus de 75 ans.",
        ],
      },
      {
        label: "SUJET AGE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SUJET POLYPATHOLOGIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [
          "La dose journalière efficace la plus faible possible doit être envisagée, sans excéder 60 mg/kg/jour (sans dépasser 3 g/jour) dans les situations suivantes : [...]\r\n- sujet âgé de plus de 65 ans et polypathologique.",
        ],
      },
    ],
  },
  {
    dose: "100 mg",
    form: "poudre pour solution buvable",
    contraindications: [
      {
        label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [
          "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
          "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
          "HYPERSENSIBILITE FRUCTOSE (INTOLERANCE)",
          "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
          "HYPERSENSIBILITE SACCHAROSE (INTOLERANCE)",
        ],
        other_comment: [
          "TENIR COMPTE PRESENCE SACCHAROSE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "INTOLERANCE GENETIQUE AU FRUCTOSE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: [
          "TENIR COMPTE PRESENCE SACCHAROSE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "DEFICIT EN SUCRASE-ISOMALTASE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: [
          "TENIR COMPTE PRESENCE SACCHAROSE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [
          "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
          "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
          "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
        ],
        other_comment: [
          "TENIR COMPTE PRESENCE GLUCOSE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du glucose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) d'une intolérance à certains sucres, contactez-le avant de prendre ce médicament.\r\n\r\n- Commentaire :\r\nProposition de RCP : Les patients présentant un syndrome de malabsorption du glucose et du galactose\r\n(maladie héréditaire rare) ne doivent pas prendre ce médicament.\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "QUEL QUE SOIT LE TERRAIN",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "TENIR COMPTE PRESENCE SACCHAROSE",
          "Cf. COMPOSITION",
          "RISQUE DE SURDOSAGE",
          "HEPATOTOXICITE",
          "PRESENCE D'EXCIPIENT(S) A EFFET NOTOIRE",
        ],
        text: [],
      },
      {
        label: "MUCOVISCIDOSE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HEPATITE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["HEPATITE AIGUE"],
        other_comment: [
          "ARRETER LE TRAITEMENT",
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
        ],
        text: [
          "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
        ],
      },
      {
        label: "HEPATITE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["HEPATITE CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
        other_comment: [],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [
          "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
          "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
        ],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INFECTION VIH",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DESHYDRATATION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HYPOVOLEMIE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "RISQUE D'ANEMIE",
          "RISQUE D'HEMOLYSE",
        ],
        text: [],
      },
      {
        label: "SYNDROME DE GILBERT",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DENUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "AMAIGRISSEMENT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "MALNUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["MALNUTRITION CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ALCOOLISME CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "SEVRAGE ALCOOLIQUE SYNDROME",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SEVRAGE ALCOOLIQUE"],
        other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
        text: [],
      },
      {
        label: "ANOREXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE RENALE CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["INSUFFISANCE RENALE SEVERE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. PROPRIETES PHARMACOCINETIQUES",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INTERACTION D'ORIGINE ALIMENTAIRE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: ["INGESTION D'ALCOOL"],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "RISQUE D'ATTEINTE HEPATIQUE",
        ],
        text: [
          "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
        ],
      },
      {
        label: "JEUNE STRICT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "CACHEXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "EXAMEN LABORATOIRE INTERFERENCE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
        other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
        text: [
          "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
        ],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "UTILISER AVEC PRUDENCE",
          "EN CAS DE POSOLOGIE ELEVEE",
          "RISQUE D'HEMOLYSE",
          "REFERENTIEL ANSM G6PD 13/06/2014",
        ],
        text: [
          "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
        ],
      },
      {
        label: "ENFANT",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["ENFANT DE PLUS DE 20 KG"],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant de 6 à 20 kg (soit environ de 3 mois à 7 ans).",
        ],
      },
      {
        label: "NOURRISSON",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["NOURRISSON DE MOINS DE 6 KG"],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant de 6 à 20 kg (soit environ de 3 mois à 7 ans).",
        ],
      },
      {
        label: "NOUVEAU-NE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant de 6 à 20 kg (soit environ de 3 mois à 7 ans).",
        ],
      },
      {
        label: "SUJET AGE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [],
      },
      {
        label: "ADULTE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant de 6 à 20 kg (soit environ de 3 mois à 7 ans).",
        ],
      },
    ],
  },
  {
    dose: "1000 mg",
    form: "comprimé effervescent",
    contraindications: [
      {
        label: "REGIME HYPOSODE STRICT",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "TENIR COMPTE PRESENCE SODIUM",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du sodium comme excipient.\r\n\r\n* Voie d'administration : Orale et parentérale\r\n\r\n- Seuil : > ou = 1 mmol (23 mg) par \"dose administrée\"\r\n\r\n- Information pour la notice \r\nCe médicament contient x mg de sodium (composant principal du sel de cuisine/table) par <dose><volume unitaire>. Cela équivaut à y% de l'apport alimentaire quotidien maximal recommandé de sodium pour un adulte.\r\n\r\n- Commentaires\r\nEn cas d'administration parentérale à dosage variable (par exemple, en fonction du poids), la teneur en sodium\r\npeut être exprimée en mg par flacon.\r\nLibellé proposé pour le RCP : \"Ce médicament contient x mg de sodium par <dose>, ce qui équivaut à y% de l'apport alimentaire quotidien maximal recommandé par l'OMS de 2 g de sodium par adulte.\"\r\n\r\n\r\n* Voie d'administration : Orale et parentérale\r\n\r\n- Seuil : 17 mmol (391 mg) à la dose quotidienne maximale\r\n\r\n- Information pour la notice \r\nParlez-en à votre médecin ou votre pharmacien si vous avez besoin de <Z> ou de plus de <dose> quotidiennement pendant une période prolongée, surtout si vous devez suivre un régime à faible teneur en sel (sodium).\r\n\r\n- Commentaires\r\nCeci s'applique uniquement aux produits pour lesquels la posologie indiquée permet une prise quotidienne pendant\r\nplus d'un mois ou une utilisation répétée de plus de deux jours par semaine.\r\n17 mmol (391 mg) représente environ 20% de l'apport alimentaire quotidien maximal adulte recommandé par\r\nl'OMS de 2 g de sodium et est considéré comme un dosage \"élevé\". Ceci vaut également pour les enfants, pour lesquels l'apport quotidien maximal est censé être proportionnel à celui des adultes et calculé selon les besoins\r\nénergétiques.\r\n<Doses Z> reflète le nombre minimum de doses pour lesquelles le seuil de 17 mmol (391 mg) de sodium est\r\natteint/dépassé. Arrondir au nombre entier le plus proche.\r\nPour le libellé du RCP, veuillez vous reporter à la recommandation du PRAC: \"1.3. Sodium-containing effervescent, dispersible and soluble medicines – Cardiovascular events\" (EMA/PRAC/234960/2015).\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "EPILEPSIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: ["EPILEPSIE ANTECEDENT PERSONNEL"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "TENIR COMPTE PRESENCE TERPENE",
          "ABAISSEMENT SEUIL EPILEPTOGENE",
          "LIE A EXCIPIENT",
        ],
        text: [
          "Ce médicament contient des dérivés terpéniques, comme excipient, qui peuvent abaisser le seuil épileptogène.  ",
        ],
      },
      {
        label: "ENFANT",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "TENIR COMPTE PRESENCE TERPENE",
          "RISQUE DE NEUROTOXICITE",
          "ABAISSEMENT SEUIL EPILEPTOGENE",
          "LIE A EXCIPIENT",
        ],
        text: [
          "Ce médicament contient des dérivés terpéniques, comme excipient, qui peuvent abaisser le seuil épileptogène.\r\n\r\nEn raison de la présence de dérivés terpéniques dans la composition et en cas de non respect des doses préconisées, un risque de convulsion existe chez l'enfant et le nourrisson.\r\n\r\nPour ces raisons entre autres, certains de ces médicaments contenant des dérivés terpéniques peuvent être réservés à l'adulte.",
        ],
      },
      {
        label: "NOURRISSON",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "TENIR COMPTE PRESENCE TERPENE",
          "RISQUE DE NEUROTOXICITE",
          "ABAISSEMENT SEUIL EPILEPTOGENE",
          "LIE A EXCIPIENT",
        ],
        text: [
          "Ce médicament contient des dérivés terpéniques, comme excipient, qui peuvent abaisser le seuil épileptogène.\r\n\r\nEn raison de la présence de dérivés terpéniques dans la composition et en cas de non respect des doses préconisées, un risque de convulsion existe chez l'enfant et le nourrisson.\r\n\r\nPour ces raisons entre autres, certains de ces médicaments contenant des dérivés terpéniques peuvent être réservés à l'adulte.",
        ],
      },
      {
        label: "NOUVEAU-NE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "TENIR COMPTE PRESENCE TERPENE",
          "RISQUE DE NEUROTOXICITE",
          "ABAISSEMENT SEUIL EPILEPTOGENE",
          "LIE A EXCIPIENT",
        ],
        text: [
          "Ce médicament contient des dérivés terpéniques, comme excipient, qui peuvent abaisser le seuil épileptogène.\r\n\r\nEn raison de la présence de dérivés terpéniques dans la composition et en cas de non respect des doses préconisées, un risque de convulsion existe chez l'enfant et le nourrisson.\r\n\r\nPour ces raisons entre autres, certains de ces médicaments contenant des dérivés terpéniques peuvent être réservés à l'adulte.",
        ],
      },
      {
        label: "ALLAITEMENT",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISATION A EVITER",
          "TENIR COMPTE PRESENCE TERPENE",
          "PAS D'ETUDE DANS L'ESPECE HUMAINE",
          "RISQUE DE NEUROTOXICITE",
          "Cf. GROSSESSE ET ALLAITEMENT",
          "LIE A EXCIPIENT",
        ],
        text: [
          "Ce médicament contient des dérivés terpéniques comme excipient.\r\n\r\nEn cas d'allaitement, il est préférable de ne pas utiliser ce médicament du fait de l'absence de donnée cinétique sur le passage des dérivés terpéniques dans le lait et de leur toxicité neurologique potentielle chez le nourrisson.",
        ],
      },
      {
        label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [
          "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
          "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
          "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
        ],
        other_comment: [
          "TENIR COMPTE PRESENCE GLUCOSE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du glucose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) d'une intolérance à certains sucres, contactez-le avant de prendre ce médicament.\r\n\r\n- Commentaire :\r\nProposition de RCP : Les patients présentant un syndrome de malabsorption du glucose et du galactose\r\n(maladie héréditaire rare) ne doivent pas prendre ce médicament.\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "EPILEPSIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "TENIR COMPTE PRESENCE TERPENE",
          "ABAISSEMENT SEUIL EPILEPTOGENE",
          "LIE A EXCIPIENT",
        ],
        text: [
          "Ce médicament contient des dérivés terpéniques, comme excipient, qui peuvent abaisser le seuil épileptogène.  ",
        ],
      },
      {
        label: "QUEL QUE SOIT LE TERRAIN",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "TENIR COMPTE PRESENCE MALTOSE DEXTRINE",
          "TENIR COMPTE PRESENCE SODIUM",
          "RISQUE DE SURDOSAGE",
          "HEPATOTOXICITE",
          "PRESENCE D'EXCIPIENT(S) A EFFET NOTOIRE",
        ],
        text: [],
      },
      {
        label: "MUCOVISCIDOSE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HEPATITE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["HEPATITE AIGUE"],
        other_comment: [
          "ARRETER LE TRAITEMENT",
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
        ],
        text: [
          "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
        ],
      },
      {
        label: "HEPATITE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["HEPATITE CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
        other_comment: [],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [
          "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
          "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
        ],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INFECTION VIH",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DESHYDRATATION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HYPOVOLEMIE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "RISQUE D'ANEMIE",
          "RISQUE D'HEMOLYSE",
        ],
        text: [],
      },
      {
        label: "SYNDROME DE GILBERT",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DENUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "AMAIGRISSEMENT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "MALNUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["MALNUTRITION CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ALCOOLISME CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "SEVRAGE ALCOOLIQUE SYNDROME",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SEVRAGE ALCOOLIQUE"],
        other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
        text: [],
      },
      {
        label: "ANOREXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE RENALE CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["INSUFFISANCE RENALE SEVERE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. PROPRIETES PHARMACOCINETIQUES",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INTERACTION D'ORIGINE ALIMENTAIRE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: ["INGESTION D'ALCOOL"],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "RISQUE D'ATTEINTE HEPATIQUE",
        ],
        text: [
          "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
        ],
      },
      {
        label: "JEUNE STRICT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "CACHEXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "EXAMEN LABORATOIRE INTERFERENCE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
        other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
        text: [
          "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
        ],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "UTILISER AVEC PRUDENCE",
          "EN CAS DE POSOLOGIE ELEVEE",
          "RISQUE D'HEMOLYSE",
          "REFERENTIEL ANSM G6PD 13/06/2014",
        ],
        text: [
          "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
        ],
      },
      {
        label: "PATIENT DE FAIBLE POIDS",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["PATIENT DE MOINS DE 50 KG"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ENFANT",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["ENFANT DE MOINS DE 50 KG"],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'adulte et à l'enfant à partir de 50 kg (soit à partir d'environ 15 ans).",
        ],
      },
      {
        label: "NOURRISSON",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: [
          "Cf. INDICATIONS",
          "DOSAGE INADAPTE POUR CE TERRAIN",
          "RISQUE DE FAUSSE ROUTE",
          "FORME GALENIQUE INADAPTEE A CE TERRAIN",
        ],
        text: [
          "Cette présentation est réservée à l'adulte et à l'enfant à partir de 50 kg (soit à partir d'environ 15 ans).",
        ],
      },
      {
        label: "NOUVEAU-NE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: [
          "Cf. INDICATIONS",
          "DOSAGE INADAPTE POUR CE TERRAIN",
          "RISQUE DE FAUSSE ROUTE",
          "FORME GALENIQUE INADAPTEE A CE TERRAIN",
        ],
        text: [
          "Cette présentation est réservée à l'adulte et à l'enfant à partir de 50 kg (soit à partir d'environ 15 ans).",
        ],
      },
      {
        label: "SUJET AGE",
        level: ["PAS DE PRECAUTION D'EMPLOI"],
        comment: ["SUJET AGE DE PLUS DE 75 ANS"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "SUJET AGE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SUJET POLYPATHOLOGIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
    ],
  },
  {
    dose: "200 mg",
    form: "poudre pour solution buvable",
    contraindications: [
      {
        label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [
          "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
          "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
          "HYPERSENSIBILITE FRUCTOSE (INTOLERANCE)",
          "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
          "HYPERSENSIBILITE SACCHAROSE (INTOLERANCE)",
        ],
        other_comment: [
          "TENIR COMPTE PRESENCE SACCHAROSE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "INTOLERANCE GENETIQUE AU FRUCTOSE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: [
          "TENIR COMPTE PRESENCE SACCHAROSE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "DEFICIT EN SUCRASE-ISOMALTASE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: [
          "TENIR COMPTE PRESENCE SACCHAROSE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [
          "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
          "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
          "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
        ],
        other_comment: [
          "TENIR COMPTE PRESENCE GLUCOSE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du glucose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) d'une intolérance à certains sucres, contactez-le avant de prendre ce médicament.\r\n\r\n- Commentaire :\r\nProposition de RCP : Les patients présentant un syndrome de malabsorption du glucose et du galactose\r\n(maladie héréditaire rare) ne doivent pas prendre ce médicament.\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "QUEL QUE SOIT LE TERRAIN",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "TENIR COMPTE PRESENCE SACCHAROSE",
          "Cf. COMPOSITION",
          "RISQUE DE SURDOSAGE",
          "HEPATOTOXICITE",
          "PRESENCE D'EXCIPIENT(S) A EFFET NOTOIRE",
        ],
        text: [],
      },
      {
        label: "MUCOVISCIDOSE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HEPATITE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["HEPATITE AIGUE"],
        other_comment: [
          "ARRETER LE TRAITEMENT",
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
        ],
        text: [
          "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
        ],
      },
      {
        label: "HEPATITE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["HEPATITE CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
        other_comment: [],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [
          "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
          "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
        ],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INFECTION VIH",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DESHYDRATATION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HYPOVOLEMIE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "RISQUE D'ANEMIE",
          "RISQUE D'HEMOLYSE",
        ],
        text: [],
      },
      {
        label: "SYNDROME DE GILBERT",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DENUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "AMAIGRISSEMENT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "MALNUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["MALNUTRITION CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ALCOOLISME CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "SEVRAGE ALCOOLIQUE SYNDROME",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SEVRAGE ALCOOLIQUE"],
        other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
        text: [],
      },
      {
        label: "ANOREXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE RENALE CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["INSUFFISANCE RENALE SEVERE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. PROPRIETES PHARMACOCINETIQUES",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INTERACTION D'ORIGINE ALIMENTAIRE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: ["INGESTION D'ALCOOL"],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "RISQUE D'ATTEINTE HEPATIQUE",
        ],
        text: [
          "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
        ],
      },
      {
        label: "JEUNE STRICT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "CACHEXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "EXAMEN LABORATOIRE INTERFERENCE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
        other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
        text: [
          "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
        ],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "UTILISER AVEC PRUDENCE",
          "EN CAS DE POSOLOGIE ELEVEE",
          "RISQUE D'HEMOLYSE",
          "REFERENTIEL ANSM G6PD 13/06/2014",
        ],
        text: [
          "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
        ],
      },
      {
        label: "ENFANT",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["ENFANT DE MOINS DE 11 KG", "ENFANT DE PLUS DE 25 KG"],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant de 11 à 25 kg (soit environ de 18 mois à 10 ans).",
        ],
      },
      {
        label: "NOURRISSON",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["NOURRISSON DE MOINS DE 11 KG"],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant de 11 à 25 kg (soit environ de 18 mois à 10 ans).",
        ],
      },
      {
        label: "NOUVEAU-NE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant de 11 à 25 kg (soit environ de 18 mois à 10 ans).",
        ],
      },
      {
        label: "SUJET AGE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant de 11 à 25 kg (soit environ de 18 mois à 10 ans).",
        ],
      },
      {
        label: "ADULTE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant de 11 à 25 kg (soit environ de 18 mois à 10 ans).",
        ],
      },
    ],
  },
  {
    dose: "100 mg",
    form: "suppositoire",
    contraindications: [
      {
        label: "MUCOVISCIDOSE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HEPATITE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["HEPATITE AIGUE"],
        other_comment: [
          "ARRETER LE TRAITEMENT",
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
        ],
        text: [
          "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
        ],
      },
      {
        label: "HEPATITE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["HEPATITE CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
        other_comment: [],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [
          "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
          "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
        ],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INFECTION VIH",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DESHYDRATATION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HYPOVOLEMIE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "RISQUE D'ANEMIE",
          "RISQUE D'HEMOLYSE",
        ],
        text: [],
      },
      {
        label: "SYNDROME DE GILBERT",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DENUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "AMAIGRISSEMENT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "MALNUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["MALNUTRITION CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ALCOOLISME CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "SEVRAGE ALCOOLIQUE SYNDROME",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SEVRAGE ALCOOLIQUE"],
        other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
        text: [],
      },
      {
        label: "ANOREXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE RENALE CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["INSUFFISANCE RENALE SEVERE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. PROPRIETES PHARMACOCINETIQUES",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INTERACTION D'ORIGINE ALIMENTAIRE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: ["INGESTION D'ALCOOL"],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "RISQUE D'ATTEINTE HEPATIQUE",
        ],
        text: [
          "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
        ],
      },
      {
        label: "JEUNE STRICT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "CACHEXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "EXAMEN LABORATOIRE INTERFERENCE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
        other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
        text: [
          "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
        ],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "UTILISER AVEC PRUDENCE",
          "EN CAS DE POSOLOGIE ELEVEE",
          "RISQUE D'HEMOLYSE",
          "REFERENTIEL ANSM G6PD 13/06/2014",
        ],
        text: [
          "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
        ],
      },
      {
        label: "ENFANT",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée au nourrisson pesant de 3 à 8 kg (environ de la naissance à 9 mois).",
        ],
      },
      {
        label: "NOURRISSON",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["NOURRISSON DE MOINS DE 3 KG", "NOURRISSON DE PLUS DE 8 KG"],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée au nourrisson pesant de 3 à 8 kg (environ de la naissance à 9 mois).",
        ],
      },
      {
        label: "NOUVEAU-NE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["NOUVEAU-NE DE MOINS DE 3 KG"],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée au nourrisson pesant de 3 à 8 kg (environ de la naissance à 9 mois).",
        ],
      },
      {
        label: "SUJET AGE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée au nourrisson pesant de 3 à 8 kg (environ de la naissance à 9 mois).",
        ],
      },
      {
        label: "ADULTE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée au nourrisson pesant de 3 à 8 kg (environ de la naissance à 9 mois).",
        ],
      },
      {
        label: "DIARRHEE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: [],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "FORME GALENIQUE INADAPTEE A CE TERRAIN",
        ],
        text: ["En cas de diarrhée, la forme suppositoire n'est pas adaptée."],
      },
      {
        label: "RECTITE / RECTORRAGIE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [
          "LESION ANORECTALE ANTECEDENT PERSONNEL",
          "RECTITE/RECTORRAGIE ANTECEDENT PERSONNEL",
        ],
        other_comment: [],
        text: [],
      },
      {
        label: "QUEL QUE SOIT LE TERRAIN",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "PREVENIR LE MALADE",
          "RISQUE DE TOXICITE LOCALE",
          "RISQUE DE SURDOSAGE",
          "RISQUE DE REACTION CUTANEE",
          "HEPATOTOXICITE",
          "RISQUE DE SYNDROME DE STEVENS JOHNSON (SSJ)",
          "RISQUE DE PUSTULOSE EXANTHEMATIQUE (PEAG)",
          "SURVEILLANCE CLINIQUE",
        ],
        text: [],
      },
    ],
  },
  {
    dose: "200 mg",
    form: "suppositoire",
    contraindications: [
      {
        label: "MUCOVISCIDOSE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HEPATITE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["HEPATITE AIGUE"],
        other_comment: [
          "ARRETER LE TRAITEMENT",
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
        ],
        text: [
          "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
        ],
      },
      {
        label: "HEPATITE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["HEPATITE CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
        other_comment: [],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [
          "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
          "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
        ],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INFECTION VIH",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DESHYDRATATION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HYPOVOLEMIE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "RISQUE D'ANEMIE",
          "RISQUE D'HEMOLYSE",
        ],
        text: [],
      },
      {
        label: "SYNDROME DE GILBERT",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DENUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "AMAIGRISSEMENT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "MALNUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["MALNUTRITION CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ALCOOLISME CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "SEVRAGE ALCOOLIQUE SYNDROME",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SEVRAGE ALCOOLIQUE"],
        other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
        text: [],
      },
      {
        label: "ANOREXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE RENALE CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["INSUFFISANCE RENALE SEVERE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. PROPRIETES PHARMACOCINETIQUES",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INTERACTION D'ORIGINE ALIMENTAIRE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: ["INGESTION D'ALCOOL"],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "RISQUE D'ATTEINTE HEPATIQUE",
        ],
        text: [
          "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
        ],
      },
      {
        label: "JEUNE STRICT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "CACHEXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "EXAMEN LABORATOIRE INTERFERENCE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
        other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
        text: [
          "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
        ],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "UTILISER AVEC PRUDENCE",
          "EN CAS DE POSOLOGIE ELEVEE",
          "RISQUE D'HEMOLYSE",
          "REFERENTIEL ANSM G6PD 13/06/2014",
        ],
        text: [
          "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
        ],
      },
      {
        label: "ENFANT",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["ENFANT DE MOINS DE 12 KG", "ENFANT DE PLUS DE 16 KG"],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant pesant de 12 à 16 kg (environ 2 ans à 5 ans).",
        ],
      },
      {
        label: "NOURRISSON",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["NOURRISSON DE MOINS DE 12 KG"],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant pesant de 12 à 16 kg (environ 2 ans à 5 ans).",
        ],
      },
      {
        label: "NOUVEAU-NE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant pesant de 12 à 16 kg (environ 2 ans à 5 ans).",
        ],
      },
      {
        label: "SUJET AGE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant pesant de 12 à 16 kg (environ 2 ans à 5 ans).",
        ],
      },
      {
        label: "ADULTE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant pesant de 12 à 16 kg (environ 2 ans à 5 ans).",
        ],
      },
      {
        label: "DIARRHEE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: [],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "FORME GALENIQUE INADAPTEE A CE TERRAIN",
        ],
        text: ["En cas de diarrhée, la forme suppositoire n'est pas adaptée."],
      },
      {
        label: "RECTITE / RECTORRAGIE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [
          "LESION ANORECTALE ANTECEDENT PERSONNEL",
          "RECTITE/RECTORRAGIE ANTECEDENT PERSONNEL",
        ],
        other_comment: [],
        text: [],
      },
      {
        label: "QUEL QUE SOIT LE TERRAIN",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "PREVENIR LE MALADE",
          "RISQUE DE TOXICITE LOCALE",
          "RISQUE DE SURDOSAGE",
          "RISQUE DE REACTION CUTANEE",
          "HEPATOTOXICITE",
          "RISQUE DE SYNDROME DE STEVENS JOHNSON (SSJ)",
          "RISQUE DE PUSTULOSE EXANTHEMATIQUE (PEAG)",
          "SURVEILLANCE CLINIQUE",
        ],
        text: [],
      },
    ],
  },
  {
    dose: "2,4 %",
    form: "suspension buvable",
    contraindications: [
      {
        label: "QUEL QUE SOIT LE TERRAIN",
        level: [
          "MISE EN GARDE (SPECIALE)",
          "PRECAUTION (PARTICULIERE) D'EMPLOI",
        ],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "TENIR COMPTE PRESENCE ALCOOL BENZYLIQUE",
          "TENIR COMPTE PRESENCE SODIUM BENZOATE",
          "TENIR COMPTE PRESENCE SORBITOL",
          "TENIR COMPTE PRESENCE MALTITOL",
          "TENIR COMPTE PRESENCE PROPYLENEGLYCOL",
          "RISQUE DE SURDOSAGE",
          "Cf. SURDOSAGE",
          "HEPATOTOXICITE",
          "PRESENCE D'EXCIPIENT(S) A EFFET NOTOIRE",
        ],
        text: [],
      },
      {
        label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: [
          "HYPERSENSIBILITE FRUCTOSE (INTOLERANCE)",
          "HYPERSENSIBILITE MALTITOL (INTOLERANCE)",
        ],
        other_comment: [
          "TENIR COMPTE PRESENCE MALTITOL",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du maltitol (E 965), de l'iIsomalt (E 953) (isomaltitol) ou du maltitol liquide (sirop de\r\nglucose hydrogéné) comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n-> Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) d'une intolérance à certains sucres, contactez-le avant de prendre ce médicament.\r\n\r\n- Commentaires\r\nProposition de RCP : Les patients présentant des problèmes héréditaires rares d'intolérance au fructose ne\r\ndoivent pas prendre ce médicament.\r\n\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "INTOLERANCE GENETIQUE AU FRUCTOSE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: [],
        other_comment: [
          "TENIR COMPTE PRESENCE MALTITOL",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du maltitol (E 965), de l'iIsomalt (E 953) (isomaltitol) ou du maltitol liquide (sirop de\r\nglucose hydrogéné) comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n-> Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) d'une intolérance à certains sucres, contactez-le avant de prendre ce médicament.\r\n\r\n- Commentaires\r\nProposition de RCP : Les patients présentant des problèmes héréditaires rares d'intolérance au fructose ne\r\ndoivent pas prendre ce médicament.\r\n\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "QUEL QUE SOIT LE TERRAIN",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "TENIR COMPTE PRESENCE MALTITOL",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du maltitol (E 965), de l'iIsomalt (E 953) (isomaltitol) ou du maltitol liquide (sirop de\r\nglucose hydrogéné) comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n-> Seuil : 10 g\r\n\r\n- Informations\r\nPeut avoir un effet laxatif léger.\r\nValeur calorique 2,3 kcal/g de <maltitol><isomaltitol>.\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "REGIME HYPOCALORIQUE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "TENIR COMPTE PRESENCE MALTITOL",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du maltitol (E 965), de l'iIsomalt (E 953) (isomaltitol) ou du maltitol liquide (sirop de\r\nglucose hydrogéné) comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n-> Seuil : 10 g\r\n\r\n- Informations\r\nPeut avoir un effet laxatif léger.\r\nValeur calorique 2,3 kcal/g de <maltitol><isomaltitol>.\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "TENIR COMPTE PRESENCE ALCOOL BENZYLIQUE",
          "RISQUE D'ACIDOSE METABOLIQUE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient de l'alcool benzylique comme excipient\r\n\r\n- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nDemandez conseil à votre médecin ou à votre pharmacien si vous souffrez d'une maladie du foie ou du rein. De grandes quantités d'alcool benzylique peuvent s'accumuler dans votre corps et entraîner des effets secondaires (appelés \"acidose métabolique\").\r\n- Commentaires\r\nLes volumes élevés doivent être utilisés avec prudence et en cas de nécessité uniquement, en particulier chez les personnes atteintes d'insuffisance hépatique ou rénale en raison du risque d'accumulation et de toxicité (acidose métabolique).\r\r\n\r\n\r\nansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "ATTEINTE HEPATIQUE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RISQUE D'ACIDOSE METABOLIQUE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient de l'alcool benzylique comme excipient\r\n\r\n- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nDemandez conseil à votre médecin ou à votre pharmacien si vous souffrez d'une maladie du foie ou du rein. De grandes quantités d'alcool benzylique peuvent s'accumuler dans votre corps et entraîner des effets secondaires (appelés \"acidose métabolique\").\r\n- Commentaires\r\nLes volumes élevés doivent être utilisés avec prudence et en cas de nécessité uniquement, en particulier chez les personnes atteintes d'insuffisance hépatique ou rénale en raison du risque d'accumulation et de toxicité (acidose métabolique).\r\r\n\r\n\r\nansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "INSUFFISANCE RENALE CHRONIQUE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "TENIR COMPTE PRESENCE ALCOOL BENZYLIQUE",
          "RISQUE D'ACIDOSE METABOLIQUE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient de l'alcool benzylique comme excipient\r\n\r\n- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nDemandez conseil à votre médecin ou à votre pharmacien si vous souffrez d'une maladie du foie ou du rein. De grandes quantités d'alcool benzylique peuvent s'accumuler dans votre corps et entraîner des effets secondaires (appelés \"acidose métabolique\").\r\n- Commentaires\r\nLes volumes élevés doivent être utilisés avec prudence et en cas de nécessité uniquement, en particulier chez les personnes atteintes d'insuffisance hépatique ou rénale en raison du risque d'accumulation et de toxicité (acidose métabolique).\r\r\n\r\n\r\nansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "ATTEINTE RENALE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "TENIR COMPTE PRESENCE ALCOOL BENZYLIQUE",
          "RISQUE D'ACIDOSE METABOLIQUE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient de l'alcool benzylique comme excipient\r\n\r\n- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nDemandez conseil à votre médecin ou à votre pharmacien si vous souffrez d'une maladie du foie ou du rein. De grandes quantités d'alcool benzylique peuvent s'accumuler dans votre corps et entraîner des effets secondaires (appelés \"acidose métabolique\").\r\n- Commentaires\r\nLes volumes élevés doivent être utilisés avec prudence et en cas de nécessité uniquement, en particulier chez les personnes atteintes d'insuffisance hépatique ou rénale en raison du risque d'accumulation et de toxicité (acidose métabolique).\r\r\n\r\n\r\nansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "ENFANT",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: ["ENFANT DE MOINS DE 3 ANS"],
        other_comment: [
          "TENIR COMPTE PRESENCE ALCOOL BENZYLIQUE",
          "RISQUE DE MAJORATION DE TOXICITE",
          "RISQUE D'ACCUMULATION",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nL'alcool benzylique est associé à un risque d'effets secondaires graves y compris des problèmes respiratoires (appelés \"syndrome de suffocation\") chez les jeunes enfants.\r\nNe pas utiliser chez le nouveau-né (jusqu'à 4 semaines) sauf recommandation contraire de votre médecin.\r\n- Commentaires\r\nL'administration intraveineuse d'alcool benzylique a été associée à des effets indésirables graves et à la mort chez les nouveau-nés (\"syndrome de suffocation\"). La quantité minimale d'alcool benzylique susceptible d'entraîner une toxicité n'est pas connue.\r\nL'avertissement à la rubrique \"Mises en garde et précautions d'emploi\" du RCP doit être donné en cas d'utilisation chez le nouveau-né.\r\n\r\n\r\n- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nNe pas utiliser pendant plus d'une semaine chez les jeunes enfants (moins de 3 ans), sauf avis contraire de votre médecin ou de votre pharmacien.\r\n- Commentaires\r\nRisque accru en raison de l'accumulation chez les jeunes enfants.\r\n\r\n\r\n- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nDemandez conseil à votre médecin ou à votre pharmacien si vous êtes enceinte ou si vous allaitez. De grandes quantités d'alcool benzylique peuvent s'accumuler dans votre corps et entraîner des effets secondaires (appelés \"acidose métabolique\").\r\n\r\n\r\n- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nDemandez conseil à votre médecin ou à votre pharmacien si vous souffrez d'une maladie du foie ou du rein. De grandes quantités d'alcool benzylique peuvent s'accumuler dans votre corps et entraîner des effets secondaires (appelés \"acidose métabolique\").\r\n- Commentaires\r\nLes volumes élevés doivent être utilisés avec prudence et en cas de nécessité uniquement, en particulier chez les personnes atteintes d'insuffisance hépatique ou rénale en raison du risque d'accumulation et de toxicité (acidose métabolique).\r\r\n\r\nansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "NOUVEAU-NE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "TENIR COMPTE PRESENCE ALCOOL BENZYLIQUE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nL'alcool benzylique est associé à un risque d'effets secondaires graves y compris des problèmes respiratoires (appelés \"syndrome de suffocation\") chez les jeunes enfants.\r\nNe pas utiliser chez le nouveau-né (jusqu'à 4 semaines) sauf recommandation contraire de votre médecin.\r\n- Commentaires\r\nL'administration intraveineuse d'alcool benzylique a été associée à des effets indésirables graves et à la mort chez les nouveau-nés (\"syndrome de suffocation\"). La quantité minimale d'alcool benzylique susceptible d'entraîner une toxicité n'est pas connue.\r\nL'avertissement à la rubrique \"Mises en garde et précautions d'emploi\" du RCP doit être donné en cas d'utilisation chez le nouveau-né.\r\n\r\n\r\n- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nNe pas utiliser pendant plus d'une semaine chez les jeunes enfants (moins de 3 ans), sauf avis contraire de votre médecin ou de votre pharmacien.\r\n- Commentaires\r\nRisque accru en raison de l'accumulation chez les jeunes enfants.\r\n\r\n\r\n- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nDemandez conseil à votre médecin ou à votre pharmacien si vous êtes enceinte ou si vous allaitez. De grandes quantités d'alcool benzylique peuvent s'accumuler dans votre corps et entraîner des effets secondaires (appelés \"acidose métabolique\").\r\n\r\n\r\n- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nDemandez conseil à votre médecin ou à votre pharmacien si vous souffrez d'une maladie du foie ou du rein. De grandes quantités d'alcool benzylique peuvent s'accumuler dans votre corps et entraîner des effets secondaires (appelés \"acidose métabolique\").\r\n- Commentaires\r\nLes volumes élevés doivent être utilisés avec prudence et en cas de nécessité uniquement, en particulier chez les personnes atteintes d'insuffisance hépatique ou rénale en raison du risque d'accumulation et de toxicité (acidose métabolique).\r\r\n\r\nansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "PREMATURE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: [],
        other_comment: [
          "TENIR COMPTE PRESENCE ALCOOL BENZYLIQUE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nL'alcool benzylique est associé à un risque d'effets secondaires graves y compris des problèmes respiratoires (appelés \"syndrome de suffocation\") chez les jeunes enfants.\r\nNe pas utiliser chez le nouveau-né (jusqu'à 4 semaines) sauf recommandation contraire de votre médecin.\r\n- Commentaires\r\nL'administration intraveineuse d'alcool benzylique a été associée à des effets indésirables graves et à la mort chez les nouveau-nés (\"syndrome de suffocation\"). La quantité minimale d'alcool benzylique susceptible d'entraîner une toxicité n'est pas connue.\r\nL'avertissement à la rubrique \"Mises en garde et précautions d'emploi\" du RCP doit être donné en cas d'utilisation chez le nouveau-né.\r\n\r\n\r\n- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nNe pas utiliser pendant plus d'une semaine chez les jeunes enfants (moins de 3 ans), sauf avis contraire de votre médecin ou de votre pharmacien.\r\n- Commentaires\r\nRisque accru en raison de l'accumulation chez les jeunes enfants.\r\n\r\n\r\nansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "GROSSESSE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "TENIR COMPTE PRESENCE ALCOOL BENZYLIQUE",
          "RISQUE D'ACIDOSE METABOLIQUE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient de l'alcool benzylique comme excipient\r\n\r\n- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nDemandez conseil à votre médecin ou à votre pharmacien si vous êtes enceinte ou si vous allaitez. De grandes quantités d'alcool benzylique peuvent s'accumuler dans votre corps et entraîner des effets secondaires (appelés \"acidose métabolique\").\r\n\r\n\r\nansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "ALLAITEMENT",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "TENIR COMPTE PRESENCE ALCOOL BENZYLIQUE",
          "RISQUE D'ACIDOSE METABOLIQUE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient de l'alcool benzylique comme excipient\r\n\r\n- Voie d'administration : orale, parentérale\r\n\r\n- Seuil : zéro\r\n\r\n- Informations\r\nDemandez conseil à votre médecin ou à votre pharmacien si vous êtes enceinte ou si vous allaitez. De grandes quantités d'alcool benzylique peuvent s'accumuler dans votre corps et entraîner des effets secondaires (appelés \"acidose métabolique\").\r\n\r\n\r\nansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: [
          "HYPERSENSIBILITE FRUCTOSE (INTOLERANCE)",
          "HYPERSENSIBILITE SORBITOL (INTOLERANCE)",
        ],
        other_comment: [
          "TENIR COMPTE PRESENCE SORBITOL",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du sorbitol E 420 comme excipient.\r\n\r\n\r\n* Voie d'administration : Orale, parentérale\r\n\r\n- Seuil : Zéro\r\n\r\n- Information pour la notice\r\nCe médicament contient x mg de sorbitol par <dose><volume unitaire> <équivalent à x mg/<poids><volume >>.\r\n\r\n- Commentaires\r\nL'effet additif des produits administrés concomitamment contenant du sorbitol (ou du fructose) et l'apport\r\nalimentaire de sorbitol (ou de fructose) doit être pris en compte.\r\nLa teneur en sorbitol dans les médicaments à usage oral peut affecter la biodisponibilité d'autres médicaments à\r\nusage oral administrés de façon concomitante.\r\n\r\n\r\n* Voie d'administration : Intraveineuse (IV)\r\n\r\n- Seuil : Zéro\r\n\r\n- Information pour la notice\r\nLe sorbitol est une source de fructose. Si vous (ou votre enfant) présentez une intolérance héréditaire au fructose (IHF), une maladie génétique rare, vous (ou votre enfant) ne devez pas recevoir ce médicament. Les patients atteints d'IHF ne peuvent pas décomposer le fructose, et ne doivent pas recevoir ce médicament en raison de risque d'effets indésirables graves.\r\nVous devez en informer votre médecin avant de recevoir ce médicament si vous (ou votre enfant) présentez une IHF ou si votre enfant ne peut plus prendre d'aliments ou de boissons sucrées du fait de nausées, de vomissements ou d'effets désagréables tels que des ballonnements, des crampes d'estomac ou la diarrhée.\r\n\r\n- Commentaires\r\nLes patients présentant une intolérance héréditaire au fructose (IHF) ne doivent pas recevoir ce médicament, sauf en cas de nécessité uniquement.\r\nLes bébés et les jeunes enfants (moins de 2 ans) peuvent ne pas avoir été diagnostiqués avec une intolérance\r\nhéréditaire au fructose (IHF). Les médicaments (contenant du sorbitol/fructose) administrés par voie\r\nintraveineuse peuvent être mortels et doivent être contreindiqués dans cette population, sauf nécessité clinique\r\nimpérieuse et en l'absence de solution alternative.\r\nL'historique détaillé des symptômes d'IHF doit être obtenu pour chaque patient avant de prescrire ce médicament.\r\n\r\n\r\n* Voie d'administration : Orale, parentérale (autre que IV)\r\n\r\n- Seuil : 5 mg/kg/jour\r\n\r\n- Information pour la notice\r\nLe sorbitol est une source de fructose. Si votre médecin vous a informé(e) que vous (ou votre enfant) présentiez une intolérance à certains sucres ou si vous avez été diagnostiqué(e) avec une intolérance héréditaire au fructose (IHF), un trouble génétique rare caractérisé par l'incapacité à décomposer le fructose, parlez-en à votre médecin\r\navant que vous (ou votre enfant) ne preniez ou ne receviez ce médicament.\r\n\r\n- Commentaires\r\nLes patients présentant une intolérance héréditaire au fructose (IHF) ne doivent pas prendre/recevoir ce médicament.\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "INTOLERANCE GENETIQUE AU FRUCTOSE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: [],
        other_comment: [
          "TENIR COMPTE PRESENCE SORBITOL",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du sorbitol E 420 comme excipient.\r\n\r\n\r\n* Voie d'administration : Orale, parentérale\r\n\r\n- Seuil : Zéro\r\n\r\n- Information pour la notice\r\nCe médicament contient x mg de sorbitol par <dose><volume unitaire> <équivalent à x mg/<poids><volume >>.\r\n\r\n- Commentaires\r\nL'effet additif des produits administrés concomitamment contenant du sorbitol (ou du fructose) et l'apport\r\nalimentaire de sorbitol (ou de fructose) doit être pris en compte.\r\nLa teneur en sorbitol dans les médicaments à usage oral peut affecter la biodisponibilité d'autres médicaments à\r\nusage oral administrés de façon concomitante.\r\n\r\n\r\n* Voie d'administration : Intraveineuse (IV)\r\n\r\n- Seuil : Zéro\r\n\r\n- Information pour la notice\r\nLe sorbitol est une source de fructose. Si vous (ou votre enfant) présentez une intolérance héréditaire au fructose (IHF), une maladie génétique rare, vous (ou votre enfant) ne devez pas recevoir ce médicament. Les patients atteints d'IHF ne peuvent pas décomposer le fructose, et ne doivent pas recevoir ce médicament en raison de risque d'effets indésirables graves.\r\nVous devez en informer votre médecin avant de recevoir ce médicament si vous (ou votre enfant) présentez une IHF ou si votre enfant ne peut plus prendre d'aliments ou de boissons sucrées du fait de nausées, de vomissements ou d'effets désagréables tels que des ballonnements, des crampes d'estomac ou la diarrhée.\r\n\r\n- Commentaires\r\nLes patients présentant une intolérance héréditaire au fructose (IHF) ne doivent pas recevoir ce médicament, sauf en cas de nécessité uniquement.\r\nLes bébés et les jeunes enfants (moins de 2 ans) peuvent ne pas avoir été diagnostiqués avec une intolérance\r\nhéréditaire au fructose (IHF). Les médicaments (contenant du sorbitol/fructose) administrés par voie\r\nintraveineuse peuvent être mortels et doivent être contreindiqués dans cette population, sauf nécessité clinique\r\nimpérieuse et en l'absence de solution alternative.\r\nL'historique détaillé des symptômes d'IHF doit être obtenu pour chaque patient avant de prescrire ce médicament.\r\n\r\n\r\n* Voie d'administration : Orale, parentérale (autre que IV)\r\n\r\n- Seuil : 5 mg/kg/jour\r\n\r\n- Information pour la notice\r\nLe sorbitol est une source de fructose. Si votre médecin vous a informé(e) que vous (ou votre enfant) présentiez une intolérance à certains sucres ou si vous avez été diagnostiqué(e) avec une intolérance héréditaire au fructose (IHF), un trouble génétique rare caractérisé par l'incapacité à décomposer le fructose, parlez-en à votre médecin\r\navant que vous (ou votre enfant) ne preniez ou ne receviez ce médicament.\r\n\r\n- Commentaires\r\nLes patients présentant une intolérance héréditaire au fructose (IHF) ne doivent pas prendre/recevoir ce médicament.\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "MUCOVISCIDOSE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HEPATITE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["HEPATITE AIGUE"],
        other_comment: [
          "ARRETER LE TRAITEMENT",
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
        ],
        text: [
          "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
        ],
      },
      {
        label: "HEPATITE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["HEPATITE CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
        other_comment: [],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [
          "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
          "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
        ],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INFECTION VIH",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DESHYDRATATION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HYPOVOLEMIE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "RISQUE D'ANEMIE",
          "RISQUE D'HEMOLYSE",
        ],
        text: [],
      },
      {
        label: "SYNDROME DE GILBERT",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DENUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "AMAIGRISSEMENT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "MALNUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["MALNUTRITION CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ALCOOLISME CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "SEVRAGE ALCOOLIQUE SYNDROME",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SEVRAGE ALCOOLIQUE"],
        other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
        text: [],
      },
      {
        label: "ANOREXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE RENALE CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["INSUFFISANCE RENALE SEVERE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. PROPRIETES PHARMACOCINETIQUES",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INTERACTION D'ORIGINE ALIMENTAIRE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: ["INGESTION D'ALCOOL"],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "RISQUE D'ATTEINTE HEPATIQUE",
        ],
        text: [
          "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
        ],
      },
      {
        label: "JEUNE STRICT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "CACHEXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "EXAMEN LABORATOIRE INTERFERENCE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
        other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
        text: [
          "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
        ],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "UTILISER AVEC PRUDENCE",
          "EN CAS DE POSOLOGIE ELEVEE",
          "RISQUE D'HEMOLYSE",
          "REFERENTIEL ANSM G6PD 13/06/2014",
        ],
        text: [
          "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
        ],
      },
      {
        label: "ENFANT",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["ENFANT DE PLUS DE 26 KG"],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant de 3 à 26 kg (soit environ de la naissance à 9 ans).",
        ],
      },
      {
        label: "NOURRISSON",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["NOURRISSON DE MOINS DE 3 KG"],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant de 3 à 26 kg (soit environ de la naissance à 9 ans).",
        ],
      },
      {
        label: "NOUVEAU-NE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["NOUVEAU-NE DE MOINS DE 3 KG"],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant de 3 à 26 kg (soit environ de la naissance à 9 ans).",
        ],
      },
      {
        label: "SUJET AGE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant de 3 à 26 kg (soit environ de la naissance à 9 ans).",
        ],
      },
      {
        label: "ADULTE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant de 3 à 26 kg (soit environ de la naissance à 9 ans).",
        ],
      },
    ],
  },
  {
    dose: "500 mg",
    form: "comprimé effervescent",
    contraindications: [
      {
        label: "REGIME HYPOSODE STRICT",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "TENIR COMPTE PRESENCE SODIUM",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du sodium comme excipient.\r\n\r\n* Voie d'administration : Orale et parentérale\r\n\r\n- Seuil : > ou = 1 mmol (23 mg) par \"dose administrée\"\r\n\r\n- Information pour la notice \r\nCe médicament contient x mg de sodium (composant principal du sel de cuisine/table) par <dose><volume unitaire>. Cela équivaut à y% de l'apport alimentaire quotidien maximal recommandé de sodium pour un adulte.\r\n\r\n- Commentaires\r\nEn cas d'administration parentérale à dosage variable (par exemple, en fonction du poids), la teneur en sodium\r\npeut être exprimée en mg par flacon.\r\nLibellé proposé pour le RCP : \"Ce médicament contient x mg de sodium par <dose>, ce qui équivaut à y% de l'apport alimentaire quotidien maximal recommandé par l'OMS de 2 g de sodium par adulte.\"\r\n\r\n\r\n* Voie d'administration : Orale et parentérale\r\n\r\n- Seuil : 17 mmol (391 mg) à la dose quotidienne maximale\r\n\r\n- Information pour la notice \r\nParlez-en à votre médecin ou votre pharmacien si vous avez besoin de <Z> ou de plus de <dose> quotidiennement pendant une période prolongée, surtout si vous devez suivre un régime à faible teneur en sel (sodium).\r\n\r\n- Commentaires\r\nCeci s'applique uniquement aux produits pour lesquels la posologie indiquée permet une prise quotidienne pendant\r\nplus d'un mois ou une utilisation répétée de plus de deux jours par semaine.\r\n17 mmol (391 mg) représente environ 20% de l'apport alimentaire quotidien maximal adulte recommandé par\r\nl'OMS de 2 g de sodium et est considéré comme un dosage \"élevé\". Ceci vaut également pour les enfants, pour lesquels l'apport quotidien maximal est censé être proportionnel à celui des adultes et calculé selon les besoins\r\nénergétiques.\r\n<Doses Z> reflète le nombre minimum de doses pour lesquelles le seuil de 17 mmol (391 mg) de sodium est\r\natteint/dépassé. Arrondir au nombre entier le plus proche.\r\nPour le libellé du RCP, veuillez vous reporter à la recommandation du PRAC: \"1.3. Sodium-containing effervescent, dispersible and soluble medicines – Cardiovascular events\" (EMA/PRAC/234960/2015).\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [
          "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
          "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
          "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
        ],
        other_comment: [
          "TENIR COMPTE PRESENCE GLUCOSE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du glucose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) d'une intolérance à certains sucres, contactez-le avant de prendre ce médicament.\r\n\r\n- Commentaire :\r\nProposition de RCP : Les patients présentant un syndrome de malabsorption du glucose et du galactose\r\n(maladie héréditaire rare) ne doivent pas prendre ce médicament.\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "MUCOVISCIDOSE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HEPATITE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["HEPATITE AIGUE"],
        other_comment: [
          "ARRETER LE TRAITEMENT",
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
        ],
        text: [
          "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
        ],
      },
      {
        label: "HEPATITE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["HEPATITE CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
        other_comment: [],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [
          "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
          "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
        ],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INFECTION VIH",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DESHYDRATATION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HYPOVOLEMIE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "RISQUE D'ANEMIE",
          "RISQUE D'HEMOLYSE",
        ],
        text: [],
      },
      {
        label: "SYNDROME DE GILBERT",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DENUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "AMAIGRISSEMENT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "MALNUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["MALNUTRITION CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ALCOOLISME CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "SEVRAGE ALCOOLIQUE SYNDROME",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SEVRAGE ALCOOLIQUE"],
        other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
        text: [],
      },
      {
        label: "ANOREXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE RENALE CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["INSUFFISANCE RENALE SEVERE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. PROPRIETES PHARMACOCINETIQUES",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INTERACTION D'ORIGINE ALIMENTAIRE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: ["INGESTION D'ALCOOL"],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "RISQUE D'ATTEINTE HEPATIQUE",
        ],
        text: [
          "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
        ],
      },
      {
        label: "JEUNE STRICT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "CACHEXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "EXAMEN LABORATOIRE INTERFERENCE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
        other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
        text: [
          "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
        ],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "UTILISER AVEC PRUDENCE",
          "EN CAS DE POSOLOGIE ELEVEE",
          "RISQUE D'HEMOLYSE",
          "REFERENTIEL ANSM G6PD 13/06/2014",
        ],
        text: [
          "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
        ],
      },
      {
        label: "PATIENT DE FAIBLE POIDS",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["PATIENT DE MOINS DE 50 KG"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ENFANT",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["ENFANT DE MOINS DE 27 KG"],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'adulte et l'enfant à partir de 27 kg (à partir d'environ 8 ans).",
        ],
      },
      {
        label: "ENFANT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["ENFANT DE MOINS DE 50 KG", "ENFANT DE PLUS DE 26 KG"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "ADAPTER LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "NOURRISSON",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'adulte et l'enfant à partir de 27 kg (à partir d'environ 8 ans).",
        ],
      },
      {
        label: "NOUVEAU-NE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'adulte et l'enfant à partir de 27 kg (à partir d'environ 8 ans).",
        ],
      },
      {
        label: "SUJET AGE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SUJET AGE DE PLUS DE 75 ANS"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [
          "La dose journalière efficace la plus faible possible doit être envisagée, sans excéder 60 mg/kg/jour (sans dépasser 3 g/jour) dans les situations suivantes : [...]\r\n- sujet âgé de plus de 75 ans.",
        ],
      },
      {
        label: "SUJET AGE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SUJET POLYPATHOLOGIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [
          "La dose journalière efficace la plus faible possible doit être envisagée, sans excéder 60 mg/kg/jour (sans dépasser 3 g/jour) dans les situations suivantes : [...]\r\n- sujet âgé de plus de 65 ans et polypathologique.",
        ],
      },
      {
        label: "QUEL QUE SOIT LE TERRAIN",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "TENIR COMPTE PRESENCE SULFITES",
          "TENIR COMPTE PRESENCE SODIUM",
          "RISQUE DE SURDOSAGE",
          "HEPATOTOXICITE",
          "PRESENCE D'EXCIPIENT(S) A EFFET NOTOIRE",
        ],
        text: [],
      },
    ],
  },
  {
    dose: "300 mg",
    form: "poudre pour solution buvable",
    contraindications: [
      {
        label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [
          "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
          "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
          "HYPERSENSIBILITE FRUCTOSE (INTOLERANCE)",
          "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
          "HYPERSENSIBILITE SACCHAROSE (INTOLERANCE)",
        ],
        other_comment: [
          "TENIR COMPTE PRESENCE SACCHAROSE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "INTOLERANCE GENETIQUE AU FRUCTOSE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: [
          "TENIR COMPTE PRESENCE SACCHAROSE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "DEFICIT EN SUCRASE-ISOMALTASE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: [
          "TENIR COMPTE PRESENCE SACCHAROSE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [
          "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
          "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
          "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
        ],
        other_comment: [
          "TENIR COMPTE PRESENCE GLUCOSE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du glucose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) d'une intolérance à certains sucres, contactez-le avant de prendre ce médicament.\r\n\r\n- Commentaire :\r\nProposition de RCP : Les patients présentant un syndrome de malabsorption du glucose et du galactose\r\n(maladie héréditaire rare) ne doivent pas prendre ce médicament.\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "QUEL QUE SOIT LE TERRAIN",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "TENIR COMPTE PRESENCE SACCHAROSE",
          "Cf. COMPOSITION",
          "RISQUE DE SURDOSAGE",
          "HEPATOTOXICITE",
          "PRESENCE D'EXCIPIENT(S) A EFFET NOTOIRE",
        ],
        text: [],
      },
      {
        label: "MUCOVISCIDOSE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HEPATITE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["HEPATITE AIGUE"],
        other_comment: [
          "ARRETER LE TRAITEMENT",
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
        ],
        text: [
          "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
        ],
      },
      {
        label: "HEPATITE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["HEPATITE CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
        other_comment: [],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [
          "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
          "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
        ],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INFECTION VIH",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DESHYDRATATION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HYPOVOLEMIE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "RISQUE D'ANEMIE",
          "RISQUE D'HEMOLYSE",
        ],
        text: [],
      },
      {
        label: "SYNDROME DE GILBERT",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DENUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "AMAIGRISSEMENT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "MALNUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["MALNUTRITION CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ALCOOLISME CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "SEVRAGE ALCOOLIQUE SYNDROME",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SEVRAGE ALCOOLIQUE"],
        other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
        text: [],
      },
      {
        label: "ANOREXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE RENALE CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["INSUFFISANCE RENALE SEVERE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. PROPRIETES PHARMACOCINETIQUES",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INTERACTION D'ORIGINE ALIMENTAIRE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: ["INGESTION D'ALCOOL"],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "RISQUE D'ATTEINTE HEPATIQUE",
        ],
        text: [
          "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
        ],
      },
      {
        label: "JEUNE STRICT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "CACHEXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "EXAMEN LABORATOIRE INTERFERENCE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
        other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
        text: [
          "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
        ],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "UTILISER AVEC PRUDENCE",
          "EN CAS DE POSOLOGIE ELEVEE",
          "RISQUE D'HEMOLYSE",
          "REFERENTIEL ANSM G6PD 13/06/2014",
        ],
        text: [
          "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
        ],
      },
      {
        label: "ENFANT",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["ENFANT DE MOINS DE 16 KG", "ENFANT DE PLUS DE 48 KG"],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant de 16 à 48 kg (soit environ de 4 à 15 ans).",
        ],
      },
      {
        label: "NOURRISSON",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant de 16 à 48 kg (soit environ de 4 à 15 ans).",
        ],
      },
      {
        label: "NOUVEAU-NE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant de 16 à 48 kg (soit environ de 4 à 15 ans).",
        ],
      },
      {
        label: "SUJET AGE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant de 16 à 48 kg (soit environ de 4 à 15 ans).",
        ],
      },
      {
        label: "ADULTE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant de 16 à 48 kg (soit environ de 4 à 15 ans).",
        ],
      },
    ],
  },
  {
    dose: "300 mg",
    form: "suppositoire",
    contraindications: [
      {
        label: "MUCOVISCIDOSE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HEPATITE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["HEPATITE AIGUE"],
        other_comment: [
          "ARRETER LE TRAITEMENT",
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
        ],
        text: [
          "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
        ],
      },
      {
        label: "HEPATITE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["HEPATITE CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
        other_comment: [],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [
          "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
          "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
        ],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INFECTION VIH",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DESHYDRATATION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HYPOVOLEMIE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "RISQUE D'ANEMIE",
          "RISQUE D'HEMOLYSE",
        ],
        text: [],
      },
      {
        label: "SYNDROME DE GILBERT",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DENUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "AMAIGRISSEMENT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "MALNUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["MALNUTRITION CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ALCOOLISME CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "SEVRAGE ALCOOLIQUE SYNDROME",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SEVRAGE ALCOOLIQUE"],
        other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
        text: [],
      },
      {
        label: "ANOREXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE RENALE CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["INSUFFISANCE RENALE SEVERE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. PROPRIETES PHARMACOCINETIQUES",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INTERACTION D'ORIGINE ALIMENTAIRE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: ["INGESTION D'ALCOOL"],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "RISQUE D'ATTEINTE HEPATIQUE",
        ],
        text: [
          "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
        ],
      },
      {
        label: "JEUNE STRICT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "CACHEXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "EXAMEN LABORATOIRE INTERFERENCE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
        other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
        text: [
          "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
        ],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "UTILISER AVEC PRUDENCE",
          "EN CAS DE POSOLOGIE ELEVEE",
          "RISQUE D'HEMOLYSE",
          "REFERENTIEL ANSM G6PD 13/06/2014",
        ],
        text: [
          "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
        ],
      },
      {
        label: "ENFANT",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["ENFANT DE MOINS DE 15 KG", "ENFANT DE PLUS DE 24 KG"],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant pesant de 15 à 24 kg (environ 4 à 9 ans).",
        ],
      },
      {
        label: "NOURRISSON",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["NOURRISSON DE MOINS DE 15 KG"],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant pesant de 15 à 24 kg (environ 4 à 9 ans).",
        ],
      },
      {
        label: "NOUVEAU-NE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant pesant de 15 à 24 kg (environ 4 à 9 ans).",
        ],
      },
      {
        label: "SUJET AGE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant pesant de 15 à 24 kg (environ 4 à 9 ans).",
        ],
      },
      {
        label: "ADULTE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant pesant de 15 à 24 kg (environ 4 à 9 ans).",
        ],
      },
      {
        label: "DIARRHEE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: [],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "FORME GALENIQUE INADAPTEE A CE TERRAIN",
        ],
        text: ["En cas de diarrhée, la forme suppositoire n'est pas adaptée."],
      },
      {
        label: "RECTITE / RECTORRAGIE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [
          "LESION ANORECTALE ANTECEDENT PERSONNEL",
          "RECTITE/RECTORRAGIE ANTECEDENT PERSONNEL",
        ],
        other_comment: [],
        text: [],
      },
      {
        label: "QUEL QUE SOIT LE TERRAIN",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "PREVENIR LE MALADE",
          "RISQUE DE TOXICITE LOCALE",
          "RISQUE DE SURDOSAGE",
          "RISQUE DE REACTION CUTANEE",
          "HEPATOTOXICITE",
          "RISQUE DE SYNDROME DE STEVENS JOHNSON (SSJ)",
          "RISQUE DE PUSTULOSE EXANTHEMATIQUE (PEAG)",
          "SURVEILLANCE CLINIQUE",
        ],
        text: [],
      },
    ],
  },
  {
    dose: "1000 mg",
    form: "gélule",
    contraindications: [
      {
        label: "MUCOVISCIDOSE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HEPATITE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["HEPATITE AIGUE"],
        other_comment: [
          "ARRETER LE TRAITEMENT",
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
        ],
        text: [
          "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
        ],
      },
      {
        label: "HEPATITE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["HEPATITE CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
        other_comment: [],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [
          "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
          "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
        ],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INFECTION VIH",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DESHYDRATATION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HYPOVOLEMIE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "RISQUE D'ANEMIE",
          "RISQUE D'HEMOLYSE",
        ],
        text: [],
      },
      {
        label: "SYNDROME DE GILBERT",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DENUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "AMAIGRISSEMENT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "MALNUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["MALNUTRITION CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ALCOOLISME CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "SEVRAGE ALCOOLIQUE SYNDROME",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SEVRAGE ALCOOLIQUE"],
        other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
        text: [],
      },
      {
        label: "ANOREXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE RENALE CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["INSUFFISANCE RENALE SEVERE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. PROPRIETES PHARMACOCINETIQUES",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INTERACTION D'ORIGINE ALIMENTAIRE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: ["INGESTION D'ALCOOL"],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "RISQUE D'ATTEINTE HEPATIQUE",
        ],
        text: [
          "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
        ],
      },
      {
        label: "JEUNE STRICT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "CACHEXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "EXAMEN LABORATOIRE INTERFERENCE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
        other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
        text: [
          "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
        ],
      },
      {
        label: "PATIENT DE FAIBLE POIDS",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["PATIENT DE MOINS DE 50 KG"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ENFANT",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["ENFANT DE MOINS DE 50 KG"],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'adulte et à l'enfant à partir de 50 kg (soit à partir d'environ 15 ans).",
        ],
      },
      {
        label: "ENFANT",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["ENFANT DE MOINS DE 6 ANS"],
        other_comment: [
          "RISQUE DE FAUSSE ROUTE",
          "FORME GALENIQUE INADAPTEE A CE TERRAIN",
        ],
        text: [],
      },
      {
        label: "NOURRISSON",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: [
          "RISQUE DE FAUSSE ROUTE",
          "FORME GALENIQUE INADAPTEE A CE TERRAIN",
        ],
        text: [""],
      },
      {
        label: "NOUVEAU-NE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: [
          "RISQUE DE FAUSSE ROUTE",
          "FORME GALENIQUE INADAPTEE A CE TERRAIN",
        ],
        text: [""],
      },
      {
        label: "SUJET AGE",
        level: ["PAS DE PRECAUTION D'EMPLOI"],
        comment: ["SUJET AGE DE PLUS DE 75 ANS"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "SUJET AGE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SUJET POLYPATHOLOGIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "UTILISER AVEC PRUDENCE",
          "EN CAS DE POSOLOGIE ELEVEE",
          "RISQUE D'HEMOLYSE",
          "REFERENTIEL ANSM G6PD 13/06/2014",
        ],
        text: [
          "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
        ],
      },
      {
        label: "QUEL QUE SOIT LE TERRAIN",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "ARRETER TRT EN CAS DE RISQUE AVERE",
          "RESPECTER LA POSOLOGIE",
          "TENIR COMPTE PRESENCE AZORUBINE",
          "RISQUE FATAL",
          "RISQUE DE SURDOSAGE",
          "RISQUE DE REACTION CUTANEE",
          "HEPATOTOXICITE",
          "RISQUE DE SYNDROME DE STEVENS JOHNSON (SSJ)",
          "RISQUE DE PUSTULOSE EXANTHEMATIQUE (PEAG)",
          "PRESENCE D'EXCIPIENT(S) A EFFET NOTOIRE",
        ],
        text: [],
      },
    ],
  },
  {
    dose: "500 mg",
    form: "gélule",
    contraindications: [
      {
        label: "PATIENT DE FAIBLE POIDS",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["PATIENT DE MOINS DE 50 KG"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ENFANT",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["ENFANT DE MOINS DE 6 ANS", "ENFANT DE MOINS DE 27 KG"],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "Cf. INDICATIONS",
          "DOSAGE INADAPTE POUR CE TERRAIN",
          "RISQUE DE FAUSSE ROUTE",
          "FORME GALENIQUE INADAPTEE A CE TERRAIN",
        ],
        text: [
          "La prise de comprimé ou de gélule est contre-indiquée chez l'enfant de moins de 6 ans car elle peut entraîner une fausse route.\r\n\r\nCette présentation est réservée à l'adulte et l'enfant à partir de 27 kg (soit environ à partir de 8 ans).",
        ],
      },
      {
        label: "ENFANT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [
          "ENFANT DE PLUS DE 6 ANS",
          "ENFANT DE MOINS DE 50 KG",
          "ENFANT DE PLUS DE 26 KG",
        ],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "ADAPTER LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "NOURRISSON",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "RISQUE DE FAUSSE ROUTE",
          "FORME GALENIQUE INADAPTEE A CE TERRAIN",
        ],
        text: [
          "La prise de comprimé ou de gélule est contre-indiquée chez l'enfant de moins de 6 ans car elle peut entraîner une fausse route.",
        ],
      },
      {
        label: "NOUVEAU-NE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "RISQUE DE FAUSSE ROUTE",
          "FORME GALENIQUE INADAPTEE A CE TERRAIN",
        ],
        text: [
          "La prise de comprimé ou de gélule est contre-indiquée chez l'enfant de moins de 6 ans car elle peut entraîner une fausse route.",
        ],
      },
      {
        label: "SUJET AGE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SUJET AGE DE PLUS DE 75 ANS"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [
          "La dose journalière efficace la plus faible possible doit être envisagée, sans excéder 60 mg/kg/jour (sans dépasser 3 g/jour) dans les situations suivantes : [...]\r\n- sujet âgé de plus de 75 ans.",
        ],
      },
      {
        label: "SUJET AGE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SUJET POLYPATHOLOGIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [
          "La dose journalière efficace la plus faible possible doit être envisagée, sans excéder 60 mg/kg/jour (sans dépasser 3 g/jour) dans les situations suivantes : [...]\r\n- sujet âgé de plus de 65 ans et polypathologique.",
        ],
      },
      {
        label: "MUCOVISCIDOSE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HEPATITE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["HEPATITE AIGUE"],
        other_comment: [
          "ARRETER LE TRAITEMENT",
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
        ],
        text: [
          "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
        ],
      },
      {
        label: "HEPATITE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["HEPATITE CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
        other_comment: [],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [
          "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
          "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
        ],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INFECTION VIH",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DESHYDRATATION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HYPOVOLEMIE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "RISQUE D'ANEMIE",
          "RISQUE D'HEMOLYSE",
        ],
        text: [],
      },
      {
        label: "SYNDROME DE GILBERT",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DENUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "AMAIGRISSEMENT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "MALNUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["MALNUTRITION CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ALCOOLISME CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "SEVRAGE ALCOOLIQUE SYNDROME",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SEVRAGE ALCOOLIQUE"],
        other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
        text: [],
      },
      {
        label: "ANOREXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE RENALE CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["INSUFFISANCE RENALE SEVERE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. PROPRIETES PHARMACOCINETIQUES",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INTERACTION D'ORIGINE ALIMENTAIRE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: ["INGESTION D'ALCOOL"],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "RISQUE D'ATTEINTE HEPATIQUE",
        ],
        text: [
          "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
        ],
      },
      {
        label: "JEUNE STRICT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "CACHEXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "EXAMEN LABORATOIRE INTERFERENCE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
        other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
        text: [
          "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
        ],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "UTILISER AVEC PRUDENCE",
          "EN CAS DE POSOLOGIE ELEVEE",
          "RISQUE D'HEMOLYSE",
          "REFERENTIEL ANSM G6PD 13/06/2014",
        ],
        text: [
          "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
        ],
      },
      {
        label: "QUEL QUE SOIT LE TERRAIN",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "RISQUE DE SURDOSAGE",
          "RISQUE DE REACTION CUTANEE",
          "HEPATOTOXICITE",
          "RISQUE DE SYNDROME DE STEVENS JOHNSON (SSJ)",
          "RISQUE DE PUSTULOSE EXANTHEMATIQUE (PEAG)",
        ],
        text: [],
      },
    ],
  },
  {
    dose: "1000 mg",
    form: "suppositoire",
    contraindications: [
      {
        label: "MUCOVISCIDOSE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HEPATITE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["HEPATITE AIGUE"],
        other_comment: [
          "ARRETER LE TRAITEMENT",
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
        ],
        text: [
          "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
        ],
      },
      {
        label: "HEPATITE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["HEPATITE CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
        other_comment: [],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [
          "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
          "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
        ],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INFECTION VIH",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DESHYDRATATION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HYPOVOLEMIE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "RISQUE D'ANEMIE",
          "RISQUE D'HEMOLYSE",
        ],
        text: [],
      },
      {
        label: "SYNDROME DE GILBERT",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DENUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "AMAIGRISSEMENT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "MALNUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["MALNUTRITION CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ALCOOLISME CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "SEVRAGE ALCOOLIQUE SYNDROME",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SEVRAGE ALCOOLIQUE"],
        other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
        text: [],
      },
      {
        label: "ANOREXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE RENALE CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["INSUFFISANCE RENALE SEVERE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. PROPRIETES PHARMACOCINETIQUES",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INTERACTION D'ORIGINE ALIMENTAIRE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: ["INGESTION D'ALCOOL"],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "RISQUE D'ATTEINTE HEPATIQUE",
        ],
        text: [
          "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
        ],
      },
      {
        label: "JEUNE STRICT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "CACHEXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "EXAMEN LABORATOIRE INTERFERENCE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
        other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
        text: [
          "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
        ],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "UTILISER AVEC PRUDENCE",
          "EN CAS DE POSOLOGIE ELEVEE",
          "RISQUE D'HEMOLYSE",
          "REFERENTIEL ANSM G6PD 13/06/2014",
        ],
        text: [
          "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
        ],
      },
      {
        label: "PATIENT DE FAIBLE POIDS",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["PATIENT DE MOINS DE 50 KG"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ENFANT",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["ENFANT DE MOINS DE 50 KG"],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'adulte et à l'enfant à partir de 50 kg (soit à partir d'environ 15 ans).",
        ],
      },
      {
        label: "NOURRISSON",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: [
          "Cf. INDICATIONS",
          "DOSAGE INADAPTE POUR CE TERRAIN",
          "RISQUE DE FAUSSE ROUTE",
          "FORME GALENIQUE INADAPTEE A CE TERRAIN",
        ],
        text: [
          "Cette présentation est réservée à l'adulte et à l'enfant à partir de 50 kg (soit à partir d'environ 15 ans).",
        ],
      },
      {
        label: "NOUVEAU-NE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: [
          "Cf. INDICATIONS",
          "DOSAGE INADAPTE POUR CE TERRAIN",
          "RISQUE DE FAUSSE ROUTE",
          "FORME GALENIQUE INADAPTEE A CE TERRAIN",
        ],
        text: [
          "Cette présentation est réservée à l'adulte et à l'enfant à partir de 50 kg (soit à partir d'environ 15 ans).",
        ],
      },
      {
        label: "SUJET AGE",
        level: ["PAS DE PRECAUTION D'EMPLOI"],
        comment: ["SUJET AGE DE PLUS DE 75 ANS"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "SUJET AGE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SUJET POLYPATHOLOGIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DIARRHEE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: [],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "FORME GALENIQUE INADAPTEE A CE TERRAIN",
        ],
        text: ["En cas de diarrhée, la forme suppositoire n'est pas adaptée."],
      },
      {
        label: "RECTITE / RECTORRAGIE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [
          "LESION ANORECTALE ANTECEDENT PERSONNEL",
          "RECTITE/RECTORRAGIE ANTECEDENT PERSONNEL",
        ],
        other_comment: [],
        text: [],
      },
      {
        label: "QUEL QUE SOIT LE TERRAIN",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "PREVENIR LE MALADE",
          "RISQUE DE TOXICITE LOCALE",
          "RISQUE DE SURDOSAGE",
          "RISQUE DE REACTION CUTANEE",
          "HEPATOTOXICITE",
          "RISQUE DE SYNDROME DE STEVENS JOHNSON (SSJ)",
          "RISQUE DE PUSTULOSE EXANTHEMATIQUE (PEAG)",
          "SURVEILLANCE CLINIQUE",
        ],
        text: [],
      },
    ],
  },
  {
    dose: "150 mg",
    form: "poudre pour solution buvable",
    contraindications: [
      {
        label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [
          "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
          "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
          "HYPERSENSIBILITE FRUCTOSE (INTOLERANCE)",
          "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
          "HYPERSENSIBILITE SACCHAROSE (INTOLERANCE)",
        ],
        other_comment: [
          "TENIR COMPTE PRESENCE SACCHAROSE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "INTOLERANCE GENETIQUE AU FRUCTOSE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: [
          "TENIR COMPTE PRESENCE SACCHAROSE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "DEFICIT EN SUCRASE-ISOMALTASE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: [
          "TENIR COMPTE PRESENCE SACCHAROSE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du saccharose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) que vous avez une intolérance à certains sucres, contactez votre médecin avant de prendre ce médicament.\r\n\r\n- Proposition de RCP : \r\nLes patients présentant une intolérance au fructose, un syndrome de malabsorption du glucose et du galactose ou un déficit en sucrase/isomaltase (maladies héréditaires rares) ne doivent pas prendre ce médicament\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "SYNDROME DE MALABSORPTION / INTOLERANCE DIGESTIVE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [
          "SYNDROME MALABSORPTION GLUCOSE/GALACTOSE",
          "HYPERSENSIBILITE GLUCOSE (INTOLERANCE)",
          "HYPERSENSIBILITE GALACTOSE (INTOLERANCE)",
        ],
        other_comment: [
          "TENIR COMPTE PRESENCE GLUCOSE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        text: [
          "Ce médicament contient du glucose comme excipient.\r\n\r\n- Voie d'administration : Orale\r\n\r\n- Seuil : Zéro\r\n\r\n- Informations\r\nSi votre médecin vous a informé(e) d'une intolérance à certains sucres, contactez-le avant de prendre ce médicament.\r\n\r\n- Commentaire :\r\nProposition de RCP : Les patients présentant un syndrome de malabsorption du glucose et du galactose\r\n(maladie héréditaire rare) ne doivent pas prendre ce médicament.\r\n\r\nRéf. : ansm/EMA liste EEN 06/02/2020",
        ],
      },
      {
        label: "QUEL QUE SOIT LE TERRAIN",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "TENIR COMPTE PRESENCE SACCHAROSE",
          "Cf. COMPOSITION",
          "RISQUE DE SURDOSAGE",
          "HEPATOTOXICITE",
          "PRESENCE D'EXCIPIENT(S) A EFFET NOTOIRE",
        ],
        text: [],
      },
      {
        label: "MUCOVISCIDOSE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HEPATITE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["HEPATITE AIGUE"],
        other_comment: [
          "ARRETER LE TRAITEMENT",
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
        ],
        text: [
          "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
        ],
      },
      {
        label: "HEPATITE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["HEPATITE CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
        other_comment: [],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [
          "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
          "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
        ],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INFECTION VIH",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DESHYDRATATION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HYPOVOLEMIE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "RISQUE D'ANEMIE",
          "RISQUE D'HEMOLYSE",
        ],
        text: [],
      },
      {
        label: "SYNDROME DE GILBERT",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DENUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "AMAIGRISSEMENT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "MALNUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["MALNUTRITION CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ALCOOLISME CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "SEVRAGE ALCOOLIQUE SYNDROME",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SEVRAGE ALCOOLIQUE"],
        other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
        text: [],
      },
      {
        label: "ANOREXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE RENALE CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["INSUFFISANCE RENALE SEVERE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. PROPRIETES PHARMACOCINETIQUES",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INTERACTION D'ORIGINE ALIMENTAIRE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: ["INGESTION D'ALCOOL"],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "RISQUE D'ATTEINTE HEPATIQUE",
        ],
        text: [
          "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
        ],
      },
      {
        label: "JEUNE STRICT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "CACHEXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "EXAMEN LABORATOIRE INTERFERENCE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
        other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
        text: [
          "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
        ],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "UTILISER AVEC PRUDENCE",
          "EN CAS DE POSOLOGIE ELEVEE",
          "RISQUE D'HEMOLYSE",
          "REFERENTIEL ANSM G6PD 13/06/2014",
        ],
        text: [
          "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
        ],
      },
      {
        label: "ENFANT",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["ENFANT DE PLUS DE 30 KG"],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant de 8 à 30 kg (soit environ de 6 mois à 11 ans).",
        ],
      },
      {
        label: "NOURRISSON",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["NOURRISSON DE MOINS DE 8 KG"],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant de 8 à 30 kg (soit environ de 6 mois à 11 ans).",
        ],
      },
      {
        label: "NOUVEAU-NE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant pesant de 8 à 30 kg (environ 6 mois à 11 ans).",
        ],
      },
      {
        label: "SUJET AGE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant de 8 à 30 kg (soit environ de 6 mois à 11 ans).",
        ],
      },
      {
        label: "ADULTE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'enfant de 8 à 30 kg (soit environ de 6 mois à 11 ans).",
        ],
      },
    ],
  },
  {
    dose: "500 mg",
    form: "comprimé",
    contraindications: [
      {
        label: "PATIENT DE FAIBLE POIDS",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["PATIENT DE MOINS DE 50 KG"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ENFANT",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["ENFANT DE MOINS DE 6 ANS", "ENFANT DE MOINS DE 27 KG"],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "Cf. INDICATIONS",
          "DOSAGE INADAPTE POUR CE TERRAIN",
          "RISQUE DE FAUSSE ROUTE",
          "FORME GALENIQUE INADAPTEE A CE TERRAIN",
        ],
        text: [
          "La prise de comprimé ou de gélule est contre-indiquée chez l'enfant de moins de 6 ans car elle peut entraîner une fausse route.\r\n\r\nCette présentation est réservée à l'adulte et l'enfant à partir de 27 kg (soit environ à partir de 8 ans).",
        ],
      },
      {
        label: "ENFANT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [
          "ENFANT DE PLUS DE 6 ANS",
          "ENFANT DE MOINS DE 50 KG",
          "ENFANT DE PLUS DE 26 KG",
        ],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "ADAPTER LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "NOURRISSON",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "RISQUE DE FAUSSE ROUTE",
          "FORME GALENIQUE INADAPTEE A CE TERRAIN",
        ],
        text: [
          "La prise de comprimé ou de gélule est contre-indiquée chez l'enfant de moins de 6 ans car elle peut entraîner une fausse route.",
        ],
      },
      {
        label: "NOUVEAU-NE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "RISQUE DE FAUSSE ROUTE",
          "FORME GALENIQUE INADAPTEE A CE TERRAIN",
        ],
        text: [
          "La prise de comprimé ou de gélule est contre-indiquée chez l'enfant de moins de 6 ans car elle peut entraîner une fausse route.",
        ],
      },
      {
        label: "SUJET AGE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SUJET AGE DE PLUS DE 75 ANS"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [
          "La dose journalière efficace la plus faible possible doit être envisagée, sans excéder 60 mg/kg/jour (sans dépasser 3 g/jour) dans les situations suivantes : [...]\r\n- sujet âgé de plus de 75 ans.",
        ],
      },
      {
        label: "SUJET AGE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SUJET POLYPATHOLOGIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [
          "La dose journalière efficace la plus faible possible doit être envisagée, sans excéder 60 mg/kg/jour (sans dépasser 3 g/jour) dans les situations suivantes : [...]\r\n- sujet âgé de plus de 65 ans et polypathologique.",
        ],
      },
      {
        label: "MUCOVISCIDOSE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HEPATITE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["HEPATITE AIGUE"],
        other_comment: [
          "ARRETER LE TRAITEMENT",
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
        ],
        text: [
          "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
        ],
      },
      {
        label: "HEPATITE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["HEPATITE CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
        other_comment: [],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [
          "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
          "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
        ],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INFECTION VIH",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DESHYDRATATION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HYPOVOLEMIE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "RISQUE D'ANEMIE",
          "RISQUE D'HEMOLYSE",
        ],
        text: [],
      },
      {
        label: "SYNDROME DE GILBERT",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DENUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "AMAIGRISSEMENT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "MALNUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["MALNUTRITION CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ALCOOLISME CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "SEVRAGE ALCOOLIQUE SYNDROME",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SEVRAGE ALCOOLIQUE"],
        other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
        text: [],
      },
      {
        label: "ANOREXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE RENALE CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["INSUFFISANCE RENALE SEVERE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. PROPRIETES PHARMACOCINETIQUES",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INTERACTION D'ORIGINE ALIMENTAIRE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: ["INGESTION D'ALCOOL"],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "RISQUE D'ATTEINTE HEPATIQUE",
        ],
        text: [
          "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
        ],
      },
      {
        label: "JEUNE STRICT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "CACHEXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "EXAMEN LABORATOIRE INTERFERENCE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
        other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
        text: [
          "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
        ],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "UTILISER AVEC PRUDENCE",
          "EN CAS DE POSOLOGIE ELEVEE",
          "RISQUE D'HEMOLYSE",
          "REFERENTIEL ANSM G6PD 13/06/2014",
        ],
        text: [
          "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
        ],
      },
      {
        label: "QUEL QUE SOIT LE TERRAIN",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "RISQUE DE SURDOSAGE",
          "RISQUE DE REACTION CUTANEE",
          "HEPATOTOXICITE",
          "RISQUE DE SYNDROME DE STEVENS JOHNSON (SSJ)",
          "RISQUE DE PUSTULOSE EXANTHEMATIQUE (PEAG)",
        ],
        text: [],
      },
    ],
  },
  {
    dose: "1000 mg",
    form: "comprimé",
    contraindications: [
      {
        label: "MUCOVISCIDOSE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HEPATITE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["HEPATITE AIGUE"],
        other_comment: [
          "ARRETER LE TRAITEMENT",
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
        ],
        text: [
          "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
        ],
      },
      {
        label: "HEPATITE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["HEPATITE CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
        other_comment: [],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [
          "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
          "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
        ],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INFECTION VIH",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DESHYDRATATION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HYPOVOLEMIE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "RISQUE D'ANEMIE",
          "RISQUE D'HEMOLYSE",
        ],
        text: [],
      },
      {
        label: "SYNDROME DE GILBERT",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DENUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "AMAIGRISSEMENT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "MALNUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["MALNUTRITION CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ALCOOLISME CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "SEVRAGE ALCOOLIQUE SYNDROME",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SEVRAGE ALCOOLIQUE"],
        other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
        text: [],
      },
      {
        label: "ANOREXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE RENALE CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["INSUFFISANCE RENALE SEVERE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. PROPRIETES PHARMACOCINETIQUES",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INTERACTION D'ORIGINE ALIMENTAIRE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: ["INGESTION D'ALCOOL"],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "RISQUE D'ATTEINTE HEPATIQUE",
        ],
        text: [
          "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
        ],
      },
      {
        label: "JEUNE STRICT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "CACHEXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "EXAMEN LABORATOIRE INTERFERENCE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
        other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
        text: [
          "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
        ],
      },
      {
        label: "PATIENT DE FAIBLE POIDS",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["PATIENT DE MOINS DE 50 KG"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ENFANT",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["ENFANT DE MOINS DE 50 KG"],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée à l'adulte et à l'enfant à partir de 50 kg (soit à partir d'environ 15 ans).",
        ],
      },
      {
        label: "ENFANT",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["ENFANT DE MOINS DE 6 ANS"],
        other_comment: [
          "RISQUE DE FAUSSE ROUTE",
          "FORME GALENIQUE INADAPTEE A CE TERRAIN",
        ],
        text: [],
      },
      {
        label: "NOURRISSON",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: [
          "RISQUE DE FAUSSE ROUTE",
          "FORME GALENIQUE INADAPTEE A CE TERRAIN",
        ],
        text: [""],
      },
      {
        label: "NOUVEAU-NE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: [
          "RISQUE DE FAUSSE ROUTE",
          "FORME GALENIQUE INADAPTEE A CE TERRAIN",
        ],
        text: [""],
      },
      {
        label: "SUJET AGE",
        level: ["PAS DE PRECAUTION D'EMPLOI"],
        comment: ["SUJET AGE DE PLUS DE 75 ANS"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "SUJET AGE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SUJET POLYPATHOLOGIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "UTILISER AVEC PRUDENCE",
          "EN CAS DE POSOLOGIE ELEVEE",
          "RISQUE D'HEMOLYSE",
          "REFERENTIEL ANSM G6PD 13/06/2014",
        ],
        text: [
          "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
        ],
      },
      {
        label: "QUEL QUE SOIT LE TERRAIN",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "RISQUE DE SURDOSAGE",
          "RISQUE DE REACTION CUTANEE",
          "HEPATOTOXICITE",
          "RISQUE DE SYNDROME DE STEVENS JOHNSON (SSJ)",
          "RISQUE DE PUSTULOSE EXANTHEMATIQUE (PEAG)",
        ],
        text: [],
      },
    ],
  },
  {
    dose: "150 mg",
    form: "suppositoire",
    contraindications: [
      {
        label: "MUCOVISCIDOSE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HEPATITE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["HEPATITE AIGUE"],
        other_comment: [
          "ARRETER LE TRAITEMENT",
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
        ],
        text: [
          "En cas de découverte d'une hépatite virale aiguë, il convient d'arrêter le traitement.",
        ],
      },
      {
        label: "HEPATITE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["HEPATITE CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["INSUFFISANCE HEPATIQUE SEVERE MALADIE"],
        other_comment: [],
        text: [],
      },
      {
        label: "INSUFFISANCE HEPATIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [
          "INSUFFISANCE HEPATIQUE LEGERE MALADIE",
          "INSUFFISANCE HEPATIQUE MODEREE MALADIE",
        ],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INFECTION VIH",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DESHYDRATATION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "HYPOVOLEMIE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "RISQUE D'ANEMIE",
          "RISQUE D'HEMOLYSE",
        ],
        text: [],
      },
      {
        label: "SYNDROME DE GILBERT",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "DENUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "AMAIGRISSEMENT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "MALNUTRITION",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["MALNUTRITION CHRONIQUE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "ALCOOLISME CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "SEVRAGE ALCOOLIQUE SYNDROME",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["SEVRAGE ALCOOLIQUE"],
        other_comment: ["RISQUE D'ATTEINTE HEPATIQUE"],
        text: [],
      },
      {
        label: "ANOREXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INSUFFISANCE RENALE CHRONIQUE",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: ["INSUFFISANCE RENALE SEVERE"],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. PROPRIETES PHARMACOCINETIQUES",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "INTERACTION D'ORIGINE ALIMENTAIRE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: ["INGESTION D'ALCOOL"],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "RISQUE D'ATTEINTE HEPATIQUE",
        ],
        text: [
          "La consommation de boissons alcoolisées pendant le traitement est déconseillée.",
        ],
      },
      {
        label: "JEUNE STRICT",
        level: ["PRECAUTION (PARTICULIERE) D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "CACHEXIE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "UTILISER AVEC PRUDENCE",
          "REDUIRE LA POSOLOGIE",
          "Cf. POSOLOGIE",
        ],
        text: [],
      },
      {
        label: "EXAMEN LABORATOIRE INTERFERENCE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: ["DOSAGE SANGUIN ACIDE URIQUE", "DOSAGE SANGUIN GLYCEMIE"],
        other_comment: ["Cf. INTERACTIONS MEDICAMENTEUSES"],
        text: [
          "La prise de paracétamol peut fausser le dosage de la glycémie par la méthode à la glucose oxydase-peroxydase en cas de concentrations anormalement élevées.\r\n\r\nLa prise de paracétamol peut fausser le dosage de l'acide urique sanguin par la méthode à l'acide phosphotungstique.",
        ],
      },
      {
        label: "DEFICIT GLUC 6 PHOSPHATE DESHYDROGENASE",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "UTILISER AVEC PRUDENCE",
          "EN CAS DE POSOLOGIE ELEVEE",
          "RISQUE D'HEMOLYSE",
          "REFERENTIEL ANSM G6PD 13/06/2014",
        ],
        text: [
          "* Paracétamol\r\n\r\n- Niveau de risque : Substance possible à utiliser sous condition du strict respect des doses maximales.\r\n\r\nIl est particulièrement important chez les sujets déficitaires en G6PD de respecter les posologies recommandées.\r\n\r\nDes cas d'hémolyse aiguë (destruction des globules rouges) ont été rapportés chez les sujets déficitaires en G6PD avec des doses élevées de paracétamol, supérieures à la posologie maximale quotidienne recommandée.\r\n\r\n- Message à l'attention des patients déficitaires en G6PD\r\nLire attentivement la notice du médicament, en particulier la rubrique “Comment prendre son médicament”. Cette rubrique vous informera sur les doses qui doivent être respectées que vous soyez ou non atteint d'un déficit en G6PD.\r\n\r\nEn cas de doute, demandez l'avis de votre médecin ou de votre pharmacien.\r\n\r\n- Informations complémentaires\r\nIl est recommandé d'être vigilant sur la composition de tous les médicaments, qu'ils soient prescrits par un médecin ou pris en automédication. En effet, des médicaments peuvent contenir plusieurs substances actives dont le paracétamol.\r\n\r\nLa prise concomitante de plusieurs médicaments contenant du paracétamol n'est pas recommandée. Si toutefois plusieurs médicaments contenant du paracétamol sont pris concomitamment, il est important de tenir compte de la dose totale de paracétamol consommée et d'être très attentif à ne pas dépasser les doses maximales recommandées.\r\n\r\nLa posologie maximale recommandée dépend de l'âge et du poids du patient.\r\n\r\n- Dose recommandée chez le nourrisson et l'enfant :\r\n60 mg/kg/jour (sans dépasser la dose maximale de 80 mg/kg/jour) en 4 à 6 prises (soit 15 mg/kg toutes les 6 heures, soit 10 mg/kg toutes les 4 heures).\r\n\r\n- Dose adulte :\r\n. Il n'est généralement pas nécessaire de dépasser 3 g/jour.\r\n. En cas de douleurs plus intenses et sur conseil du médecin, la dose totale peut être augmentée jusqu'à 4 g/jour. En\r\ncas de poids < 50 kg, d'insuffisance hépatique légère à modérée, d'insuffisance rénale sévère, d'alcoolisme chronique, de malnutrition chronique ou de déshydratation : ne pas dépasser 3 g/jour.\r\n\r\nLes prises doivent être espacées d'au moins 4 heures.\r\n\r\nRef : Référentiel Ansm - Médicaments et déficit en Glucose-6-Phosphate Déshydrogénase (G6PD)",
        ],
      },
      {
        label: "ENFANT",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["ENFANT DE PLUS DE 12 KG"],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée AU NOURRISSON pesant de 8 à 12 kg (environ 6 à 24 mois).",
        ],
      },
      {
        label: "NOURRISSON",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: ["NOURRISSON DE PLUS DE 12 KG", "NOURRISSON DE MOINS DE 8 KG"],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée AU NOURRISSON pesant de 8 à 12 kg (environ 6 à 24 mois).",
        ],
      },
      {
        label: "NOUVEAU-NE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée AU NOURRISSON pesant de 8 à 12 kg (environ 6 à 24 mois).",
        ],
      },
      {
        label: "SUJET AGE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée AU NOURRISSON pesant de 8 à 12 kg (environ 6 à 24 mois).",
        ],
      },
      {
        label: "ADULTE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [],
        other_comment: ["Cf. INDICATIONS", "DOSAGE INADAPTE POUR CE TERRAIN"],
        text: [
          "Cette présentation est réservée AU NOURRISSON pesant de 8 à 12 kg (environ 6 à 24 mois).",
        ],
      },
      {
        label: "DIARRHEE",
        level: ["UTILISATION DECONSEILLEE"],
        comment: [],
        other_comment: [
          "Cf. MISE EN GARDE ET PRECAUTION D'EMPLOI",
          "FORME GALENIQUE INADAPTEE A CE TERRAIN",
        ],
        text: ["En cas de diarrhée, la forme suppositoire n'est pas adaptée."],
      },
      {
        label: "RECTITE / RECTORRAGIE",
        level: ["CONTRE-INDICATION ABSOLUE"],
        comment: [
          "LESION ANORECTALE ANTECEDENT PERSONNEL",
          "RECTITE/RECTORRAGIE ANTECEDENT PERSONNEL",
        ],
        other_comment: [],
        text: [],
      },
      {
        label: "QUEL QUE SOIT LE TERRAIN",
        level: ["MISE EN GARDE ET PRECAUTION D'EMPLOI"],
        comment: [],
        other_comment: [
          "RESPECTER LA POSOLOGIE",
          "PREVENIR LE MALADE",
          "RISQUE DE TOXICITE LOCALE",
          "RISQUE DE SURDOSAGE",
          "RISQUE DE REACTION CUTANEE",
          "HEPATOTOXICITE",
          "RISQUE DE SYNDROME DE STEVENS JOHNSON (SSJ)",
          "RISQUE DE PUSTULOSE EXANTHEMATIQUE (PEAG)",
          "SURVEILLANCE CLINIQUE",
        ],
        text: [],
      },
    ],
  },
];

export const mockDolipraneSideEffectsDTOResponse: DTOSideEffectsResponse = {
  drugs: [
    {
      form: "poudre pour solution buvable",
      dose: "1000 mg",
      side_effects_categories: [
        {
          category: "TROUBLES SYSTEMES SANGUIN ET LYMPHATIQUE",
          severity: ["MODERE(S)", " OU", "SEVERE(S)"],
          severity_category: "MODERE(S) OU SEVERE(S)",
          frequency: 1,
          frequency_string: "rare (< 1%)",
          frequency_comment: null,
          behaviour: [
            "ARRETER LE TRAITEMENT",
            "EFFECTUER UNE SURVEILLANCE BIOLOGIQUE",
            "HOSPITALISER EN MILIEU SPECIALISE",
          ],
          behaviour_comment: " ",
          occurence_time: ["AU COURS DU TRAITEMENT"],
          occurence_comment: null,
          favoring_factors: ["HYPERSENSIBILITE"],
          other_favoring_factors: [
            "A FORTE DOSE",
            "ASSOCIATION MEDICAMENTEUSE",
            "SUSCEPTIBILITE INDIVIDUELLE",
          ],
          effects: ["DYSCRASIE SANGUINE", "PURPURA"],
        },
        {
          category: "TROUBLES SYSTEMES SANGUIN ET LYMPHATIQUE",
          severity: ["MODERE(S)", " OU", "SEVERE(S)"],
          severity_category: "MODERE(S) OU SEVERE(S)",
          frequency: 1,
          frequency_string: "rare (< 1%)",
          frequency_comment: null,
          behaviour: [
            "ARRETER LE TRAITEMENT",
            "EFFECTUER UNE SURVEILLANCE BIOLOGIQUE",
            "HOSPITALISER EN MILIEU SPECIALISE",
          ],
          behaviour_comment: " ",
          occurence_time: ["AU COURS DU TRAITEMENT"],
          occurence_comment: null,
          favoring_factors: ["HYPERSENSIBILITE"],
          other_favoring_factors: [
            "A FORTE DOSE",
            "ASSOCIATION MEDICAMENTEUSE",
            "SUSCEPTIBILITE INDIVIDUELLE",
          ],
          effects: [
            "THROMBOCYTOPENIE",
            "NEUTROPENIE",
            "AGRANULOCYTOSE",
            "TAUX PROTHROMBINE MODIFICATION",
            "LEUCOPENIE",
            "PANCYTOPENIE",
            "ANEMIE HEMOLYTIQUE",
            "COAGULATION TROUBLE",
          ],
        },
        {
          category: "TROUBLES HEPATO-BILIAIRES",
          severity: ["MODERE(S)", " OU", "SEVERE(S)"],
          severity_category: "MODERE(S) OU SEVERE(S)",
          frequency: 1,
          frequency_string: "rare (< 1%)",
          frequency_comment: null,
          behaviour: [
            "ADAPTER LA POSOLOGIE",
            "OU",
            "ARRETER LE TRAITEMENT",
            "EFFECTUER UNE SURVEILLANCE BIOLOGIQUE",
            "EFFECTUER UNE SURVEILLANCE HEPATIQUE",
          ],
          behaviour_comment: " ",
          occurence_time: [
            "AU COURS DU TRAITEMENT",
            "EN CAS DE TRAITEMENT PROLONGE",
          ],
          occurence_comment: null,
          favoring_factors: ["INSUFFISANCE HEPATIQUE"],
          other_favoring_factors: ["A FORTE DOSE"],
          effects: [
            "ATTEINTE HEPATIQUE",
            "HEPATITE",
            "INSUFFISANCE HEPATIQUE",
            "ICTERE",
            "NECROSE HEPATIQUE",
            "FIBROSE HEPATIQUE",
            "CIRRHOSE",
            "DECES / MORTALITE",
            "LESION HEPATIQUE",
            "CYTOLYSE HEPATIQUE",
          ],
        },
        {
          category: "TROUBLES HEPATO-BILIAIRES",
          severity: ["MODERE(S)", " OU", "SEVERE(S)"],
          severity_category: "MODERE(S) OU SEVERE(S)",
          frequency: 1,
          frequency_string: "rare (< 1%)",
          frequency_comment: null,
          behaviour: [
            "ADAPTER LA POSOLOGIE",
            "OU",
            "ARRETER LE TRAITEMENT",
            "EFFECTUER UNE SURVEILLANCE BIOLOGIQUE",
            "EFFECTUER UNE SURVEILLANCE HEPATIQUE",
          ],
          behaviour_comment: " ",
          occurence_time: [
            "AU COURS DU TRAITEMENT",
            "EN CAS DE TRAITEMENT PROLONGE",
          ],
          occurence_comment: null,
          favoring_factors: ["INSUFFISANCE HEPATIQUE"],
          other_favoring_factors: ["A FORTE DOSE"],
          effects: ["ASAT MODIFICATION", "ALAT MODIFICATION"],
        },
        {
          category: "TROUBLES DU SYSTEME IMMUNITAIRE",
          severity: ["MODERE(S)", " OU", "SEVERE(S)"],
          severity_category: "MODERE(S) OU SEVERE(S)",
          frequency: 1,
          frequency_string: "rare (< 1%)",
          frequency_comment: null,
          behaviour: [
            "ARRETER LE TRAITEMENT",
            "FAIRE UN TRAITEMENT SYMPTOMATIQUE",
            "EFFECTUER UNE SURVEILLANCE CLINIQUE",
          ],
          behaviour_comment: " ",
          occurence_time: ["AU COURS DU TRAITEMENT"],
          occurence_comment: null,
          favoring_factors: ["HYPERSENSIBILITE"],
          other_favoring_factors: ["SUSCEPTIBILITE INDIVIDUELLE"],
          effects: [
            "REACTION ALLERGIQUE",
            "CHOC ANAPHYLACTIQUE",
            "OEDEME DE QUINCKE / ANGIOEDEME",
            "ERYTHEME",
            "URTICAIRE",
            "ERUPTION CUTANEE",
            "DYSPNEE",
            "HYPOTENSION ARTERIELLE",
            "BRONCHOSPASME / ASTHME",
            "ANAPHYLAXIE",
            "ECZEMA",
            "PRURIT",
            "HYPERSUDATION",
            "TACHYCARDIE",
            "BOUFFEE VASOMOTRICE",
            "TOXIDERMIE BULLEUSE / PEMPHIGUS",
            "STEVENS JOHNSON SYNDROME",
            "LYELL SYNDROME / NECROLYSE EPIDERMIQUE TOXIQUE (NET)",
            "PUSTULOSE",
            "EXANTHEME",
            "PURPURA",
            "DECES / MORTALITE",
            "ERYTHEME PIGMENTE FIXE",
          ],
        },
        {
          category: "TROUBLES HEPATO-BILIAIRES",
          severity: [
            "MODERE(S)",
            "  A",
            "SEVERE(S)",
            "LIE A EXCIPIENT A EFFET NOTOIRE",
            "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
          ],
          severity_category: "MODERE(S)",
          frequency: 1,
          frequency_string: "rare (< 1%)",
          frequency_comment: null,
          behaviour: ["EVALUER LE RAPPORT BENEFICE/RISQUE"],
          behaviour_comment: null,
          occurence_time: ["AU COURS DU TRAITEMENT"],
          occurence_comment: null,
          favoring_factors: ["NOUVEAU-NE"],
          other_favoring_factors: [],
          effects: ["ICTERE"],
        },
        {
          category: "TROUBLES HEPATO-BILIAIRES",
          severity: [
            "MODERE(S)",
            "  A",
            "SEVERE(S)",
            "LIE A EXCIPIENT A EFFET NOTOIRE",
            "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
          ],
          severity_category: "MODERE(S)",
          frequency: 1,
          frequency_string: "rare (< 1%)",
          frequency_comment: null,
          behaviour: ["EVALUER LE RAPPORT BENEFICE/RISQUE"],
          behaviour_comment: null,
          occurence_time: ["AU COURS DU TRAITEMENT"],
          occurence_comment: null,
          favoring_factors: ["NOUVEAU-NE"],
          other_favoring_factors: [],
          effects: ["BILIRUBINE MODIFICATION"],
        },
        {
          category: null,
          severity: ["MODERE(S)", "  A", "SEVERE(S)"],
          severity_category: "MODERE(S)",
          frequency: null,
          frequency_string: null,
          frequency_comment: null,
          behaviour: [
            "ARRETER LE TRAITEMENT",
            "FAIRE UN TRAITEMENT D'URGENCE",
            "HOSPITALISER EN MILIEU SPECIALISE",
            "PRATIQUER UN LAVAGE GASTRIQUE",
            "ADMINISTRER UN ANTIDOTE",
            "EFFECTUER UNE SURVEILLANCE BIOLOGIQUE",
            "FAIRE UN TRAITEMENT SYMPTOMATIQUE",
            "EFFECTUER UNE SURVEILLANCE HEPATIQUE",
          ],
          behaviour_comment: " ",
          occurence_time: [],
          occurence_comment: null,
          favoring_factors: [],
          other_favoring_factors: [],
          effects: [
            "NAUSEE VOMISSEMENT",
            "ANOREXIE",
            "PALEUR",
            "DOULEUR ABDOMINALE",
            "CYTOLYSE HEPATIQUE",
            "NECROSE HEPATIQUE",
            "INSUFFISANCE HEPATIQUE",
            "ENCEPHALOPATHIE HEPATIQUE",
            "COMA",
            "DECES / MORTALITE",
            "ATTEINTE HEPATIQUE",
            "INSUFFISANCE RENALE AIGUE",
            "NECROSE TUBULAIRE RENALE",
            "ARYTHMIE",
            "PANCREATITE AIGUE",
            "IRRITATION ANALE",
            "ANORECTITE",
          ],
        },
        {
          category: null,
          severity: ["MODERE(S)", "  A", "SEVERE(S)"],
          severity_category: "MODERE(S)",
          frequency: null,
          frequency_string: null,
          frequency_comment: null,
          behaviour: [
            "ARRETER LE TRAITEMENT",
            "FAIRE UN TRAITEMENT D'URGENCE",
            "HOSPITALISER EN MILIEU SPECIALISE",
            "PRATIQUER UN LAVAGE GASTRIQUE",
            "ADMINISTRER UN ANTIDOTE",
            "EFFECTUER UNE SURVEILLANCE BIOLOGIQUE",
            "FAIRE UN TRAITEMENT SYMPTOMATIQUE",
            "EFFECTUER UNE SURVEILLANCE HEPATIQUE",
          ],
          behaviour_comment: " ",
          occurence_time: [],
          occurence_comment: null,
          favoring_factors: [],
          other_favoring_factors: [],
          effects: [
            "TAUX PROTHROMBINE MODIFICATION",
            "ALAT MODIFICATION",
            "ASAT MODIFICATION",
            "BILIRUBINE MODIFICATION",
            "LACTICO-DESHYDROGENASE MODIFICATION",
            "ACIDOSE METABOLIQUE",
            "HYPOGLYCEMIE",
            "HYPERGLYCEMIE",
            "HYPERAMYLASEMIE",
          ],
        },
        {
          category: "TROUBLES RESPIRATOIRES",
          severity: ["SEVERE(S)"],
          severity_category: "SEVERE(S)",
          frequency: 1,
          frequency_string: "rare (< 1%)",
          frequency_comment: "Ces effets sont rares.",
          behaviour: [
            "ARRETER LE TRAITEMENT",
            "FAIRE UN TRAITEMENT D'URGENCE",
            "HOSPITALISER EN MILIEU SPECIALISE",
          ],
          behaviour_comment: " ",
          occurence_time: [
            "AU COURS DU TRAITEMENT",
            "EN CAS DE TRAITEMENT PROLONGE",
          ],
          occurence_comment: null,
          favoring_factors: ["HYPERSENSIBILITE"],
          other_favoring_factors: ["SUSCEPTIBILITE INDIVIDUELLE"],
          effects: ["BRONCHOSPASME / ASTHME", "DYSPNEE"],
        },
        {
          category: "TROUBLES MENTAUX ET DU COMPORTEMENT",
          severity: ["MODERE(S)", " OU", "SEVERE(S)"],
          severity_category: "MODERE(S) OU SEVERE(S)",
          frequency: 1,
          frequency_string: "rare (< 1%)",
          frequency_comment: null,
          behaviour: [],
          behaviour_comment: null,
          occurence_time: [],
          occurence_comment: null,
          favoring_factors: [],
          other_favoring_factors: [],
          effects: [
            "DEPRESSION",
            "CONFUSION MENTALE",
            "HALLUCINATION",
            "HUMEUR TROUBLE",
            "ANXIETE",
            "NERVOSITE",
            "EUPHORIE",
            "SOMMEIL TROUBLE",
            "CAUCHEMAR",
            "DELIRE",
            "DEPENDANCE",
          ],
        },
        {
          category: "TROUBLES DU SYSTEME NERVEUX",
          severity: ["MODERE(S)", " OU", "SEVERE(S)"],
          severity_category: "MODERE(S) OU SEVERE(S)",
          frequency: 1,
          frequency_string: "rare (< 1%)",
          frequency_comment: null,
          behaviour: [],
          behaviour_comment: null,
          occurence_time: [],
          occurence_comment: null,
          favoring_factors: [],
          other_favoring_factors: [],
          effects: [
            "TREMBLEMENT",
            "CEPHALEE",
            "VERTIGE / ETOURDISSEMENT",
            "MALAISE / LIPOTHYMIE",
            "SOMNOLENCE DIURNE",
            "ATAXIE",
            "CONVULSION",
            "SYNCOPE",
            "DYSARTHRIE / PAROLE DIFFICULTE",
            "AMNESIE",
          ],
        },
        {
          category: "TROUBLES DES ORGANES DES SENS",
          severity: ["MODERE(S)", " OU", "SEVERE(S)"],
          severity_category: "MODERE(S) OU SEVERE(S)",
          frequency: 1,
          frequency_string: "rare (< 1%)",
          frequency_comment: null,
          behaviour: [],
          behaviour_comment: null,
          occurence_time: [],
          occurence_comment: null,
          favoring_factors: [],
          other_favoring_factors: [],
          effects: [
            "VISION ALTERATION",
            "ACOUPHENE / BOURDONNEMENT D'OREILLE",
            "MYOSIS",
            "MYDRIASE",
            "ACCOMMODATION TROUBLE",
          ],
        },
        {
          category: "TROUBLES DE L'ETAT GENERAL",
          severity: ["MODERE(S)", " OU", "SEVERE(S)"],
          severity_category: "MODERE(S) OU SEVERE(S)",
          frequency: 1,
          frequency_string: "rare (< 1%)",
          frequency_comment: null,
          behaviour: [],
          behaviour_comment: "  ",
          occurence_time: [],
          occurence_comment: null,
          favoring_factors: [],
          other_favoring_factors: [],
          effects: [
            "OEDEME",
            "FIEVRE",
            "FRISSON",
            "DOULEUR / OPPRESSION THORACIQUE",
            "HYPERTENSION ARTERIELLE",
            "BOUFFEE VASOMOTRICE",
            "KOUNIS SYNDROME",
          ],
        },
        {
          category: "TROUBLES DE L'ETAT GENERAL",
          severity: ["MODERE(S)", " OU", "SEVERE(S)"],
          severity_category: "MODERE(S) OU SEVERE(S)",
          frequency: 1,
          frequency_string: "rare (< 1%)",
          frequency_comment: null,
          behaviour: [],
          behaviour_comment: "  ",
          occurence_time: [],
          occurence_comment: null,
          favoring_factors: [],
          other_favoring_factors: [],
          effects: ["HYPOGLYCEMIE"],
        },
        {
          category: "TROUBLES GASTRO-INTESTINAUX",
          severity: ["MODERE(S)", " OU", "SEVERE(S)"],
          severity_category: "MODERE(S) OU SEVERE(S)",
          frequency: 1,
          frequency_string: "rare (< 1%)",
          frequency_comment: null,
          behaviour: [],
          behaviour_comment: " ",
          occurence_time: [],
          occurence_comment: null,
          favoring_factors: [],
          other_favoring_factors: [],
          effects: [
            "HEMORRAGIE DIGESTIVE",
            "DOULEUR ABDOMINALE",
            "DIARRHEE",
            "NAUSEE VOMISSEMENT",
            "PANCREATITE AIGUE",
            "CONSTIPATION",
            "COLITE",
          ],
        },
        {
          category: "TROUBLES RENAUX ET GENITO-URINAIRES",
          severity: ["MODERE(S)", " OU", "SEVERE(S)"],
          severity_category: "MODERE(S) OU SEVERE(S)",
          frequency: 1,
          frequency_string: "rare (< 1%)",
          frequency_comment: null,
          behaviour: [],
          behaviour_comment: " ",
          occurence_time: [],
          occurence_comment: null,
          favoring_factors: [],
          other_favoring_factors: [],
          effects: [
            "URINES MODIFICATION",
            "INSUFFISANCE RENALE AIGUE",
            "NEPHRITE INTERSTITIELLE",
            "ANURIE",
            "NEPHROTOXICITE",
            "ATTEINTE RENALE",
            "DYSURIE",
            "RETENTION D'URINE",
          ],
        },
        {
          category: "TROUBLES RENAUX ET GENITO-URINAIRES",
          severity: ["MODERE(S)", " OU", "SEVERE(S)"],
          severity_category: "MODERE(S) OU SEVERE(S)",
          frequency: 1,
          frequency_string: "rare (< 1%)",
          frequency_comment: null,
          behaviour: [],
          behaviour_comment: " ",
          occurence_time: [],
          occurence_comment: null,
          favoring_factors: [],
          other_favoring_factors: [],
          effects: ["HEMATURIE", "ALBUMINURIE"],
        },
      ],
    },
  ],
};

export const mockDolipraneSideEffects: FormDoseAndSideEffectsCategory[] = [
  {
    form: "poudre pour solution buvable",
    dose: "1000 mg",
    sideEffectsCategories: [
      {
        category: "TROUBLES SYSTEMES SANGUIN ET LYMPHATIQUE",
        severity: ["MODERE(S)", " OU", "SEVERE(S)"],
        severityCategory: "MODERE(S) OU SEVERE(S)",
        frequency: 1,
        frequencyString: "rare (< 1%)",
        frequencyComment: null,
        behaviour: [
          "ARRETER LE TRAITEMENT",
          "EFFECTUER UNE SURVEILLANCE BIOLOGIQUE",
          "HOSPITALISER EN MILIEU SPECIALISE",
        ],
        behaviourComment: " ",
        occurenceTime: ["AU COURS DU TRAITEMENT"],
        occurenceComment: null,
        favoringFactors: ["HYPERSENSIBILITE"],
        otherFavoringFactors: [
          "A FORTE DOSE",
          "ASSOCIATION MEDICAMENTEUSE",
          "SUSCEPTIBILITE INDIVIDUELLE",
        ],
        effects: ["DYSCRASIE SANGUINE", "PURPURA"],
      },
      {
        category: "TROUBLES SYSTEMES SANGUIN ET LYMPHATIQUE",
        severity: ["MODERE(S)", " OU", "SEVERE(S)"],
        severityCategory: "MODERE(S) OU SEVERE(S)",
        frequency: 1,
        frequencyString: "rare (< 1%)",
        frequencyComment: null,
        behaviour: [
          "ARRETER LE TRAITEMENT",
          "EFFECTUER UNE SURVEILLANCE BIOLOGIQUE",
          "HOSPITALISER EN MILIEU SPECIALISE",
        ],
        behaviourComment: " ",
        occurenceTime: ["AU COURS DU TRAITEMENT"],
        occurenceComment: null,
        favoringFactors: ["HYPERSENSIBILITE"],
        otherFavoringFactors: [
          "A FORTE DOSE",
          "ASSOCIATION MEDICAMENTEUSE",
          "SUSCEPTIBILITE INDIVIDUELLE",
        ],
        effects: [
          "THROMBOCYTOPENIE",
          "NEUTROPENIE",
          "AGRANULOCYTOSE",
          "TAUX PROTHROMBINE MODIFICATION",
          "LEUCOPENIE",
          "PANCYTOPENIE",
          "ANEMIE HEMOLYTIQUE",
          "COAGULATION TROUBLE",
        ],
      },
      {
        category: "TROUBLES HEPATO-BILIAIRES",
        severity: ["MODERE(S)", " OU", "SEVERE(S)"],
        severityCategory: "MODERE(S) OU SEVERE(S)",
        frequency: 1,
        frequencyString: "rare (< 1%)",
        frequencyComment: null,
        behaviour: [
          "ADAPTER LA POSOLOGIE",
          "OU",
          "ARRETER LE TRAITEMENT",
          "EFFECTUER UNE SURVEILLANCE BIOLOGIQUE",
          "EFFECTUER UNE SURVEILLANCE HEPATIQUE",
        ],
        behaviourComment: " ",
        occurenceTime: [
          "AU COURS DU TRAITEMENT",
          "EN CAS DE TRAITEMENT PROLONGE",
        ],
        occurenceComment: null,
        favoringFactors: ["INSUFFISANCE HEPATIQUE"],
        otherFavoringFactors: ["A FORTE DOSE"],
        effects: [
          "ATTEINTE HEPATIQUE",
          "HEPATITE",
          "INSUFFISANCE HEPATIQUE",
          "ICTERE",
          "NECROSE HEPATIQUE",
          "FIBROSE HEPATIQUE",
          "CIRRHOSE",
          "DECES / MORTALITE",
          "LESION HEPATIQUE",
          "CYTOLYSE HEPATIQUE",
        ],
      },
      {
        category: "TROUBLES HEPATO-BILIAIRES",
        severity: ["MODERE(S)", " OU", "SEVERE(S)"],
        severityCategory: "MODERE(S) OU SEVERE(S)",
        frequency: 1,
        frequencyString: "rare (< 1%)",
        frequencyComment: null,
        behaviour: [
          "ADAPTER LA POSOLOGIE",
          "OU",
          "ARRETER LE TRAITEMENT",
          "EFFECTUER UNE SURVEILLANCE BIOLOGIQUE",
          "EFFECTUER UNE SURVEILLANCE HEPATIQUE",
        ],
        behaviourComment: " ",
        occurenceTime: [
          "AU COURS DU TRAITEMENT",
          "EN CAS DE TRAITEMENT PROLONGE",
        ],
        occurenceComment: null,
        favoringFactors: ["INSUFFISANCE HEPATIQUE"],
        otherFavoringFactors: ["A FORTE DOSE"],
        effects: ["ASAT MODIFICATION", "ALAT MODIFICATION"],
      },
      {
        category: "TROUBLES DU SYSTEME IMMUNITAIRE",
        severity: ["MODERE(S)", " OU", "SEVERE(S)"],
        severityCategory: "MODERE(S) OU SEVERE(S)",
        frequency: 1,
        frequencyString: "rare (< 1%)",
        frequencyComment: null,
        behaviour: [
          "ARRETER LE TRAITEMENT",
          "FAIRE UN TRAITEMENT SYMPTOMATIQUE",
          "EFFECTUER UNE SURVEILLANCE CLINIQUE",
        ],
        behaviourComment: " ",
        occurenceTime: ["AU COURS DU TRAITEMENT"],
        occurenceComment: null,
        favoringFactors: ["HYPERSENSIBILITE"],
        otherFavoringFactors: ["SUSCEPTIBILITE INDIVIDUELLE"],
        effects: [
          "REACTION ALLERGIQUE",
          "CHOC ANAPHYLACTIQUE",
          "OEDEME DE QUINCKE / ANGIOEDEME",
          "ERYTHEME",
          "URTICAIRE",
          "ERUPTION CUTANEE",
          "DYSPNEE",
          "HYPOTENSION ARTERIELLE",
          "BRONCHOSPASME / ASTHME",
          "ANAPHYLAXIE",
          "ECZEMA",
          "PRURIT",
          "HYPERSUDATION",
          "TACHYCARDIE",
          "BOUFFEE VASOMOTRICE",
          "TOXIDERMIE BULLEUSE / PEMPHIGUS",
          "STEVENS JOHNSON SYNDROME",
          "LYELL SYNDROME / NECROLYSE EPIDERMIQUE TOXIQUE (NET)",
          "PUSTULOSE",
          "EXANTHEME",
          "PURPURA",
          "DECES / MORTALITE",
          "ERYTHEME PIGMENTE FIXE",
        ],
      },
      {
        category: "TROUBLES HEPATO-BILIAIRES",
        severity: [
          "MODERE(S)",
          "  A",
          "SEVERE(S)",
          "LIE A EXCIPIENT A EFFET NOTOIRE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        severityCategory: "MODERE(S)",
        frequency: 1,
        frequencyString: "rare (< 1%)",
        frequencyComment: null,
        behaviour: ["EVALUER LE RAPPORT BENEFICE/RISQUE"],
        behaviourComment: null,
        occurenceTime: ["AU COURS DU TRAITEMENT"],
        occurenceComment: null,
        favoringFactors: ["NOUVEAU-NE"],
        otherFavoringFactors: [],
        effects: ["ICTERE"],
      },
      {
        category: "TROUBLES HEPATO-BILIAIRES",
        severity: [
          "MODERE(S)",
          "  A",
          "SEVERE(S)",
          "LIE A EXCIPIENT A EFFET NOTOIRE",
          "EXCIPIENT A EFFET NOTOIRE LISTE ANSM/EMA",
        ],
        severityCategory: "MODERE(S)",
        frequency: 1,
        frequencyString: "rare (< 1%)",
        frequencyComment: null,
        behaviour: ["EVALUER LE RAPPORT BENEFICE/RISQUE"],
        behaviourComment: null,
        occurenceTime: ["AU COURS DU TRAITEMENT"],
        occurenceComment: null,
        favoringFactors: ["NOUVEAU-NE"],
        otherFavoringFactors: [],
        effects: ["BILIRUBINE MODIFICATION"],
      },
      {
        category: null,
        severity: ["MODERE(S)", "  A", "SEVERE(S)"],
        severityCategory: "MODERE(S)",
        frequency: null,
        frequencyString: null,
        frequencyComment: null,
        behaviour: [
          "ARRETER LE TRAITEMENT",
          "FAIRE UN TRAITEMENT D'URGENCE",
          "HOSPITALISER EN MILIEU SPECIALISE",
          "PRATIQUER UN LAVAGE GASTRIQUE",
          "ADMINISTRER UN ANTIDOTE",
          "EFFECTUER UNE SURVEILLANCE BIOLOGIQUE",
          "FAIRE UN TRAITEMENT SYMPTOMATIQUE",
          "EFFECTUER UNE SURVEILLANCE HEPATIQUE",
        ],
        behaviourComment: " ",
        occurenceTime: [],
        occurenceComment: null,
        favoringFactors: [],
        otherFavoringFactors: [],
        effects: [
          "NAUSEE VOMISSEMENT",
          "ANOREXIE",
          "PALEUR",
          "DOULEUR ABDOMINALE",
          "CYTOLYSE HEPATIQUE",
          "NECROSE HEPATIQUE",
          "INSUFFISANCE HEPATIQUE",
          "ENCEPHALOPATHIE HEPATIQUE",
          "COMA",
          "DECES / MORTALITE",
          "ATTEINTE HEPATIQUE",
          "INSUFFISANCE RENALE AIGUE",
          "NECROSE TUBULAIRE RENALE",
          "ARYTHMIE",
          "PANCREATITE AIGUE",
          "IRRITATION ANALE",
          "ANORECTITE",
        ],
      },
      {
        category: null,
        severity: ["MODERE(S)", "  A", "SEVERE(S)"],
        severityCategory: "MODERE(S)",
        frequency: null,
        frequencyString: null,
        frequencyComment: null,
        behaviour: [
          "ARRETER LE TRAITEMENT",
          "FAIRE UN TRAITEMENT D'URGENCE",
          "HOSPITALISER EN MILIEU SPECIALISE",
          "PRATIQUER UN LAVAGE GASTRIQUE",
          "ADMINISTRER UN ANTIDOTE",
          "EFFECTUER UNE SURVEILLANCE BIOLOGIQUE",
          "FAIRE UN TRAITEMENT SYMPTOMATIQUE",
          "EFFECTUER UNE SURVEILLANCE HEPATIQUE",
        ],
        behaviourComment: " ",
        occurenceTime: [],
        occurenceComment: null,
        favoringFactors: [],
        otherFavoringFactors: [],
        effects: [
          "TAUX PROTHROMBINE MODIFICATION",
          "ALAT MODIFICATION",
          "ASAT MODIFICATION",
          "BILIRUBINE MODIFICATION",
          "LACTICO-DESHYDROGENASE MODIFICATION",
          "ACIDOSE METABOLIQUE",
          "HYPOGLYCEMIE",
          "HYPERGLYCEMIE",
          "HYPERAMYLASEMIE",
        ],
      },
      {
        category: "TROUBLES RESPIRATOIRES",
        severity: ["SEVERE(S)"],
        severityCategory: "SEVERE(S)",
        frequency: 1,
        frequencyString: "rare (< 1%)",
        frequencyComment: "Ces effets sont rares.",
        behaviour: [
          "ARRETER LE TRAITEMENT",
          "FAIRE UN TRAITEMENT D'URGENCE",
          "HOSPITALISER EN MILIEU SPECIALISE",
        ],
        behaviourComment: " ",
        occurenceTime: [
          "AU COURS DU TRAITEMENT",
          "EN CAS DE TRAITEMENT PROLONGE",
        ],
        occurenceComment: null,
        favoringFactors: ["HYPERSENSIBILITE"],
        otherFavoringFactors: ["SUSCEPTIBILITE INDIVIDUELLE"],
        effects: ["BRONCHOSPASME / ASTHME", "DYSPNEE"],
      },
      {
        category: "TROUBLES MENTAUX ET DU COMPORTEMENT",
        severity: ["MODERE(S)", " OU", "SEVERE(S)"],
        severityCategory: "MODERE(S) OU SEVERE(S)",
        frequency: 1,
        frequencyString: "rare (< 1%)",
        frequencyComment: null,
        behaviour: [],
        behaviourComment: null,
        occurenceTime: [],
        occurenceComment: null,
        favoringFactors: [],
        otherFavoringFactors: [],
        effects: [
          "DEPRESSION",
          "CONFUSION MENTALE",
          "HALLUCINATION",
          "HUMEUR TROUBLE",
          "ANXIETE",
          "NERVOSITE",
          "EUPHORIE",
          "SOMMEIL TROUBLE",
          "CAUCHEMAR",
          "DELIRE",
          "DEPENDANCE",
        ],
      },
      {
        category: "TROUBLES DU SYSTEME NERVEUX",
        severity: ["MODERE(S)", " OU", "SEVERE(S)"],
        severityCategory: "MODERE(S) OU SEVERE(S)",
        frequency: 1,
        frequencyString: "rare (< 1%)",
        frequencyComment: null,
        behaviour: [],
        behaviourComment: null,
        occurenceTime: [],
        occurenceComment: null,
        favoringFactors: [],
        otherFavoringFactors: [],
        effects: [
          "TREMBLEMENT",
          "CEPHALEE",
          "VERTIGE / ETOURDISSEMENT",
          "MALAISE / LIPOTHYMIE",
          "SOMNOLENCE DIURNE",
          "ATAXIE",
          "CONVULSION",
          "SYNCOPE",
          "DYSARTHRIE / PAROLE DIFFICULTE",
          "AMNESIE",
        ],
      },
      {
        category: "TROUBLES DES ORGANES DES SENS",
        severity: ["MODERE(S)", " OU", "SEVERE(S)"],
        severityCategory: "MODERE(S) OU SEVERE(S)",
        frequency: 1,
        frequencyString: "rare (< 1%)",
        frequencyComment: null,
        behaviour: [],
        behaviourComment: null,
        occurenceTime: [],
        occurenceComment: null,
        favoringFactors: [],
        otherFavoringFactors: [],
        effects: [
          "VISION ALTERATION",
          "ACOUPHENE / BOURDONNEMENT D'OREILLE",
          "MYOSIS",
          "MYDRIASE",
          "ACCOMMODATION TROUBLE",
        ],
      },
      {
        category: "TROUBLES DE L'ETAT GENERAL",
        severity: ["MODERE(S)", " OU", "SEVERE(S)"],
        severityCategory: "MODERE(S) OU SEVERE(S)",
        frequency: 1,
        frequencyString: "rare (< 1%)",
        frequencyComment: null,
        behaviour: [],
        behaviourComment: "  ",
        occurenceTime: [],
        occurenceComment: null,
        favoringFactors: [],
        otherFavoringFactors: [],
        effects: [
          "OEDEME",
          "FIEVRE",
          "FRISSON",
          "DOULEUR / OPPRESSION THORACIQUE",
          "HYPERTENSION ARTERIELLE",
          "BOUFFEE VASOMOTRICE",
          "KOUNIS SYNDROME",
        ],
      },
      {
        category: "TROUBLES DE L'ETAT GENERAL",
        severity: ["MODERE(S)", " OU", "SEVERE(S)"],
        severityCategory: "MODERE(S) OU SEVERE(S)",
        frequency: 1,
        frequencyString: "rare (< 1%)",
        frequencyComment: null,
        behaviour: [],
        behaviourComment: "  ",
        occurenceTime: [],
        occurenceComment: null,
        favoringFactors: [],
        otherFavoringFactors: [],
        effects: ["HYPOGLYCEMIE"],
      },
      {
        category: "TROUBLES GASTRO-INTESTINAUX",
        severity: ["MODERE(S)", " OU", "SEVERE(S)"],
        severityCategory: "MODERE(S) OU SEVERE(S)",
        frequency: 1,
        frequencyString: "rare (< 1%)",
        frequencyComment: null,
        behaviour: [],
        behaviourComment: " ",
        occurenceTime: [],
        occurenceComment: null,
        favoringFactors: [],
        otherFavoringFactors: [],
        effects: [
          "HEMORRAGIE DIGESTIVE",
          "DOULEUR ABDOMINALE",
          "DIARRHEE",
          "NAUSEE VOMISSEMENT",
          "PANCREATITE AIGUE",
          "CONSTIPATION",
          "COLITE",
        ],
      },
      {
        category: "TROUBLES RENAUX ET GENITO-URINAIRES",
        severity: ["MODERE(S)", " OU", "SEVERE(S)"],
        severityCategory: "MODERE(S) OU SEVERE(S)",
        frequency: 1,
        frequencyString: "rare (< 1%)",
        frequencyComment: null,
        behaviour: [],
        behaviourComment: " ",
        occurenceTime: [],
        occurenceComment: null,
        favoringFactors: [],
        otherFavoringFactors: [],
        effects: [
          "URINES MODIFICATION",
          "INSUFFISANCE RENALE AIGUE",
          "NEPHRITE INTERSTITIELLE",
          "ANURIE",
          "NEPHROTOXICITE",
          "ATTEINTE RENALE",
          "DYSURIE",
          "RETENTION D'URINE",
        ],
      },
      {
        category: "TROUBLES RENAUX ET GENITO-URINAIRES",
        severity: ["MODERE(S)", " OU", "SEVERE(S)"],
        severityCategory: "MODERE(S) OU SEVERE(S)",
        frequency: 1,
        frequencyString: "rare (< 1%)",
        frequencyComment: null,
        behaviour: [],
        behaviourComment: " ",
        occurenceTime: [],
        occurenceComment: null,
        favoringFactors: [],
        otherFavoringFactors: [],
        effects: ["HEMATURIE", "ALBUMINURIE"],
      },
    ],
  },
];

export const mockParacetamolInteractionsDTOResponse: DTOInteractionsResponse = {
  dci: {
    interactions: [
      {
        nature: ["INFORMATION GENERALE"],
        with: [
          {
            dci: "warfarine",
          },
          {
            dci: "fluindione",
          },
          {
            dci: "acénocoumarol",
          },
        ],
        details: {
          title: "ANTIVITAMINES K",
          nature: null,
          instructions: null,
          informations: [
            "ANTI-INFECTIEUX ET HEMOSTASE",
            "De nombreux cas d'augmentation de l'activité des antivitamines K ont été rapportés chez des patients recevant des antibiotiques. Le contexte infectieux ou inflammatoire marqué, l'âge et l'état général du patient apparaissent comme des facteurs de risque. Dans ces circonstances, il apparaît difficile de faire la part entre la pathologie infectieuse et son traitement dans la survenue du déséquilibre de l'INR. Cependant, certaines classes d'antibiotiques sont davantage impliquées : il s'agit notamment des fluoroquinolones, des macrolides, des cyclines, du cotrimoxazole et de certaines céphalosporines, qui imposent, dans ces conditions, de renforcer la surveillance de l'INR. Certaines céphalosporines (céfamandole, ceftriaxone, céfazoline), la clindamycine, semblent interagir au niveau de l'hémostase avec apparition d'anticorps anti facteur V. Enfin, la tigécycline et le danazol possèdent une action fibrinolytique propre.",
            "AVK et INR",
            "Chez un patient traité par antivitamines K, il convient de contrôler l'INR à chaque initiation ou suppression d'un ou plusieurs médicaments. La modification soudaine des habitudes alimentaires doit être également prise en compte et la régularité est préconisée pour le maintien à l'équilibre de l'INR. Les aliments riches en vitamine K sont essentiellement représentés par les choux, épinards, brocolis, certaines salades.",
            "(acénocoumarol, fluindione, (phénindione nsfp), (tioclomarol nsfp), warfarine)",
          ],
          history: [],
          bibliography: [],
          source: null,
        },
      },
      {
        nature: ["PRECAUTION D'EMPLOI"],
        with: [
          {
            dci: "polystyrene sulfonate",
          },
          {
            dci: "sevelamer",
          },
          {
            dci: "colestyramine",
          },
          {
            dci: "calcium polystyrene sulfonate",
          },
        ],
        details: {
          title: "RESINES CHELATRICES + MEDICAMENTS ADMINISTRES PAR VOIE ORALE",
          nature:
            "la prise de colestyramine peut diminuer l'absorption intestinale et potentiellement l'efficacité d'autres médicaments pris simultanément.",
          instructions:
            "d'une façon générale, la prise de la résine doit se faire à distance de celle des autres médicaments, en respectant un intervalle de plus de 2 heures, si possible.",
          informations: [
            "La cisclosporine et le tacrolimus se fixe sur le sevelamer réduisant leurs absorptions intestinales. Egalement le sevelamer se lie au métabolite AM1 de la ciclosporine sécrété dans la bile réduisant sa réabsorption.",
            "La revue de la littérature décrit des baisses de taux de ciclosporine et de tacrolimus sans conséquences cliniques (rejet de greffe). Ces taux sont revenus aux valeurs normales après l'arrêt de sevelamer.",
            "Certains auteurs décrivent des baisses d'AUC de 9 % de ciclosporine et de 30 % du métabolite AM1 de la ciclosporine.",
            "Certains auteurs rapportent des diminutions variables de l'AUC de ciprofloxacine de 39 % à 48 % avec le sevelamer.",
          ],
          history: [
            "Les catiorésines sulfosodique et sulfocalcique sont respectivement renommées polystyrène sulfonate de sodium et polystyrène sulfonate de calcium, en conformité avec la dénomination utilisée dans l'AMM (Thesaurus interactions ansm du 01/10/2019).",
            'Le polystyrène sulfonate de calcium intègre la classe "résines chélatrices" (Thesaurus interactions ansm du 01/10/2019).',
            "La catiorésine sulfo calcique et le colestilan n'apparaissent plus dans le Thesaurus (Thesaurus interactions ansm du 12/08/2016).",
          ],
          bibliography: [
            "Northcutt RC, Stiel JN, Hollifield JX, Stant EG. The influence of cholestyramine on thyroxine absorption. JAMA 1969 ; 208 : 1857.",
            "Benjamin D, Robinson DS, McCormack JJ.  Cholestyramine binding to warfarin in man and in vitro. Clin Res 1970 ; 18 : 336.",
            "Kuentzel WP, Brunk SF. Cholestyramine-warfarin interaction. Clin Res 1970 ; 18 : 594.",
            "Robinson DA, Benjamin DM, McCormack JJ. Interaction of warfarin and non-systemic gastrointestinal drugs. Clin Pharmacol Ther 1971 ; 12 : 491.",
            "Brown DD, Juhl RP, Warner SL. Decreased bioavailability of digoxin produced by dietary fibre and cholestyramine. Am J Cardiol 1977 ; 39 : 297.",
            "Jahnchen E, Meinertz T, Gilfrich HJ, Kersting F, Groth U. Enhanced elimination of warfarin during treatment with cholestyramine. Br J Clin Pharmacol 1978 ; 5 : 437.",
            "Hunninghake DB, King S, LaCroix K. The effect of cholestyramine and colestipol on the absorption of hydrochlorothiazide. Int J Clin Pharmacol Ther Toxicol. 1982 ; 20 (4) :151-4.",
            "Hunninghake DB, Hibbard DM. Influence of time intervals for cholestyramine dosing on the absorption of hydrochlorothiazide. Clin Pharmacol Ther. 1986 ; 39 (3) :329-34.",
            "Lawler DP, Hyers TM. Extreme prolongation of the prothrombin time in a patient receiving warfarin and cholestyramine. Cardiovasc Rev Rep 1993 ; april : 72-4.",
            "Brown DD, Schimdt J, Long RA, Hull JH. A steady-state evaluation of the effects of propantheline bromide and cholestyramine on the bioavailability of digoxin when administered as tablets or capsules. J Clin Pharmacol 1985 ; 25 : 360-4.",
            "Harmon SM, Seifert CF. Levothyroxine-cholestyramine interaction reemphasized. Ann Intern Med 1991 ; 115 : 658-9.",
            "Kays MB, Overholser BR, Mueller BA, Moe SM, Sowinski KM. Effects of sevelamer hydrochloride and calcium acetate on the oral bioavailability of ciprofloxacin. Am J Kidney Dis. 2003 Dec ; 42 (6) : 1253-9.",
            "Pieper AK, Buhle F, Bauer S, Mai I, Budde K, Haffner D, Neumayer HH, Querfeld U. The effect of sevelamer on the pharmacokinetics of cyclosporin A and mycophenolate mofetil after renal transplantation. Nephrol Dial Transplant. 2004 ; 19 (10) : 2630-3.",
            "Guillen-Anaya MA, Jadoul M. Drug interaction between sevelamer and cyclosporin. Nephrol Dial Transplant. 2004 ; 19 (2) : 515.",
            "Wauters JP, Uehlinger D, Marti HP. Drug interaction between sevelamer and cyclosporin. Nephrol Dial Transplant. 2004 ; 19 (7) : 1939-40.",
            "Uehlinger D, Marti HP, Jadoul M, Wauters JP. Sevelamer and pharmacokinetics of cyclosporin A after kidney transplantation. Nephrol Dial Transplant. 2005 ; 20 (3) : 661.",
            "Wauters JP, Uehlinger D, Marti HP. Drug interaction between sevelamer and cyclosporin. Nephrol Dial Transplant. 2005 ; 20 (3) : 660-1;",
            "Merkle M, Wornle M, Rupprecht HD. The effect of sevelamer on tacrolimus target levels. Transplantation. 2005 ; 80 (5) : 707.",
          ],
          source: "Thesaurus - ANSM",
        },
      },
      {
        nature: ["PRECAUTION D'EMPLOI"],
        with: [
          {
            dci: "charbon actif",
          },
          {
            dci: "hydroxyde d'aluminium / hydroxyde de magnésium",
          },
          {
            dci: "carbonate de calcium / magnesium",
          },
          {
            dci: "carbonate de lanthane",
          },
          {
            dci: "hydroxyde de magnésium",
          },
          {
            dci: "bicarbonate de sodium / sodium alginate",
          },
          {
            dci: "charbon actif / diméticone / oxyde de magnésium",
          },
          {
            dci: "diosmectite",
          },
          {
            dci: "bicarbonate de sodium / carbonate de calcium / sodium alginate",
          },
          {
            dci: "charbon actif / diméticone",
          },
          {
            dci: "carbonate de calcium / kaolin / magnesium / magnesium trisilicate",
          },
          {
            dci: "hydrotalcite",
          },
          {
            dci: "crospovidone",
          },
          {
            dci: "diosmectite / hydroxyde d'aluminium / hydroxyde de magnésium",
          },
          {
            dci: "acide citrique / oxyde de magnésium / sodium picosulfate",
          },
          {
            dci: "bicarbonate de potassium / sodium alginate",
          },
          {
            dci: "gomme de guar / hydroxyde de magnésium / oxyde d'aluminium / phosphate d'aluminium",
          },
          {
            dci: "carbonate de calcium / hydroxyde de magnésium / oxyde d'aluminium",
          },
          {
            dci: "charbon actif / papaverine",
          },
          {
            dci: "bicarbonate de sodium / carbonate de calcium / hydroxyde de magnésium / kaolin / magnesium / magnesium trisilicate / phosphate tricalcique",
          },
          {
            dci: "phosphate d'aluminium",
          },
          {
            dci: "crospovidone / sterculia (sterculia urens)",
          },
          {
            dci: "oxyde d'aluminium",
          },
          {
            dci: "carbonate de calcium / diméticone / magnesium",
          },
          {
            dci: "aluminium glycinate / galactane / myrtecaine",
          },
          {
            dci: "charbon actif / saccharomyces cerevisiae",
          },
        ],
        details: {
          title:
            "TOPIQUES GASTRO-INTESTINAUX, ANTIACIDES ET ADSORBANTS + MEDICAMENTS ADMINISTRES PAR VOIE ORALE",
          nature: "diminution de l'absorption de ces substances.",
          instructions:
            "par mesure de précaution, il convient de prendre ces topiques ou antiacides à distance de tout autre médicament (plus de 2 heures, si possible).",
          informations: [
            "Les topiques gastro-intestinaux, le charbon, le lanthane et les antiacides (sels d'aluminium, de calcium et de magnésium), associés ou non aux alginates, diminuent la résorption digestive de certains autres médicaments ingérés simultanément.",
            "Par mesure de précaution, il convient de prendre ces topiques ou antiacides à distance de tout autre médicament (plus de 2 heures, si possible).",
            "(charbon activé, charbon végétal officinal, crospovidone, diosmectite, gel d'hydroxyde d'aluminium et de carbonate de magnésium codéssechés, hydrotalcite, kaolin lourd, lanthane, magaldrate, magnesium (hydroxyde de), magnésium (trisilicate de), monmectite)",
            "ASDEC - PE",
            "TOPIQUES GASTRO-INTESTINAUX, ANTIACIDES ET ADSORBANTS (charbon activé, charbon végétal officinal, crospovidone, diosmectite, gel d'hydroxyde d'aluminium et de carbonate de magnésium codéssechés, hydrotalcite, kaolin lourd, lanthane, magaldrate, magnesium (hydroxyde de), magnésium (trisilicate de), monmectite) + SUBSTANCES A  ABSORPTION REDUITE PAR LES TOPIQUES GASTRO-INTESTINAUX, ANTIACIDES ET ADSORBANTS ((acépromazine nsfp), (acéprométazine nsfp), acide acétylsalicylique, acide alendronique, acide clodronique, acide étidronique, acide ibandronique, (acide médronique), acide oxidronique, acide pamidronique, acide risédronique, acide tiludronique, acide zolédronique, alimémazine, aténolol, bêtaméthasone, bictégravir, budésonide, (chlorproéthazine nsfp), chlorpromazine, chlortétracycline, cimétidine, ciprofloxacine, clindamycine, cortisone, cyamémazine, déméclocycline, dexaméthasone, digoxine, dolutégravir, doxycycline, elvitégravir, enoxacine, éthambutol, famotidine, fer, fexofénadine, fluor, fluphénazine, isoniazide, lansoprazole, lédipasvir, lévofloxacine, lévomépromazine, lévothyroxine, lincomycine, liothyronine sodique, loméfloxacine, lymécycline, methylènecycline, methylprednisolone, métopimazine, métoprolol, minocycline, moxifloxacine, nizatidine, norfloxacine, ofloxacine, oxomémazine, oxytétracycline, péfloxacine, pénicillamine, (perphénazine nsfp), phosphore, pipérazine, pipotiazine, prednisolone, prednisone, (prochlorpérazine), proguanil, prométhazine, propériciazine, propranolol, raltégravir, ranitidine, rosuvastatine, (roxatidine nsfp), sulpiride, tériflunomide, tétracycline, (thiopropérazine nsfp), thyroxines, tigécycline, tiratricol, triamcinolone, (trifluopérazine nsfp), ulipristal)",
            "ASDEC - PE",
            ". association déconseillée : avec les inhibiteurs d'intégrase (raltégravir, bictégravir, dolutégravir)",
            ". précaution d'emploi : avec les autres substances.",
          ],
          history: [
            "La chloroquine sort de la classe des substances à absorption réduite par les topiques gastro-intestinaux, antiacides et adsorbants (Thesaurus interactions ansm du 20/10/2020).",
            "Le dolutégravir rejoint les deux autres inhibiteurs d'intégrase déjà déconseillés avec les topiques gastrointestinaux (Thesaurus interactions ansm du 20/10/2020).",
          ],
          bibliography: [
            "McElnay JC, Harron DWG, d'Arcy PF, Eagle MRG. Interaction of digoxin with antiacid constituents. Br Med J 1978 ; i : 1554.",
            "Alber A, Rees CW. Avidity of the tetracycline fot the cations of metals. Nature 1956 ; 177 : 433.",
            "Hall GJL, Davis AE. Inhibition of iron absorption by magnesium trisilicate. Med J aust 1969 ; 2 : 95.",
            "Schroeder ET. Alkalosis resulting from combined administration of a nonsystemic antacid and a cation-exchange resin. Gastroenterology 1969 ; 56 : 868.",
            "Fernandez PC. Metabolic acidosis reversed by the combination of magnesium hydroxide and a cation-exchange resin. N Engl J Med 1972 ; 286 : 23.",
            "Hurwitz A, Schlozman DL. Effects of antiacids on gastrointestinal absorption of isoniazid in rat and man. Am Rev Respir Dis 1974 ; 109 : 41.",
            "Emori HW, Paulus H, Bluestone R, Champion GD, Pearson C. Indomethacin serum concentrations in man. Effects of dosage, food and antacid. Ann Rheum J 1976 ; 35 : 333-8.",
            "Brown DD, Juhl RP, Lewis K, Schrott M, Bartels B. Decreased bioavailability of digoxin due to antiacids and kaolin-pectin. N Engl J Med 1976 ; 295 : 1034.",
            "Ziessman HA. Alkalosis and seizure due to a cation-exchange resin and magnesium hydroxide. South Med J 1976 ; 69 : 497.",
            "Dobbs JH, Skoutakis VA, Acchardio SR, Dobbs BR. Effect of aluminium hydroxyde on the absorption of propranolol. Curr Ther Res 1977 ; 21 : 857.",
            "Galeazzi RL. The effect of an antacid on the  bioavailability of indomethacin. Europ J Clin Pharmacol 1977 ; 12 : 65-8.",
            "Garnham JC, Kaspi T, Kaye CM, Oh VMS. Different effects of sodium bicarbonate and aluminium hydroxyde on the absorption of indomethacin in man. Post Grad Med J 1977 ; 53 : 126-9.",
            "Baluarte HJ, Prebis J, Goldberg M, Gruskin AB. Metabolic alkalosis in an anephric child caused by the combined use of Kayexalate and Basaljel. J Pediatr 1978 ; 92 : 237-9.",
            "Mattila MJ, Linnoila M, Seppala T, Koskinen R. Effect of aluminium hydroxyde and glycpyrrhonium on the absorption of ethambutol and alcohol in man. Br J Clin Pharmacol 1978 ; 5 : 161.",
            "Naggar-VF, Khalil SA, Gouda MW. Effect of concomitant administration of magnesium trisilicate on GI absorption of dexamethasone in humans. J Pharm Sci 1978 ; 67 : 1029.",
            "Pinell OC, Fenimore DC, Davis CM, Fann WE. Drug-drug interaction of chlorpromazine and antiacid. Clin Pharmacol Ther 1978 ; 23 : 125.",
            "Naggar VF, Khalil SA. Effect of magnesium trisilicate on nitrofurantoin absorption. Clin Pharmacol Ther 1979 ; 25 : 857.",
            "Tobert JA, de Schepper P, Tjandramaga TB et al. The effect of antiacids on the bioavailability of diflunisal. Clin Pharmacol Ther 1979 ; 25 : 251.",
            "Garty M, Hurwitz A. Effect of cimetidine and antacids on gastrointestinal absorption of tetracycline. Clin Pharmacol Ther 1980 ; 28 : 203.",
            "Hansten PD, Hayton WL. Effect of antiacid and ascorbic acid on serum salicylate concentration. J Clin Pharmacol 1980 ; 24 : 326.",
            "Van der Meer JW, Keuning JJ, Scheigrond HW, Heykants J, Van Cutsem J, Brugmans J. The influence of gastric acidity on the biavailability of ketoconazole. J Antimicrob Chemother 1980 ; 6 : 552-6.",
            "Regardh CG, Lundborg P, Persson BA. The effect of antacid, metoclopramide and propantheline on the availability of metoprolol and atenolol. Biopharm Drug Dispos 1981 ; 2 : 79-87.",
            "Tobert JA, de Schepper P, Tjandramaga TB et al. Effect of antiacids on the bioavailability of diflunisal in the fasting and postprandial states. Clin Pharmacol Ther 1981 ; 30 : 385.",
            "McElnay JC, Mukhtar HA, D'Arcy PE, Temple DJ, Collier PS. The effects of magnesium trisilicate and kaolin on the in vivo absorption of chloroquine. J Trop Med Hyg 1982 ; 85 : 159-63.",
            "McElnay JC, Mukhtar HA, D'Arcy PE, Temple DJ. In vitro experiments on chloroquine and pyrimethamine absorption in the presence of antacid constituents of kaolin. J Trop Med Hyg 1982 ; 85 : 153-8.",
            "Albin H, Vincon G, Pehourcq F, Lecorre C, Fleury B, Conri C. Influence d'un anti-acide sur la biodisponibilité de la prednisolone. Thérapie 1983 ; 38 : 61-5.",
            'Madias NE, Levey AS. Metabolic alkalosis due to absorption of "nonabsorbable" antacids. Am J Med 1983 ; 74 : 155-8.',
            "Osman MA, Patel RB, Schuna A, sundstrom WR, Welling PG. Reduction in oral penicillamin absorption by food, antacid and ferrous sulphate. Clin Pharmacol Ther 1983 ; 33 : 465-70.",
            "D'Arcy PF. Nitrofurantoin. Drug Intell Clin Pharm 1985 ; 19 : 540-7.",
            "Shastri RA. Effect of antacid on salicykate kinetics. Int J Clin Ther vTox 1985 ; 23 : 480-4.",
            "Desmond PV, Harman PJ, Gannoulis N, Kamm M, Mashford ML. The effect of antiacids and food on the absorption of cimetidine and ranitidine. Gastroenterology 1986 ; 90 : 1393.",
            "Fleming LW, Moreland TA, Stewart WK, Scott AC. Ciprofloxacin and antiacids. Lancet 1986 ; ii : 248.",
            "Ifan A, Welling PG. Pharmacokinetics of oral 500 mg penicillamine : effect of antacid on absorption. Biopharm Drug Disp 1986 ; 7 : 401-7.",
            "Moustafa MA, Gouda MW, Tariq M. Decreased bioavailability of propranolol due to interaction with adsorbent  antacids and antidiarrhoeal mixtures. Int J Pharmaceutics 1986 ; 30 : 225-8.",
            "O'Neil-Cutting MA, Crosby WH. The effect of antacids on the absorption of simultaneously ingested iron. J Am Med Ass 1986 ; 255 : 1468-70.",
            "Vinceneux Ph, Weber Ph, Gaudin H, Boussougant Y. Diminution de l'absorption de la péfloxacine par les pansements gastriques. La Presse Med 1986 ; 15 : 1826.",
            "Maesen FPV, Davies BJ, Geraedts WH, Sumajow CA. Ofloxacin and antiacids. J Antimicrob Chemother 1987 ; 19 : 848-9.",
            "Moustafa MA, Babhair SA, Kouta HI. Decreased biavailability of some antipsychotic phenothiazines due to interactions with adsorbent antiacid and antidiarrhoeal mixtures. Int J Pharmaceutics 1987 ; 36 : 185-9.",
            "Nassif F, Sinnassamy P, Bensman A. [A cause of alkalosis in children under hemodialysis: combined administration of magnesium hydroxide and polystyrene sodium sulfonate]. Press Méd 1987 ; 16 : 1003.",
            "Noyes M, Polk RE. Norfloxacin and absorption of magnesium-aluminium. Ann Intern Med 1988 ; 109 : 168-9.",
            "Scjhentag JJ, Watson WA, Nix DE, Sedman AJ, Frost RW, Letteri J. Time dependent interactions between antacids and quinolone antibiotics. Clin Pharmacol Ther 1988 ; 43 : 135.",
            "Barzaghi N, Gatti G, Crema F, Perucca E. Impaired bioavailability of famotidine given concurrently with a potent antiacid. J Clin Pharmacol 1989 ; 37 : 409-10.",
            "Grasela TH, Schentag JJ, Sedman AJ et al. Inhibition  of enoxacin absorption by antiacids or ranitidine. Antimicrob Ag Chemother 1989 ; 33 : 615-7.",
            "Blum RA, D'Andrea DT, Florentino BM et al. Increased gastric pH and the bioavailability of fluconazole and ketoconazole. Ann Intern Med 1991 ; 114 : 755-7.",
            "Sullivan TJ, Reese JH, Jaurequi L, Miller K, Levine L, Bachmann KA. Short report : a comparative study of the interaction between antiacid and H2-receptor antagonists. Aliment Pharmacol Ther 1994 ; 4 : 123-6.",
            "Williams DD, Peng B, Bailey CK, Wire MB, Deng Y, Park JW, Collins DA, Kapsi SG, Jenkins JM. Effects of food and antacids on the pharmacokinetics of eltrombopag in healthy adult subjects: two single-dose, open-label, randomized-sequence, crossover studies. Clin Ther. 2009 ; 31 (4) : 764-76.",
            "Document laboratoire : eltrombopag (REVOLADE® - GLAXOSMITHKLINE)",
          ],
          source: "Thesaurus - ANSM",
        },
      },
      {
        nature: ["A PRENDRE EN COMPTE"],
        with: [
          {
            dci: "macrogol",
          },
          {
            dci: "bicarbonate de sodium / chlorure de potassium / macrogol / sodium chlorure",
          },
          {
            dci: "bicarbonate de sodium / chlorure de potassium / macrogol / sodium chlorure / sulfate de sodium anhydre",
          },
          {
            dci: "acide ascorbique / chlorure de potassium / macrogol / sodium chlorure / sulfate de sodium anhydre",
          },
          {
            dci: "acide citrique / chlorure de potassium / citrate de sodium / diméticone / macrogol / sodium chlorure / sulfate de sodium anhydre",
          },
        ],
        details: {
          title: "LAXATIFS + MEDICAMENTS ADMINISTRES PAR VOIE ORALE",
          nature:
            "avec les laxatifs, notamment en vue d'explorations endoscopiques : risque de diminution de l'efficacité du médicament administré avec le laxatif.",
          instructions:
            "éviter la prise d'autres médicaments pendant et après l'ingestion dans un délai d'au moins 2 h après la prise du laxatif, voire jusqu'à la réalisation de l'examen.",
          informations: ["Aucune information complémentaire."],
          history: [],
          bibliography: [],
          source: "Thesaurus - ANSM",
        },
      },
      {
        nature: ["PRECAUTION D'EMPLOI"],
        with: [
          {
            dci: "warfarine",
          },
          {
            dci: "fluindione",
          },
          {
            dci: "acénocoumarol",
          },
        ],
        details: {
          title: "ANTIVITAMINES K + PARACETAMOL",
          nature:
            "risque d'augmentation de l'effet de l'antivitamine K et du risque hémorragique en cas de prise de paracétamol aux doses maximales (4 grammes/jour) pendant au moins 4 jours.",
          instructions:
            "contrôle plus fréquent de l'INR. Adaptation éventuelle de la posologie de l'antivitamine K pendant le traitement par le paracétamol et après son arrêt.",
          informations: [
            "Le mécanisme n'est pas clairement établi.",
            "L'effet anticoagulant est dose-dépendant et ne semble pas être affecté lors d'une prise occasionnelle et/ou de courte durée du paracétamol.",
          ],
          history: [
            "La phénindione et le tioclomarol n'apparaissent plus dans le Thesaurus (Thesaurus interactions ansm du 12/08/2016).",
            "Le tioclomarol, ancien AVK, disparait du livret (Thesaurus interactions du 16/03/2012).",
          ],
          bibliography: [
            "Antlitz AM, Mead JA Jr, Tolentino MA.Potentiation of oral anticoagulant therapy by acetaminophen. Curr Ther Res Clin Exp 1968 ; 10 : 501-7.",
            "Rubin RN, Mentzer RL, Budzinsky AZ. Potentialisation of anticaogulant effect of warfarin by acetaminophen (Tylenol). Clin Res 1984 ; 32 : 698A.",
            "Bartle WR, Blakely JA. Potentiation of warfarin anticoagulation by acetaminophen.JAMA. 1991  ; 265 : 1260.",
            "Kwan D, Bartle WR. Drug interactions with warfarin. Med J Aust 1993 ; 158 : 574-5.",
            "Fitzmaurice DA, Murray JA. Potentiation of the anticoagulant effect of warfarin. Postgrad Med J 1997 ; 73 : 439-40.",
            "Hylek EM, Heiman H, Skates SJ, Sheehan MA, Singer DE. Acetaminophen and other risk factors for excessive warfarin anticoagulation. JAMA 1998 ; 279 : 657-62.",
            "Bagheri H, Bernhard NB, Montastruc JL. Potentiation of the acenocoumarol anticoagulant effect by acetaminophen. Ann Pharmacother 1999 ; 33 : 506.",
            "Johnsen SP, Sorensen HT, Mellemkjoer L, Blot WJ, Nielsen GL, McLaughlin JK, Olsen JH.  Hospitalisation for upper gastrointestinal bleeding associated with use of oral anticoagulants. Thromb Haemost 2001 ; 86 : 563-8.",
            "Andrews FJ. Retroperitoneal haematoma after paracetamol increased anticoagulation. Emerg Med J 2002 ; 19 : 84-5.",
            "Gebauer MG, Nyfort-Hansen K, Henschke PJ, Gallus AS. Warfarin and interaction.Pharmacotherapy 2003 ; 23 : 109-12.",
          ],
          source: "Thesaurus - ANSM",
        },
      },
    ],
  },
};

export const mockParacetamolInteractions: InteractionFromDrugGuide[] = [
  {
    severity: ["PRECAUTION D'EMPLOI"],
    with: ["acénocoumarol", "fluindione", "warfarine"],
    title: "Antivitamines k + Paracetamol",
    nature:
      "risque d'augmentation de l'effet de l'antivitamine K et du risque hémorragique en cas de prise de paracétamol aux doses maximales (4 grammes/jour) pendant au moins 4 jours.",
    instructions:
      "contrôle plus fréquent de l'INR. Adaptation éventuelle de la posologie de l'antivitamine K pendant le traitement par le paracétamol et après son arrêt.",
    informations: [
      "Le mécanisme n'est pas clairement établi.",
      "L'effet anticoagulant est dose-dépendant et ne semble pas être affecté lors d'une prise occasionnelle et/ou de courte durée du paracétamol.",
    ],
    history: [
      "La phénindione et le tioclomarol n'apparaissent plus dans le Thesaurus (Thesaurus interactions ansm du 12/08/2016).",
      "Le tioclomarol, ancien AVK, disparait du livret (Thesaurus interactions du 16/03/2012).",
    ],
    bibliography: [
      "Antlitz AM, Mead JA Jr, Tolentino MA.Potentiation of oral anticoagulant therapy by acetaminophen. Curr Ther Res Clin Exp 1968 ; 10 : 501-7.",
      "Rubin RN, Mentzer RL, Budzinsky AZ. Potentialisation of anticaogulant effect of warfarin by acetaminophen (Tylenol). Clin Res 1984 ; 32 : 698A.",
      "Bartle WR, Blakely JA. Potentiation of warfarin anticoagulation by acetaminophen.JAMA. 1991  ; 265 : 1260.",
      "Kwan D, Bartle WR. Drug interactions with warfarin. Med J Aust 1993 ; 158 : 574-5.",
      "Fitzmaurice DA, Murray JA. Potentiation of the anticoagulant effect of warfarin. Postgrad Med J 1997 ; 73 : 439-40.",
      "Hylek EM, Heiman H, Skates SJ, Sheehan MA, Singer DE. Acetaminophen and other risk factors for excessive warfarin anticoagulation. JAMA 1998 ; 279 : 657-62.",
      "Bagheri H, Bernhard NB, Montastruc JL. Potentiation of the acenocoumarol anticoagulant effect by acetaminophen. Ann Pharmacother 1999 ; 33 : 506.",
      "Johnsen SP, Sorensen HT, Mellemkjoer L, Blot WJ, Nielsen GL, McLaughlin JK, Olsen JH.  Hospitalisation for upper gastrointestinal bleeding associated with use of oral anticoagulants. Thromb Haemost 2001 ; 86 : 563-8.",
      "Andrews FJ. Retroperitoneal haematoma after paracetamol increased anticoagulation. Emerg Med J 2002 ; 19 : 84-5.",
      "Gebauer MG, Nyfort-Hansen K, Henschke PJ, Gallus AS. Warfarin and interaction.Pharmacotherapy 2003 ; 23 : 109-12.",
    ],
  },
  {
    severity: ["A PRENDRE EN COMPTE"],
    with: [
      "acide ascorbique / chlorure de potassium / macrogol / sodium chlorure / sulfate de sodium anhydre",
      "acide citrique / chlorure de potassium / citrate de sodium / diméticone / macrogol / sodium chlorure / sulfate de sodium anhydre",
      "bicarbonate de sodium / chlorure de potassium / macrogol / sodium chlorure",
      "bicarbonate de sodium / chlorure de potassium / macrogol / sodium chlorure / sulfate de sodium anhydre",
      "macrogol",
    ],
    title: "Laxatifs + Medicaments administres par voie orale",
    nature:
      "avec les laxatifs, notamment en vue d'explorations endoscopiques : risque de diminution de l'efficacité du médicament administré avec le laxatif.",
    instructions:
      "éviter la prise d'autres médicaments pendant et après l'ingestion dans un délai d'au moins 2 h après la prise du laxatif, voire jusqu'à la réalisation de l'examen.",
    informations: ["Aucune information complémentaire."],
    history: [],
    bibliography: [],
  },
  {
    severity: ["PRECAUTION D'EMPLOI"],
    with: [
      "calcium polystyrene sulfonate",
      "colestyramine",
      "polystyrene sulfonate",
      "sevelamer",
    ],
    title: "Resines chelatrices + Medicaments administres par voie orale",
    nature:
      "la prise de colestyramine peut diminuer l'absorption intestinale et potentiellement l'efficacité d'autres médicaments pris simultanément.",
    instructions:
      "d'une façon générale, la prise de la résine doit se faire à distance de celle des autres médicaments, en respectant un intervalle de plus de 2 heures, si possible.",
    informations: [
      "La cisclosporine et le tacrolimus se fixe sur le sevelamer réduisant leurs absorptions intestinales. Egalement le sevelamer se lie au métabolite AM1 de la ciclosporine sécrété dans la bile réduisant sa réabsorption.",
      "La revue de la littérature décrit des baisses de taux de ciclosporine et de tacrolimus sans conséquences cliniques (rejet de greffe). Ces taux sont revenus aux valeurs normales après l'arrêt de sevelamer.",
      "Certains auteurs décrivent des baisses d'AUC de 9 % de ciclosporine et de 30 % du métabolite AM1 de la ciclosporine.",
      "Certains auteurs rapportent des diminutions variables de l'AUC de ciprofloxacine de 39 % à 48 % avec le sevelamer.",
    ],
    history: [
      "Les catiorésines sulfosodique et sulfocalcique sont respectivement renommées polystyrène sulfonate de sodium et polystyrène sulfonate de calcium, en conformité avec la dénomination utilisée dans l'AMM (Thesaurus interactions ansm du 01/10/2019).",
      'Le polystyrène sulfonate de calcium intègre la classe "résines chélatrices" (Thesaurus interactions ansm du 01/10/2019).',
      "La catiorésine sulfo calcique et le colestilan n'apparaissent plus dans le Thesaurus (Thesaurus interactions ansm du 12/08/2016).",
    ],
    bibliography: [
      "Northcutt RC, Stiel JN, Hollifield JX, Stant EG. The influence of cholestyramine on thyroxine absorption. JAMA 1969 ; 208 : 1857.",
      "Benjamin D, Robinson DS, McCormack JJ.  Cholestyramine binding to warfarin in man and in vitro. Clin Res 1970 ; 18 : 336.",
      "Kuentzel WP, Brunk SF. Cholestyramine-warfarin interaction. Clin Res 1970 ; 18 : 594.",
      "Robinson DA, Benjamin DM, McCormack JJ. Interaction of warfarin and non-systemic gastrointestinal drugs. Clin Pharmacol Ther 1971 ; 12 : 491.",
      "Brown DD, Juhl RP, Warner SL. Decreased bioavailability of digoxin produced by dietary fibre and cholestyramine. Am J Cardiol 1977 ; 39 : 297.",
      "Jahnchen E, Meinertz T, Gilfrich HJ, Kersting F, Groth U. Enhanced elimination of warfarin during treatment with cholestyramine. Br J Clin Pharmacol 1978 ; 5 : 437.",
      "Hunninghake DB, King S, LaCroix K. The effect of cholestyramine and colestipol on the absorption of hydrochlorothiazide. Int J Clin Pharmacol Ther Toxicol. 1982 ; 20 (4) :151-4.",
      "Hunninghake DB, Hibbard DM. Influence of time intervals for cholestyramine dosing on the absorption of hydrochlorothiazide. Clin Pharmacol Ther. 1986 ; 39 (3) :329-34.",
      "Lawler DP, Hyers TM. Extreme prolongation of the prothrombin time in a patient receiving warfarin and cholestyramine. Cardiovasc Rev Rep 1993 ; april : 72-4.",
      "Brown DD, Schimdt J, Long RA, Hull JH. A steady-state evaluation of the effects of propantheline bromide and cholestyramine on the bioavailability of digoxin when administered as tablets or capsules. J Clin Pharmacol 1985 ; 25 : 360-4.",
      "Harmon SM, Seifert CF. Levothyroxine-cholestyramine interaction reemphasized. Ann Intern Med 1991 ; 115 : 658-9.",
      "Kays MB, Overholser BR, Mueller BA, Moe SM, Sowinski KM. Effects of sevelamer hydrochloride and calcium acetate on the oral bioavailability of ciprofloxacin. Am J Kidney Dis. 2003 Dec ; 42 (6) : 1253-9.",
      "Pieper AK, Buhle F, Bauer S, Mai I, Budde K, Haffner D, Neumayer HH, Querfeld U. The effect of sevelamer on the pharmacokinetics of cyclosporin A and mycophenolate mofetil after renal transplantation. Nephrol Dial Transplant. 2004 ; 19 (10) : 2630-3.",
      "Guillen-Anaya MA, Jadoul M. Drug interaction between sevelamer and cyclosporin. Nephrol Dial Transplant. 2004 ; 19 (2) : 515.",
      "Wauters JP, Uehlinger D, Marti HP. Drug interaction between sevelamer and cyclosporin. Nephrol Dial Transplant. 2004 ; 19 (7) : 1939-40.",
      "Uehlinger D, Marti HP, Jadoul M, Wauters JP. Sevelamer and pharmacokinetics of cyclosporin A after kidney transplantation. Nephrol Dial Transplant. 2005 ; 20 (3) : 661.",
      "Wauters JP, Uehlinger D, Marti HP. Drug interaction between sevelamer and cyclosporin. Nephrol Dial Transplant. 2005 ; 20 (3) : 660-1;",
      "Merkle M, Wornle M, Rupprecht HD. The effect of sevelamer on tacrolimus target levels. Transplantation. 2005 ; 80 (5) : 707.",
    ],
  },
  {
    severity: ["PRECAUTION D'EMPLOI"],
    with: [
      "acide citrique / oxyde de magnésium / sodium picosulfate",
      "aluminium glycinate / galactane / myrtecaine",
      "bicarbonate de potassium / sodium alginate",
      "bicarbonate de sodium / carbonate de calcium / hydroxyde de magnésium / kaolin / magnesium / magnesium trisilicate / phosphate tricalcique",
      "bicarbonate de sodium / carbonate de calcium / sodium alginate",
      "bicarbonate de sodium / sodium alginate",
      "carbonate de calcium / diméticone / magnesium",
      "carbonate de calcium / hydroxyde de magnésium / oxyde d'aluminium",
      "carbonate de calcium / kaolin / magnesium / magnesium trisilicate",
      "carbonate de calcium / magnesium",
      "carbonate de lanthane",
      "charbon actif",
      "charbon actif / diméticone",
      "charbon actif / diméticone / oxyde de magnésium",
      "charbon actif / papaverine",
      "charbon actif / saccharomyces cerevisiae",
      "crospovidone",
      "crospovidone / sterculia (sterculia urens)",
      "diosmectite",
      "diosmectite / hydroxyde d'aluminium / hydroxyde de magnésium",
      "gomme de guar / hydroxyde de magnésium / oxyde d'aluminium / phosphate d'aluminium",
      "hydrotalcite",
      "hydroxyde d'aluminium / hydroxyde de magnésium",
      "hydroxyde de magnésium",
      "oxyde d'aluminium",
      "phosphate d'aluminium",
    ],
    title:
      "Topiques gastro-intestinaux, antiacides et adsorbants + Medicaments administres par voie orale",
    nature: "diminution de l'absorption de ces substances.",
    instructions:
      "par mesure de précaution, il convient de prendre ces topiques ou antiacides à distance de tout autre médicament (plus de 2 heures, si possible).",
    informations: [
      "Les topiques gastro-intestinaux, le charbon, le lanthane et les antiacides (sels d'aluminium, de calcium et de magnésium), associés ou non aux alginates, diminuent la résorption digestive de certains autres médicaments ingérés simultanément.",
      "Par mesure de précaution, il convient de prendre ces topiques ou antiacides à distance de tout autre médicament (plus de 2 heures, si possible).",
      "(charbon activé, charbon végétal officinal, crospovidone, diosmectite, gel d'hydroxyde d'aluminium et de carbonate de magnésium codéssechés, hydrotalcite, kaolin lourd, lanthane, magaldrate, magnesium (hydroxyde de), magnésium (trisilicate de), monmectite)",
      "ASDEC - PE",
      "TOPIQUES GASTRO-INTESTINAUX, ANTIACIDES ET ADSORBANTS (charbon activé, charbon végétal officinal, crospovidone, diosmectite, gel d'hydroxyde d'aluminium et de carbonate de magnésium codéssechés, hydrotalcite, kaolin lourd, lanthane, magaldrate, magnesium (hydroxyde de), magnésium (trisilicate de), monmectite) + SUBSTANCES A  ABSORPTION REDUITE PAR LES TOPIQUES GASTRO-INTESTINAUX, ANTIACIDES ET ADSORBANTS ((acépromazine nsfp), (acéprométazine nsfp), acide acétylsalicylique, acide alendronique, acide clodronique, acide étidronique, acide ibandronique, (acide médronique), acide oxidronique, acide pamidronique, acide risédronique, acide tiludronique, acide zolédronique, alimémazine, aténolol, bêtaméthasone, bictégravir, budésonide, (chlorproéthazine nsfp), chlorpromazine, chlortétracycline, cimétidine, ciprofloxacine, clindamycine, cortisone, cyamémazine, déméclocycline, dexaméthasone, digoxine, dolutégravir, doxycycline, elvitégravir, enoxacine, éthambutol, famotidine, fer, fexofénadine, fluor, fluphénazine, isoniazide, lansoprazole, lédipasvir, lévofloxacine, lévomépromazine, lévothyroxine, lincomycine, liothyronine sodique, loméfloxacine, lymécycline, methylènecycline, methylprednisolone, métopimazine, métoprolol, minocycline, moxifloxacine, nizatidine, norfloxacine, ofloxacine, oxomémazine, oxytétracycline, péfloxacine, pénicillamine, (perphénazine nsfp), phosphore, pipérazine, pipotiazine, prednisolone, prednisone, (prochlorpérazine), proguanil, prométhazine, propériciazine, propranolol, raltégravir, ranitidine, rosuvastatine, (roxatidine nsfp), sulpiride, tériflunomide, tétracycline, (thiopropérazine nsfp), thyroxines, tigécycline, tiratricol, triamcinolone, (trifluopérazine nsfp), ulipristal)",
      "ASDEC - PE",
      ". association déconseillée : avec les inhibiteurs d'intégrase (raltégravir, bictégravir, dolutégravir)",
      ". précaution d'emploi : avec les autres substances.",
    ],
    history: [
      "La chloroquine sort de la classe des substances à absorption réduite par les topiques gastro-intestinaux, antiacides et adsorbants (Thesaurus interactions ansm du 20/10/2020).",
      "Le dolutégravir rejoint les deux autres inhibiteurs d'intégrase déjà déconseillés avec les topiques gastrointestinaux (Thesaurus interactions ansm du 20/10/2020).",
    ],
    bibliography: [
      "McElnay JC, Harron DWG, d'Arcy PF, Eagle MRG. Interaction of digoxin with antiacid constituents. Br Med J 1978 ; i : 1554.",
      "Alber A, Rees CW. Avidity of the tetracycline fot the cations of metals. Nature 1956 ; 177 : 433.",
      "Hall GJL, Davis AE. Inhibition of iron absorption by magnesium trisilicate. Med J aust 1969 ; 2 : 95.",
      "Schroeder ET. Alkalosis resulting from combined administration of a nonsystemic antacid and a cation-exchange resin. Gastroenterology 1969 ; 56 : 868.",
      "Fernandez PC. Metabolic acidosis reversed by the combination of magnesium hydroxide and a cation-exchange resin. N Engl J Med 1972 ; 286 : 23.",
      "Hurwitz A, Schlozman DL. Effects of antiacids on gastrointestinal absorption of isoniazid in rat and man. Am Rev Respir Dis 1974 ; 109 : 41.",
      "Emori HW, Paulus H, Bluestone R, Champion GD, Pearson C. Indomethacin serum concentrations in man. Effects of dosage, food and antacid. Ann Rheum J 1976 ; 35 : 333-8.",
      "Brown DD, Juhl RP, Lewis K, Schrott M, Bartels B. Decreased bioavailability of digoxin due to antiacids and kaolin-pectin. N Engl J Med 1976 ; 295 : 1034.",
      "Ziessman HA. Alkalosis and seizure due to a cation-exchange resin and magnesium hydroxide. South Med J 1976 ; 69 : 497.",
      "Dobbs JH, Skoutakis VA, Acchardio SR, Dobbs BR. Effect of aluminium hydroxyde on the absorption of propranolol. Curr Ther Res 1977 ; 21 : 857.",
      "Galeazzi RL. The effect of an antacid on the  bioavailability of indomethacin. Europ J Clin Pharmacol 1977 ; 12 : 65-8.",
      "Garnham JC, Kaspi T, Kaye CM, Oh VMS. Different effects of sodium bicarbonate and aluminium hydroxyde on the absorption of indomethacin in man. Post Grad Med J 1977 ; 53 : 126-9.",
      "Baluarte HJ, Prebis J, Goldberg M, Gruskin AB. Metabolic alkalosis in an anephric child caused by the combined use of Kayexalate and Basaljel. J Pediatr 1978 ; 92 : 237-9.",
      "Mattila MJ, Linnoila M, Seppala T, Koskinen R. Effect of aluminium hydroxyde and glycpyrrhonium on the absorption of ethambutol and alcohol in man. Br J Clin Pharmacol 1978 ; 5 : 161.",
      "Naggar-VF, Khalil SA, Gouda MW. Effect of concomitant administration of magnesium trisilicate on GI absorption of dexamethasone in humans. J Pharm Sci 1978 ; 67 : 1029.",
      "Pinell OC, Fenimore DC, Davis CM, Fann WE. Drug-drug interaction of chlorpromazine and antiacid. Clin Pharmacol Ther 1978 ; 23 : 125.",
      "Naggar VF, Khalil SA. Effect of magnesium trisilicate on nitrofurantoin absorption. Clin Pharmacol Ther 1979 ; 25 : 857.",
      "Tobert JA, de Schepper P, Tjandramaga TB et al. The effect of antiacids on the bioavailability of diflunisal. Clin Pharmacol Ther 1979 ; 25 : 251.",
      "Garty M, Hurwitz A. Effect of cimetidine and antacids on gastrointestinal absorption of tetracycline. Clin Pharmacol Ther 1980 ; 28 : 203.",
      "Hansten PD, Hayton WL. Effect of antiacid and ascorbic acid on serum salicylate concentration. J Clin Pharmacol 1980 ; 24 : 326.",
      "Van der Meer JW, Keuning JJ, Scheigrond HW, Heykants J, Van Cutsem J, Brugmans J. The influence of gastric acidity on the biavailability of ketoconazole. J Antimicrob Chemother 1980 ; 6 : 552-6.",
      "Regardh CG, Lundborg P, Persson BA. The effect of antacid, metoclopramide and propantheline on the availability of metoprolol and atenolol. Biopharm Drug Dispos 1981 ; 2 : 79-87.",
      "Tobert JA, de Schepper P, Tjandramaga TB et al. Effect of antiacids on the bioavailability of diflunisal in the fasting and postprandial states. Clin Pharmacol Ther 1981 ; 30 : 385.",
      "McElnay JC, Mukhtar HA, D'Arcy PE, Temple DJ, Collier PS. The effects of magnesium trisilicate and kaolin on the in vivo absorption of chloroquine. J Trop Med Hyg 1982 ; 85 : 159-63.",
      "McElnay JC, Mukhtar HA, D'Arcy PE, Temple DJ. In vitro experiments on chloroquine and pyrimethamine absorption in the presence of antacid constituents of kaolin. J Trop Med Hyg 1982 ; 85 : 153-8.",
      "Albin H, Vincon G, Pehourcq F, Lecorre C, Fleury B, Conri C. Influence d'un anti-acide sur la biodisponibilité de la prednisolone. Thérapie 1983 ; 38 : 61-5.",
      'Madias NE, Levey AS. Metabolic alkalosis due to absorption of "nonabsorbable" antacids. Am J Med 1983 ; 74 : 155-8.',
      "Osman MA, Patel RB, Schuna A, sundstrom WR, Welling PG. Reduction in oral penicillamin absorption by food, antacid and ferrous sulphate. Clin Pharmacol Ther 1983 ; 33 : 465-70.",
      "D'Arcy PF. Nitrofurantoin. Drug Intell Clin Pharm 1985 ; 19 : 540-7.",
      "Shastri RA. Effect of antacid on salicykate kinetics. Int J Clin Ther vTox 1985 ; 23 : 480-4.",
      "Desmond PV, Harman PJ, Gannoulis N, Kamm M, Mashford ML. The effect of antiacids and food on the absorption of cimetidine and ranitidine. Gastroenterology 1986 ; 90 : 1393.",
      "Fleming LW, Moreland TA, Stewart WK, Scott AC. Ciprofloxacin and antiacids. Lancet 1986 ; ii : 248.",
      "Ifan A, Welling PG. Pharmacokinetics of oral 500 mg penicillamine : effect of antacid on absorption. Biopharm Drug Disp 1986 ; 7 : 401-7.",
      "Moustafa MA, Gouda MW, Tariq M. Decreased bioavailability of propranolol due to interaction with adsorbent  antacids and antidiarrhoeal mixtures. Int J Pharmaceutics 1986 ; 30 : 225-8.",
      "O'Neil-Cutting MA, Crosby WH. The effect of antacids on the absorption of simultaneously ingested iron. J Am Med Ass 1986 ; 255 : 1468-70.",
      "Vinceneux Ph, Weber Ph, Gaudin H, Boussougant Y. Diminution de l'absorption de la péfloxacine par les pansements gastriques. La Presse Med 1986 ; 15 : 1826.",
      "Maesen FPV, Davies BJ, Geraedts WH, Sumajow CA. Ofloxacin and antiacids. J Antimicrob Chemother 1987 ; 19 : 848-9.",
      "Moustafa MA, Babhair SA, Kouta HI. Decreased biavailability of some antipsychotic phenothiazines due to interactions with adsorbent antiacid and antidiarrhoeal mixtures. Int J Pharmaceutics 1987 ; 36 : 185-9.",
      "Nassif F, Sinnassamy P, Bensman A. [A cause of alkalosis in children under hemodialysis: combined administration of magnesium hydroxide and polystyrene sodium sulfonate]. Press Méd 1987 ; 16 : 1003.",
      "Noyes M, Polk RE. Norfloxacin and absorption of magnesium-aluminium. Ann Intern Med 1988 ; 109 : 168-9.",
      "Scjhentag JJ, Watson WA, Nix DE, Sedman AJ, Frost RW, Letteri J. Time dependent interactions between antacids and quinolone antibiotics. Clin Pharmacol Ther 1988 ; 43 : 135.",
      "Barzaghi N, Gatti G, Crema F, Perucca E. Impaired bioavailability of famotidine given concurrently with a potent antiacid. J Clin Pharmacol 1989 ; 37 : 409-10.",
      "Grasela TH, Schentag JJ, Sedman AJ et al. Inhibition  of enoxacin absorption by antiacids or ranitidine. Antimicrob Ag Chemother 1989 ; 33 : 615-7.",
      "Blum RA, D'Andrea DT, Florentino BM et al. Increased gastric pH and the bioavailability of fluconazole and ketoconazole. Ann Intern Med 1991 ; 114 : 755-7.",
      "Sullivan TJ, Reese JH, Jaurequi L, Miller K, Levine L, Bachmann KA. Short report : a comparative study of the interaction between antiacid and H2-receptor antagonists. Aliment Pharmacol Ther 1994 ; 4 : 123-6.",
      "Williams DD, Peng B, Bailey CK, Wire MB, Deng Y, Park JW, Collins DA, Kapsi SG, Jenkins JM. Effects of food and antacids on the pharmacokinetics of eltrombopag in healthy adult subjects: two single-dose, open-label, randomized-sequence, crossover studies. Clin Ther. 2009 ; 31 (4) : 764-76.",
      "Document laboratoire : eltrombopag (REVOLADE® - GLAXOSMITHKLINE)",
    ],
  },
];

export const mockDolipraneSpecialtiesDTOResponse: DTOSpecialtiesResponse = {
  drugs: [
    {
      form: "poudre pour solution buvable",
      dose: "1000 mg",
      formulary_specialties: [],
      specialties: [
        {
          name: "DOLIPRANE 1000 mg, poudre pour solution buvable en sachet-dose",
          cis: "61681702",
          crushable: null,
          excipients: [
            {
              name: "SACCHAROSE",
            },
            {
              name: "SODIUM",
            },
            {
              name: "GLUCOSE",
            },
          ],
          presentations: [
            {
              presentation:
                "8 sachet(s)-dose(s) papier aluminium polyéthylène de 4 g",
              reimbursement: "65%",
              price: "2,18",
            },
          ],
        },
      ],
    },
    {
      form: "poudre pour solution buvable",
      dose: "500 mg",
      formulary_specialties: [],
      specialties: [
        {
          name: "DOLIPRANE 500 mg, poudre pour solution buvable en sachet-dose",
          cis: "66731536",
          crushable: null,
          excipients: [
            {
              name: "SACCHAROSE",
            },
            {
              name: "SODIUM",
            },
            {
              name: "GLUCOSE",
            },
          ],
          presentations: [
            {
              presentation: "12 sachet(s) papier aluminium polyéthylène de 2 g",
              reimbursement: "65%",
              price: "2,18",
            },
          ],
        },
      ],
    },
    {
      form: "poudre pour solution buvable",
      dose: "100 mg",
      formulary_specialties: [
        {
          cis: "64793681",
        },
      ],
      specialties: [
        {
          name: "DOLIPRANE 100 mg, poudre pour solution buvable en sachet-dose",
          cis: "64793681",
          crushable: null,
          excipients: [
            {
              name: "SACCHAROSE",
            },
            {
              name: "SODIUM",
            },
            {
              name: "GLUCOSE",
            },
          ],
          presentations: [
            {
              presentation:
                "12 sachet(s)-dose(s) papier aluminium polyéthylène de 0,4 g",
              reimbursement: "65%",
              price: "2,18",
            },
          ],
        },
      ],
    },
    {
      form: "comprimé effervescent",
      dose: "1000 mg",
      formulary_specialties: [],
      specialties: [
        {
          name: "DOLIPRANE 1000 mg, comprimé effervescent sécable",
          cis: "66567738",
          crushable: null,
          excipients: [
            {
              name: "SODIUM",
            },
            {
              name: "SODIUM",
            },
            {
              name: "MANNITOL",
            },
            {
              name: "SODIUM",
            },
            {
              name: "SACCHARINE",
            },
            {
              name: "CITRAL",
            },
            {
              name: "GLUCOSE",
            },
            {
              name: "BUTYLHYDROXYANISOLE",
            },
            {
              name: "LINALOL",
            },
          ],
          presentations: [
            {
              presentation: "tube(s) polypropylène de 8 comprimé(s)",
              reimbursement: "65%",
              price: "2,09",
            },
            {
              presentation:
                "film(s) thermosoudé(s) polyéthylène aluminium de 100 comprimé(s)",
              reimbursement: null,
              price: null,
            },
          ],
        },
      ],
    },
    {
      form: "poudre pour solution buvable",
      dose: "200 mg",
      formulary_specialties: [
        {
          cis: "68794211",
        },
      ],
      specialties: [
        {
          name: "DOLIPRANE 200 mg, poudre pour solution buvable en sachet-dose",
          cis: "68794211",
          crushable: null,
          excipients: [
            {
              name: "SACCHAROSE",
            },
            {
              name: "SODIUM",
            },
            {
              name: "GLUCOSE",
            },
          ],
          presentations: [
            {
              presentation:
                "12 sachet(s)-dose(s) papier aluminium polyéthylène de 0,8 g",
              reimbursement: "65%",
              price: "2,18",
            },
          ],
        },
      ],
    },
    {
      form: "suppositoire",
      dose: "100 mg",
      formulary_specialties: [
        {
          cis: "66057393",
        },
      ],
      specialties: [
        {
          name: "DOLIPRANE 100 mg, suppositoire sécable",
          cis: "66057393",
          crushable: null,
          excipients: [],
          presentations: [
            {
              presentation:
                "plaquette(s) thermoformée(s) PVC polyéthylène de 10 suppositoire(s)",
              reimbursement: "65%",
              price: "2,35",
            },
          ],
        },
      ],
    },
    {
      form: "suppositoire",
      dose: "200 mg",
      formulary_specialties: [
        {
          cis: "64361369",
        },
      ],
      specialties: [
        {
          name: "DOLIPRANE 200 mg, suppositoire",
          cis: "64361369",
          crushable: null,
          excipients: [],
          presentations: [
            {
              presentation:
                "plaquette(s) thermoformée(s) PVC polyéthylène de 10 suppositoire(s)",
              reimbursement: "65%",
              price: "2,35",
            },
          ],
        },
      ],
    },
    {
      form: "suspension buvable",
      dose: "2,4 %",
      formulary_specialties: [
        {
          cis: "66477582",
        },
      ],
      specialties: [
        {
          name: "DOLIPRANE 2,4 POUR CENT SANS SUCRE, suspension buvable édulcorée au maltitol liquide et au sorbitol",
          cis: "66477582",
          crushable: null,
          excipients: [
            {
              name: "SORBITOL",
            },
            {
              name: "MALTITOL LIQUIDE",
            },
            {
              name: "SORBITOL",
            },
            {
              name: "PARAHYDROXYBENZOATE",
            },
            {
              name: "PARAHYDROXYBENZOATE",
            },
            {
              name: "PARAHYDROXYBENZOATE",
            },
            {
              name: "PARAHYDROXYBENZOATE",
            },
            {
              name: "ALCOOL NON ETHYLIQUE",
            },
            {
              name: "PROPYLENE GLYCOL",
            },
          ],
          presentations: [
            {
              presentation:
                "1 flacon(s) en verre brun de 100 ml avec seringue(s) pour administration orale en polyéthylène/polystyrène ou polypropylène/polyéthylène avec fermeture de sécurité enfant",
              reimbursement: "65%",
              price: "2,40",
            },
          ],
        },
      ],
    },
    {
      form: "comprimé effervescent",
      dose: "500 mg",
      formulary_specialties: [],
      specialties: [
        {
          name: "DOLIPRANE 500 mg, comprimé effervescent",
          cis: "65196753",
          crushable: null,
          excipients: [
            {
              name: "SODIUM",
            },
            {
              name: "SODIUM",
            },
            {
              name: "MANNITOL",
            },
            {
              name: "SODIUM",
            },
            {
              name: "SACCHARINE",
            },
            {
              name: "CITRAL",
            },
            {
              name: "SULFITE",
            },
            {
              name: "GLUCOSE",
            },
            {
              name: "BUTYLHYDROXYANISOLE",
            },
            {
              name: "SULFITE",
            },
            {
              name: "GLYCERYLE",
            },
            {
              name: "SULFITE",
            },
            {
              name: "LINALOL",
            },
          ],
          presentations: [
            {
              presentation: "tube(s) polypropylène de 16  comprimé(s)",
              reimbursement: "65%",
              price: "2,09",
            },
          ],
        },
      ],
    },
    {
      form: "poudre pour solution buvable",
      dose: "300 mg",
      formulary_specialties: [
        {
          cis: "69002078",
        },
      ],
      specialties: [
        {
          name: "DOLIPRANE 300 mg, poudre pour solution buvable en sachet-dose",
          cis: "69002078",
          crushable: null,
          excipients: [
            {
              name: "SACCHAROSE",
            },
            {
              name: "SODIUM",
            },
            {
              name: "GLUCOSE",
            },
          ],
          presentations: [
            {
              presentation:
                "12 sachet(s)-dose(s) papier aluminium polyéthylène de 1,2 g",
              reimbursement: "65%",
              price: "2,18",
            },
          ],
        },
      ],
    },
    {
      form: "suppositoire",
      dose: "300 mg",
      formulary_specialties: [
        {
          cis: "67210479",
        },
      ],
      specialties: [
        {
          name: "DOLIPRANE 300 mg, suppositoire",
          cis: "67210479",
          crushable: null,
          excipients: [],
          presentations: [
            {
              presentation:
                "plaquette(s) thermoformée(s) PVC polyéthylène de 10 suppositoire(s)",
              reimbursement: "65%",
              price: "2,35",
            },
          ],
        },
      ],
    },
    {
      form: "gélule",
      dose: "1000 mg",
      formulary_specialties: [],
      specialties: [
        {
          name: "DOLIPRANE 1000 mg, gélule",
          cis: "69309629",
          crushable: null,
          excipients: [
            {
              name: "CARBOXYMETHYLAMIDON",
            },
            {
              name: "AZORUBINE",
            },
          ],
          presentations: [
            {
              presentation:
                "plaquette(s) thermoformée(s) PVC-Aluminium de 8 gélule(s)",
              reimbursement: "65%",
              price: "2,09",
            },
          ],
        },
      ],
    },
    {
      form: "gélule",
      dose: "500 mg",
      formulary_specialties: [
        {
          cis: "67119691",
        },
      ],
      specialties: [
        {
          name: "DOLIPRANE 500 mg, gélule",
          cis: "67119691",
          crushable: {
            uri: "http://geriatrie.sfpc.eu/application/index/pdf/3953",
            recommandations: "Ouverture possible des gélules",
            intake:
              "D\\'un point de vue galénique, la gélule peut être ouverte et absorbée extemporanément",
            stability: "Aucune donnée de stabilité",
            pk_pd:
              "Aucune donnée sur ce mode d\\'administration donc pas de garantie sur les paramètres pharmacocinétiques et pharmacodynamiques ainsi que sur la tolérance.",
            smpc_comment:
              "Très amer. A avaler telles quelles sans les ouvrir avec une boisson \\(eau, lait, jus de fruit\\)",
            other_comments: null,
          },
          excipients: [
            {
              name: "GLYCEROL",
            },
          ],
          presentations: [
            {
              presentation:
                "plaquette(s) thermoformée(s) PVC aluminium de 16 gélule(s)",
              reimbursement: "65%",
              price: "2,09",
            },
            {
              presentation:
                "plaquette(s) thermoformée(s) PVC aluminium de 100 gélule(s)",
              reimbursement: null,
              price: null,
            },
          ],
        },
      ],
    },
    {
      form: "suppositoire",
      dose: "1000 mg",
      formulary_specialties: [
        {
          cis: "67488731",
        },
      ],
      specialties: [
        {
          name: "DOLIPRANE ADULTES 1000 mg, suppositoire",
          cis: "67488731",
          crushable: null,
          excipients: [],
          presentations: [
            {
              presentation:
                "film(s) thermosoudé(s) PVC polyéthylène de 8  suppositoire(s)",
              reimbursement: "65%",
              price: "2,48",
            },
          ],
        },
      ],
    },
    {
      form: "poudre pour solution buvable",
      dose: "150 mg",
      formulary_specialties: [
        {
          cis: "65103838",
        },
      ],
      specialties: [
        {
          name: "DOLIPRANE 150 mg, poudre pour solution buvable en sachet-dose",
          cis: "65103838",
          crushable: null,
          excipients: [
            {
              name: "SACCHAROSE",
            },
            {
              name: "SODIUM",
            },
            {
              name: "GLUCOSE",
            },
          ],
          presentations: [
            {
              presentation:
                "12 sachet(s)-dose(s) papier aluminium polyéthylène de 0,6 g",
              reimbursement: "65%",
              price: "2,18",
            },
          ],
        },
      ],
    },
    {
      form: "comprimé",
      dose: "500 mg",
      formulary_specialties: [
        {
          cis: "63368332",
        },
      ],
      specialties: [
        {
          name: "DOLIPRANE 500 mg, comprimé",
          cis: "63368332",
          crushable: {
            uri: "http://geriatrie.sfpc.eu/application/index/pdf/3952",
            recommandations: null,
            intake: null,
            stability: "Aucune donnée de stabilité",
            pk_pd:
              "Aucune donnée sur ce mode d\\'administration donc pas de garantie sur les paramètres pharmacocinétiques et pharmacodynamiques ainsi que sur la tolérance.",
            smpc_comment:
              "Très amer. A avaler tels quels avec une boisson \\(eau, lait, jus de fruit\\)",
            other_comments: null,
          },
          excipients: [],
          presentations: [
            {
              presentation:
                "plaquette(s) thermoformée(s) PVC-Aluminium de 16 comprimé(s)",
              reimbursement: "65%",
              price: "2,09",
            },
            {
              presentation:
                "10 plaquette(s) thermoformée(s) papier aluminium polyéthylène de 10 comprimé(s)",
              reimbursement: null,
              price: null,
            },
          ],
        },
      ],
    },
    {
      form: "comprimé",
      dose: "1000 mg",
      formulary_specialties: [],
      specialties: [
        {
          name: "DOLIPRANE 1000 mg, comprimé",
          cis: "60234100",
          crushable: null,
          excipients: [
            {
              name: "CARBOXYMETHYLAMIDON",
            },
          ],
          presentations: [
            {
              presentation:
                "plaquette(s) thermoformée(s) PVC-aluminium de 8  comprimé(s)",
              reimbursement: "65%",
              price: "2,09",
            },
            {
              presentation:
                "plaquette(s) thermoformée(s) PVC-aluminium de 100  comprimé(s)",
              reimbursement: null,
              price: null,
            },
          ],
        },
      ],
    },
    {
      form: "suppositoire",
      dose: "150 mg",
      formulary_specialties: [
        {
          cis: "60310861",
        },
      ],
      specialties: [
        {
          name: "DOLIPRANE 150 mg, suppositoire",
          cis: "60310861",
          crushable: null,
          excipients: [],
          presentations: [
            {
              presentation:
                "plaquette(s) thermoformée(s) PVC polyéthylène de 10 suppositoire(s)",
              reimbursement: "65%",
              price: "2,35",
            },
          ],
        },
      ],
    },
  ],
};

export const mockDolipraneSpecialties: FormDoseAndSpecialties[] = [
  {
    dose: "1000 mg",
    form: "poudre pour solution buvable",
    specialties: [
      {
        name: "DOLIPRANE 1000 mg, poudre pour solution buvable en sachet-dose",
        excipients: ["GLUCOSE", "SACCHAROSE", "SODIUM"],
        availableInFormulary: false,
        presentations: [
          {
            name: "8 sachet(s)-dose(s) papier aluminium polyéthylène de 4 g",
            reimbursement: "65%",
            price: "2,18",
          },
        ],
        crushable: null,
      },
    ],
  },
  {
    dose: "500 mg",
    form: "poudre pour solution buvable",
    specialties: [
      {
        name: "DOLIPRANE 500 mg, poudre pour solution buvable en sachet-dose",
        excipients: ["GLUCOSE", "SACCHAROSE", "SODIUM"],
        availableInFormulary: false,
        presentations: [
          {
            name: "12 sachet(s) papier aluminium polyéthylène de 2 g",
            reimbursement: "65%",
            price: "2,18",
          },
        ],
        crushable: null,
      },
    ],
  },
  {
    dose: "100 mg",
    form: "poudre pour solution buvable",
    specialties: [
      {
        name: "DOLIPRANE 100 mg, poudre pour solution buvable en sachet-dose",
        excipients: ["GLUCOSE", "SACCHAROSE", "SODIUM"],
        availableInFormulary: true,
        presentations: [
          {
            name: "12 sachet(s)-dose(s) papier aluminium polyéthylène de 0,4 g",
            reimbursement: "65%",
            price: "2,18",
          },
        ],
        crushable: null,
      },
    ],
  },
  {
    dose: "1000 mg",
    form: "comprimé effervescent",
    specialties: [
      {
        name: "DOLIPRANE 1000 mg, comprimé effervescent sécable",
        excipients: [
          "BUTYLHYDROXYANISOLE",
          "CITRAL",
          "GLUCOSE",
          "LINALOL",
          "MANNITOL",
          "SACCHARINE",
          "SODIUM",
        ],
        availableInFormulary: false,
        presentations: [
          {
            name: "tube(s) polypropylène de 8 comprimé(s)",
            reimbursement: "65%",
            price: "2,09",
          },
          {
            name: "film(s) thermosoudé(s) polyéthylène aluminium de 100 comprimé(s)",
            reimbursement: null,
            price: null,
          },
        ],
        crushable: null,
      },
    ],
  },
  {
    dose: "200 mg",
    form: "poudre pour solution buvable",
    specialties: [
      {
        name: "DOLIPRANE 200 mg, poudre pour solution buvable en sachet-dose",
        excipients: ["GLUCOSE", "SACCHAROSE", "SODIUM"],
        availableInFormulary: true,
        presentations: [
          {
            name: "12 sachet(s)-dose(s) papier aluminium polyéthylène de 0,8 g",
            reimbursement: "65%",
            price: "2,18",
          },
        ],
        crushable: null,
      },
    ],
  },
  {
    dose: "100 mg",
    form: "suppositoire",
    specialties: [
      {
        name: "DOLIPRANE 100 mg, suppositoire sécable",
        excipients: [],
        availableInFormulary: true,
        presentations: [
          {
            name: "plaquette(s) thermoformée(s) PVC polyéthylène de 10 suppositoire(s)",
            reimbursement: "65%",
            price: "2,35",
          },
        ],
        crushable: null,
      },
    ],
  },
  {
    dose: "200 mg",
    form: "suppositoire",
    specialties: [
      {
        name: "DOLIPRANE 200 mg, suppositoire",
        excipients: [],
        availableInFormulary: true,
        presentations: [
          {
            name: "plaquette(s) thermoformée(s) PVC polyéthylène de 10 suppositoire(s)",
            reimbursement: "65%",
            price: "2,35",
          },
        ],
        crushable: null,
      },
    ],
  },
  {
    dose: "2,4 %",
    form: "suspension buvable",
    specialties: [
      {
        name: "DOLIPRANE 2,4 POUR CENT SANS SUCRE, suspension buvable édulcorée au maltitol liquide et au sorbitol",
        excipients: [
          "ALCOOL NON ETHYLIQUE",
          "MALTITOL LIQUIDE",
          "PARAHYDROXYBENZOATE",
          "PROPYLENE GLYCOL",
          "SORBITOL",
        ],
        availableInFormulary: true,
        presentations: [
          {
            name: "1 flacon(s) en verre brun de 100 ml avec seringue(s) pour administration orale en polyéthylène/polystyrène ou polypropylène/polyéthylène avec fermeture de sécurité enfant",
            reimbursement: "65%",
            price: "2,40",
          },
        ],
        crushable: null,
      },
    ],
  },
  {
    dose: "500 mg",
    form: "comprimé effervescent",
    specialties: [
      {
        name: "DOLIPRANE 500 mg, comprimé effervescent",
        excipients: [
          "BUTYLHYDROXYANISOLE",
          "CITRAL",
          "GLUCOSE",
          "GLYCERYLE",
          "LINALOL",
          "MANNITOL",
          "SACCHARINE",
          "SODIUM",
          "SULFITE",
        ],
        availableInFormulary: false,
        presentations: [
          {
            name: "tube(s) polypropylène de 16  comprimé(s)",
            reimbursement: "65%",
            price: "2,09",
          },
        ],
        crushable: null,
      },
    ],
  },
  {
    dose: "300 mg",
    form: "poudre pour solution buvable",
    specialties: [
      {
        name: "DOLIPRANE 300 mg, poudre pour solution buvable en sachet-dose",
        excipients: ["GLUCOSE", "SACCHAROSE", "SODIUM"],
        availableInFormulary: true,
        presentations: [
          {
            name: "12 sachet(s)-dose(s) papier aluminium polyéthylène de 1,2 g",
            reimbursement: "65%",
            price: "2,18",
          },
        ],
        crushable: null,
      },
    ],
  },
  {
    dose: "300 mg",
    form: "suppositoire",
    specialties: [
      {
        name: "DOLIPRANE 300 mg, suppositoire",
        excipients: [],
        availableInFormulary: true,
        presentations: [
          {
            name: "plaquette(s) thermoformée(s) PVC polyéthylène de 10 suppositoire(s)",
            reimbursement: "65%",
            price: "2,35",
          },
        ],
        crushable: null,
      },
    ],
  },
  {
    dose: "1000 mg",
    form: "gélule",
    specialties: [
      {
        name: "DOLIPRANE 1000 mg, gélule",
        excipients: ["AZORUBINE", "CARBOXYMETHYLAMIDON"],
        availableInFormulary: false,
        presentations: [
          {
            name: "plaquette(s) thermoformée(s) PVC-Aluminium de 8 gélule(s)",
            reimbursement: "65%",
            price: "2,09",
          },
        ],
        crushable: null,
      },
    ],
  },
  {
    dose: "500 mg",
    form: "gélule",
    specialties: [
      {
        name: "DOLIPRANE 500 mg, gélule",
        excipients: ["GLYCEROL"],
        availableInFormulary: true,
        presentations: [
          {
            name: "plaquette(s) thermoformée(s) PVC aluminium de 16 gélule(s)",
            reimbursement: "65%",
            price: "2,09",
          },
          {
            name: "plaquette(s) thermoformée(s) PVC aluminium de 100 gélule(s)",
            reimbursement: null,
            price: null,
          },
        ],
        crushable: {
          uri: "http://geriatrie.sfpc.eu/application/index/pdf/3953",
          recommandations: "Ouverture possible des gélules",
          intake:
            "D'un point de vue galénique, la gélule peut être ouverte et absorbée extemporanément",
          smpc_comment:
            "Très amer. A avaler telles quelles sans les ouvrir avec une boisson (eau, lait, jus de fruit)",
          pk_pd:
            "Aucune donnée sur ce mode d'administration donc pas de garantie sur les paramètres pharmacocinétiques et pharmacodynamiques ainsi que sur la tolérance.",
          stability: "Aucune donnée de stabilité",
          other_comments: "",
        },
      },
    ],
  },
  {
    dose: "1000 mg",
    form: "suppositoire",
    specialties: [
      {
        name: "DOLIPRANE ADULTES 1000 mg, suppositoire",
        excipients: [],
        availableInFormulary: true,
        presentations: [
          {
            name: "film(s) thermosoudé(s) PVC polyéthylène de 8  suppositoire(s)",
            reimbursement: "65%",
            price: "2,48",
          },
        ],
        crushable: null,
      },
    ],
  },
  {
    dose: "150 mg",
    form: "poudre pour solution buvable",
    specialties: [
      {
        name: "DOLIPRANE 150 mg, poudre pour solution buvable en sachet-dose",
        excipients: ["GLUCOSE", "SACCHAROSE", "SODIUM"],
        availableInFormulary: true,
        presentations: [
          {
            name: "12 sachet(s)-dose(s) papier aluminium polyéthylène de 0,6 g",
            reimbursement: "65%",
            price: "2,18",
          },
        ],
        crushable: null,
      },
    ],
  },
  {
    dose: "500 mg",
    form: "comprimé",
    specialties: [
      {
        name: "DOLIPRANE 500 mg, comprimé",
        excipients: [],
        availableInFormulary: true,
        presentations: [
          {
            name: "plaquette(s) thermoformée(s) PVC-Aluminium de 16 comprimé(s)",
            reimbursement: "65%",
            price: "2,09",
          },
          {
            name: "10 plaquette(s) thermoformée(s) papier aluminium polyéthylène de 10 comprimé(s)",
            reimbursement: null,
            price: null,
          },
        ],
        crushable: {
          uri: "http://geriatrie.sfpc.eu/application/index/pdf/3952",
          recommandations: "",
          intake: "",
          smpc_comment:
            "Très amer. A avaler tels quels avec une boisson (eau, lait, jus de fruit)",
          pk_pd:
            "Aucune donnée sur ce mode d'administration donc pas de garantie sur les paramètres pharmacocinétiques et pharmacodynamiques ainsi que sur la tolérance.",
          stability: "Aucune donnée de stabilité",
          other_comments: "",
        },
      },
    ],
  },
  {
    dose: "1000 mg",
    form: "comprimé",
    specialties: [
      {
        name: "DOLIPRANE 1000 mg, comprimé",
        excipients: ["CARBOXYMETHYLAMIDON"],
        availableInFormulary: false,
        presentations: [
          {
            name: "plaquette(s) thermoformée(s) PVC-aluminium de 8  comprimé(s)",
            reimbursement: "65%",
            price: "2,09",
          },
          {
            name: "plaquette(s) thermoformée(s) PVC-aluminium de 100  comprimé(s)",
            reimbursement: null,
            price: null,
          },
        ],
        crushable: null,
      },
    ],
  },
  {
    dose: "150 mg",
    form: "suppositoire",
    specialties: [
      {
        name: "DOLIPRANE 150 mg, suppositoire",
        excipients: [],
        availableInFormulary: true,
        presentations: [
          {
            name: "plaquette(s) thermoformée(s) PVC polyéthylène de 10 suppositoire(s)",
            reimbursement: "65%",
            price: "2,35",
          },
        ],
        crushable: null,
      },
    ],
  },
];

export const mockRisperdalCrushableSpecialtiesDTOResponse: DTOCrushableSpecialtiesResponse =
  {
    drugs: [
      {
        form: "comprimé pelliculé",
        dose: "1 mg",
        specialties: [
          {
            name: "RISPERDAL 1 mg, comprimé pelliculé",
            crushable: {
              uri: "http://geriatrie.sfpc.eu/application/index/pdf/4514",
              recommandations: null,
              intake: null,
              stability: null,
              pk_pd:
                "Pas étude de biodisponibilité des cp écrasés. Pelliculage masque le goût amer des cps , il est déconseillé d\\'écraser les cp, alternative solution buvable",
              smpc_comment: "-",
              other_comments: null,
            },
          },
        ],
      },
      {
        form: "comprimé pelliculé",
        dose: "4 mg",
        specialties: [
          {
            name: "RISPERDAL 4 mg, comprimé pelliculé",
            crushable: {
              uri: "http://geriatrie.sfpc.eu/application/index/pdf/4516",
              recommandations: null,
              intake: null,
              stability: null,
              pk_pd:
                "Pas étude de biodisponibilité des cp écrasés. Pelliculage masque le goût amer des cps , il est déconseillé d\\'écraser les cp, alternative solution buvable",
              smpc_comment: "-",
              other_comments: null,
            },
          },
        ],
      },
      {
        form: "solution  buvable",
        dose: "1 mg/ml",
        specialties: [
          {
            name: "RISPERDAL 1 mg/ml, solution buvable",
            crushable: null,
          },
        ],
      },
      {
        form: "comprimé pelliculé",
        dose: "2 mg",
        specialties: [
          {
            name: "RISPERDAL 2 mg, comprimé pelliculé",
            crushable: {
              uri: "http://geriatrie.sfpc.eu/application/index/pdf/4515",
              recommandations: null,
              intake: null,
              stability: null,
              pk_pd:
                "Pas étude de biodisponibilité des cp écrasés. Pelliculage masque le goût amer des cps , il est déconseillé d\\'écraser les cp, alternative solution buvable",
              smpc_comment: "-",
              other_comments: null,
            },
          },
        ],
      },
    ],
  };

export const mockRisperdalCrushableSpecialties: FormDoseAndCrushableSpecialties[] =
  [
    {
      dose: "1 mg",
      form: "comprimé pelliculé",
      crushableSpecialties: [
        {
          name: "RISPERDAL 1 mg, comprimé pelliculé",
          crushable: {
            uri: "http://geriatrie.sfpc.eu/application/index/pdf/4514",
            recommandations: "",
            intake: "",
            smpc_comment: "-",
            pk_pd:
              "Pas étude de biodisponibilité des cp écrasés. Pelliculage masque le goût amer des cps , il est déconseillé d'écraser les cp, alternative solution buvable",
            stability: "",
            other_comments: "",
          },
        },
      ],
    },
    {
      dose: "4 mg",
      form: "comprimé pelliculé",
      crushableSpecialties: [
        {
          name: "RISPERDAL 4 mg, comprimé pelliculé",
          crushable: {
            uri: "http://geriatrie.sfpc.eu/application/index/pdf/4516",
            recommandations: "",
            intake: "",
            smpc_comment: "-",
            pk_pd:
              "Pas étude de biodisponibilité des cp écrasés. Pelliculage masque le goût amer des cps , il est déconseillé d'écraser les cp, alternative solution buvable",
            stability: "",
            other_comments: "",
          },
        },
      ],
    },
    {
      dose: "2 mg",
      form: "comprimé pelliculé",
      crushableSpecialties: [
        {
          name: "RISPERDAL 2 mg, comprimé pelliculé",
          crushable: {
            uri: "http://geriatrie.sfpc.eu/application/index/pdf/4515",
            recommandations: "",
            intake: "",
            smpc_comment: "-",
            pk_pd:
              "Pas étude de biodisponibilité des cp écrasés. Pelliculage masque le goût amer des cps , il est déconseillé d'écraser les cp, alternative solution buvable",
            stability: "",
            other_comments: "",
          },
        },
      ],
    },
  ];

export const mockBactrimPharmacologyDTOResponse: DTOPharmacologyResponse = {
  drugs: [
    {
      form: "suspension buvable",
      dose: "40 mg/ml + 8 mg/ml",
      pharmacodynamics: [
        {
          description:
            "Classe pharmacothérapeutique : Antibactériens à usage systémique, code ATC : J01EE01.\r\n\r\n\r\n* Mécanisme d'action\r\n\r\nLe sulfaméthoxazole est un sulfamide qui inhibe de manière compétitive la synthèse de l'acide folique nécessaire à la croissance bactérienne. Le triméthoprime est un dérivé des pyrimidines qui inhibe spécifiquement la dihydrofolate réductase dans les micro-organismes. L'association d'un sulfamide et du triméthoprime bloque deux étapes consécutives du métabolisme de l'acide folique, interrompant ainsi la synthèse de la purine, de l'ARN et de l'ADN par les micro-organismes. Cette forme de blocage séquentiel entraîne un effet bactéricide in vitro de l'association à des concentrations auxquelles les substances actives à elles seules n'exercent qu'un effet bactériostatique. Le mécanisme d'action interfère avec le développement d'une résistance, ce qui signifie que l'association est généralement efficace contre les organismes résistants à l'une ou l'autre des deux substances.\r\n\r\n\r\n* Résistance\r\n\r\nUne résistance survient (1-10 %) chez les streptocoques, les pneumocoques et les staphylocoques. Elle est fréquente (> 10 %) chez Haemophilus influenzae et les bactéries intestinales à Gram négatif.\r\n\r\nUne résistance croisée existe avec le triméthoprime et les sulfamides, mais pas avec d'autres antibiotiques.\r\n\r\nMécanisme de résistance :\r\n\r\nUne résistance acquise, portée par des plasmides, à la fois aux sulfamides et au triméthoprime survient principalement chez les espèces de bactéries intestinales à Gram négatif. La résistance aux sulfamides est fondée sur la production d'une autre dihydroptéroate synthétase qui est insensible aux sulfamides, tandis que la résistance au triméthoprime est habituellement due à la production d'une autre dihydrofolate réductase résistante au triméthoprime. On trouve des isolats résistants aux sulfamides seuls ou à la fois aux sulfamides et au triméthoprime, alors que les isolats résistants au triméthoprime et sensibles aux sulfamides sont très peu courants.\r\n\r\nDéveloppement de la résistance :\r\n\r\nLa prévalence de la résistance peut varier en fonction de la géographie et du temps pour certaines espèces. Il est donc utile de disposer d'informations locales sur la résistance, surtout pour le traitement d'infections sévères. Si nécessaire, il convient d'obtenir un avis spécialisé, notamment lorsque la prévalence locale de la résistance est telle que l'intérêt du médicament peut être mis en cause pour certains types d'infections.\r\n\r\nPoints de rupture pour la détermination de la résistance\r\n\r\nLes concentrations minimales inhibitrices (CMI) d'après l'EUCAST (European Committee on Antimicrobial Susceptibility Testing) sont les suivantes :\r\n\r\nCMI (microgrammes/mL) (a)\r\n\r\nEnterobacteriaceae\r\nSensible < ou = : 2\r\nRésistant > : 4\r\n\r\nAcinetobacter spp.\r\nSensible < ou = : 2\r\nRésistant > : 4\r\n\r\nStenotrophomonas maltophila (b)\r\nSensible < ou = : 0,001\r\nRésistant > : 4\r\n\r\nStaphylococcus spp.\r\nSensible < ou = : 2\r\nRésistant > : 4\r\n\r\nEnterococcus spp (c)\r\nSensible < ou = : -\r\nRésistant > : -\r\n\r\nStreptococcus pneumoniae\r\nSensible < ou = : 1\r\nRésistant > : 2\r\n\r\nStreptococcus groups A, B, C and G\r\nSensible < ou = : 1\r\nRésistant > : 2\r\n\r\nHaemophilus influenzae\r\nSensible < ou = : 0,5\r\nRésistant > : 1\r\n\r\nListeria monocytogenes\r\nSensible < ou = : 0,06\r\nRésistant > : 0,06\r\n\r\nPasteurella multocida\r\nSensible < ou = : 0,25\r\nRésistant > : 0,25\r\n\r\nMoraxella catarrhalis\r\nSensible < ou = : 0,5\r\nRésistant > : 1\r\n\r\nKingella kingae\r\nSensible < ou = : 0,25\r\nRésistant > : 0,25\r\n\r\nAeromonas spp\r\nSensible < ou = : 2\r\nRésistant > : 4\r\n\r\nBurkholderia pseudomallei\r\nSensible < ou = : 0,001\r\nRésistant > : 4\r\n\r\n(a) Le triméthoprime:sulfaméthoxazole dans le rapport de 1:19. Les valeurs des points de rupture sont exprimées sous forme de concentration de triméthoprime.\r\n(b) Les points de rupture sont fondés sur un traitement à haute dose, > ou = 240 mg de triméthoprime et 1,2 grammes de sulfaméthoxazole co-administrés deux fois par jour.\r\n(c) L'activité du triméthoprime et de l'association trimethoprime-sulfaméthoxazole sur les entérocoques est incertaine et il n'est pas possible de prédire le résultat clinique.\r\n\r\nSPECTRE D'ACTIVITE ANTIBACTERIENNE\r\n\r\nESPECES SENSIBLES\r\nStaphylococcus aureus et staphylocoques à coagulase négative\r\nStreptocoques, pneumocoques et entérocoques\r\nListeria\r\nMoraxella catarrhalis\r\nHaemophilus influenzae et parainfluenzae\r\nE. coli, Klebsiella, Enterobacter, Proteus, Morganella morganii, Citrobacter, Serratia et Hafnia\r\nSalmonella, Shigella\r\nStenotrophomonas maltophilia\r\n\r\nESPECES MODEREMENT SENSIBLES\r\nHaemophilus ducreyi\r\nProvidencia\r\nAcinetobacter\r\nAeromonas hydrophilia \r\n\r\nESPECES RESISTANTES\r\nPseudomonas\r\nLegionella\r\nBactéries anaérobies, y compris Clostridium difficile\r\nMycoplasma\r\n\r\nOutre son effet antibactérien, l'association triméthoprime-sulfaméthoxazole est efficace contre Pneumocystis jirovecii.",
        },
      ],
      pharmacokinetics: [
        {
          description:
            "* Absorption\r\n\r\nAprès administration orale, le sulfaméthoxazole et le triméthoprime sont rapidement et entièrement absorbés dans la partie supérieure du tractus gastro-intestinal. Les concentrations sériques de sulfaméthoxazole et de triméthoprime sont identiques, que les deux substances soient administrées en concomitance ou séparément. La concentration sérique maximale de ce médicament est atteinte en 2 à 4 heures après administration orale. La demi-vie est de 11 heures pour le sulfaméthoxazole et de 10 heures pour le triméthoprime. Les concentrations sériques des substances respectives après administration répétée sont de 6,5 (5,2 - 10,3) micromol/litre = 1,9 (1,5 - 3,0) microgrammes/mL (triméthoprime), 225 (150 - 300) micromol/litre = 56 (37,5 - 75) microgrammes/mL (sulfaméthoxazole). Ces concentrations sériques sont nettement supérieures aux CMI bactériennes actuelles.\r\n\r\n\r\n* Distribution\r\n\r\nLe volume de distribution est d'environ 1,6 litres/kg pour le triméthoprime et d'environ 0,2 litre/kg pour le sulfaméthoxazole. La liaison aux protéines plasmatiques atteint 37 % pour le triméthoprime et 62 % pour le sulfaméthoxazole.\r\n\r\nLe sulfaméthoxazole et le triméthoprime sont présents dans le sérum sous la forme libre, liée aux protéines et métabolisées. Le degré de liaison aux protéines pour le triméthoprime et le sulfaméthoxazole est de 45 % et 70 % respectivement. Les taux tissulaires de triméthoprime sont généralement plus élevés que les taux plasmatiques correspondants. Des concentrations particulièrement élevées sont retrouvées dans les poumons et les reins. Les concentrations de triméthoprime dans la bile, le liquide prostatique, la salive et les sécrétions bronchiques notamment sont supérieures aux concentrations plasmatiques correspondantes. Les concentrations présentes dans l'humeur aqueuse et le liquide céphalo-rachidien sont adéquates pour un effet antibactérien. La concentration de sulfaméthoxazole actif dans l'humeur aqueuse, la bile, le liquide céphalorachidien et les sécrétions bronchiques représente environ 30 % de la concentration plasmatique.\r\n\r\nChez l'être humain, le triméthoprime et le sulfaméthoxazole sont détectés dans les tissus fœtaux (placenta, foie, poumon), le sang du cordon ombilical et le liquide amniotique, ce qui signifie que ces deux substances traversent le placenta. La concentration fœtale de triméthoprime est généralement comparable à celle observée chez la mère, tandis que la concentration de sulfaméthoxazole est légèrement inférieure (Cf. rubrique \"Grossesse et allaitement\").\r\n\r\nLes deux substances sont excrétées dans le lait maternel. Les concentrations de triméthoprime dans le lait maternel sont généralement comparables aux concentrations mesurées dans le plasma maternel alors que celles de sulfaméthoxazole sont légèrement inférieures (Cf. rubrique \"Grossesse et allaitement\").\r\n\r\n\r\n* Métabolisme\r\n\r\nEnviron 30 % de la dose de triméthoprime sont métabolisés. Les résultats d'une étude in vitro avec des microsomes hépatiques humains montrent que le CYP3A4, le CYP1A2 et le CYP2C9 sont principalement responsables du métabolisme du triméthoprime. Les principaux métabolites du triméthoprime sont le 1-oxyde et le 3-oxyde, ainsi que les dérivés 3-hydroxyde et 4-hydroxyde. Certains métabolites ont une activité microbiologique.\r\n\r\nEnviron 80 % de la dose de sulfaméthoxazole sont métabolisés dans le foie, essentiellement en dérivé N4-acétyl (environ 40 % de la dose) et, dans une moindre mesure, par glucurono-conjugaison. Le sulfaméthoxazole est également métabolisé par la voie oxydative. La première étape de l'oxydation, qui conduit à la formation du dérivé hydroxylamine, est catalysée par le CYP2C9.\r\n\r\n\r\n* Elimination\r\n\r\nLa demi-vie des deux substances est semblable (10 heures en moyenne pour le triméthoprime et 11 heures pour le sulfaméthoxazole).\r\n\r\nLe triméthoprime et le sulfaméthoxazole sont éliminés par les reins par filtration glomérulaire ; le triméthoprime est également éliminé par sécrétion tubulaire. Vingt pour cent du sulfaméthoxazole sont éliminés sous forme de substance active inchangée, 60 % sont présents sous forme acétylée et environ 15 % sous forme glucuronoconjuguée. Environ deux tiers du triméthoprime sont excrétés sous forme active inchangée. La clairance plasmatique totale du triméthoprime est de 1,9 mL/min/kg et celle du sulfaméthoxazole est de 0,32 mL/min/kg. Les deux substances sont retrouvées dans une faible proportion dans les fèces.\r\n\r\n\r\n* Pharmacocinétique pour certains groupes de patients\r\n\r\n- Population pédiatrique\r\nLa pharmacocinétique des deux composants de ce médicament, le triméthoprime et le sulfaméthoxazole, dépend de l'âge dans la population pédiatrique présentant une fonction rénale normale. Tandis que l'élimination du triméthoprime et du sulfaméthoxazole est réduite chez les nouveau-nés durant les deux premiers mois de la vie, tous deux présentent ensuite une élimination accrue avec une clairance corporelle plus élevée et une demi-vie d'élimination plus courte. Les différences sont les plus marquées chez les nourrissons (> 1,7 mois à 24 mois) et diminuent avec l'âge, par comparaison avec les jeunes enfants (de 1 an à 3,6 ans), les enfants (de 7,5 ans à < 10 ans) et les adultes (Cf. rubrique \"Posologie et mode d'administration\").\r\n\r\n- Patients âgés\r\nLe triméthoprime étant éliminé dans une large mesure par voie rénale sous forme inchangée et compte tenu de la diminution physiologique de la clairance de la créatinine avec l'âge, on peut s'attendre à une diminution de la clairance rénale et de la clairance totale du triméthoprime. La pharmacocinétique du sulfaméthoxazole devrait être moins affectée par l'avancement en âge, car la clairance rénale du sulfaméthoxazole ne représente que 20 % de sa clairance totale.\r\n\r\n- Patients présentant une altération de la fonction rénale\r\nChez les patients souffrant d'une altération sévère de la fonction rénale (clairance de la créatinine de 15-30 mL/min), la demi-vie des deux substances est prolongée, nécessitant une adaptation posologique (Cf. rubrique \"Posologie et mode d'administration\").\r\n\r\nUne dialyse péritonéale ambulatoire intermittente ou continue n'a pas d'influence significative sur l'élimination du triméthoprime et du sulfaméthoxazole. Le triméthoprime et le sulfaméthoxazole sont éliminés en quantité non négligeable pendant l'hémodialyse et l'hémofiltration. Chez les enfants présentant une altération de la fonction rénale (clairance de la créatinine < 30 mL/min), la clairance du triméthoprime est réduite et sa demi-vie est prolongée. La dose de triméthoprime et de sulfaméthoxazole doit être adaptée à la fonction rénale chez ces patients.\r\n\r\n- Patients présentant une altération de la fonction hépatique\r\nLa pharmacocinétique du triméthoprime et du sulfaméthoxazole chez les patients présentant une altération modérée ou sévère de la fonction rénale n'est pas considérée comme significativement différente de celle observée chez les sujets sains.\r\n\r\n- Patients atteints de mucoviscidose\r\nLa clairance rénale du triméthoprime et la clairance métabolique du sulfaméthoxazole sont accrues chez les patients atteints de mucoviscidose. En conséquence, la clairance plasmatique totale est augmentée et la demi-vie est réduite pour les deux substances.",
        },
      ],
      etiology: [
        {
          intro:
            "Les concentrations critiques séparent les souches sensibles des souches de sensibilité intermédiaire et ces dernières, des résistantes :\r\n\r\nTriméthoprime - sulfaméthoxasole : S < ou = 2 mg/litre et R > 8 mg/litre\r\n\r\nLa prévalence de la résistance peut varier en fonction de la géographie et du temps pour certaines espèces. Il est donc utile de disposer d'informations sur la prévalence de la résistance locale, surtout pour le traitement s'infections sévères. Ces données ne peuvent apporter qu'une orientation sur les probabilités de la sensibilité d'une souche bactérienne à cet antibiotique.\r\n\r\nLorsque la variabilité de la prévalence de la résistance en France est connue pour une espèce bactérienne, elle est indiquée dans la liste ci-dessous [Catégories / Fréquence de résistance acquise en France (> 10 %) (valeurs extrêmes)].",
          inconsistently_sensitive: null,
          usually_sensitive: {
            agent: [
              {
                name: "ISOSPORA BELLI",
                percentage: null,
                category: "PARASITOLOGIE",
              },
              {
                name: "PNEUMOCYSTIS JIROVECII",
                percentage: null,
                category: "PARASITOLOGIE",
              },
              {
                name: "TOXOPLASMA",
                percentage: null,
                category: "PARASITOLOGIE",
              },
              {
                name: "STAPHYLOCOCCUS AUREUS",
                percentage: null,
                category: "BACTERIES GRAM POSITIF AEROBIES",
              },
              {
                name: "STAPHYLOCOCCUS COAGULASE NEGAT.",
                percentage: "5 - 40 %",
                category: "BACTERIES GRAM POSITIF AEROBIES",
              },
              {
                name: "STREPTOCOCCUS sp",
                percentage: "5 - 20 %",
                category: "BACTERIES GRAM POSITIF AEROBIES",
              },
              {
                name: "STREPTOCOCCUS PNEUMONIAE",
                percentage: "10 - 50 %",
                category: "BACTERIES GRAM POSITIF AEROBIES",
              },
              {
                name: "ENTEROCOCCUS sp",
                percentage: null,
                category: "BACTERIES GRAM POSITIF AEROBIES",
              },
              {
                name: "CORYNEBACTERIUM sp",
                percentage: null,
                category: "BACTERIES GRAM POSITIF AEROBIES",
              },
              {
                name: "LISTERIA sp",
                percentage: null,
                category: "BACTERIES GRAM POSITIF AEROBIES",
              },
              {
                name: "ESCHERICHIA COLI",
                percentage: "5 - 30 %",
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "PROTEUS sp",
                percentage: "20 - 40 %",
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "MORGANELLA sp",
                percentage: "10 - 20 %",
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "KLEBSIELLA sp",
                percentage: "10 - 40 %",
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "ENTEROBACTER sp",
                percentage: "10 - 40 %",
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "SALMONELLA sp",
                percentage: null,
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "SHIGELLA sp",
                percentage: null,
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "PASTEURELLA sp",
                percentage: null,
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "CITROBACTER FREUNDII",
                percentage: "10 - 40 %",
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "HAEMOPHILUS sp",
                percentage: "5 - 15 %",
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "PEPTOSTREPTOCOCCUS sp",
                percentage: null,
                category: "BACTERIES GRAM POSITIF ANAEROBIES",
              },
              {
                name: "MYCOBACTERIES sp",
                percentage: null,
                category: "BACTERIES AUTRES",
              },
              {
                name: "BORRELIA sp",
                percentage: null,
                category: "BACTERIES AUTRES",
              },
              {
                name: "SPIROCHETES sp",
                percentage: null,
                category: "BACTERIES AUTRES",
              },
            ],
            comment: [],
            text: ["Mycobacterium (sauf tuberculosis, avium intracellulare)"],
          },
          moderate_sensitive: null,
          resistant: {
            agent: [
              {
                name: "PSEUDOMONAS sp",
                category: "BACTERIES GRAM NEGATIF AEROBIES",
                percentage: null,
              },
              {
                name: "MYCOBACTERIUM TUBERCULOSIS",
                category: "BACTERIES AUTRES",
                percentage: null,
              },
              {
                name: "MYCOBACTERIUM AVIUM INTRACELLULARE",
                category: "BACTERIES AUTRES",
                percentage: null,
              },
            ],
            comment: [],
            text: [
              "L'association sulfamides-triméthoprime présente un effet fortement synergique vis à vis de la plupart des bactéries, y compris les souches résistantes à l'un des deux produits. Ceci explique l'activité de l'association sur les Nocardia et les Stenotrophomonas mais aussi sur Escherichia coli ayant une résistance acquise aux sulfamides (résistance même de haut niveau).\r\n\r\nCette synergie est maximale dans le rapport de leur CMI, c'est à dire 1/20 triméthoprime-sulfamide pour les entérobactéries et staphylocoques. En revanche, vis à vis des bactéries naturellement résistantes au triméthoprime (Nocardia, Stenotrophomonas, Neisseria) le rapport optimal doit être de 1/1 ou 2/1 triméthoprime-sulfamide.",
            ],
          },
        },
      ],
    },
    {
      form: "comprimé",
      dose: null,
      pharmacodynamics: [
        {
          description:
            "Classe pharmacothérapeutique : ASSOCIATION DE SULFAMIDE ET TRIMETHOPRIME, code ATC : J01EE01.\r\n\r\nCe médicament est une association d'un sulfamide, le sulfaméthoxazole, à une diaminopyrimidine, le triméthoprime, dans la proportion de 5/1.\r\n\r\nLe sulfaméthoxazole et le triméthoprime agissent en synergie dans les proportions incluses entre : 100/1 et 10/1.",
        },
      ],
      pharmacokinetics: [
        {
          description:
            "* Absorption\r\n\r\nAdministrés par voie orale, le sulfaméthoxazole et le triméthoprime sont rapidement absorbés à 90 %. Les concentrations plasmatiques sont atteintes en 2 à 4 heures.\r\n\r\n\r\n* Distribution\r\n\r\nAprès administration orale d'une seule dose de l'association triméthoprime-sulfaméthoxazole comprimés adultes ou comprimés à dosage fort (800 mg de sulfaméthoxazole et 160 mg de triméthoprime), les concentrations plasmatiques maximales sont comprises entre 40 et 60 microgrammes/ml pour le sulfaméthoxazole et 1 à 2 microgrammes/ml pour le triméthoprime. Après administration orale d'une seule prise de 10 mg/kg de sulfaméthoxazole et de 2 mg/kg de triméthoprime, les concentrations plasmatiques maximales sont comprises entre 35 et 40 microgrammes/ml pour le sulfaméthoxazole et 0,5 microgramme/ml et 1 microgramme/ml pour le triméthoprime.\r\n\r\nLa demi-vie du sulfaméthoxazole est de 9 - 11 heures et celle du triméthoprime de 10 - 12 heures. Par rapport à l'adulte, la demi-vie plasmatique des deux constituants est plus courte chez l'enfant.\r\n\r\nCe médicament diffuse rapidement dans les tissus et dans les sécrétions : le liquide céphalo-rachidien, l'oreille moyenne, les amygdales et la salive, les poumons et les sécrétions bronchiques, la prostate et le liquide séminal, les sécrétions vaginales, l'os.\r\n\r\nLa liaison aux protéines plasmatiques est de 66 % pour le sulfaméthoxazole et 45 % pour le triméthoprime.\r\n\r\nLe sulfaméthoxazole et le triméthoprime traversent le placenta et passent dans le lait maternel (Cf. rubrique \"Grossesse et allaitement\").\r\n\r\n\r\n* Biotransformation\r\n\r\nDans le sang et l'urine on retrouve le sulfaméthoxazole sous sa forme initiale et sous forme métabolisée (environ 85 %) ; les métabolites seraient bactériologiquement inactifs.\r\n\r\nOn retrouve le triméthoprime principalement sous forme non métabolisée ainsi que métabolisée (25 % environ) ; certains dérivés seraient bactériologiquement actifs.\r\n\r\nLe triméthoprime est un inhibiteur du transporteur de cations organiques (OCT2), et un inhibiteur faible du CYP2C8. Le sulfaméthoxazole est un inhibiteur faible du CYP2C9.\r\n\r\n\r\n* Elimination\r\n\r\nL'élimination de ce médicament est essentiellement urinaire (80 % de la dose administrée en 72 heures) sous forme métabolisée et sous forme inchangée (20 % pour le sulfaméthoxazole et 50 % pour le triméthoprime). Une partie est excrétée par la bile où les concentrations sont proches des concentrations plasmatiques mais, étant donné la réabsorption intestinale, seule une faible fraction de triméthoprime (4 %) est éliminée dans les fécès.\r\n\r\nLe sulfaméthoxazole et le triméthoprime sont hémodialysables.\r\n\r\n\r\n* Pharmacocinétique dans des populations particulières\r\n\r\n- Insuffisance rénale\r\nChez les patients présentant une insuffisance rénale sévère (clairance de la créatinine comprise entre 15 et 30 ml/min), les demi-vies d'élimination du triméthoprime et du sulfaméthoxazole sont augmentées et nécessitent un ajustement de la dose administrée.\r\n\r\n- Enfants (jusqu'à l'âge de 12 ans)\r\nLa pharmacocinétique des deux composants de ce médicament, le triméthoprime et le sulfaméthoxazole, dans la population pédiatrique avec une fonction rénale normale, est âge-dépendante. L'élimination de ce médicament est réduite chez les nouveau-nés au cours des deux premiers mois de la vie, celle-ci est augmentée par la suite, la fois pour le triméthoprime et le sulfaméthoxazole, avec une élimination plus élevée, donc une demi-vie d'élimination plus courte. Les différences sont plus importantes chez les nourrissons (> 1,7 mois jusqu'à 24 mois) et diminuent avec l'âge, en comparaison aux jeunes enfants (de 1 an à 3,6 ans), aux enfants (7,5 ans et < 10 ans), et aux adultes.",
        },
      ],
      etiology: [
        {
          intro:
            "Les concentrations critiques séparent les souches sensibles des souches de sensibilité intermédiaire et ces dernières, des résistantes :\r\n\r\nTriméthoprime - sulfaméthoxasole : S < ou = 2 mg/litre et R > 8 mg/litre\r\n\r\nLa prévalence de la résistance peut varier en fonction de la géographie et du temps pour certaines espèces. Il est donc utile de disposer d'informations sur la prévalence de la résistance locale, surtout pour le traitement s'infections sévères. Ces données ne peuvent apporter qu'une orientation sur les probabilités de la sensibilité d'une souche bactérienne à cet antibiotique.\r\n\r\nLorsque la variabilité de la prévalence de la résistance en France est connue pour une espèce bactérienne, elle est indiquée dans la liste ci-dessous [Catégories / Fréquence de résistance acquise en France (> 10 %) (valeurs extrêmes)].",
          inconsistently_sensitive: null,
          usually_sensitive: {
            agent: [
              {
                name: "ISOSPORA BELLI",
                percentage: null,
                category: "PARASITOLOGIE",
              },
              {
                name: "PNEUMOCYSTIS JIROVECII",
                percentage: null,
                category: "PARASITOLOGIE",
              },
              {
                name: "TOXOPLASMA",
                percentage: null,
                category: "PARASITOLOGIE",
              },
              {
                name: "STAPHYLOCOCCUS AUREUS",
                percentage: null,
                category: "BACTERIES GRAM POSITIF AEROBIES",
              },
              {
                name: "STAPHYLOCOCCUS COAGULASE NEGAT.",
                percentage: "5 - 40 %",
                category: "BACTERIES GRAM POSITIF AEROBIES",
              },
              {
                name: "STREPTOCOCCUS sp",
                percentage: "5 - 20 %",
                category: "BACTERIES GRAM POSITIF AEROBIES",
              },
              {
                name: "STREPTOCOCCUS PNEUMONIAE",
                percentage: "10 - 50 %",
                category: "BACTERIES GRAM POSITIF AEROBIES",
              },
              {
                name: "ENTEROCOCCUS sp",
                percentage: null,
                category: "BACTERIES GRAM POSITIF AEROBIES",
              },
              {
                name: "CORYNEBACTERIUM sp",
                percentage: null,
                category: "BACTERIES GRAM POSITIF AEROBIES",
              },
              {
                name: "LISTERIA sp",
                percentage: null,
                category: "BACTERIES GRAM POSITIF AEROBIES",
              },
              {
                name: "ESCHERICHIA COLI",
                percentage: "5 - 30 %",
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "PROTEUS sp",
                percentage: "20 - 40 %",
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "MORGANELLA sp",
                percentage: "10 - 20 %",
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "KLEBSIELLA sp",
                percentage: "10 - 40 %",
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "ENTEROBACTER sp",
                percentage: "10 - 40 %",
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "SALMONELLA sp",
                percentage: null,
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "SHIGELLA sp",
                percentage: null,
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "PASTEURELLA sp",
                percentage: null,
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "CITROBACTER FREUNDII",
                percentage: "10 - 40 %",
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "HAEMOPHILUS sp",
                percentage: "5 - 15 %",
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "PEPTOSTREPTOCOCCUS sp",
                percentage: null,
                category: "BACTERIES GRAM POSITIF ANAEROBIES",
              },
              {
                name: "MYCOBACTERIES sp",
                percentage: null,
                category: "BACTERIES AUTRES",
              },
              {
                name: "BORRELIA sp",
                percentage: null,
                category: "BACTERIES AUTRES",
              },
              {
                name: "SPIROCHETES sp",
                percentage: null,
                category: "BACTERIES AUTRES",
              },
            ],
            comment: [],
            text: ["Mycobacterium (sauf tuberculosis, avium intracellulare)"],
          },
          moderate_sensitive: null,
          resistant: {
            agent: [
              {
                name: "PSEUDOMONAS sp",
                category: "BACTERIES GRAM NEGATIF AEROBIES",
                percentage: null,
              },
              {
                name: "MYCOBACTERIUM TUBERCULOSIS",
                category: "BACTERIES AUTRES",
                percentage: null,
              },
              {
                name: "MYCOBACTERIUM AVIUM INTRACELLULARE",
                category: "BACTERIES AUTRES",
                percentage: null,
              },
            ],
            comment: [],
            text: [
              "L'association sulfamides-triméthoprime présente un effet fortement synergique vis à vis de la plupart des bactéries, y compris les souches résistantes à l'un des deux produits. Ceci explique l'activité de l'association sur les Nocardia et les Stenotrophomonas mais aussi sur Escherichia coli ayant une résistance acquise aux sulfamides (résistance même de haut niveau).\r\n\r\nCette synergie est maximale dans le rapport de leur CMI, c'est à dire 1/20 triméthoprime-sulfamide pour les entérobactéries et staphylocoques. En revanche, vis à vis des bactéries naturellement résistantes au triméthoprime (Nocardia, Stenotrophomonas, Neisseria) le rapport optimal doit être de 1/1 ou 2/1 triméthoprime-sulfamide.",
            ],
          },
        },
      ],
    },
    {
      form: "solution injectable/pour perfusion",
      dose: null,
      pharmacodynamics: [
        {
          description:
            "Classe pharmacothérapeutique : ASSOCIATION DE SULFAMIDE ET TRIMETHOPRIME, code ATC : J01EE01.\r\n\r\nCe médicament est une association d'un sulfamide, le sulfaméthoxazole, à une diaminopyrimidine, le triméthoprime, dans la proportion de 5/1.\r\n\r\nLe sulfaméthoxazole et le triméthoprime agissent en synergie dans les proportions incluses entre : 100/1 et 10/1.",
        },
      ],
      pharmacokinetics: [
        {
          description:
            "* Distribution\r\n\r\nAprès administration par voie intraveineuse d'une seule dose de ce médicament (400 mg de sulfaméthoxazole et 80 mg de triméthoprime), les concentrations plasmatiques maximales sont de 40 microgrammes/ml pour le sulfaméthoxazole et d'environ 1 microgramme/ml pour le triméthoprime.\r\n\r\nLa demi-vie du sulfaméthoxazole est de 9 - 11 heures et celle du triméthoprime de 10 - 12 heures ; la demi-vie des deux constituants est plus courte chez l'enfant.\r\n\r\nCe médicament diffuse rapidement dans les tissus et les sécrétions : le liquide céphalo-rachidien, l'oreille moyenne, les amygdales et la salive, les poumons et les sécrétions bronchiques, la prostate et le liquide séminal, les sécrétions vaginales, l'os.\r\n\r\nLa liaison aux protéines plasmatiques est de 66 % pour le sulfaméthoxazole et 45 % pour le triméthoprime.\r\n\r\nLe sulfaméthoxazole et le triméthoprime traversent le placenta et passent dans le lait maternel (Cf. rubrique \"Grossesse et allaitement\").\r\n\r\n\r\n* Biotransformation\r\n\r\nDans le sang et l'urine on retrouve le sulfaméthoxazole sous sa forme initiale et sous forme métabolisée (environ 85 %) ; les métabolites seraient bactériologiquement inactifs. On retrouve le triméthoprime principalement sous forme non métabolisée ainsi que métabolisée (25 % environ) ; certains dérivés seraient bactériologiquement actifs.\r\n\r\nLe triméthoprime est un inhibiteur du transporteur de cations organiques (OCT2), et un inhibiteur faible du CYP2C8. Le sulfaméthoxazole est un inhibiteur faible du CYP2C9.\r\n\r\n\r\n* Elimination\r\n\r\nL'élimination de ce médicament est essentiellement urinaire (80 % de la dose administrée en 72 heures) sous forme métabolisée et sous forme inchangée (20 % pour le sulfaméthoxazole et 50 % pour le triméthoprime). Une partie est excrétée par la bile où les concentrations sont proches des concentrations plasmatiques mais, étant donné la réabsorption intestinale, seule une faible fraction de triméthoprime (4 %) est éliminée dans les fécès.\r\n\r\nLe sulfaméthoxazole et le triméthoprime sont hémodialysables.\r\n\r\n\r\n* Pharmacocinétique dans des populations particulières\r\n\r\n- Insuffisance rénale\r\nChez les patients présentant une insuffisance rénale sévère (clairance de la créatinine comprise entre 15 et 30 ml/min), les demi-vies d'élimination du triméthoprime et du sulfaméthoxazole sont augmentées et nécessitent un ajustement de la dose administrée.\r\n\r\n- Enfants (jusqu'à l'âge de 12 ans)\r\nLa pharmacocinétique des deux composants de ce médicament, le triméthoprime et le sulfaméthoxazole, dans la population pédiatrique avec une fonction rénale normale, est âge-dépendante. L'élimination de ce médicament, est réduite chez les nouveau-nés au cours des deux premiers mois de la vie, celle-ci est augmentée par la suite, à la fois pour le triméthoprime et le sulfaméthoxazole, avec une élimination plus élevée, donc une demi-vie d'élimination plus courte. Les différences sont plus importantes chez les nourrissons (> 1,7 mois jusqu'à 24 mois) et diminuent avec l'âge, en comparaison aux jeunes enfants (de 1 an à 3,6 ans), aux enfants (7,5 ans et < 10 ans) et aux adultes.",
        },
      ],
      etiology: [
        {
          intro:
            "Les concentrations critiques séparent les souches sensibles des souches de sensibilité intermédiaire et ces dernières, des résistantes :\r\n\r\nTriméthoprime - sulfaméthoxasole : S < ou = 2 mg/litre et R > 8 mg/litre\r\n\r\nLa prévalence de la résistance peut varier en fonction de la géographie et du temps pour certaines espèces. Il est donc utile de disposer d'informations sur la prévalence de la résistance locale, surtout pour le traitement s'infections sévères. Ces données ne peuvent apporter qu'une orientation sur les probabilités de la sensibilité d'une souche bactérienne à cet antibiotique.\r\n\r\nLorsque la variabilité de la prévalence de la résistance en France est connue pour une espèce bactérienne, elle est indiquée dans la liste ci-dessous [Catégories / Fréquence de résistance acquise en France (> 10 %) (valeurs extrêmes)].",
          inconsistently_sensitive: null,
          usually_sensitive: {
            agent: [
              {
                name: "ISOSPORA BELLI",
                percentage: null,
                category: "PARASITOLOGIE",
              },
              {
                name: "PNEUMOCYSTIS JIROVECII",
                percentage: null,
                category: "PARASITOLOGIE",
              },
              {
                name: "TOXOPLASMA",
                percentage: null,
                category: "PARASITOLOGIE",
              },
              {
                name: "STAPHYLOCOCCUS AUREUS",
                percentage: null,
                category: "BACTERIES GRAM POSITIF AEROBIES",
              },
              {
                name: "STAPHYLOCOCCUS COAGULASE NEGAT.",
                percentage: "5 - 40 %",
                category: "BACTERIES GRAM POSITIF AEROBIES",
              },
              {
                name: "STREPTOCOCCUS sp",
                percentage: "5 - 20 %",
                category: "BACTERIES GRAM POSITIF AEROBIES",
              },
              {
                name: "STREPTOCOCCUS PNEUMONIAE",
                percentage: "10 - 50 %",
                category: "BACTERIES GRAM POSITIF AEROBIES",
              },
              {
                name: "ENTEROCOCCUS sp",
                percentage: null,
                category: "BACTERIES GRAM POSITIF AEROBIES",
              },
              {
                name: "CORYNEBACTERIUM sp",
                percentage: null,
                category: "BACTERIES GRAM POSITIF AEROBIES",
              },
              {
                name: "LISTERIA sp",
                percentage: null,
                category: "BACTERIES GRAM POSITIF AEROBIES",
              },
              {
                name: "ESCHERICHIA COLI",
                percentage: "5 - 30 %",
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "PROTEUS sp",
                percentage: "20 - 40 %",
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "MORGANELLA sp",
                percentage: "10 - 20 %",
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "KLEBSIELLA sp",
                percentage: "10 - 40 %",
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "ENTEROBACTER sp",
                percentage: "10 - 40 %",
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "SALMONELLA sp",
                percentage: null,
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "SHIGELLA sp",
                percentage: null,
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "PASTEURELLA sp",
                percentage: null,
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "CITROBACTER FREUNDII",
                percentage: "10 - 40 %",
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "HAEMOPHILUS sp",
                percentage: "5 - 15 %",
                category: "BACTERIES GRAM NEGATIF AEROBIES",
              },
              {
                name: "PEPTOSTREPTOCOCCUS sp",
                percentage: null,
                category: "BACTERIES GRAM POSITIF ANAEROBIES",
              },
              {
                name: "MYCOBACTERIES sp",
                percentage: null,
                category: "BACTERIES AUTRES",
              },
              {
                name: "BORRELIA sp",
                percentage: null,
                category: "BACTERIES AUTRES",
              },
              {
                name: "SPIROCHETES sp",
                percentage: null,
                category: "BACTERIES AUTRES",
              },
            ],
            comment: [],
            text: ["Mycobacterium (sauf tuberculosis, avium intracellulare)"],
          },
          moderate_sensitive: null,
          resistant: {
            agent: [
              {
                name: "PSEUDOMONAS sp",
                category: "BACTERIES GRAM NEGATIF AEROBIES",
                percentage: null,
              },
              {
                name: "MYCOBACTERIUM TUBERCULOSIS",
                category: "BACTERIES AUTRES",
                percentage: null,
              },
              {
                name: "MYCOBACTERIUM AVIUM INTRACELLULARE",
                category: "BACTERIES AUTRES",
                percentage: null,
              },
            ],
            comment: [],
            text: [
              "L'association sulfamides-triméthoprime présente un effet fortement synergique vis à vis de la plupart des bactéries, y compris les souches résistantes à l'un des deux produits. Ceci explique l'activité de l'association sur les Nocardia et les Stenotrophomonas mais aussi sur Escherichia coli ayant une résistance acquise aux sulfamides (résistance même de haut niveau).\r\n\r\nCette synergie est maximale dans le rapport de leur CMI, c'est à dire 1/20 triméthoprime-sulfamide pour les entérobactéries et staphylocoques. En revanche, vis à vis des bactéries naturellement résistantes au triméthoprime (Nocardia, Stenotrophomonas, Neisseria) le rapport optimal doit être de 1/1 ou 2/1 triméthoprime-sulfamide.",
            ],
          },
        },
      ],
    },
  ],
};

export const mockBactrimPharmacology: FormDoseAndPharmacology[] = [
  {
    dose: "40 mg/ml + 8 mg/ml",
    form: "suspension buvable",
    pharmacodynamics:
      "Classe pharmacothérapeutique : Antibactériens à usage systémique, code ATC : J01EE01.\r\n\r\n\r\n* Mécanisme d'action\r\n\r\nLe sulfaméthoxazole est un sulfamide qui inhibe de manière compétitive la synthèse de l'acide folique nécessaire à la croissance bactérienne. Le triméthoprime est un dérivé des pyrimidines qui inhibe spécifiquement la dihydrofolate réductase dans les micro-organismes. L'association d'un sulfamide et du triméthoprime bloque deux étapes consécutives du métabolisme de l'acide folique, interrompant ainsi la synthèse de la purine, de l'ARN et de l'ADN par les micro-organismes. Cette forme de blocage séquentiel entraîne un effet bactéricide in vitro de l'association à des concentrations auxquelles les substances actives à elles seules n'exercent qu'un effet bactériostatique. Le mécanisme d'action interfère avec le développement d'une résistance, ce qui signifie que l'association est généralement efficace contre les organismes résistants à l'une ou l'autre des deux substances.\r\n\r\n\r\n* Résistance\r\n\r\nUne résistance survient (1-10 %) chez les streptocoques, les pneumocoques et les staphylocoques. Elle est fréquente (> 10 %) chez Haemophilus influenzae et les bactéries intestinales à Gram négatif.\r\n\r\nUne résistance croisée existe avec le triméthoprime et les sulfamides, mais pas avec d'autres antibiotiques.\r\n\r\nMécanisme de résistance :\r\n\r\nUne résistance acquise, portée par des plasmides, à la fois aux sulfamides et au triméthoprime survient principalement chez les espèces de bactéries intestinales à Gram négatif. La résistance aux sulfamides est fondée sur la production d'une autre dihydroptéroate synthétase qui est insensible aux sulfamides, tandis que la résistance au triméthoprime est habituellement due à la production d'une autre dihydrofolate réductase résistante au triméthoprime. On trouve des isolats résistants aux sulfamides seuls ou à la fois aux sulfamides et au triméthoprime, alors que les isolats résistants au triméthoprime et sensibles aux sulfamides sont très peu courants.\r\n\r\nDéveloppement de la résistance :\r\n\r\nLa prévalence de la résistance peut varier en fonction de la géographie et du temps pour certaines espèces. Il est donc utile de disposer d'informations locales sur la résistance, surtout pour le traitement d'infections sévères. Si nécessaire, il convient d'obtenir un avis spécialisé, notamment lorsque la prévalence locale de la résistance est telle que l'intérêt du médicament peut être mis en cause pour certains types d'infections.\r\n\r\nPoints de rupture pour la détermination de la résistance\r\n\r\nLes concentrations minimales inhibitrices (CMI) d'après l'EUCAST (European Committee on Antimicrobial Susceptibility Testing) sont les suivantes :\r\n\r\nCMI (microgrammes/mL) (a)\r\n\r\nEnterobacteriaceae\r\nSensible < ou = : 2\r\nRésistant > : 4\r\n\r\nAcinetobacter spp.\r\nSensible < ou = : 2\r\nRésistant > : 4\r\n\r\nStenotrophomonas maltophila (b)\r\nSensible < ou = : 0,001\r\nRésistant > : 4\r\n\r\nStaphylococcus spp.\r\nSensible < ou = : 2\r\nRésistant > : 4\r\n\r\nEnterococcus spp (c)\r\nSensible < ou = : -\r\nRésistant > : -\r\n\r\nStreptococcus pneumoniae\r\nSensible < ou = : 1\r\nRésistant > : 2\r\n\r\nStreptococcus groups A, B, C and G\r\nSensible < ou = : 1\r\nRésistant > : 2\r\n\r\nHaemophilus influenzae\r\nSensible < ou = : 0,5\r\nRésistant > : 1\r\n\r\nListeria monocytogenes\r\nSensible < ou = : 0,06\r\nRésistant > : 0,06\r\n\r\nPasteurella multocida\r\nSensible < ou = : 0,25\r\nRésistant > : 0,25\r\n\r\nMoraxella catarrhalis\r\nSensible < ou = : 0,5\r\nRésistant > : 1\r\n\r\nKingella kingae\r\nSensible < ou = : 0,25\r\nRésistant > : 0,25\r\n\r\nAeromonas spp\r\nSensible < ou = : 2\r\nRésistant > : 4\r\n\r\nBurkholderia pseudomallei\r\nSensible < ou = : 0,001\r\nRésistant > : 4\r\n\r\n(a) Le triméthoprime:sulfaméthoxazole dans le rapport de 1:19. Les valeurs des points de rupture sont exprimées sous forme de concentration de triméthoprime.\r\n(b) Les points de rupture sont fondés sur un traitement à haute dose, > ou = 240 mg de triméthoprime et 1,2 grammes de sulfaméthoxazole co-administrés deux fois par jour.\r\n(c) L'activité du triméthoprime et de l'association trimethoprime-sulfaméthoxazole sur les entérocoques est incertaine et il n'est pas possible de prédire le résultat clinique.\r\n\r\nSPECTRE D'ACTIVITE ANTIBACTERIENNE\r\n\r\nESPECES SENSIBLES\r\nStaphylococcus aureus et staphylocoques à coagulase négative\r\nStreptocoques, pneumocoques et entérocoques\r\nListeria\r\nMoraxella catarrhalis\r\nHaemophilus influenzae et parainfluenzae\r\nE. coli, Klebsiella, Enterobacter, Proteus, Morganella morganii, Citrobacter, Serratia et Hafnia\r\nSalmonella, Shigella\r\nStenotrophomonas maltophilia\r\n\r\nESPECES MODEREMENT SENSIBLES\r\nHaemophilus ducreyi\r\nProvidencia\r\nAcinetobacter\r\nAeromonas hydrophilia \r\n\r\nESPECES RESISTANTES\r\nPseudomonas\r\nLegionella\r\nBactéries anaérobies, y compris Clostridium difficile\r\nMycoplasma\r\n\r\nOutre son effet antibactérien, l'association triméthoprime-sulfaméthoxazole est efficace contre Pneumocystis jirovecii.",
    pharmacokinetics:
      "* Absorption\r\n\r\nAprès administration orale, le sulfaméthoxazole et le triméthoprime sont rapidement et entièrement absorbés dans la partie supérieure du tractus gastro-intestinal. Les concentrations sériques de sulfaméthoxazole et de triméthoprime sont identiques, que les deux substances soient administrées en concomitance ou séparément. La concentration sérique maximale de ce médicament est atteinte en 2 à 4 heures après administration orale. La demi-vie est de 11 heures pour le sulfaméthoxazole et de 10 heures pour le triméthoprime. Les concentrations sériques des substances respectives après administration répétée sont de 6,5 (5,2 - 10,3) micromol/litre = 1,9 (1,5 - 3,0) microgrammes/mL (triméthoprime), 225 (150 - 300) micromol/litre = 56 (37,5 - 75) microgrammes/mL (sulfaméthoxazole). Ces concentrations sériques sont nettement supérieures aux CMI bactériennes actuelles.\r\n\r\n\r\n* Distribution\r\n\r\nLe volume de distribution est d'environ 1,6 litres/kg pour le triméthoprime et d'environ 0,2 litre/kg pour le sulfaméthoxazole. La liaison aux protéines plasmatiques atteint 37 % pour le triméthoprime et 62 % pour le sulfaméthoxazole.\r\n\r\nLe sulfaméthoxazole et le triméthoprime sont présents dans le sérum sous la forme libre, liée aux protéines et métabolisées. Le degré de liaison aux protéines pour le triméthoprime et le sulfaméthoxazole est de 45 % et 70 % respectivement. Les taux tissulaires de triméthoprime sont généralement plus élevés que les taux plasmatiques correspondants. Des concentrations particulièrement élevées sont retrouvées dans les poumons et les reins. Les concentrations de triméthoprime dans la bile, le liquide prostatique, la salive et les sécrétions bronchiques notamment sont supérieures aux concentrations plasmatiques correspondantes. Les concentrations présentes dans l'humeur aqueuse et le liquide céphalo-rachidien sont adéquates pour un effet antibactérien. La concentration de sulfaméthoxazole actif dans l'humeur aqueuse, la bile, le liquide céphalorachidien et les sécrétions bronchiques représente environ 30 % de la concentration plasmatique.\r\n\r\nChez l'être humain, le triméthoprime et le sulfaméthoxazole sont détectés dans les tissus fœtaux (placenta, foie, poumon), le sang du cordon ombilical et le liquide amniotique, ce qui signifie que ces deux substances traversent le placenta. La concentration fœtale de triméthoprime est généralement comparable à celle observée chez la mère, tandis que la concentration de sulfaméthoxazole est légèrement inférieure (Cf. rubrique \"Grossesse et allaitement\").\r\n\r\nLes deux substances sont excrétées dans le lait maternel. Les concentrations de triméthoprime dans le lait maternel sont généralement comparables aux concentrations mesurées dans le plasma maternel alors que celles de sulfaméthoxazole sont légèrement inférieures (Cf. rubrique \"Grossesse et allaitement\").\r\n\r\n\r\n* Métabolisme\r\n\r\nEnviron 30 % de la dose de triméthoprime sont métabolisés. Les résultats d'une étude in vitro avec des microsomes hépatiques humains montrent que le CYP3A4, le CYP1A2 et le CYP2C9 sont principalement responsables du métabolisme du triméthoprime. Les principaux métabolites du triméthoprime sont le 1-oxyde et le 3-oxyde, ainsi que les dérivés 3-hydroxyde et 4-hydroxyde. Certains métabolites ont une activité microbiologique.\r\n\r\nEnviron 80 % de la dose de sulfaméthoxazole sont métabolisés dans le foie, essentiellement en dérivé N4-acétyl (environ 40 % de la dose) et, dans une moindre mesure, par glucurono-conjugaison. Le sulfaméthoxazole est également métabolisé par la voie oxydative. La première étape de l'oxydation, qui conduit à la formation du dérivé hydroxylamine, est catalysée par le CYP2C9.\r\n\r\n\r\n* Elimination\r\n\r\nLa demi-vie des deux substances est semblable (10 heures en moyenne pour le triméthoprime et 11 heures pour le sulfaméthoxazole).\r\n\r\nLe triméthoprime et le sulfaméthoxazole sont éliminés par les reins par filtration glomérulaire ; le triméthoprime est également éliminé par sécrétion tubulaire. Vingt pour cent du sulfaméthoxazole sont éliminés sous forme de substance active inchangée, 60 % sont présents sous forme acétylée et environ 15 % sous forme glucuronoconjuguée. Environ deux tiers du triméthoprime sont excrétés sous forme active inchangée. La clairance plasmatique totale du triméthoprime est de 1,9 mL/min/kg et celle du sulfaméthoxazole est de 0,32 mL/min/kg. Les deux substances sont retrouvées dans une faible proportion dans les fèces.\r\n\r\n\r\n* Pharmacocinétique pour certains groupes de patients\r\n\r\n- Population pédiatrique\r\nLa pharmacocinétique des deux composants de ce médicament, le triméthoprime et le sulfaméthoxazole, dépend de l'âge dans la population pédiatrique présentant une fonction rénale normale. Tandis que l'élimination du triméthoprime et du sulfaméthoxazole est réduite chez les nouveau-nés durant les deux premiers mois de la vie, tous deux présentent ensuite une élimination accrue avec une clairance corporelle plus élevée et une demi-vie d'élimination plus courte. Les différences sont les plus marquées chez les nourrissons (> 1,7 mois à 24 mois) et diminuent avec l'âge, par comparaison avec les jeunes enfants (de 1 an à 3,6 ans), les enfants (de 7,5 ans à < 10 ans) et les adultes (Cf. rubrique \"Posologie et mode d'administration\").\r\n\r\n- Patients âgés\r\nLe triméthoprime étant éliminé dans une large mesure par voie rénale sous forme inchangée et compte tenu de la diminution physiologique de la clairance de la créatinine avec l'âge, on peut s'attendre à une diminution de la clairance rénale et de la clairance totale du triméthoprime. La pharmacocinétique du sulfaméthoxazole devrait être moins affectée par l'avancement en âge, car la clairance rénale du sulfaméthoxazole ne représente que 20 % de sa clairance totale.\r\n\r\n- Patients présentant une altération de la fonction rénale\r\nChez les patients souffrant d'une altération sévère de la fonction rénale (clairance de la créatinine de 15-30 mL/min), la demi-vie des deux substances est prolongée, nécessitant une adaptation posologique (Cf. rubrique \"Posologie et mode d'administration\").\r\n\r\nUne dialyse péritonéale ambulatoire intermittente ou continue n'a pas d'influence significative sur l'élimination du triméthoprime et du sulfaméthoxazole. Le triméthoprime et le sulfaméthoxazole sont éliminés en quantité non négligeable pendant l'hémodialyse et l'hémofiltration. Chez les enfants présentant une altération de la fonction rénale (clairance de la créatinine < 30 mL/min), la clairance du triméthoprime est réduite et sa demi-vie est prolongée. La dose de triméthoprime et de sulfaméthoxazole doit être adaptée à la fonction rénale chez ces patients.\r\n\r\n- Patients présentant une altération de la fonction hépatique\r\nLa pharmacocinétique du triméthoprime et du sulfaméthoxazole chez les patients présentant une altération modérée ou sévère de la fonction rénale n'est pas considérée comme significativement différente de celle observée chez les sujets sains.\r\n\r\n- Patients atteints de mucoviscidose\r\nLa clairance rénale du triméthoprime et la clairance métabolique du sulfaméthoxazole sont accrues chez les patients atteints de mucoviscidose. En conséquence, la clairance plasmatique totale est augmentée et la demi-vie est réduite pour les deux substances.",
    etiology: {
      intro:
        "Les concentrations critiques séparent les souches sensibles des souches de sensibilité intermédiaire et ces dernières, des résistantes :\r\n\r\nTriméthoprime - sulfaméthoxasole : S < ou = 2 mg/litre et R > 8 mg/litre\r\n\r\nLa prévalence de la résistance peut varier en fonction de la géographie et du temps pour certaines espèces. Il est donc utile de disposer d'informations sur la prévalence de la résistance locale, surtout pour le traitement s'infections sévères. Ces données ne peuvent apporter qu'une orientation sur les probabilités de la sensibilité d'une souche bactérienne à cet antibiotique.\r\n\r\nLorsque la variabilité de la prévalence de la résistance en France est connue pour une espèce bactérienne, elle est indiquée dans la liste ci-dessous [Catégories / Fréquence de résistance acquise en France (> 10 %) (valeurs extrêmes)].",
      usuallySensitive: {
        agent: [
          {
            category: "PARASITOLOGIE",
            name: "ISOSPORA BELLI",
            percentage: null,
          },
          {
            category: "PARASITOLOGIE",
            name: "PNEUMOCYSTIS JIROVECII",
            percentage: null,
          },
          {
            category: "PARASITOLOGIE",
            name: "TOXOPLASMA",
            percentage: null,
          },
          {
            category: "BACTERIES GRAM POSITIF AEROBIES",
            name: "STAPHYLOCOCCUS AUREUS",
            percentage: null,
          },
          {
            category: "BACTERIES GRAM POSITIF AEROBIES",
            name: "STAPHYLOCOCCUS COAGULASE NEGAT.",
            percentage: "5 - 40 %",
          },
          {
            category: "BACTERIES GRAM POSITIF AEROBIES",
            name: "STREPTOCOCCUS sp",
            percentage: "5 - 20 %",
          },
          {
            category: "BACTERIES GRAM POSITIF AEROBIES",
            name: "STREPTOCOCCUS PNEUMONIAE",
            percentage: "10 - 50 %",
          },
          {
            category: "BACTERIES GRAM POSITIF AEROBIES",
            name: "ENTEROCOCCUS sp",
            percentage: null,
          },
          {
            category: "BACTERIES GRAM POSITIF AEROBIES",
            name: "CORYNEBACTERIUM sp",
            percentage: null,
          },
          {
            category: "BACTERIES GRAM POSITIF AEROBIES",
            name: "LISTERIA sp",
            percentage: null,
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "ESCHERICHIA COLI",
            percentage: "5 - 30 %",
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "PROTEUS sp",
            percentage: "20 - 40 %",
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "MORGANELLA sp",
            percentage: "10 - 20 %",
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "KLEBSIELLA sp",
            percentage: "10 - 40 %",
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "ENTEROBACTER sp",
            percentage: "10 - 40 %",
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "SALMONELLA sp",
            percentage: null,
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "SHIGELLA sp",
            percentage: null,
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "PASTEURELLA sp",
            percentage: null,
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "CITROBACTER FREUNDII",
            percentage: "10 - 40 %",
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "HAEMOPHILUS sp",
            percentage: "5 - 15 %",
          },
          {
            category: "BACTERIES GRAM POSITIF ANAEROBIES",
            name: "PEPTOSTREPTOCOCCUS sp",
            percentage: null,
          },
          {
            category: "BACTERIES AUTRES",
            name: "MYCOBACTERIES sp",
            percentage: null,
          },
          {
            category: "BACTERIES AUTRES",
            name: "BORRELIA sp",
            percentage: null,
          },
          {
            category: "BACTERIES AUTRES",
            name: "SPIROCHETES sp",
            percentage: null,
          },
        ],
        comment: [],
        text: ["Mycobacterium (sauf tuberculosis, avium intracellulare)"],
      },
      moderateSensitive: null,
      inconsistentlySensitive: null,
      resistantSensitive: {
        agent: [
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "PSEUDOMONAS sp",
            percentage: null,
          },
          {
            category: "BACTERIES AUTRES",
            name: "MYCOBACTERIUM TUBERCULOSIS",
            percentage: null,
          },
          {
            category: "BACTERIES AUTRES",
            name: "MYCOBACTERIUM AVIUM INTRACELLULARE",
            percentage: null,
          },
        ],
        comment: [],
        text: [
          "L'association sulfamides-triméthoprime présente un effet fortement synergique vis à vis de la plupart des bactéries, y compris les souches résistantes à l'un des deux produits. Ceci explique l'activité de l'association sur les Nocardia et les Stenotrophomonas mais aussi sur Escherichia coli ayant une résistance acquise aux sulfamides (résistance même de haut niveau).\r\n\r\nCette synergie est maximale dans le rapport de leur CMI, c'est à dire 1/20 triméthoprime-sulfamide pour les entérobactéries et staphylocoques. En revanche, vis à vis des bactéries naturellement résistantes au triméthoprime (Nocardia, Stenotrophomonas, Neisseria) le rapport optimal doit être de 1/1 ou 2/1 triméthoprime-sulfamide.",
        ],
      },
    },
  },
  {
    dose: null,
    form: "comprimé",
    pharmacodynamics:
      "Classe pharmacothérapeutique : ASSOCIATION DE SULFAMIDE ET TRIMETHOPRIME, code ATC : J01EE01.\r\n\r\nCe médicament est une association d'un sulfamide, le sulfaméthoxazole, à une diaminopyrimidine, le triméthoprime, dans la proportion de 5/1.\r\n\r\nLe sulfaméthoxazole et le triméthoprime agissent en synergie dans les proportions incluses entre : 100/1 et 10/1.",
    pharmacokinetics:
      "* Absorption\r\n\r\nAdministrés par voie orale, le sulfaméthoxazole et le triméthoprime sont rapidement absorbés à 90 %. Les concentrations plasmatiques sont atteintes en 2 à 4 heures.\r\n\r\n\r\n* Distribution\r\n\r\nAprès administration orale d'une seule dose de l'association triméthoprime-sulfaméthoxazole comprimés adultes ou comprimés à dosage fort (800 mg de sulfaméthoxazole et 160 mg de triméthoprime), les concentrations plasmatiques maximales sont comprises entre 40 et 60 microgrammes/ml pour le sulfaméthoxazole et 1 à 2 microgrammes/ml pour le triméthoprime. Après administration orale d'une seule prise de 10 mg/kg de sulfaméthoxazole et de 2 mg/kg de triméthoprime, les concentrations plasmatiques maximales sont comprises entre 35 et 40 microgrammes/ml pour le sulfaméthoxazole et 0,5 microgramme/ml et 1 microgramme/ml pour le triméthoprime.\r\n\r\nLa demi-vie du sulfaméthoxazole est de 9 - 11 heures et celle du triméthoprime de 10 - 12 heures. Par rapport à l'adulte, la demi-vie plasmatique des deux constituants est plus courte chez l'enfant.\r\n\r\nCe médicament diffuse rapidement dans les tissus et dans les sécrétions : le liquide céphalo-rachidien, l'oreille moyenne, les amygdales et la salive, les poumons et les sécrétions bronchiques, la prostate et le liquide séminal, les sécrétions vaginales, l'os.\r\n\r\nLa liaison aux protéines plasmatiques est de 66 % pour le sulfaméthoxazole et 45 % pour le triméthoprime.\r\n\r\nLe sulfaméthoxazole et le triméthoprime traversent le placenta et passent dans le lait maternel (Cf. rubrique \"Grossesse et allaitement\").\r\n\r\n\r\n* Biotransformation\r\n\r\nDans le sang et l'urine on retrouve le sulfaméthoxazole sous sa forme initiale et sous forme métabolisée (environ 85 %) ; les métabolites seraient bactériologiquement inactifs.\r\n\r\nOn retrouve le triméthoprime principalement sous forme non métabolisée ainsi que métabolisée (25 % environ) ; certains dérivés seraient bactériologiquement actifs.\r\n\r\nLe triméthoprime est un inhibiteur du transporteur de cations organiques (OCT2), et un inhibiteur faible du CYP2C8. Le sulfaméthoxazole est un inhibiteur faible du CYP2C9.\r\n\r\n\r\n* Elimination\r\n\r\nL'élimination de ce médicament est essentiellement urinaire (80 % de la dose administrée en 72 heures) sous forme métabolisée et sous forme inchangée (20 % pour le sulfaméthoxazole et 50 % pour le triméthoprime). Une partie est excrétée par la bile où les concentrations sont proches des concentrations plasmatiques mais, étant donné la réabsorption intestinale, seule une faible fraction de triméthoprime (4 %) est éliminée dans les fécès.\r\n\r\nLe sulfaméthoxazole et le triméthoprime sont hémodialysables.\r\n\r\n\r\n* Pharmacocinétique dans des populations particulières\r\n\r\n- Insuffisance rénale\r\nChez les patients présentant une insuffisance rénale sévère (clairance de la créatinine comprise entre 15 et 30 ml/min), les demi-vies d'élimination du triméthoprime et du sulfaméthoxazole sont augmentées et nécessitent un ajustement de la dose administrée.\r\n\r\n- Enfants (jusqu'à l'âge de 12 ans)\r\nLa pharmacocinétique des deux composants de ce médicament, le triméthoprime et le sulfaméthoxazole, dans la population pédiatrique avec une fonction rénale normale, est âge-dépendante. L'élimination de ce médicament est réduite chez les nouveau-nés au cours des deux premiers mois de la vie, celle-ci est augmentée par la suite, la fois pour le triméthoprime et le sulfaméthoxazole, avec une élimination plus élevée, donc une demi-vie d'élimination plus courte. Les différences sont plus importantes chez les nourrissons (> 1,7 mois jusqu'à 24 mois) et diminuent avec l'âge, en comparaison aux jeunes enfants (de 1 an à 3,6 ans), aux enfants (7,5 ans et < 10 ans), et aux adultes.",
    etiology: {
      intro:
        "Les concentrations critiques séparent les souches sensibles des souches de sensibilité intermédiaire et ces dernières, des résistantes :\r\n\r\nTriméthoprime - sulfaméthoxasole : S < ou = 2 mg/litre et R > 8 mg/litre\r\n\r\nLa prévalence de la résistance peut varier en fonction de la géographie et du temps pour certaines espèces. Il est donc utile de disposer d'informations sur la prévalence de la résistance locale, surtout pour le traitement s'infections sévères. Ces données ne peuvent apporter qu'une orientation sur les probabilités de la sensibilité d'une souche bactérienne à cet antibiotique.\r\n\r\nLorsque la variabilité de la prévalence de la résistance en France est connue pour une espèce bactérienne, elle est indiquée dans la liste ci-dessous [Catégories / Fréquence de résistance acquise en France (> 10 %) (valeurs extrêmes)].",
      usuallySensitive: {
        agent: [
          {
            category: "PARASITOLOGIE",
            name: "ISOSPORA BELLI",
            percentage: null,
          },
          {
            category: "PARASITOLOGIE",
            name: "PNEUMOCYSTIS JIROVECII",
            percentage: null,
          },
          {
            category: "PARASITOLOGIE",
            name: "TOXOPLASMA",
            percentage: null,
          },
          {
            category: "BACTERIES GRAM POSITIF AEROBIES",
            name: "STAPHYLOCOCCUS AUREUS",
            percentage: null,
          },
          {
            category: "BACTERIES GRAM POSITIF AEROBIES",
            name: "STAPHYLOCOCCUS COAGULASE NEGAT.",
            percentage: "5 - 40 %",
          },
          {
            category: "BACTERIES GRAM POSITIF AEROBIES",
            name: "STREPTOCOCCUS sp",
            percentage: "5 - 20 %",
          },
          {
            category: "BACTERIES GRAM POSITIF AEROBIES",
            name: "STREPTOCOCCUS PNEUMONIAE",
            percentage: "10 - 50 %",
          },
          {
            category: "BACTERIES GRAM POSITIF AEROBIES",
            name: "ENTEROCOCCUS sp",
            percentage: null,
          },
          {
            category: "BACTERIES GRAM POSITIF AEROBIES",
            name: "CORYNEBACTERIUM sp",
            percentage: null,
          },
          {
            category: "BACTERIES GRAM POSITIF AEROBIES",
            name: "LISTERIA sp",
            percentage: null,
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "ESCHERICHIA COLI",
            percentage: "5 - 30 %",
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "PROTEUS sp",
            percentage: "20 - 40 %",
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "MORGANELLA sp",
            percentage: "10 - 20 %",
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "KLEBSIELLA sp",
            percentage: "10 - 40 %",
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "ENTEROBACTER sp",
            percentage: "10 - 40 %",
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "SALMONELLA sp",
            percentage: null,
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "SHIGELLA sp",
            percentage: null,
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "PASTEURELLA sp",
            percentage: null,
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "CITROBACTER FREUNDII",
            percentage: "10 - 40 %",
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "HAEMOPHILUS sp",
            percentage: "5 - 15 %",
          },
          {
            category: "BACTERIES GRAM POSITIF ANAEROBIES",
            name: "PEPTOSTREPTOCOCCUS sp",
            percentage: null,
          },
          {
            category: "BACTERIES AUTRES",
            name: "MYCOBACTERIES sp",
            percentage: null,
          },
          {
            category: "BACTERIES AUTRES",
            name: "BORRELIA sp",
            percentage: null,
          },
          {
            category: "BACTERIES AUTRES",
            name: "SPIROCHETES sp",
            percentage: null,
          },
        ],
        comment: [],
        text: ["Mycobacterium (sauf tuberculosis, avium intracellulare)"],
      },
      moderateSensitive: null,
      inconsistentlySensitive: null,
      resistantSensitive: {
        agent: [
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "PSEUDOMONAS sp",
            percentage: null,
          },
          {
            category: "BACTERIES AUTRES",
            name: "MYCOBACTERIUM TUBERCULOSIS",
            percentage: null,
          },
          {
            category: "BACTERIES AUTRES",
            name: "MYCOBACTERIUM AVIUM INTRACELLULARE",
            percentage: null,
          },
        ],
        comment: [],
        text: [
          "L'association sulfamides-triméthoprime présente un effet fortement synergique vis à vis de la plupart des bactéries, y compris les souches résistantes à l'un des deux produits. Ceci explique l'activité de l'association sur les Nocardia et les Stenotrophomonas mais aussi sur Escherichia coli ayant une résistance acquise aux sulfamides (résistance même de haut niveau).\r\n\r\nCette synergie est maximale dans le rapport de leur CMI, c'est à dire 1/20 triméthoprime-sulfamide pour les entérobactéries et staphylocoques. En revanche, vis à vis des bactéries naturellement résistantes au triméthoprime (Nocardia, Stenotrophomonas, Neisseria) le rapport optimal doit être de 1/1 ou 2/1 triméthoprime-sulfamide.",
        ],
      },
    },
  },
  {
    dose: null,
    form: "solution injectable/pour perfusion",
    pharmacodynamics:
      "Classe pharmacothérapeutique : ASSOCIATION DE SULFAMIDE ET TRIMETHOPRIME, code ATC : J01EE01.\r\n\r\nCe médicament est une association d'un sulfamide, le sulfaméthoxazole, à une diaminopyrimidine, le triméthoprime, dans la proportion de 5/1.\r\n\r\nLe sulfaméthoxazole et le triméthoprime agissent en synergie dans les proportions incluses entre : 100/1 et 10/1.",
    pharmacokinetics:
      "* Distribution\r\n\r\nAprès administration par voie intraveineuse d'une seule dose de ce médicament (400 mg de sulfaméthoxazole et 80 mg de triméthoprime), les concentrations plasmatiques maximales sont de 40 microgrammes/ml pour le sulfaméthoxazole et d'environ 1 microgramme/ml pour le triméthoprime.\r\n\r\nLa demi-vie du sulfaméthoxazole est de 9 - 11 heures et celle du triméthoprime de 10 - 12 heures ; la demi-vie des deux constituants est plus courte chez l'enfant.\r\n\r\nCe médicament diffuse rapidement dans les tissus et les sécrétions : le liquide céphalo-rachidien, l'oreille moyenne, les amygdales et la salive, les poumons et les sécrétions bronchiques, la prostate et le liquide séminal, les sécrétions vaginales, l'os.\r\n\r\nLa liaison aux protéines plasmatiques est de 66 % pour le sulfaméthoxazole et 45 % pour le triméthoprime.\r\n\r\nLe sulfaméthoxazole et le triméthoprime traversent le placenta et passent dans le lait maternel (Cf. rubrique \"Grossesse et allaitement\").\r\n\r\n\r\n* Biotransformation\r\n\r\nDans le sang et l'urine on retrouve le sulfaméthoxazole sous sa forme initiale et sous forme métabolisée (environ 85 %) ; les métabolites seraient bactériologiquement inactifs. On retrouve le triméthoprime principalement sous forme non métabolisée ainsi que métabolisée (25 % environ) ; certains dérivés seraient bactériologiquement actifs.\r\n\r\nLe triméthoprime est un inhibiteur du transporteur de cations organiques (OCT2), et un inhibiteur faible du CYP2C8. Le sulfaméthoxazole est un inhibiteur faible du CYP2C9.\r\n\r\n\r\n* Elimination\r\n\r\nL'élimination de ce médicament est essentiellement urinaire (80 % de la dose administrée en 72 heures) sous forme métabolisée et sous forme inchangée (20 % pour le sulfaméthoxazole et 50 % pour le triméthoprime). Une partie est excrétée par la bile où les concentrations sont proches des concentrations plasmatiques mais, étant donné la réabsorption intestinale, seule une faible fraction de triméthoprime (4 %) est éliminée dans les fécès.\r\n\r\nLe sulfaméthoxazole et le triméthoprime sont hémodialysables.\r\n\r\n\r\n* Pharmacocinétique dans des populations particulières\r\n\r\n- Insuffisance rénale\r\nChez les patients présentant une insuffisance rénale sévère (clairance de la créatinine comprise entre 15 et 30 ml/min), les demi-vies d'élimination du triméthoprime et du sulfaméthoxazole sont augmentées et nécessitent un ajustement de la dose administrée.\r\n\r\n- Enfants (jusqu'à l'âge de 12 ans)\r\nLa pharmacocinétique des deux composants de ce médicament, le triméthoprime et le sulfaméthoxazole, dans la population pédiatrique avec une fonction rénale normale, est âge-dépendante. L'élimination de ce médicament, est réduite chez les nouveau-nés au cours des deux premiers mois de la vie, celle-ci est augmentée par la suite, à la fois pour le triméthoprime et le sulfaméthoxazole, avec une élimination plus élevée, donc une demi-vie d'élimination plus courte. Les différences sont plus importantes chez les nourrissons (> 1,7 mois jusqu'à 24 mois) et diminuent avec l'âge, en comparaison aux jeunes enfants (de 1 an à 3,6 ans), aux enfants (7,5 ans et < 10 ans) et aux adultes.",
    etiology: {
      intro:
        "Les concentrations critiques séparent les souches sensibles des souches de sensibilité intermédiaire et ces dernières, des résistantes :\r\n\r\nTriméthoprime - sulfaméthoxasole : S < ou = 2 mg/litre et R > 8 mg/litre\r\n\r\nLa prévalence de la résistance peut varier en fonction de la géographie et du temps pour certaines espèces. Il est donc utile de disposer d'informations sur la prévalence de la résistance locale, surtout pour le traitement s'infections sévères. Ces données ne peuvent apporter qu'une orientation sur les probabilités de la sensibilité d'une souche bactérienne à cet antibiotique.\r\n\r\nLorsque la variabilité de la prévalence de la résistance en France est connue pour une espèce bactérienne, elle est indiquée dans la liste ci-dessous [Catégories / Fréquence de résistance acquise en France (> 10 %) (valeurs extrêmes)].",
      usuallySensitive: {
        agent: [
          {
            category: "PARASITOLOGIE",
            name: "ISOSPORA BELLI",
            percentage: null,
          },
          {
            category: "PARASITOLOGIE",
            name: "PNEUMOCYSTIS JIROVECII",
            percentage: null,
          },
          {
            category: "PARASITOLOGIE",
            name: "TOXOPLASMA",
            percentage: null,
          },
          {
            category: "BACTERIES GRAM POSITIF AEROBIES",
            name: "STAPHYLOCOCCUS AUREUS",
            percentage: null,
          },
          {
            category: "BACTERIES GRAM POSITIF AEROBIES",
            name: "STAPHYLOCOCCUS COAGULASE NEGAT.",
            percentage: "5 - 40 %",
          },
          {
            category: "BACTERIES GRAM POSITIF AEROBIES",
            name: "STREPTOCOCCUS sp",
            percentage: "5 - 20 %",
          },
          {
            category: "BACTERIES GRAM POSITIF AEROBIES",
            name: "STREPTOCOCCUS PNEUMONIAE",
            percentage: "10 - 50 %",
          },
          {
            category: "BACTERIES GRAM POSITIF AEROBIES",
            name: "ENTEROCOCCUS sp",
            percentage: null,
          },
          {
            category: "BACTERIES GRAM POSITIF AEROBIES",
            name: "CORYNEBACTERIUM sp",
            percentage: null,
          },
          {
            category: "BACTERIES GRAM POSITIF AEROBIES",
            name: "LISTERIA sp",
            percentage: null,
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "ESCHERICHIA COLI",
            percentage: "5 - 30 %",
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "PROTEUS sp",
            percentage: "20 - 40 %",
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "MORGANELLA sp",
            percentage: "10 - 20 %",
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "KLEBSIELLA sp",
            percentage: "10 - 40 %",
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "ENTEROBACTER sp",
            percentage: "10 - 40 %",
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "SALMONELLA sp",
            percentage: null,
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "SHIGELLA sp",
            percentage: null,
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "PASTEURELLA sp",
            percentage: null,
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "CITROBACTER FREUNDII",
            percentage: "10 - 40 %",
          },
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "HAEMOPHILUS sp",
            percentage: "5 - 15 %",
          },
          {
            category: "BACTERIES GRAM POSITIF ANAEROBIES",
            name: "PEPTOSTREPTOCOCCUS sp",
            percentage: null,
          },
          {
            category: "BACTERIES AUTRES",
            name: "MYCOBACTERIES sp",
            percentage: null,
          },
          {
            category: "BACTERIES AUTRES",
            name: "BORRELIA sp",
            percentage: null,
          },
          {
            category: "BACTERIES AUTRES",
            name: "SPIROCHETES sp",
            percentage: null,
          },
        ],
        comment: [],
        text: ["Mycobacterium (sauf tuberculosis, avium intracellulare)"],
      },
      moderateSensitive: null,
      inconsistentlySensitive: null,
      resistantSensitive: {
        agent: [
          {
            category: "BACTERIES GRAM NEGATIF AEROBIES",
            name: "PSEUDOMONAS sp",
            percentage: null,
          },
          {
            category: "BACTERIES AUTRES",
            name: "MYCOBACTERIUM TUBERCULOSIS",
            percentage: null,
          },
          {
            category: "BACTERIES AUTRES",
            name: "MYCOBACTERIUM AVIUM INTRACELLULARE",
            percentage: null,
          },
        ],
        comment: [],
        text: [
          "L'association sulfamides-triméthoprime présente un effet fortement synergique vis à vis de la plupart des bactéries, y compris les souches résistantes à l'un des deux produits. Ceci explique l'activité de l'association sur les Nocardia et les Stenotrophomonas mais aussi sur Escherichia coli ayant une résistance acquise aux sulfamides (résistance même de haut niveau).\r\n\r\nCette synergie est maximale dans le rapport de leur CMI, c'est à dire 1/20 triméthoprime-sulfamide pour les entérobactéries et staphylocoques. En revanche, vis à vis des bactéries naturellement résistantes au triméthoprime (Nocardia, Stenotrophomonas, Neisseria) le rapport optimal doit être de 1/1 ou 2/1 triméthoprime-sulfamide.",
        ],
      },
    },
  },
];

export const mockEprexProtocolsDTOResponse: DTOProtocolsResponse = {
  drugs: [
    {
      form: "solution injectable",
      dose: "40 000 ui/ml",
      conditions: {
        uri: "http://www.meddispar.fr/3400938327649/(type)/letter/(value)/E/(cip)/3400938327649",
        summary:
          "Médicament d'exception à prescription initiale hospitalière annuelle **ou** à prescription initiale par un médecin exerçant dans un service de dialyse à domicile",
        prescription: {
          base_content: null,
          validity_initial_hospital_prescription: "###   \n\n1 an",
          maximum_prescription_period: "###   \n\n1 an",
          prescription_reserved: null,
          monitoring_during_treatment: null,
          hospital_prescription: null,
          exception_drugs:
            "\n\n_**Indications ouvrant droit à prise en charge :** _\n\n\n  * Traitement de l'anémie symptomatique associée à une insuffisance rénale chronique \\(IRC\\) :\n\n\n\n\n\\- chez les adultes et les enfants âgés de 1 à 18 ans hémodialysés et chez les patients adultes en dialyse péritonéale ; \n\n\n\\- chez les adultes insuffisants rénaux non encore dialysés pour le traitement de l'anémie sévère d'origine rénale accompagnée de symptômes cliniques chez les patients.\n\n\n  * Traitement de l'anémie et la réduction des besoins transfusionnels chez les adultes traités par chimiothérapie pour des tumeurs solides, un lymphome malin ou un myélome multiple, et à risque de transfusion en raison de leur état général \\(par exemple, état cardiovasculaire, anémie pré-existante au début de la chimiothérapie\\)\n\n\n\n  * Traitement de l'anémie symptomatique \\(concentration d'hémoglobine ≤ 10 g/dL\\) chez les adultes atteints de syndromes myélodysplasiques \\(SMD\\) primitifs de risque faible ou intermédiaire 1, présentant un taux sérique d'érythropoïétine faible \\(< 200 mU/mL\\)",
          archives: null,
        },
        first_issuance: {
          base_content: null,
          prescription_support:
            "\n\n**Ordonnance** de médicaments, de produits ou de prestations **d'exception** à 4 volets établie **à l'hôpital par tout prescripteur ou par un médecin exerçant dans un service de dialyse à domicile**",
          time_limit: "\n\n3 mois",
          duration_treatment: "\n\n4 semaines ou 30 jours",
        },
        renewal: {
          base_content: null,
          prescription_support:
            "\n\n ** _Renouvellement de la délivrance_**\n\n\nPrésentation du volet 1 de l **'** **ordonnance hospitalière** établie par **tout prescripteur** **ou** du volet 1 de l' **ordonnance émanant d’un médecin exerçant dans un service de dialyse à domicile** de médicaments ou de produits **d'exception** indiquant le nombre de renouvellements\n\n\n ** _Renouvellement de la prescription_**\n\n\n **Ordonnance** **** de médicaments ou de produits et prestations **d'exception** à 4 volets établie par tout prescripteur et **présentation simultanée de la PIH datant de moins d'1 an ou d’une prescription émanant d’un médecin exerçant dans un service de dialyse à domicile**",
        },
      },
    },
    {
      form: "solution injectable",
      dose: "4000 ui/ml",
      conditions: {
        uri: "http://www.meddispar.fr/Medicaments/EPREX-4000-B-6/(type)/letter/(value)/E/(cip)/3400936466715",
        summary:
          "Médicament d'exception à prescription initiale hospitalière annuelle **ou** à prescription initiale par un médecin exerçant dans un service de dialyse à domicile",
        prescription: {
          base_content: null,
          validity_initial_hospital_prescription: "###   \n\n1 an",
          maximum_prescription_period: "###   \n\n1 an",
          prescription_reserved: null,
          monitoring_during_treatment: null,
          hospital_prescription: null,
          exception_drugs:
            "\n\n_**Indications ouvrant droit à prise en charge :** _\n\n\n  * Traitement de l'anémie symptomatique associée à une insuffisance rénale chronique \\(IRC\\) :\n\n\n\n\n\\- chez les adultes et les enfants âgés de 1 à 18 ans hémodialysés et chez les patients adultes en dialyse péritonéale ; \n\n\n\\- chez les adultes insuffisants rénaux non encore dialysés pour le traitement de l'anémie sévère d'origine rénale accompagnée de symptômes cliniques chez les patients.\n\n\n  * Traitement de l'anémie et la réduction des besoins transfusionnels chez les adultes traités par chimiothérapie pour des tumeurs solides, un lymphome malin ou un myélome multiple, et à risque de transfusion en raison de leur état général \\(par exemple, état cardiovasculaire, anémie pré-existante au début de la chimiothérapie\\).\n\n\n\n  * Traitement de l'anémie symptomatique \\(concentration d'hémoglobine ≤ 10 g/dL\\) chez les adultes atteints de syndromes myélodysplasiques \\(SMD\\) primitifs de risque faible ou intermédiaire 1, présentant un taux sérique d'érythropoïétine faible \\(< 200 mU/mL\\)",
          archives: null,
        },
        first_issuance: {
          base_content: null,
          prescription_support:
            "\n\n**Ordonnance** de médicaments, de produits ou de prestations **d'exception** à 4 volets établie **à l'hôpital par tout prescripteur ou par un médecin exerçant dans un service de dialyse à domicile**",
          time_limit: "\n\n3 mois",
          duration_treatment: "\n\n4 semaines ou 30 jours",
        },
        renewal: {
          base_content: null,
          prescription_support:
            "\n\n ** _Renouvellement de la délivrance_**\n\n\nPrésentation du volet 1 de l **'** **ordonnance hospitalière** établie par **tout prescripteur** **ou** du volet 1 de l' **ordonnance émanant d’un médecin exerçant dans un service de dialyse à domicile** de médicaments ou de produits **d'exception** indiquant le nombre de renouvellements\n\n\n ** _Renouvellement de la prescription_**\n\n\n **Ordonnance** **** de médicaments ou de produits et prestations **d'exception** à 4 volets établie par tout prescripteur et **présentation simultanée de la PIH datant de moins d'1 an ou d’une prescription émanant d’un médecin exerçant dans un service de dialyse à domicile**",
        },
      },
    },
    {
      form: "solution injectable",
      dose: "10 000 ui/ml",
      conditions: {
        uri: "http://www.meddispar.fr/Medicaments/EPREX-10000-B-6/(type)/letter/(value)/E/(cip)/3400936466883",
        summary:
          "Médicament d'exception à prescription initiale hospitalière annuelle **ou** à prescription initiale par un médecin exerçant dans un service de dialyse à domicile",
        prescription: {
          base_content: null,
          validity_initial_hospital_prescription: "###   \n\n1 an",
          maximum_prescription_period: "###   \n\n1 an",
          prescription_reserved: null,
          monitoring_during_treatment: null,
          hospital_prescription: null,
          exception_drugs:
            "\n\n_**Indications ouvrant droit à prise en charge :** _\n\n\n  * Traitement de l'anémie symptomatique associée à une insuffisance rénale chronique \\(IRC\\) :\n\n\n\n\n\\- chez les adultes et les enfants âgés de 1 à 18 ans hémodialysés et chez les patients adultes en dialyse péritonéale ; \n\n\n\\- chez les adultes insuffisants rénaux non encore dialysés pour le traitement de l'anémie sévère d'origine rénale accompagnée de symptômes cliniques chez les patients.\n\n\n  * Traitement de l'anémie et la réduction des besoins transfusionnels chez les adultes traités par chimiothérapie pour des tumeurs solides, un lymphome malin ou un myélome multiple, et à risque de transfusion en raison de leur état général \\(par exemple, état cardiovasculaire, anémie pré-existante au début de la chimiothérapie\\).\n\n\n\n  * Traitement de l'anémie symptomatique \\(concentration d'hémoglobine ≤ 10 g/dL\\) chez les adultes atteints de syndromes myélodysplasiques \\(SMD\\) primitifs de risque faible ou intermédiaire 1, présentant un taux sérique d'érythropoïétine faible \\(< 200 mU/mL\\)",
          archives: null,
        },
        first_issuance: {
          base_content: null,
          prescription_support:
            "\n\n**Ordonnance** de médicaments, de produits ou de prestations **d'exception** à 4 volets établie **à l'hôpital par tout prescripteur ou par un médecin exerçant dans un service de dialyse à domicile**",
          time_limit: "\n\n3 mois",
          duration_treatment: "\n\n4 semaines ou 30 jours",
        },
        renewal: {
          base_content: null,
          prescription_support:
            "\n\n ** _Renouvellement de la délivrance_**\n\n\nPrésentation du volet 1 de l **'** **ordonnance hospitalière** établie par **tout prescripteur** **ou** du volet 1 de l' **ordonnance émanant d’un médecin exerçant dans un service de dialyse à domicile** de médicaments ou de produits **d'exception** indiquant le nombre de renouvellements\n\n\n ** _Renouvellement de la prescription_**\n\n\n **Ordonnance** **** de médicaments ou de produits et prestations **d'exception** à 4 volets établie par tout prescripteur et **présentation simultanée de la PIH datant de moins d'1 an ou d’une prescription émanant d’un médecin exerçant dans un service de dialyse à domicile**",
        },
      },
    },
    {
      form: "solution injectable",
      dose: "2000 ui/ml",
      conditions: {
        uri: "http://www.meddispar.fr/Medicaments/EPREX-2000-B-6/(type)/letter/(value)/E/(cip)/3400936466654",
        summary:
          "Médicament d'exception à prescription initiale hospitalière annuelle **ou** à prescription initiale par un médecin exerçant dans un service de dialyse à domicile",
        prescription: {
          base_content: null,
          validity_initial_hospital_prescription: "###   \n\n1 an",
          maximum_prescription_period: "###   \n\n1 an",
          prescription_reserved: null,
          monitoring_during_treatment: null,
          hospital_prescription: null,
          exception_drugs:
            "\n\n_**Indications ouvrant droit à prise en charge :** _\n\n\n  * Traitement de l'anémie symptomatique associée à une insuffisance rénale chronique \\(IRC\\) :\n\n\n\n\n\\- chez les adultes et les enfants âgés de 1 à 18 ans hémodialysés et chez les patients adultes en dialyse péritonéale ; \n\n\n\\- chez les adultes insuffisants rénaux non encore dialysés pour le traitement de l'anémie sévère d'origine rénale accompagnée de symptômes cliniques chez les patients.\n\n\n  * Traitement de l'anémie et la réduction des besoins transfusionnels chez les adultes traités par chimiothérapie pour des tumeurs solides, un lymphome malin ou un myélome multiple, et à risque de transfusion en raison de leur état général \\(par exemple, état cardiovasculaire, anémie pré-existante au début de la chimiothérapie\\). \n\n\n\n  * Traitement de l'anémie symptomatique \\(concentration d'hémoglobine ≤ 10 g/dL\\) chez les adultes atteints de syndromes myélodysplasiques \\(SMD\\) primitifs de risque faible ou intermédiaire 1, présentant un taux sérique d'érythropoïétine faible \\(< 200 mU/mL\\)",
          archives: null,
        },
        first_issuance: {
          base_content: null,
          prescription_support:
            "\n\n**Ordonnance** de médicaments, de produits ou de prestations **d'exception** à 4 volets établie **à l'hôpital par tout prescripteur ou par un médecin exerçant dans un service de dialyse à domicile**",
          time_limit: "\n\n3 mois",
          duration_treatment: "\n\n4 semaines ou 30 jours",
        },
        renewal: {
          base_content: null,
          prescription_support:
            "\n\n ** _Renouvellement de la délivrance_**\n\n\nPrésentation du volet 1 de l **'** **ordonnance hospitalière** établie par **tout prescripteur** **ou** du volet 1 de l' **ordonnance émanant d’un médecin exerçant dans un service de dialyse à domicile** de médicaments ou de produits **d'exception** indiquant le nombre de renouvellements\n\n\n ** _Renouvellement de la prescription_**\n\n\n **Ordonnance** **** de médicaments ou de produits et prestations **d'exception** à 4 volets établie par tout prescripteur et **présentation simultanée de la PIH datant de moins d'1 an ou d’une prescription émanant d’un médecin exerçant dans un service de dialyse à domicile**",
        },
      },
    },
  ],
};

export const mockEprexProtocols: FormDoseAndProtocols[] = [
  {
    dose: "40 000 ui/ml",
    form: "solution injectable",
    protocols: {
      uri: "http://www.meddispar.fr/3400938327649/(type)/letter/(value)/E/(cip)/3400938327649",
      summary:
        "Médicament d'exception à prescription initiale hospitalière annuelle **ou** à prescription initiale par un médecin exerçant dans un service de dialyse à domicile",
      prescription: {
        baseContent: null,
        validityInitialHospitalPrescription: "###   \n\n1 an",
        maximumPrescriptionPeriod: "###   \n\n1 an",
        prescriptionReserved: null,
        monitoringDuringTreatment: null,
        hospitalPrescription: null,
        exceptionDrugs:
          "\n\n_**Indications ouvrant droit à prise en charge :** _\n\n\n  * Traitement de l'anémie symptomatique associée à une insuffisance rénale chronique \\(IRC\\) :\n\n\n\n\n\\- chez les adultes et les enfants âgés de 1 à 18 ans hémodialysés et chez les patients adultes en dialyse péritonéale ; \n\n\n\\- chez les adultes insuffisants rénaux non encore dialysés pour le traitement de l'anémie sévère d'origine rénale accompagnée de symptômes cliniques chez les patients.\n\n\n  * Traitement de l'anémie et la réduction des besoins transfusionnels chez les adultes traités par chimiothérapie pour des tumeurs solides, un lymphome malin ou un myélome multiple, et à risque de transfusion en raison de leur état général \\(par exemple, état cardiovasculaire, anémie pré-existante au début de la chimiothérapie\\)\n\n\n\n  * Traitement de l'anémie symptomatique \\(concentration d'hémoglobine ≤ 10 g/dL\\) chez les adultes atteints de syndromes myélodysplasiques \\(SMD\\) primitifs de risque faible ou intermédiaire 1, présentant un taux sérique d'érythropoïétine faible \\(< 200 mU/mL\\)",
        archives: null,
      },
      firstIssuance: {
        baseContent: null,
        prescriptionSupport:
          "\n\n**Ordonnance** de médicaments, de produits ou de prestations **d'exception** à 4 volets établie **à l'hôpital par tout prescripteur ou par un médecin exerçant dans un service de dialyse à domicile**",
        timeLimit: "\n\n3 mois",
        durationTreatment: "\n\n4 semaines ou 30 jours",
      },
      renewal: {
        baseContent: null,
        prescriptionSupport:
          "\n\n ** _Renouvellement de la délivrance_**\n\n\nPrésentation du volet 1 de l **'** **ordonnance hospitalière** établie par **tout prescripteur** **ou** du volet 1 de l' **ordonnance émanant d’un médecin exerçant dans un service de dialyse à domicile** de médicaments ou de produits **d'exception** indiquant le nombre de renouvellements\n\n\n ** _Renouvellement de la prescription_**\n\n\n **Ordonnance** **** de médicaments ou de produits et prestations **d'exception** à 4 volets établie par tout prescripteur et **présentation simultanée de la PIH datant de moins d'1 an ou d’une prescription émanant d’un médecin exerçant dans un service de dialyse à domicile**",
      },
    },
  },
  {
    dose: "4000 ui/ml",
    form: "solution injectable",
    protocols: {
      uri: "http://www.meddispar.fr/Medicaments/EPREX-4000-B-6/(type)/letter/(value)/E/(cip)/3400936466715",
      summary:
        "Médicament d'exception à prescription initiale hospitalière annuelle **ou** à prescription initiale par un médecin exerçant dans un service de dialyse à domicile",
      prescription: {
        baseContent: null,
        validityInitialHospitalPrescription: "###   \n\n1 an",
        maximumPrescriptionPeriod: "###   \n\n1 an",
        prescriptionReserved: null,
        monitoringDuringTreatment: null,
        hospitalPrescription: null,
        exceptionDrugs:
          "\n\n_**Indications ouvrant droit à prise en charge :** _\n\n\n  * Traitement de l'anémie symptomatique associée à une insuffisance rénale chronique \\(IRC\\) :\n\n\n\n\n\\- chez les adultes et les enfants âgés de 1 à 18 ans hémodialysés et chez les patients adultes en dialyse péritonéale ; \n\n\n\\- chez les adultes insuffisants rénaux non encore dialysés pour le traitement de l'anémie sévère d'origine rénale accompagnée de symptômes cliniques chez les patients.\n\n\n  * Traitement de l'anémie et la réduction des besoins transfusionnels chez les adultes traités par chimiothérapie pour des tumeurs solides, un lymphome malin ou un myélome multiple, et à risque de transfusion en raison de leur état général \\(par exemple, état cardiovasculaire, anémie pré-existante au début de la chimiothérapie\\).\n\n\n\n  * Traitement de l'anémie symptomatique \\(concentration d'hémoglobine ≤ 10 g/dL\\) chez les adultes atteints de syndromes myélodysplasiques \\(SMD\\) primitifs de risque faible ou intermédiaire 1, présentant un taux sérique d'érythropoïétine faible \\(< 200 mU/mL\\)",
        archives: null,
      },
      firstIssuance: {
        baseContent: null,
        prescriptionSupport:
          "\n\n**Ordonnance** de médicaments, de produits ou de prestations **d'exception** à 4 volets établie **à l'hôpital par tout prescripteur ou par un médecin exerçant dans un service de dialyse à domicile**",
        timeLimit: "\n\n3 mois",
        durationTreatment: "\n\n4 semaines ou 30 jours",
      },
      renewal: {
        baseContent: null,
        prescriptionSupport:
          "\n\n ** _Renouvellement de la délivrance_**\n\n\nPrésentation du volet 1 de l **'** **ordonnance hospitalière** établie par **tout prescripteur** **ou** du volet 1 de l' **ordonnance émanant d’un médecin exerçant dans un service de dialyse à domicile** de médicaments ou de produits **d'exception** indiquant le nombre de renouvellements\n\n\n ** _Renouvellement de la prescription_**\n\n\n **Ordonnance** **** de médicaments ou de produits et prestations **d'exception** à 4 volets établie par tout prescripteur et **présentation simultanée de la PIH datant de moins d'1 an ou d’une prescription émanant d’un médecin exerçant dans un service de dialyse à domicile**",
      },
    },
  },
  {
    dose: "10 000 ui/ml",
    form: "solution injectable",
    protocols: {
      uri: "http://www.meddispar.fr/Medicaments/EPREX-10000-B-6/(type)/letter/(value)/E/(cip)/3400936466883",
      summary:
        "Médicament d'exception à prescription initiale hospitalière annuelle **ou** à prescription initiale par un médecin exerçant dans un service de dialyse à domicile",
      prescription: {
        baseContent: null,
        validityInitialHospitalPrescription: "###   \n\n1 an",
        maximumPrescriptionPeriod: "###   \n\n1 an",
        prescriptionReserved: null,
        monitoringDuringTreatment: null,
        hospitalPrescription: null,
        exceptionDrugs:
          "\n\n_**Indications ouvrant droit à prise en charge :** _\n\n\n  * Traitement de l'anémie symptomatique associée à une insuffisance rénale chronique \\(IRC\\) :\n\n\n\n\n\\- chez les adultes et les enfants âgés de 1 à 18 ans hémodialysés et chez les patients adultes en dialyse péritonéale ; \n\n\n\\- chez les adultes insuffisants rénaux non encore dialysés pour le traitement de l'anémie sévère d'origine rénale accompagnée de symptômes cliniques chez les patients.\n\n\n  * Traitement de l'anémie et la réduction des besoins transfusionnels chez les adultes traités par chimiothérapie pour des tumeurs solides, un lymphome malin ou un myélome multiple, et à risque de transfusion en raison de leur état général \\(par exemple, état cardiovasculaire, anémie pré-existante au début de la chimiothérapie\\).\n\n\n\n  * Traitement de l'anémie symptomatique \\(concentration d'hémoglobine ≤ 10 g/dL\\) chez les adultes atteints de syndromes myélodysplasiques \\(SMD\\) primitifs de risque faible ou intermédiaire 1, présentant un taux sérique d'érythropoïétine faible \\(< 200 mU/mL\\)",
        archives: null,
      },
      firstIssuance: {
        baseContent: null,
        prescriptionSupport:
          "\n\n**Ordonnance** de médicaments, de produits ou de prestations **d'exception** à 4 volets établie **à l'hôpital par tout prescripteur ou par un médecin exerçant dans un service de dialyse à domicile**",
        timeLimit: "\n\n3 mois",
        durationTreatment: "\n\n4 semaines ou 30 jours",
      },
      renewal: {
        baseContent: null,
        prescriptionSupport:
          "\n\n ** _Renouvellement de la délivrance_**\n\n\nPrésentation du volet 1 de l **'** **ordonnance hospitalière** établie par **tout prescripteur** **ou** du volet 1 de l' **ordonnance émanant d’un médecin exerçant dans un service de dialyse à domicile** de médicaments ou de produits **d'exception** indiquant le nombre de renouvellements\n\n\n ** _Renouvellement de la prescription_**\n\n\n **Ordonnance** **** de médicaments ou de produits et prestations **d'exception** à 4 volets établie par tout prescripteur et **présentation simultanée de la PIH datant de moins d'1 an ou d’une prescription émanant d’un médecin exerçant dans un service de dialyse à domicile**",
      },
    },
  },
  {
    dose: "2000 ui/ml",
    form: "solution injectable",
    protocols: {
      uri: "http://www.meddispar.fr/Medicaments/EPREX-2000-B-6/(type)/letter/(value)/E/(cip)/3400936466654",
      summary:
        "Médicament d'exception à prescription initiale hospitalière annuelle **ou** à prescription initiale par un médecin exerçant dans un service de dialyse à domicile",
      prescription: {
        baseContent: null,
        validityInitialHospitalPrescription: "###   \n\n1 an",
        maximumPrescriptionPeriod: "###   \n\n1 an",
        prescriptionReserved: null,
        monitoringDuringTreatment: null,
        hospitalPrescription: null,
        exceptionDrugs:
          "\n\n_**Indications ouvrant droit à prise en charge :** _\n\n\n  * Traitement de l'anémie symptomatique associée à une insuffisance rénale chronique \\(IRC\\) :\n\n\n\n\n\\- chez les adultes et les enfants âgés de 1 à 18 ans hémodialysés et chez les patients adultes en dialyse péritonéale ; \n\n\n\\- chez les adultes insuffisants rénaux non encore dialysés pour le traitement de l'anémie sévère d'origine rénale accompagnée de symptômes cliniques chez les patients.\n\n\n  * Traitement de l'anémie et la réduction des besoins transfusionnels chez les adultes traités par chimiothérapie pour des tumeurs solides, un lymphome malin ou un myélome multiple, et à risque de transfusion en raison de leur état général \\(par exemple, état cardiovasculaire, anémie pré-existante au début de la chimiothérapie\\). \n\n\n\n  * Traitement de l'anémie symptomatique \\(concentration d'hémoglobine ≤ 10 g/dL\\) chez les adultes atteints de syndromes myélodysplasiques \\(SMD\\) primitifs de risque faible ou intermédiaire 1, présentant un taux sérique d'érythropoïétine faible \\(< 200 mU/mL\\)",
        archives: null,
      },
      firstIssuance: {
        baseContent: null,
        prescriptionSupport:
          "\n\n**Ordonnance** de médicaments, de produits ou de prestations **d'exception** à 4 volets établie **à l'hôpital par tout prescripteur ou par un médecin exerçant dans un service de dialyse à domicile**",
        timeLimit: "\n\n3 mois",
        durationTreatment: "\n\n4 semaines ou 30 jours",
      },
      renewal: {
        baseContent: null,
        prescriptionSupport:
          "\n\n ** _Renouvellement de la délivrance_**\n\n\nPrésentation du volet 1 de l **'** **ordonnance hospitalière** établie par **tout prescripteur** **ou** du volet 1 de l' **ordonnance émanant d’un médecin exerçant dans un service de dialyse à domicile** de médicaments ou de produits **d'exception** indiquant le nombre de renouvellements\n\n\n ** _Renouvellement de la prescription_**\n\n\n **Ordonnance** **** de médicaments ou de produits et prestations **d'exception** à 4 volets établie par tout prescripteur et **présentation simultanée de la PIH datant de moins d'1 an ou d’une prescription émanant d’un médecin exerçant dans un service de dialyse à domicile**",
      },
    },
  },
];

export const mockDolipraneProtocolsDTOResponse: DTOProtocolsResponse = {
  drugs: [
    {
      form: "poudre pour solution buvable",
      dose: "1000 mg",
      conditions: null,
    },
    {
      form: "poudre pour solution buvable",
      dose: "500 mg",
      conditions: null,
    },
    {
      form: "poudre pour solution buvable",
      dose: "100 mg",
      conditions: null,
    },
    {
      form: "comprimé effervescent",
      dose: "1000 mg",
      conditions: null,
    },
    {
      form: "poudre pour solution buvable",
      dose: "200 mg",
      conditions: null,
    },
    {
      form: "suppositoire",
      dose: "100 mg",
      conditions: null,
    },
    {
      form: "suppositoire",
      dose: "200 mg",
      conditions: null,
    },
    {
      form: "suspension buvable",
      dose: "2,4 %",
      conditions: null,
    },
    {
      form: "comprimé effervescent",
      dose: "500 mg",
      conditions: null,
    },
    {
      form: "poudre pour solution buvable",
      dose: "300 mg",
      conditions: null,
    },
    {
      form: "suppositoire",
      dose: "300 mg",
      conditions: null,
    },
    {
      form: "gélule",
      dose: "1000 mg",
      conditions: null,
    },
    {
      form: "gélule",
      dose: "500 mg",
      conditions: null,
    },
    {
      form: "suppositoire",
      dose: "1000 mg",
      conditions: null,
    },
    {
      form: "poudre pour solution buvable",
      dose: "150 mg",
      conditions: null,
    },
    {
      form: "comprimé",
      dose: "500 mg",
      conditions: null,
    },
    {
      form: "comprimé",
      dose: "1000 mg",
      conditions: null,
    },
    {
      form: "suppositoire",
      dose: "150 mg",
      conditions: null,
    },
  ],
};
